'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tsModuleType = require('typescript');
var tsSimpleType = require('ts-simple-type');
var vscode = require('vscode-css-languageservice');
var vscode$1 = require('vscode-html-languageservice');
var webComponentAnalyzer = require('web-component-analyzer');
var path = require('path');
var didYouMean = require('didyoumean2');
var didYouMean__default = _interopDefault(didYouMean);
var fs = require('fs');
var chalk = _interopDefault(require('chalk'));
var fastGlob = require('fast-glob');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

/**
 * Flattens an array.
 * Use this function to keep support for node 10
 * @param items
 */
function arrayFlat(items) {
    var e_1, _a;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    if ("flat" in items) {
        return items.flat();
    }
    var flattenArray = [];
    try {
        for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
            var item = items_1_1.value;
            flattenArray.push.apply(flattenArray, __spread(item));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return flattenArray;
}
/**
 * Filters an array returning only defined items
 * @param array
 */
function arrayDefined(array) {
    return array.filter(function (item) { return item != null; });
}
/**
 * Joins an array with a custom final splitter
 * @param items
 * @param splitter
 * @param finalSplitter
 */
function joinArray(items, splitter, finalSplitter) {
    if (splitter === void 0) { splitter = ", "; }
    if (finalSplitter === void 0) { finalSplitter = "or"; }
    return items.join(splitter).replace(/, ([^,]*)$/, " " + finalSplitter + " $1");
}

function makeSourceFileRange(range) {
    return range;
}
function makeDocumentRange(range) {
    return range;
}
function rangeFromHtmlNodeAttr(htmlAttr) {
    return documentRangeToSFRange(htmlAttr.document, htmlAttr.location.name);
    //return { document: htmlAttr.document, ...htmlAttr.location.name };
}
function rangeFromHtmlNode(htmlNode) {
    return documentRangeToSFRange(htmlNode.document, htmlNode.location.name);
    //return { document: htmlNode.document, ...htmlNode.location.name };
}
function rangeFromNode(node) {
    //return { file: node.getSourceFile(), start: node.getStart(), end: node.getEnd() };
    return makeSourceFileRange({ start: node.getStart(), end: node.getEnd() });
}
function documentRangeToSFRange(document, range) {
    return makeSourceFileRange({
        start: document.virtualDocument.documentOffsetToSFPosition(range.start),
        end: document.virtualDocument.documentOffsetToSFPosition(range.end)
    });
}
function sfRangeToDocumentRange(document, range) {
    return makeDocumentRange({
        start: document.virtualDocument.sfPositionToDocumentOffset(range.start),
        end: document.virtualDocument.sfPositionToDocumentOffset(range.end)
    });
}
/**
 * Returns if a position is within start and end.
 * @param position
 * @param start
 * @param end
 */
//export function intersects(position: SourceFilePosition | SourceFileRange, { start, end }: SourceFileRange): boolean;
//export function intersects(position: DocumentOffset | DocumentRange, { start, end }: DocumentRange): boolean;
function intersects(position, _a) {
    var start = _a.start, end = _a.end;
    if (typeof position === "number") {
        return start <= position && position <= end;
    }
    else {
        return start <= position.start && position.end <= end;
    }
}

/**
 * The values of this map are tuples where 1st element is
 * non-strict severity and 2nd element is "strict" severity
 */
var DEFAULT_RULES_SEVERITY = {
    "no-unknown-tag-name": ["off", "warn"],
    "no-missing-import": ["off", "warn"],
    "no-unclosed-tag": ["warn", "error"],
    "no-unknown-attribute": ["off", "warn"],
    "no-unknown-property": ["off", "warn"],
    "no-unknown-event": ["off", "off"],
    "no-unknown-slot": ["off", "warn"],
    "no-unintended-mixed-binding": ["warn", "warn"],
    "no-invalid-boolean-binding": ["error", "error"],
    "no-expressionless-property-binding": ["error", "error"],
    "no-noncallable-event-binding": ["error", "error"],
    "no-boolean-in-attribute-binding": ["error", "error"],
    "no-complex-attribute-binding": ["error", "error"],
    "no-nullable-attribute-binding": ["error", "error"],
    "no-incompatible-type-binding": ["error", "error"],
    "no-invalid-directive-binding": ["error", "error"],
    "no-incompatible-property-type": ["warn", "error"],
    "no-invalid-attribute-name": ["error", "error"],
    "no-invalid-tag-name": ["error", "error"],
    "no-invalid-css": ["warn", "error"],
    "no-property-visibility-mismatch": ["off", "warning"],
    "no-legacy-attribute": ["off", "off"],
    "no-missing-element-type-definition": ["off", "off"]
};
// All rule names order alphabetically
var ALL_RULE_IDS = Object.keys(DEFAULT_RULES_SEVERITY).sort();
// This map is based on alphabetic order, so it assumed that
//   these rule codes are changed when new rules are added and
//   should not be depended on by the user.
// The user should always use the "rule id" string.
// Consider if this map should be manually maintained in the future.
var RULE_ID_CODE_MAP = ALL_RULE_IDS.reduce(function (acc, ruleId, i) {
    acc[ruleId] = i + 1;
    return acc;
}, {});
function ruleIdCode(ruleId) {
    return RULE_ID_CODE_MAP[ruleId];
}
function ruleSeverity(rules, ruleId) {
    if ("rules" in rules)
        return ruleSeverity(rules.rules, ruleId);
    var ruleConfig = rules[ruleId] || "off";
    return Array.isArray(ruleConfig) ? ruleConfig[0] : ruleConfig;
}
function isRuleDisabled(config, ruleId) {
    return ["off", 0, false].includes(ruleSeverity(config, ruleId));
}
function isRuleEnabled(config, ruleId) {
    return !isRuleDisabled(config, ruleId);
}
function litDiagnosticRuleSeverity(config, ruleId) {
    switch (ruleSeverity(config, ruleId)) {
        case "off":
        case false:
        case 0:
            return "warning";
        case "warn":
        case "warning":
        case true:
        case "on":
        case 1:
            return "warning";
        case "error":
        case 2:
            return "error";
    }
}
/**
 * Parses a partial user configuration and returns a full options object with defaults.
 * @param userOptions
 */
function makeConfig(userOptions) {
    if (userOptions === void 0) { userOptions = {}; }
    var securitySystem = userOptions.securitySystem || "off";
    switch (securitySystem) {
        case "off":
        case "ClosureSafeTypes":
            break; // legal values
        default:
            // Unknown values get converted to "off".
            securitySystem = "off";
    }
    return {
        strict: userOptions.strict || false,
        rules: makeRules(userOptions),
        securitySystem: userOptions.securitySystem || "off",
        disable: userOptions.disable || false,
        logging: userOptions.logging || "off",
        cwd: userOptions.cwd || process.cwd(),
        format: {
            disable: userOptions.format != null ? userOptions.format.disable :  false // always disable formating for now
        },
        dontSuggestConfigChanges: userOptions.dontSuggestConfigChanges || false,
        dontShowSuggestions: userOptions.dontShowSuggestions || getDeprecatedOption(userOptions, "skipSuggestions") || false,
        maxProjectImportDepth: parseImportDepth(userOptions.maxProjectImportDepth, Infinity),
        maxNodeModuleImportDepth: parseImportDepth(userOptions.maxNodeModuleImportDepth, 1),
        // Template tags
        htmlTemplateTags: userOptions.htmlTemplateTags || ["html", "raw"],
        cssTemplateTags: userOptions.cssTemplateTags || ["css"],
        // Global additions
        globalTags: userOptions.globalTags || getDeprecatedOption(userOptions, "externalHtmlTagNames") || [],
        globalAttributes: userOptions.globalAttributes || [],
        globalEvents: userOptions.globalEvents || [],
        customHtmlData: userOptions.customHtmlData || []
    };
}
function getDeprecatedOption(userOptions, name) {
    return userOptions[name];
}
/*function getDeprecatedRule(userOptions: Partial<LitAnalyzerConfig>, name: string): LitAnalyzerRuleSeverity | undefined {
    return userOptions.rules?.[name as never];
}*/
function makeRules(userOptions) {
    var mappedDeprecatedRules = getDeprecatedMappedRules(userOptions);
    var defaultRules = getDefaultRules(userOptions);
    var userRules = getUserRules(userOptions);
    return Object.assign({}, defaultRules, mappedDeprecatedRules, userRules);
}
function getUserRules(userOptions) {
    return userOptions.rules || {};
}
function getDefaultRules(userOptions) {
    var isStrict = userOptions.strict || false;
    return ALL_RULE_IDS.reduce(function (acc, ruleId) {
        var severities = DEFAULT_RULES_SEVERITY[ruleId];
        acc[ruleId] = isStrict ? severities[1] : severities[0];
        return acc;
    }, {});
}
function getDeprecatedMappedRules(userOptions) {
    var mappedDeprecatedRules = {};
    if (getDeprecatedOption(userOptions, "skipMissingImports") === true) {
        mappedDeprecatedRules["no-missing-import"] = "off";
    }
    if (getDeprecatedOption(userOptions, "skipUnknownTags") === true) {
        mappedDeprecatedRules["no-unknown-tag-name"] = "off";
    }
    if (getDeprecatedOption(userOptions, "skipUnknownAttributes") === true) {
        mappedDeprecatedRules["no-unknown-attribute"] = "off";
    }
    if (getDeprecatedOption(userOptions, "skipUnknownProperties") === true) {
        mappedDeprecatedRules["no-unknown-property"] = "off";
    }
    if (getDeprecatedOption(userOptions, "skipUnknownSlots") === true) {
        mappedDeprecatedRules["no-unknown-slot"] = "off";
    }
    if (getDeprecatedOption(userOptions, "skipCssChecks") === true) {
        mappedDeprecatedRules["no-invalid-css"] = "off";
    }
    if (getDeprecatedOption(userOptions, "checkUnknownEvents") === true) {
        mappedDeprecatedRules["no-unknown-event"] = "warn";
    }
    if (getDeprecatedOption(userOptions, "skipTypeChecking") === true) {
        Object.assign(mappedDeprecatedRules, {
            "no-invalid-boolean-binding": "off",
            "no-noncallable-event-binding": "off",
            "no-boolean-in-attribute-binding": "off",
            "no-complex-attribute-binding": "off",
            "no-nullable-attribute-binding": "off",
            "no-incompatible-type-binding": "off",
            "no-incompatible-property-type": "off"
        });
    }
    return mappedDeprecatedRules;
}
/**
 * Parses dependency traversal depth from configuration.
 * The number -1 (as well as any other negative number) gets parsed into the number Infinity.
 * @param value
 * @param defaultValue
 */
function parseImportDepth(value, defaultValue) {
    if (value != null) {
        return value < 0 ? Infinity : value;
    }
    else {
        return defaultValue;
    }
}

function convertRuleDiagnosticToLitDiagnostic(reported, context) {
    var source = reported.source;
    var _a = reported.diagnostic, message = _a.message, location = _a.location, fixMessage = _a.fixMessage, suggestion = _a.suggestion;
    return {
        fixMessage: fixMessage,
        location: location,
        suggestion: suggestion,
        message: message,
        source: source,
        file: context.currentFile,
        severity: litDiagnosticRuleSeverity(context.config, source),
        code: ruleIdCode(source)
    };
}

var tsModule = { ts: tsModuleType };

function converRuleFixToLitCodeFix(codeFix) {
    return {
        name: "",
        message: codeFix.message,
        actions: arrayFlat(codeFix.actions.map(ruleFixActionConverter))
    };
}
function ruleFixActionConverter(action) {
    var _a, _b;
    switch (action.kind) {
        case "changeTagName": {
            var document = action.htmlNode.document;
            var startLocation = action.htmlNode.location.name;
            var endLocation = action.htmlNode.location.endTag;
            return __spread([
                {
                    range: documentRangeToSFRange(document, startLocation),
                    newText: action.newName
                }
            ], (endLocation == null
                ? []
                : [
                    {
                        range: documentRangeToSFRange(document, {
                            start: endLocation.start + 2,
                            end: endLocation.end - 1
                        }),
                        newText: action.newName
                    }
                ]));
        }
        case "addAttribute": {
            var htmlNode = action.htmlNode;
            return [
                {
                    range: documentRangeToSFRange(htmlNode.document, {
                        start: htmlNode.location.name.end,
                        end: htmlNode.location.name.end
                    }),
                    newText: " " + action.name + (action.value == null ? "" : "=\"" + action.value + "\"")
                }
            ];
        }
        case "changeAttributeName": {
            return [
                {
                    range: rangeFromHtmlNodeAttr(action.htmlAttr),
                    newText: action.newName
                }
            ];
        }
        case "changeAttributeModifier": {
            var document = action.htmlAttr.document;
            return [
                {
                    // Make a range that includes the modifier.
                    range: documentRangeToSFRange(document, {
                        start: action.htmlAttr.location.start,
                        end: action.htmlAttr.location.name.start
                    }),
                    newText: action.newModifier
                }
            ];
        }
        case "changeAssignment": {
            var assignment = action.assignment;
            if (assignment.location == null) {
                return [];
            }
            return [
                {
                    range: documentRangeToSFRange(assignment.htmlAttr.document, {
                        start: assignment.location.start + 2,
                        end: assignment.location.end - 1 // Offset 1 for '}'
                    }),
                    newText: action.newValue
                }
            ];
        }
        case "import": {
            // Get the import path and the position where it can be placed
            var lastImportIndex = getLastImportIndex(action.file);
            return [
                {
                    range: makeSourceFileRange({
                        start: lastImportIndex,
                        end: lastImportIndex
                    }),
                    newText: "\nimport \"" + action.path + "\";"
                }
            ];
        }
        case "changeIdentifier": {
            return [
                {
                    range: rangeFromNode(action.identifier),
                    newText: action.newText
                }
            ];
        }
        case "changeRange": {
            return [
                {
                    range: action.range,
                    newText: action.newText
                }
            ];
        }
        case "extendGlobalDeclaration": {
            if (action.file == null) {
                break;
            }
            var MEMBER_PART = "\n\t\t" + action.newMembers.join("\t\t");
            var DECLARATION_PART = "\n\tinterface " + action.name + " {" + MEMBER_PART + "\n\t}";
            var MODULE_PART = "\n\ndeclare global {" + DECLARATION_PART + "\n}";
            var existingModuleDeclaration = (_a = action.file.statements) === null || _a === void 0 ? void 0 : _a.find(function (statement) { return tsModule.ts.isModuleDeclaration(statement) && statement.name.text === "global"; });
            var existingModuleBody = existingModuleDeclaration === null || existingModuleDeclaration === void 0 ? void 0 : existingModuleDeclaration.body;
            // If there is no existing "global" module declaration, add an entire global module declaration
            if (existingModuleDeclaration == null) {
                return [
                    {
                        range: makeSourceFileRange({
                            start: action.file.getEnd(),
                            end: action.file.getEnd()
                        }),
                        newText: MODULE_PART
                    }
                ];
            }
            if (existingModuleBody == null || !tsModule.ts.isModuleBlock(existingModuleBody)) {
                return [];
            }
            var existingDeclaration = (_b = existingModuleBody.statements) === null || _b === void 0 ? void 0 : _b.find(function (statement) { return tsModule.ts.isInterfaceDeclaration(statement) && statement.name.text === action.name; });
            // If there is no existing declaration with "action.name", add a new declaration inside the module block
            if (existingDeclaration == null) {
                return [
                    {
                        range: makeSourceFileRange({
                            start: existingModuleBody.getStart() + 1,
                            end: existingModuleBody.getStart() + 1
                        }),
                        newText: DECLARATION_PART
                    }
                ];
            }
            // If there is an existing declaration with "action.name", add members to it
            return [
                {
                    range: makeSourceFileRange({
                        start: existingDeclaration.name.getEnd() + 2,
                        end: existingDeclaration.name.getEnd() + 2
                    }),
                    newText: MEMBER_PART
                }
            ];
        }
    }
    return [];
}
/**
 * Returns the position of the last import line.
 * @param sourceFile
 */
function getLastImportIndex(sourceFile) {
    var e_1, _a;
    var lastImportIndex = 0;
    try {
        for (var _b = __values(sourceFile.statements), _c = _b.next(); !_c.done; _c = _b.next()) {
            var statement = _c.value;
            if (tsModule.ts.isImportDeclaration(statement)) {
                lastImportIndex = statement.getEnd();
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return lastImportIndex;
}

var ComponentAnalyzer = /** @class */ (function () {
    function ComponentAnalyzer() {
    }
    ComponentAnalyzer.prototype.getDiagnostics = function (definitionOrDeclaration, context) {
        return this.getRuleDiagnostics(definitionOrDeclaration, context).map(function (d) { return convertRuleDiagnosticToLitDiagnostic(d, context); });
    };
    ComponentAnalyzer.prototype.getCodeFixesAtOffsetRange = function (definitionOrDeclaration, range, context) {
        return arrayFlat(arrayDefined(this.getRuleDiagnostics(definitionOrDeclaration, context)
            .filter(function (_a) {
            var diagnostic = _a.diagnostic;
            return intersects(range, diagnostic.location);
        })
            .map(function (_a) {
            var _b;
            var diagnostic = _a.diagnostic;
            return (_b = diagnostic.fix) === null || _b === void 0 ? void 0 : _b.call(diagnostic);
        }))).map(function (ruleFix) { return converRuleFixToLitCodeFix(ruleFix); });
    };
    ComponentAnalyzer.prototype.getRuleDiagnostics = function (definitionOrDeclaration, context) {
        if ("tagName" in definitionOrDeclaration) {
            return context.rules.getDiagnosticsFromDefinition(definitionOrDeclaration, context);
        }
        else {
            return context.rules.getDiagnosticsFromDeclaration(definitionOrDeclaration, context);
        }
    };
    return ComponentAnalyzer;
}());

var tsModule$1 = { ts: tsModuleType };
function setTypescriptModule(newModule) {
    tsModule$1.ts = newModule;
    tsSimpleType.setTypescriptModule(newModule);
}

/**
 * Tests nodes recursively walking up the tree using parent nodes.
 * @param node
 * @param test
 */
function findParent(node, test) {
    if (node == null)
        return;
    return test(node) ? node : findParent(node.parent, test);
}
function findChild(node, test) {
    if (!node)
        return;
    if (test(node))
        return node;
    return node.forEachChild(function (child) { return findChild(child, test); });
}
/**
 * Returns a node at a specific position.
 * @param node
 * @param position
 */
function getNodeAtPosition(node, position) {
    if (!intersects(position, { start: node.pos, end: node.end })) {
        return;
    }
    return node.forEachChild(function (child) { return getNodeAtPosition(child, position); }) || node;
}
function nodeIntersects(nodeA, nodeB) {
    return intersects({
        start: nodeA.getStart(),
        end: nodeA.getEnd()
    }, {
        start: nodeB.getStart(),
        end: nodeB.getEnd()
    });
}
/**
 * Returns the declaration name of a given node if possible.
 * @param node
 * @param ts
 */
function getNodeIdentifier(node, ts) {
    if (ts.isIdentifier(node)) {
        return node;
    }
    else if (ts.isCallExpression(node) && ts.isIdentifier(node.expression)) {
        return node.expression;
    }
    else if ((ts.isClassLike(node) ||
        ts.isInterfaceDeclaration(node) ||
        ts.isVariableDeclaration(node) ||
        ts.isMethodDeclaration(node) ||
        ts.isPropertyDeclaration(node) ||
        ts.isFunctionDeclaration(node)) &&
        node.name != null &&
        ts.isIdentifier(node.name)) {
        return node.name;
    }
    return undefined;
}

/**
 * Returns information about the position in a document.
 * @param document
 * @param offset
 */
function getPositionContextInDocument(document, offset) {
    var text = document.virtualDocument.text;
    var stopChar = /[/=<>\s"${}():]/;
    var leftWord = grabWordInDirection({
        direction: "left",
        startOffset: offset,
        stopChar: stopChar,
        text: text
    });
    var rightWord = grabWordInDirection({
        direction: "right",
        startOffset: offset,
        stopChar: stopChar,
        text: text
    });
    var word = leftWord + rightWord;
    var beforeWord = text[Math.max(0, offset - leftWord.length - 1)];
    var afterWord = text[Math.min(text.length - 1, offset + rightWord.length)];
    return {
        offset: offset,
        text: text,
        word: word,
        leftWord: leftWord,
        rightWord: rightWord,
        beforeWord: beforeWord,
        afterWord: afterWord
    };
}
/**
 * Reads a word in a specific direction.
 * Stops if "stopChar" is encountered.
 * @param startPosition
 * @param stopChar
 * @param direction
 * @param text
 */
function grabWordInDirection(_a) {
    var startOffset = _a.startOffset, stopChar = _a.stopChar, direction = _a.direction, text = _a.text;
    var dir = direction === "left" ? -1 : 1;
    var curPosition = startOffset - (dir < 0 ? 1 : 0);
    while (curPosition > 0 && curPosition < text.length) {
        if (text[curPosition].match(stopChar))
            break;
        curPosition += dir;
        if (curPosition > text.length || curPosition < 0)
            return "";
    }
    var a = curPosition;
    var b = startOffset;
    return text.substring(Math.min(a, b) + (dir < 0 ? 1 : 0), Math.max(a, b));
}

function iterableMap(iterable, map) {
    var iterable_2, iterable_2_1, item, e_3_1;
    var e_3, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 5, 6, 7]);
                iterable_2 = __values(iterable), iterable_2_1 = iterable_2.next();
                _b.label = 1;
            case 1:
                if (!!iterable_2_1.done) return [3 /*break*/, 4];
                item = iterable_2_1.value;
                return [4 /*yield*/, map(item)];
            case 2:
                _b.sent();
                _b.label = 3;
            case 3:
                iterable_2_1 = iterable_2.next();
                return [3 /*break*/, 1];
            case 4: return [3 /*break*/, 7];
            case 5:
                e_3_1 = _b.sent();
                e_3 = { error: e_3_1 };
                return [3 /*break*/, 7];
            case 6:
                try {
                    if (iterable_2_1 && !iterable_2_1.done && (_a = iterable_2.return)) _a.call(iterable_2);
                }
                finally { if (e_3) throw e_3.error; }
                return [7 /*endfinally*/];
            case 7: return [2 /*return*/];
        }
    });
}
function iterableFilter(iterable, filter) {
    var iterable_3, iterable_3_1, item, e_4_1;
    var e_4, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 5, 6, 7]);
                iterable_3 = __values(iterable), iterable_3_1 = iterable_3.next();
                _b.label = 1;
            case 1:
                if (!!iterable_3_1.done) return [3 /*break*/, 4];
                item = iterable_3_1.value;
                if (!filter(item)) return [3 /*break*/, 3];
                return [4 /*yield*/, item];
            case 2:
                _b.sent();
                _b.label = 3;
            case 3:
                iterable_3_1 = iterable_3.next();
                return [3 /*break*/, 1];
            case 4: return [3 /*break*/, 7];
            case 5:
                e_4_1 = _b.sent();
                e_4 = { error: e_4_1 };
                return [3 /*break*/, 7];
            case 6:
                try {
                    if (iterable_3_1 && !iterable_3_1.done && (_a = iterable_3.return)) _a.call(iterable_3);
                }
                finally { if (e_4) throw e_4.error; }
                return [7 /*endfinally*/];
            case 7: return [2 /*return*/];
        }
    });
}
function iterableFind(iterable, match) {
    var e_5, _a;
    try {
        for (var iterable_4 = __values(iterable), iterable_4_1 = iterable_4.next(); !iterable_4_1.done; iterable_4_1 = iterable_4.next()) {
            var item = iterable_4_1.value;
            if (match(item)) {
                return item;
            }
        }
    }
    catch (e_5_1) { e_5 = { error: e_5_1 }; }
    finally {
        try {
            if (iterable_4_1 && !iterable_4_1.done && (_a = iterable_4.return)) _a.call(iterable_4);
        }
        finally { if (e_5) throw e_5.error; }
    }
    return;
}
function iterableDefined(iterable) {
    return iterable.filter(function (i) { return i != null; });
}
function iterableFirst(iterable) {
    if (iterable == null) {
        return iterable;
    }
    if (iterable instanceof Map || iterable instanceof Set) {
        return iterableFirst(iterable.values());
    }
    return iterable.next().value;
}

var LIT_HTML_PROP_ATTRIBUTE_MODIFIER = ".";
var LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER = "?";
var LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER = "@";
var LIT_HTML_ATTRIBUTE_MODIFIERS = [
    LIT_HTML_PROP_ATTRIBUTE_MODIFIER,
    LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER,
    LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER
];
var DIAGNOSTIC_SOURCE = "lit-plugin";
var TS_IGNORE_FLAG = "@ts-ignore";
var VERSION = "1.2.0-next.4";
var MAX_RUNNING_TIME_PER_OPERATION = 150; // Default to small timeouts. Opt in to larger timeouts where necessary.

function isHtmlMember(target) {
    return "kind" in target;
}
function isHtmlAttr(target) {
    return isHtmlMember(target) && target.kind === "attribute";
}
function isHtmlProp(target) {
    return isHtmlMember(target) && target.kind === "property";
}
function isHtmlEvent(target) {
    return !isHtmlMember(target);
}
function litAttributeModifierForTarget(target) {
    if (isHtmlAttr(target)) {
        if (tsSimpleType.isAssignableToSimpleTypeKind(target.getType(), "BOOLEAN")) {
            return LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER;
        }
        return "";
    }
    else if (isHtmlProp(target)) {
        return LIT_HTML_PROP_ATTRIBUTE_MODIFIER;
    }
    else {
        return LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER;
    }
}
function descriptionHeader(title, titleLevel, _a) {
    if (titleLevel === void 0) { titleLevel = 0; }
    var markdown = _a.markdown;
    return markdown ? (titleLevel === 0 ? "**" + title.trim() + "**" : "#".repeat(titleLevel) + " " + title) : title;
}
function descriptionListItem(item, _a) {
    var markdown = _a.markdown;
    return markdown ? " * " + item.replace("\n", " ") : " * " + item;
}
function descriptionList(title, items, toString, options) {
    var itemsDesc = items.map(function (item) { return descriptionListItem(toString(item), options); }).join("\n");
    return descriptionHeader(title + ":", 0, options) + "\n" + itemsDesc;
}
function documentationForCssPart(cssPart, options) {
    var relatedText = (function () {
        var _a;
        if ((((_a = cssPart.related) === null || _a === void 0 ? void 0 : _a.length) || 0) > 0) {
            return "From multiple elements: " + cssPart.related.map(function (p) { return "<" + p.fromTagName + ">"; }).join(", ");
        }
        else if (cssPart.fromTagName != null) {
            return "From: <" + cssPart.fromTagName + ">";
        }
        return undefined;
    })();
    return iterableDefined([cssPart.description, relatedText]).join("\n\n");
}
function documentationForCssProperty(cssProperty, options) {
    var relatedText = (function () {
        var _a;
        if ((((_a = cssProperty.related) === null || _a === void 0 ? void 0 : _a.length) || 0) > 0) {
            return "From multiple elements: " + cssProperty.related.map(function (p) { return "<" + p.fromTagName + ">"; }).join(", ");
        }
        else if (cssProperty.fromTagName != null) {
            return "From: <" + cssProperty.fromTagName + ">";
        }
        return undefined;
    })();
    return iterableDefined([cssProperty.description, cssProperty.typeHint, relatedText]).join("\n\n");
}
function documentationForHtmlTag(htmlTag, options) {
    if (options === void 0) { options = {}; }
    var desc = htmlTag.description || "";
    if (htmlTag.slots.length > 0) {
        var items = htmlTag.slots.sort(function (a, b) { return a.name.localeCompare(b.name); });
        desc += "\n\n" + descriptionList("Slots", items, function (slot) { return "" + descriptionHeader("@slot " + slot.name, 0, options) + (slot.description ? " - " + slot.description : ""); }, options);
    }
    if (htmlTag.events.length > 0) {
        var items = htmlTag.events.sort(function (a, b) { return a.name.localeCompare(b.name); });
        desc += "\n\n" + descriptionList("Events", items, function (event) { return "" + descriptionHeader("@fires " + event.name, 0, options) + (event.description ? " - " + event.description : ""); }, options);
    }
    return desc || undefined;
}
function documentationForTarget(target, options) {
    if (options === void 0) { options = {}; }
    var typeText = targetKindAndTypeText(target, options);
    var documentation = descriptionForTarget(target, options);
    return "" + typeText + (documentation != null ? " \n\n" + documentation : "");
}
function descriptionForTarget(target, options) {
    if (options === void 0) { options = {}; }
    if (target.related != null && target.related.length > 1) {
        var subDocumentation = target.related
            .map(function (t) { return "" + (t.fromTagName ? "<" + t.fromTagName + ">: " : "(global): ") + (t.description || "[no documentation]"); })
            .map(function (doc, i) { return i + 1 + ". " + doc; });
        return descriptionHeader("Multiple declarations (best match first):", 0, options) + "\n" + subDocumentation.join("\n");
    }
    return target.description;
}
function targetKindAndTypeText(target, options) {
    if (options === void 0) { options = {}; }
    var prefix = "(" + targetKindText(target) + ") " + (options.modifier || "") + target.name;
    if (tsSimpleType.isAssignableToSimpleTypeKind(target.getType(), "ANY")) {
        return "" + prefix;
    }
    return prefix + ": " + tsSimpleType.typeToString(target.getType());
}
function targetKindText(target) {
    if (isHtmlMember(target)) {
        return target.kind === "property" ? "property" : "attribute";
    }
    else if (isHtmlEvent(target)) {
        return "event";
    }
    return "unknown";
}
function mergeFirstUnique(items, uniqueOn) {
    var unique = new Set();
    return items.filter(function (item) {
        var identity = uniqueOn(item);
        if (!unique.has(identity)) {
            unique.add(identity);
            return true;
        }
        return false;
    });
}
function mergeHtmlAttrs(attrs) {
    return mergeFirstUnique(attrs, function (attr) { return attr.name; });
}
function mergeHtmlProps(props) {
    return mergeFirstUnique(props, function (prop) { return prop.name; });
}
function mergeHtmlEvents(events) {
    return mergeFirstUnique(events, function (event) { return event.name; });
}
function mergeHtmlSlots(slots) {
    return mergeFirstUnique(slots, function (event) { return event.name; });
}
function mergeCssParts(cssParts) {
    return mergeFirstUnique(cssParts, function (cssPart) { return cssPart.name; });
}
function mergeCssProperties(cssProperties) {
    return mergeFirstUnique(cssProperties, function (cssProp) { return cssProp.name; });
}
function mergeHtmlTags(tags) {
    var e_1, _a;
    var mergedTags = new Map();
    try {
        for (var tags_1 = __values(tags), tags_1_1 = tags_1.next(); !tags_1_1.done; tags_1_1 = tags_1.next()) {
            var tag = tags_1_1.value;
            var existingTag = mergedTags.get(tag.tagName);
            if (existingTag != null) {
                mergedTags.set(tag.tagName, __assign(__assign({}, tag), { builtIn: tag.builtIn || existingTag.builtIn, global: tag.global || existingTag.global, declaration: tag.declaration || existingTag.declaration, description: tag.description || existingTag.description, attributes: mergeHtmlAttrs(__spread(tag.attributes, existingTag.attributes)), properties: mergeHtmlProps(__spread(tag.properties, existingTag.properties)), events: mergeHtmlEvents(__spread(tag.events, existingTag.events)), slots: mergeHtmlSlots(__spread(tag.slots, existingTag.slots)) }));
            }
            else {
                mergedTags.set(tag.tagName, tag);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (tags_1_1 && !tags_1_1.done && (_a = tags_1.return)) _a.call(tags_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return Array.from(mergedTags.values());
}

/**
 * Parses an attribute name returning a name and eg. a modifier.
 * Examples:
 *  - ?disabled="..."
 *  - .myProp="..."
 *  - @click="..."
 * @param attributeName
 */
function parseLitAttrName(attributeName) {
    var _a = __read(attributeName.match(/^([.?@])?(.*)/) || ["", "", ""], 3), modifier = _a[1], name = _a[2];
    return { name: name, modifier: modifier };
}
function lazy(func) {
    var called = false;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    var value;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return (function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (called)
            return value;
        called = true;
        return (value = func.apply(void 0, __spread(args)));
    });
}

/**
 * Compares two strings case insensitive.
 * @param strA
 * @param strB
 */
function replacePrefix(str, prefix) {
    return str.replace(new RegExp("^" + escapeRegExp(prefix)), "");
}
function escapeRegExp(text) {
    return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
}

function makeVscTextDocument(cssDocument) {
    return vscode.TextDocument.create("untitled://embedded.css", "css", 1, cssDocument.virtualDocument.text);
}
var LitCssVscodeService = /** @class */ (function () {
    function LitCssVscodeService() {
        this.dataProvider = new LitVscodeCSSDataProvider();
    }
    Object.defineProperty(LitCssVscodeService.prototype, "cssService", {
        get: function () {
            return vscode.getCSSLanguageService({ customDataProviders: [this.dataProvider.provider] });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LitCssVscodeService.prototype, "scssService", {
        get: function () {
            return vscode.getSCSSLanguageService({ customDataProviders: [this.dataProvider.provider] });
        },
        enumerable: false,
        configurable: true
    });
    LitCssVscodeService.prototype.getDiagnostics = function (document, context) {
        if (isRuleDisabled(context.config, "no-invalid-css")) {
            return [];
        }
        this.dataProvider.update(context.htmlStore);
        var vscTextDocument = makeVscTextDocument(document);
        // Return nothing if this is a one liner css snippet.
        // Example: css`100px`
        if (!vscTextDocument.getText().includes("\n")) {
            return [];
        }
        var vscStylesheet = this.makeVscStylesheet(vscTextDocument);
        var diagnostics = this.scssService.doValidation(vscTextDocument, vscStylesheet);
        return diagnostics
            .filter(function (diagnostic) { return diagnostic.range.start.line !== 0 && diagnostic.range.start.line < vscTextDocument.lineCount - 1; })
            .map(function (diagnostic) {
            return ({
                severity: diagnostic.severity === vscode.DiagnosticSeverity.Error ? "error" : "warning",
                source: "no-invalid-css",
                location: documentRangeToSFRange(document, {
                    start: vscTextDocument.offsetAt(diagnostic.range.start),
                    end: vscTextDocument.offsetAt(diagnostic.range.end)
                }),
                message: diagnostic.message,
                file: context.currentFile
            });
        });
    };
    LitCssVscodeService.prototype.getQuickInfo = function (document, offset, context) {
        var e_1, _a;
        this.dataProvider.update(context.htmlStore);
        var vscTextDocument = makeVscTextDocument(document);
        var vscStylesheet = this.makeVscStylesheet(vscTextDocument);
        var vscPosition = vscTextDocument.positionAt(offset);
        var hover = this.scssService.doHover(vscTextDocument, vscPosition, vscStylesheet);
        if (hover == null || hover.range == null)
            return;
        var contents = Array.isArray(hover.contents) ? hover.contents : [hover.contents];
        var primaryInfo = undefined;
        var secondaryInfo = undefined;
        try {
            for (var contents_1 = __values(contents), contents_1_1 = contents_1.next(); !contents_1_1.done; contents_1_1 = contents_1.next()) {
                var content = contents_1_1.value;
                var text = typeof content === "string" ? content : content.value;
                if (typeof content === "object" && "language" in content) {
                    if (content.language === "html") {
                        primaryInfo = "" + (primaryInfo == null ? "" : "\n\n") + text;
                    }
                }
                else {
                    secondaryInfo = text;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (contents_1_1 && !contents_1_1.done && (_a = contents_1.return)) _a.call(contents_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return {
            primaryInfo: primaryInfo || "",
            secondaryInfo: secondaryInfo,
            range: documentRangeToSFRange(document, { start: vscTextDocument.offsetAt(hover.range.start), end: vscTextDocument.offsetAt(hover.range.end) })
        };
    };
    LitCssVscodeService.prototype.getCompletions = function (document, offset, context) {
        var e_2, _a, e_3, _b;
        this.dataProvider.update(context.htmlStore);
        var positionContext = getPositionContextInDocument(document, offset);
        // If there is ":" before the word, treat them like it's a part of the "leftWord", because ":" is a part of the name, but also a separator
        if (positionContext.beforeWord === ":") {
            positionContext.leftWord =
                ":" +
                    grabWordInDirection({
                        startOffset: offset - positionContext.leftWord.length - 1,
                        stopChar: /[^:]/,
                        direction: "left",
                        text: document.virtualDocument.text
                    }) +
                    positionContext.leftWord;
        }
        var vscTextDocument = makeVscTextDocument(document);
        var vscStylesheet = this.makeVscStylesheet(vscTextDocument);
        var vscPosition = vscTextDocument.positionAt(offset);
        var items = this.cssService.doComplete(vscTextDocument, vscPosition, vscStylesheet);
        // Get all completions from vscode html language service
        var completions = items.items.map(function (i) {
            return ({
                kind: i.kind == null ? "unknown" : translateCompletionItemKind(i.kind),
                name: i.label,
                insert: replacePrefix(i.label, positionContext.leftWord),
                kindModifiers: i.kind === vscode.CompletionItemKind.Color ? "color" : undefined,
                importance: i.label.startsWith("@") || i.label.startsWith("-") || i.label.startsWith(":") ? "low" : "medium",
                documentation: lazy(function () { return (typeof i.documentation === "string" || i.documentation == null ? i.documentation : i.documentation.value); })
            });
        });
        var _loop_1 = function (cssProp) {
            if (completions.some(function (c) { return c.name === cssProp.name; })) {
                return "continue";
            }
            completions.push({
                kind: "variableElement",
                name: cssProp.name,
                insert: replacePrefix(cssProp.name, positionContext.leftWord),
                importance: positionContext.leftWord.startsWith("-") ? "high" : "medium",
                documentation: lazy(function () { return documentationForCssProperty(cssProp); })
            });
        };
        try {
            // Add completions for css custom properties
            for (var _c = __values(context.htmlStore.getAllCssPropertiesForTag("")), _d = _c.next(); !_d.done; _d = _c.next()) {
                var cssProp = _d.value;
                _loop_1(cssProp);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_2) throw e_2.error; }
        }
        if (positionContext.beforeWord === "(") {
            // Get the name of the pseudo element
            var pseudoElementName = grabWordInDirection({
                startOffset: offset - positionContext.leftWord.length - 1,
                stopChar: /[^-A-Za-z]/,
                direction: "left",
                text: document.virtualDocument.text
            });
            // Add completions for css shadow parts
            if (pseudoElementName === "part") {
                var _loop_2 = function (cssPart) {
                    completions.push({
                        kind: "variableElement",
                        name: cssPart.name,
                        insert: replacePrefix(cssPart.name, positionContext.leftWord),
                        importance: "high",
                        documentation: lazy(function () { return documentationForCssPart(cssPart); })
                    });
                };
                try {
                    for (var _e = __values(context.htmlStore.getAllCssPartsForTag("")), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var cssPart = _f.value;
                        _loop_2(cssPart);
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
        }
        return completions;
    };
    LitCssVscodeService.prototype.makeVscStylesheet = function (vscTextDocument) {
        return this.scssService.parseStylesheet(vscTextDocument);
    };
    return LitCssVscodeService;
}());
function translateCompletionItemKind(kind) {
    switch (kind) {
        case vscode.CompletionItemKind.Method:
            return "memberFunctionElement";
        case vscode.CompletionItemKind.Function:
            return "functionElement";
        case vscode.CompletionItemKind.Constructor:
            return "constructorImplementationElement";
        case vscode.CompletionItemKind.Field:
        case vscode.CompletionItemKind.Variable:
            return "variableElement";
        case vscode.CompletionItemKind.Class:
            return "classElement";
        case vscode.CompletionItemKind.Interface:
            return "interfaceElement";
        case vscode.CompletionItemKind.Module:
            return "moduleElement";
        case vscode.CompletionItemKind.Property:
            return "memberVariableElement";
        case vscode.CompletionItemKind.Unit:
        case vscode.CompletionItemKind.Value:
            return "constElement";
        case vscode.CompletionItemKind.Enum:
            return "enumElement";
        case vscode.CompletionItemKind.Keyword:
            return "keyword";
        case vscode.CompletionItemKind.Color:
            return "constElement";
        case vscode.CompletionItemKind.Reference:
            return "alias";
        case vscode.CompletionItemKind.File:
            return "moduleElement";
        case vscode.CompletionItemKind.Snippet:
        case vscode.CompletionItemKind.Text:
        default:
            return "unknown";
    }
}
var LitVscodeCSSDataProvider = /** @class */ (function () {
    function LitVscodeCSSDataProvider() {
        var _this = this;
        this.pseudoElementData = [];
        this.customDataProvider = (function () {
            var provider = _this;
            return {
                providePseudoElements: function () {
                    return [
                        {
                            browsers: [],
                            description: "Unlike ::part, ::theme matches elements parts with that theme name, anywhere in the document.",
                            name: "::theme",
                            status: "nonstandard"
                        }
                    ];
                },
                provideAtDirectives: function () {
                    return [];
                },
                providePseudoClasses: function () {
                    return provider.pseudoElementData;
                },
                provideProperties: function () {
                    return [];
                }
            };
        })();
    }
    Object.defineProperty(LitVscodeCSSDataProvider.prototype, "provider", {
        get: function () {
            return this.customDataProvider;
        },
        enumerable: false,
        configurable: true
    });
    LitVscodeCSSDataProvider.prototype.update = function (htmlStore) {
        this.pseudoElementData = Array.from(iterableMap(iterableFilter(htmlStore.getGlobalTags(), function (tag) { return !tag.builtIn; }), function (tag) {
            return ({
                browsers: [],
                description: documentationForHtmlTag(tag),
                name: tag.tagName,
                status: "standard"
            });
        }));
    };
    return LitVscodeCSSDataProvider;
}());

var LitCssDocumentAnalyzer = /** @class */ (function () {
    function LitCssDocumentAnalyzer() {
        this.vscodeCssService = new LitCssVscodeService();
        this.completionsCache = [];
    }
    LitCssDocumentAnalyzer.prototype.getCompletionDetailsAtOffset = function (document, offset, name, context) {
        var completionWithName = this.completionsCache.find(function (completion) { return completion.name === name; });
        if (completionWithName == null || completionWithName.documentation == null)
            return undefined;
        var primaryInfo = completionWithName.documentation();
        if (primaryInfo == null)
            return undefined;
        return {
            name: name,
            kind: completionWithName.kind,
            primaryInfo: primaryInfo
        };
    };
    LitCssDocumentAnalyzer.prototype.getCompletionsAtOffset = function (document, offset, context) {
        this.completionsCache = this.vscodeCssService.getCompletions(document, offset, context);
        return this.completionsCache;
    };
    LitCssDocumentAnalyzer.prototype.getQuickInfoAtOffset = function (document, offset, context) {
        return this.vscodeCssService.getQuickInfo(document, offset, context);
    };
    LitCssDocumentAnalyzer.prototype.getDiagnostics = function (document, context) {
        return this.vscodeCssService.getDiagnostics(document, context);
    };
    LitCssDocumentAnalyzer.prototype.getDefinitionAtOffset = function (document, offset, context) {
        var e_1, _a;
        var positionContext = getPositionContextInDocument(document, offset);
        var word = positionContext.word;
        var start = offset - positionContext.leftWord.length;
        var end = start + word.length;
        // Return definitions for css custom properties
        if (word.startsWith("-")) {
            try {
                for (var _b = __values(context.htmlStore.getAllCssPropertiesForTag("")), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var cssProp = _c.value;
                    if (cssProp.name === word) {
                        var nodes = iterableDefined((cssProp.related != null ? cssProp.related : [cssProp]).map(function (p) { var _a, _b; return (_b = (_a = p.declaration) === null || _a === void 0 ? void 0 : _a.declaration) === null || _b === void 0 ? void 0 : _b.node; }));
                        if (nodes.length === 0) {
                            return;
                        }
                        return {
                            fromRange: documentRangeToSFRange(document, { start: start, end: end }),
                            target: nodes.map(function (node) { return ({
                                kind: "node",
                                node: getNodeIdentifier(node, context.ts) || node
                            }); })
                        };
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        // Return definitions for custom elements
        else {
            var definition = context.definitionStore.getDefinitionForTagName(word);
            if (definition != null && definition.declaration != null) {
                var node = definition.declaration.node;
                return {
                    fromRange: documentRangeToSFRange(document, { start: start, end: end }),
                    target: {
                        kind: "node",
                        node: getNodeIdentifier(node, context.ts) || node
                    }
                };
            }
        }
        return undefined;
    };
    return LitCssDocumentAnalyzer;
}());

var HtmlNodeAttrKind;
(function (HtmlNodeAttrKind) {
    HtmlNodeAttrKind["EVENT_LISTENER"] = "EVENT_LISTENER";
    HtmlNodeAttrKind["ATTRIBUTE"] = "ATTRIBUTE";
    HtmlNodeAttrKind["BOOLEAN_ATTRIBUTE"] = "BOOLEAN_ATTRIBUTE";
    HtmlNodeAttrKind["PROPERTY"] = "PROPERTY";
})(HtmlNodeAttrKind || (HtmlNodeAttrKind = {}));
function isHTMLAttr(obj) {
    return "name" in obj && "location" in obj && "htmlNode" in obj;
}

var HtmlNodeKind;
(function (HtmlNodeKind) {
    HtmlNodeKind["NODE"] = "NODE";
    HtmlNodeKind["SVG"] = "SVG";
    HtmlNodeKind["STYLE"] = "STYLE";
})(HtmlNodeKind || (HtmlNodeKind = {}));
function isHTMLNode(obj) {
    return "tagName" in obj && "location" in obj && "attributes" in obj;
}

(function (LitOutliningSpanKind) {
    LitOutliningSpanKind["Comment"] = "comment";
    LitOutliningSpanKind["Region"] = "region";
    LitOutliningSpanKind["Code"] = "code";
    LitOutliningSpanKind["Imports"] = "imports";
})(exports.LitOutliningSpanKind || (exports.LitOutliningSpanKind = {}));

function codeFixesForHtmlDocument(htmlDocument, range, context) {
    return arrayFlat(arrayDefined(context.rules
        .getDiagnosticsFromDocument(htmlDocument, context)
        .filter(function (_a) {
        var diagnostic = _a.diagnostic;
        return intersects(documentRangeToSFRange(htmlDocument, range), diagnostic.location);
    })
        .map(function (_a) {
        var _b;
        var diagnostic = _a.diagnostic;
        return (_b = diagnostic.fix) === null || _b === void 0 ? void 0 : _b.call(diagnostic);
    }))).map(function (ruleFix) { return converRuleFixToLitCodeFix(ruleFix); });
}

var HtmlNodeAttrAssignmentKind;
(function (HtmlNodeAttrAssignmentKind) {
    HtmlNodeAttrAssignmentKind["BOOLEAN"] = "BOOLEAN";
    HtmlNodeAttrAssignmentKind["EXPRESSION"] = "EXPRESSION";
    HtmlNodeAttrAssignmentKind["STRING"] = "STRING";
    HtmlNodeAttrAssignmentKind["MIXED"] = "MIXED";
})(HtmlNodeAttrAssignmentKind || (HtmlNodeAttrAssignmentKind = {}));

function completionsForHtmlAttrValues(htmlNodeAttr, location, _a) {
    var htmlStore = _a.htmlStore;
    // There is not point in showing completions for event listener bindings
    if (htmlNodeAttr.kind === HtmlNodeAttrKind.EVENT_LISTENER)
        return [];
    // Don't show completions inside assignments with expressions
    if (htmlNodeAttr.assignment && htmlNodeAttr.assignment.kind === HtmlNodeAttrAssignmentKind.EXPRESSION)
        return [];
    var htmlTagMember = htmlStore.getHtmlAttrTarget(htmlNodeAttr);
    if (htmlTagMember == null)
        return [];
    // Special case for handling slot attr as we need to look at its parent
    if (htmlNodeAttr.name === "slot") {
        var parentHtmlTag = htmlNodeAttr.htmlNode.parent && htmlStore.getHtmlTag(htmlNodeAttr.htmlNode.parent);
        if (parentHtmlTag != null && parentHtmlTag.slots.length > 0) {
            return parentHtmlTag.slots.map(function (slot) {
                return ({
                    name: slot.name || " ",
                    insert: slot.name || "",
                    documentation: function () { return slot.description; },
                    kind: "enumElement"
                });
            });
        }
    }
    var options = getOptionsFromType(htmlTagMember.getType());
    return options.map(function (option) {
        return ({
            name: option,
            insert: option,
            kind: "enumElement"
        });
    });
}
function getOptionsFromType(type) {
    switch (type.kind) {
        case "UNION":
            return type.types.filter(tsSimpleType.isSimpleTypeLiteral).map(function (t) { return t.value.toString(); });
        case "ENUM":
            return type.types
                .map(function (m) { return m.type; })
                .filter(tsSimpleType.isSimpleTypeLiteral)
                .map(function (t) { return t.value.toString(); });
        case "ALIAS":
            return getOptionsFromType(type.target);
    }
    return [];
}

function completionsForHtmlAttrs(htmlNode, location, _a) {
    var htmlStore = _a.htmlStore;
    var onTagName = htmlNode.tagName;
    // Code completions for ".[...]";
    if (location.word.startsWith(LIT_HTML_PROP_ATTRIBUTE_MODIFIER)) {
        var alreadyUsedPropNames_1 = htmlNode.attributes.filter(function (a) { return a.modifier === LIT_HTML_PROP_ATTRIBUTE_MODIFIER; }).map(function (a) { return a.name; });
        var unusedProps = iterableFilter(htmlStore.getAllPropertiesForTag(htmlNode), function (prop) { return !alreadyUsedPropNames_1.includes(prop.name); });
        return Array.from(iterableMap(unusedProps, function (prop) {
            return targetToCompletion(prop, {
                modifier: LIT_HTML_PROP_ATTRIBUTE_MODIFIER,
                onTagName: onTagName
            });
        }));
    }
    // Code completions for "?[...]";
    else if (location.word.startsWith(LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER)) {
        var alreadyUsedAttrNames_1 = htmlNode.attributes
            .filter(function (a) { return a.modifier === LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER || a.modifier == null; })
            .map(function (a) { return a.name; });
        var unusedAttrs_1 = iterableFilter(htmlStore.getAllAttributesForTag(htmlNode), function (prop) { return !alreadyUsedAttrNames_1.includes(prop.name); });
        var booleanAttributes = iterableFilter(unusedAttrs_1, function (prop) { return isAssignableToBoolean(prop.getType()); });
        return Array.from(iterableMap(booleanAttributes, function (attr) {
            return targetToCompletion(attr, {
                modifier: LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER,
                onTagName: onTagName
            });
        }));
    }
    // Code completions for "@[...]";
    else if (location.word.startsWith(LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER)) {
        var alreadyUsedEventNames_1 = htmlNode.attributes.filter(function (a) { return a.modifier === LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER; }).map(function (a) { return a.name; });
        var unusedEvents = iterableFilter(htmlStore.getAllEventsForTag(htmlNode), function (prop) { return !alreadyUsedEventNames_1.includes(prop.name); });
        return Array.from(iterableMap(unusedEvents, function (prop) {
            return targetToCompletion(prop, {
                modifier: LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER,
                onTagName: onTagName
            });
        }));
    }
    var alreadyUsedAttrNames = htmlNode.attributes.filter(function (a) { return a.modifier == null; }).map(function (a) { return a.name; });
    var unusedAttrs = iterableFilter(htmlStore.getAllAttributesForTag(htmlNode), function (prop) { return !alreadyUsedAttrNames.includes(prop.name); });
    return Array.from(iterableMap(unusedAttrs, function (prop) { return targetToCompletion(prop, { modifier: "", onTagName: onTagName }); }));
}
function isAssignableToBoolean(type, _a) {
    var matchAny = (_a === void 0 ? { matchAny: true } : _a).matchAny;
    return tsSimpleType.isAssignableToSimpleTypeKind(type, ["BOOLEAN", "BOOLEAN_LITERAL"], {
        matchAny: matchAny
    });
}
function targetToCompletion(target, _a) {
    var modifier = _a.modifier, insertModifier = _a.insertModifier, onTagName = _a.onTagName;
    if (modifier == null) {
        if (isHtmlAttr(target)) {
            if (isAssignableToBoolean(target.getType(), { matchAny: false })) {
                modifier = LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER;
            }
            else {
                modifier = "";
            }
        }
        else if (isHtmlProp(target)) {
            modifier = LIT_HTML_PROP_ATTRIBUTE_MODIFIER;
        }
        else if (isHtmlEvent(target)) {
            modifier = LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER;
        }
    }
    var isMember = onTagName && target.fromTagName === onTagName;
    var isBuiltIn = target.builtIn;
    return {
        name: "" + (modifier || "") + target.name + ("required" in target && target.required ? "!" : ""),
        insert: "" + (insertModifier ? modifier : "") + target.name,
        kind: isBuiltIn ? "enumElement" : isMember ? "member" : "label",
        importance: isBuiltIn ? "low" : isMember ? "high" : "medium",
        documentation: lazy(function () { return documentationForTarget(target, { modifier: modifier }); })
    };
}

/**
 * According to {@link https://html.spec.whatwg.org/multipage/syntax.html#attributes-2}, the following Unicode characters are illegal in an attribute name
 * @type {RegExp}
 */
var ILLEGAL_UNICODE_CHARACTERS = /[\u0020\u0022\u0027\u003E\u002F\u003D]/g;
/**
 * According to {@link https://infra.spec.whatwg.org/#noncharacter},
 * a noncharacter is a codepoint that matches any of the given unicode characters
 * @type {RegExp}
 */
var NONCHARACTERS = /[\uFFFF\uFFFE\uFDD1\uFDD2\uFDD3\uFDD4\uFDD5\uFDD6\uFDD7\uFDD8\uFDD9\uFDDA\uFDDB\uFDDC\uFDDD\uFDDE\uFDDF\uFDE0\uFDE1\uFDE2\uFDE3\uFDE4\uFDE5\uFDE6\uFDE7\uFDE8\uFDE9\uFDEA\uFDEB\uFDEC\uFDED\uFDEE\uFDEF]/g;
function hasOnlyValidCharacters(name) {
    return name.match(ILLEGAL_UNICODE_CHARACTERS) == null && name.match(NONCHARACTERS) == null;
}
/**
 * Returns true if the given input is a valid attribute name
 * @param {string} input
 * @return {boolean}
 */
function isValidAttributeName(input) {
    return hasOnlyValidCharacters(input);
}
/**
 * Returns true if the given input is a valid custom element name.
 * @param {string} input
 * @return {boolean}
 */
function isValidCustomElementName(input) {
    return input.includes("-") && input.toLowerCase() === input && hasOnlyValidCharacters(input);
}
function isCustomElementTagName(tagName) {
    return tagName.includes("-");
}

function completionsForHtmlNodes(document, intersectingClosestNode, _a, _b) {
    var offset = _a.offset, leftWord = _a.leftWord, rightWord = _a.rightWord, beforeWord = _a.beforeWord, afterWord = _a.afterWord;
    var htmlStore = _b.htmlStore;
    var isClosingTag = beforeWord === "/";
    // This case handles closing the closest intersecting node.
    // For this case we only suggest closing the closest intersecting node: so 1 single suggestion.
    // Example:   <my-element></|
    // This doesn't handle:   <my-element></my-el|ement> , because in that case we would like to show all options to the user.
    if (isClosingTag && leftWord === "" && rightWord === "" && afterWord !== ">" && intersectingClosestNode != null) {
        var insert = "</" + intersectingClosestNode.tagName + ">";
        return [
            {
                name: insert,
                insert: insert,
                kind: "enumElement",
                importance: "high",
                range: documentRangeToSFRange(document, {
                    start: offset - leftWord.length - 2,
                    end: offset + rightWord.length
                }),
                documentation: lazy(function () {
                    var htmlTag = htmlStore.getHtmlTag(intersectingClosestNode);
                    return htmlTag != null ? documentationForHtmlTag(htmlTag) : undefined;
                })
            }
        ];
    }
    var htmlTags = Array.from(htmlStore.getGlobalTags());
    return htmlTags.map(function (htmlTag) {
        var isBuiltIn = !isCustomElementTagName(htmlTag.tagName);
        var hasDeclaration = htmlTag.declaration != null;
        var insert = isClosingTag ? "</" + htmlTag.tagName + ">" : htmlTag.tagName;
        return {
            name: insert,
            insert: insert,
            kind: isBuiltIn ? "enumElement" : hasDeclaration ? "member" : "label",
            importance: isBuiltIn ? "low" : hasDeclaration ? "high" : "medium",
            range: documentRangeToSFRange(document, {
                start: offset - leftWord.length - (isClosingTag ? 2 : 0),
                end: offset + rightWord.length + (isClosingTag && afterWord === ">" ? 1 : 0)
            }),
            documentation: lazy(function () { return documentationForHtmlTag(htmlTag); })
        };
    });
}

function completionsAtOffset(document, offset, context) {
    var positionContext = getPositionContextInDocument(document, offset);
    var beforeWord = positionContext.beforeWord;
    // Get possible intersecting html attribute or attribute area.
    var intersectingAttr = document.htmlAttrNameAtOffset(offset);
    var intersectingAttrAreaNode = document.htmlAttrAreaAtOffset(offset);
    var intersectingAttrAssignment = document.htmlAttrAssignmentAtOffset(offset);
    var intersectingClosestNode = document.htmlNodeClosestToOffset(offset);
    // Get entries from the extensions
    if (intersectingAttr != null) {
        var entries = completionsForHtmlAttrs(intersectingAttr.htmlNode, positionContext, context);
        // Make sure that every entry overwrites the entire attribute name.
        return entries.map(function (entry) { return (__assign(__assign({}, entry), { range: rangeFromHtmlNodeAttr(intersectingAttr) })); });
    }
    else if (intersectingAttrAssignment != null) {
        return completionsForHtmlAttrValues(intersectingAttrAssignment, positionContext, context);
    }
    else if (intersectingAttrAreaNode != null) {
        return completionsForHtmlAttrs(intersectingAttrAreaNode, positionContext, context);
    }
    else if (beforeWord === "<" || beforeWord === "/") {
        return completionsForHtmlNodes(document, intersectingClosestNode, positionContext, context);
    }
    return [];
}

function definitionForHtmlAttr(htmlAttr, _a) {
    var htmlStore = _a.htmlStore, ts = _a.ts;
    var target = htmlStore.getHtmlAttrTarget(htmlAttr);
    if (target == null)
        return undefined;
    if (isHtmlMember(target) && target.declaration != null) {
        var node = target.declaration.node;
        return {
            fromRange: rangeFromHtmlNodeAttr(htmlAttr),
            target: {
                kind: "node",
                node: getNodeIdentifier(node, ts) || node
            }
        };
    }
    else if (isHtmlEvent(target) && target.declaration != null) {
        var node = target.declaration.node;
        return {
            fromRange: rangeFromHtmlNodeAttr(htmlAttr),
            target: {
                kind: "node",
                node: getNodeIdentifier(node, ts) || node
            }
        };
    }
    return;
}

function definitionForHtmlNode(htmlNode, _a) {
    var htmlStore = _a.htmlStore, ts = _a.ts;
    var tag = htmlStore.getHtmlTag(htmlNode);
    if (tag == null || tag.declaration == null)
        return undefined;
    var node = tag.declaration.node;
    return {
        fromRange: rangeFromHtmlNode(htmlNode),
        target: {
            kind: "node",
            node: getNodeIdentifier(node, ts) || node
        }
    };
}

function validateHTMLDocument(htmlDocument, context) {
    return context.rules.getDiagnosticsFromDocument(htmlDocument, context).map(function (d) { return convertRuleDiagnosticToLitDiagnostic(d, context); });
}

function textPartsToRanges(parts) {
    var offset = 0;
    return parts
        .map(function (p) {
        if (typeof p === "string") {
            var startOffset = offset;
            offset += p.length;
            return {
                start: startOffset,
                end: offset
            };
        }
        else {
            offset += p.getText().length + 3;
        }
        return;
    })
        .filter(function (r) { return r != null; });
}

var htmlService = vscode$1.getLanguageService();
function makeVscTextDocument$1(htmlDocument) {
    return vscode$1.TextDocument.create("untitled://embedded.html", "html", 1, htmlDocument.virtualDocument.text);
}
function makeVscHtmlDocument(vscTextDocument) {
    return htmlService.parseHTMLDocument(vscTextDocument);
}
var LitHtmlVscodeService = /** @class */ (function () {
    function LitHtmlVscodeService() {
    }
    LitHtmlVscodeService.prototype.getClosingTagAtOffset = function (document, offset) {
        var vscTextDocument = makeVscTextDocument$1(document);
        var vscHtmlDocument = makeVscHtmlDocument(vscTextDocument);
        var htmlLSPosition = vscTextDocument.positionAt(offset);
        var tagComplete = htmlService.doTagComplete(vscTextDocument, htmlLSPosition, vscHtmlDocument);
        if (tagComplete == null)
            return;
        // Html returns completions with snippet placeholders. Strip these out.
        return {
            newText: tagComplete.replace(/\$\d/g, "")
        };
    };
    LitHtmlVscodeService.prototype.format = function (document, settings) {
        var parts = document.virtualDocument.getPartsAtDocumentRange(makeDocumentRange({
            start: 0,
            end: document.virtualDocument.location.end - document.virtualDocument.location.start
        }));
        var ranges = textPartsToRanges(parts);
        var originalHtml = parts.map(function (p) { return (typeof p === "string" ? p : "[#" + "#".repeat(p.getText().length) + "]"); }).join("");
        var vscTextDocument = vscode$1.TextDocument.create("untitled://embedded.html", "html", 1, originalHtml);
        var edits = htmlService.format(vscTextDocument, undefined, {
            tabSize: settings.tabSize,
            insertSpaces: !!settings.convertTabsToSpaces,
            wrapLineLength: 90,
            unformatted: "",
            contentUnformatted: "pre,code,textarea",
            indentInnerHtml: true,
            preserveNewLines: true,
            maxPreserveNewLines: undefined,
            indentHandlebars: false,
            endWithNewline: false,
            extraLiners: "head, body, /html",
            wrapAttributes: "auto"
        });
        var hasLeadingNewline = originalHtml.startsWith("\n");
        var hasTrailingNewline = originalHtml.endsWith("\n");
        var newHtml = "" + (hasLeadingNewline ? "\n" : "") + vscode$1.TextDocument.applyEdits(vscTextDocument, edits) + (hasTrailingNewline ? "\n" : "");
        var splitted = newHtml.split(/\[#+\]/);
        return splitted.map(function (newText, i) {
            var range = ranges[i];
            return { range: documentRangeToSFRange(document, range), newText: newText };
        });
    };
    return LitHtmlVscodeService;
}());

function quickInfoForHtmlAttr(htmlAttr, _a) {
    var htmlStore = _a.htmlStore;
    var target = htmlStore.getHtmlAttrTarget(htmlAttr);
    if (target == null)
        return undefined;
    return {
        range: rangeFromHtmlNodeAttr(htmlAttr),
        primaryInfo: targetKindAndTypeText(target, { modifier: htmlAttr.modifier }),
        secondaryInfo: descriptionForTarget(target, { markdown: true })
    };
}

function quickInfoForHtmlNode(htmlNode, _a) {
    var htmlStore = _a.htmlStore;
    var htmlTag = htmlStore.getHtmlTag(htmlNode);
    if (htmlTag == null)
        return undefined;
    return {
        range: rangeFromHtmlNode(htmlNode),
        primaryInfo: "<" + htmlNode.tagName + ">",
        secondaryInfo: documentationForHtmlTag(htmlTag, { markdown: true })
    };
}

var TextDocument = /** @class */ (function () {
    function TextDocument(virtualDocument) {
        this.virtualDocument = virtualDocument;
    }
    return TextDocument;
}());

var HtmlDocument = /** @class */ (function (_super) {
    __extends(HtmlDocument, _super);
    function HtmlDocument(virtualDocument, rootNodes) {
        var _this = _super.call(this, virtualDocument) || this;
        _this.rootNodes = rootNodes;
        return _this;
    }
    HtmlDocument.prototype.htmlAttrAreaAtOffset = function (offset) {
        return this.mapFindOne(function (node) {
            var e_1, _a;
            if (offset > node.location.name.end && intersects(offset, node.location.startTag)) {
                try {
                    // Check if the position intersects any attributes. Break if so.
                    for (var _b = __values(node.attributes), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var htmlAttr = _c.value;
                        if (intersects(offset, htmlAttr.location)) {
                            return undefined;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return node;
            }
            return;
        });
    };
    HtmlDocument.prototype.htmlAttrAssignmentAtOffset = function (offset) {
        return this.findAttr(function (attr) {
            return attr.assignment != null && attr.assignment.location != null ? intersects(offset, attr.assignment.location) : false;
        });
    };
    HtmlDocument.prototype.htmlAttrNameAtOffset = function (offset) {
        return this.findAttr(function (attr) { return intersects(offset, attr.location.name); });
    };
    HtmlDocument.prototype.htmlNodeNameAtOffset = function (offset) {
        return this.findNode(function (node) { return intersects(offset, node.location.name) || (node.location.endTag != null && intersects(offset, node.location.endTag)); });
    };
    HtmlDocument.prototype.htmlNodeOrAttrAtOffset = function (offset) {
        var htmlNode = this.htmlNodeNameAtOffset(offset);
        if (htmlNode != null)
            return htmlNode;
        var htmlAttr = this.htmlAttrNameAtOffset(offset);
        if (htmlAttr != null)
            return htmlAttr;
        return;
    };
    /**
     * Finds the closest node to offset.
     * This method can be used to find out which tag to close in the HTML.
     * @param offset
     */
    HtmlDocument.prototype.htmlNodeClosestToOffset = function (offset) {
        var closestNode = undefined;
        // Use 'findNode' to iterate nodes. Keep track of the closest node.
        this.findNode(function (node) {
            if (offset < node.location.startTag.end) {
                // Break as soon as we find a node that starts AFTER the offset.
                // The closestNode would now be the previous found node.
                return true;
            }
            else if (node.location.endTag == null || offset < node.location.endTag.end) {
                // Save closest node if the node doesn't have an end tag of the node ends AFTER the offset.
                closestNode = node;
            }
            return false;
        });
        return closestNode;
    };
    HtmlDocument.prototype.findAttr = function (test) {
        return this.mapFindOne(function (node) {
            var e_2, _a;
            try {
                for (var _b = __values(node.attributes), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var attr = _c.value;
                    if (test(attr))
                        return attr;
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return;
        });
    };
    HtmlDocument.prototype.findNode = function (test) {
        return this.mapFindOne(function (node) {
            if (test(node))
                return node;
            return;
        });
    };
    HtmlDocument.prototype.mapNodes = function (map) {
        var items = [];
        function childrenLoop(node) {
            items.push(map(node));
            node.children.forEach(function (childNode) { return childrenLoop(childNode); });
        }
        this.rootNodes.forEach(function (rootNode) { return childrenLoop(rootNode); });
        return items;
    };
    HtmlDocument.prototype.mapFindOne = function (map) {
        var e_3, _a;
        function innerTest(node) {
            var e_4, _a;
            var res = map(node);
            if (res)
                return res;
            try {
                for (var _b = __values(node.children || []), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var childNode = _c.value;
                    var found = innerTest(childNode);
                    if (found != null)
                        return found;
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_4) throw e_4.error; }
            }
            return;
        }
        try {
            for (var _b = __values(this.rootNodes || []), _c = _b.next(); !_c.done; _c = _b.next()) {
                var rootNode = _c.value;
                var found = innerTest(rootNode);
                if (found != null) {
                    return found;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return;
    };
    return HtmlDocument;
}(TextDocument));

function renameLocationsForTagName(tagName, context) {
    var e_1, _a, e_2, _b;
    var locations = [];
    try {
        for (var _c = __values(context.program.getSourceFiles()), _d = _c.next(); !_d.done; _d = _c.next()) {
            var sourceFile = _d.value;
            var documents = context.documentStore.getDocumentsInFile(sourceFile, context.config);
            var _loop_1 = function (document) {
                if (document instanceof HtmlDocument) {
                    document.rootNodes.forEach(function (rootNode) {
                        return visitHtmlNode(rootNode, {
                            document: document,
                            tagName: tagName,
                            emitRenameLocation: function (location) {
                                locations.push(location);
                            }
                        });
                    });
                }
            };
            try {
                for (var documents_1 = (e_2 = void 0, __values(documents)), documents_1_1 = documents_1.next(); !documents_1_1.done; documents_1_1 = documents_1.next()) {
                    var document = documents_1_1.value;
                    _loop_1(document);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (documents_1_1 && !documents_1_1.done && (_b = documents_1.return)) _b.call(documents_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var definition = context.definitionStore.getDefinitionForTagName(tagName);
    if (definition != null) {
        // TODO
        var definitionNode = iterableFirst(definition.tagNameNodes);
        if (definitionNode != null) {
            var fileName = definitionNode.getSourceFile().fileName;
            if (context.ts.isCallLikeExpression(definitionNode)) {
                var stringLiteralNode = findChild(definitionNode, function (child) { return context.ts.isStringLiteralLike(child) && child.text === tagName; });
                if (stringLiteralNode != null) {
                    locations.push({
                        fileName: fileName,
                        range: makeSourceFileRange({ start: stringLiteralNode.getStart() + 1, end: stringLiteralNode.getEnd() - 1 })
                    });
                }
            }
            else if (definitionNode.kind === context.ts.SyntaxKind.JSDocTag) {
                var jsDocTagNode = definitionNode;
                if (jsDocTagNode.comment != null) {
                    var start = jsDocTagNode.tagName.getEnd() + 1;
                    locations.push({
                        fileName: fileName,
                        range: makeSourceFileRange({ start: start, end: start + jsDocTagNode.comment.length })
                    });
                }
            }
            else if (context.ts.isInterfaceDeclaration(definitionNode)) {
                var stringLiteralNode = findChild(definitionNode, function (child) { return context.ts.isStringLiteralLike(child) && child.text === tagName; });
                if (stringLiteralNode != null) {
                    locations.push({
                        fileName: fileName,
                        range: makeSourceFileRange({ start: stringLiteralNode.getStart() + 1, end: stringLiteralNode.getEnd() - 1 })
                    });
                }
            }
        }
    }
    return locations;
}
function visitHtmlNode(node, context) {
    if (node.tagName === context.tagName) {
        context.emitRenameLocation({
            range: documentRangeToSFRange(context.document, node.location.name),
            fileName: context.document.virtualDocument.fileName
        });
        if (node.location.endTag != null) {
            var _a = node.location.endTag, start = _a.start, end = _a.end;
            context.emitRenameLocation({
                range: documentRangeToSFRange(context.document, { start: start + 2, end: end - 1 }),
                fileName: context.document.virtualDocument.fileName
            });
        }
    }
    node.children.forEach(function (childNode) { return visitHtmlNode(childNode, context); });
}

function renameLocationsAtOffset(document, offset, context) {
    var hit = document.htmlNodeOrAttrAtOffset(offset);
    if (hit == null)
        return [];
    if (isHTMLNode(hit)) {
        return renameLocationsForTagName(hit.tagName, context);
    }
    return [];
}

var LitHtmlDocumentAnalyzer = /** @class */ (function () {
    function LitHtmlDocumentAnalyzer() {
        this.vscodeHtmlService = new LitHtmlVscodeService();
        this.completionsCache = [];
    }
    LitHtmlDocumentAnalyzer.prototype.getCompletionDetailsAtOffset = function (document, offset, name, context) {
        var completionWithName = this.completionsCache.find(function (completion) { return completion.name === name; });
        if (completionWithName == null || completionWithName.documentation == null)
            return undefined;
        var primaryInfo = completionWithName.documentation();
        if (primaryInfo == null)
            return undefined;
        return {
            name: name,
            kind: completionWithName.kind,
            primaryInfo: primaryInfo
        };
    };
    LitHtmlDocumentAnalyzer.prototype.getCompletionsAtOffset = function (document, offset, context) {
        this.completionsCache = completionsAtOffset(document, offset, context);
        return completionsAtOffset(document, offset, context);
    };
    LitHtmlDocumentAnalyzer.prototype.getDiagnostics = function (document, context) {
        return validateHTMLDocument(document, context);
    };
    LitHtmlDocumentAnalyzer.prototype.getClosingTagAtOffset = function (document, offset) {
        return this.vscodeHtmlService.getClosingTagAtOffset(document, offset);
    };
    LitHtmlDocumentAnalyzer.prototype.getCodeFixesAtOffsetRange = function (document, offsetRange, context) {
        var hit = document.htmlNodeOrAttrAtOffset(offsetRange);
        if (hit == null)
            return [];
        return codeFixesForHtmlDocument(document, offsetRange, context);
    };
    LitHtmlDocumentAnalyzer.prototype.getDefinitionAtOffset = function (document, offset, context) {
        var hit = document.htmlNodeOrAttrAtOffset(offset);
        if (hit == null)
            return undefined;
        if (isHTMLNode(hit)) {
            return definitionForHtmlNode(hit, context);
        }
        else if (isHTMLAttr(hit)) {
            return definitionForHtmlAttr(hit, context);
        }
        return;
    };
    LitHtmlDocumentAnalyzer.prototype.getRenameInfoAtOffset = function (document, offset, context) {
        var hit = document.htmlNodeOrAttrAtOffset(offset);
        if (hit == null)
            return undefined;
        if (isHTMLNode(hit)) {
            return {
                kind: "memberVariableElement",
                fullDisplayName: hit.tagName,
                displayName: hit.tagName,
                range: documentRangeToSFRange(document, __assign({}, hit.location.name)),
                document: document,
                target: hit
            };
        }
        return;
    };
    LitHtmlDocumentAnalyzer.prototype.getRenameLocationsAtOffset = function (document, offset, context) {
        return renameLocationsAtOffset(document, offset, context);
    };
    LitHtmlDocumentAnalyzer.prototype.getQuickInfoAtOffset = function (document, offset, context) {
        var hit = document.htmlNodeOrAttrAtOffset(offset);
        if (hit == null)
            return undefined;
        if (isHTMLNode(hit)) {
            return quickInfoForHtmlNode(hit, context);
        }
        if (isHTMLAttr(hit)) {
            return quickInfoForHtmlAttr(hit, context);
        }
        return;
    };
    LitHtmlDocumentAnalyzer.prototype.getOutliningSpans = function (document) {
        return iterableDefined(document.mapNodes(function (node) {
            if (node.location.endTag == null)
                return undefined;
            // Calculate last index of the collapsed span.
            // We don't want to include the last line because it will include the </endtag> in the collapsed region
            var endIndex = (function () {
                var lastChild = node.children[node.children.length - 1];
                if (lastChild != null) {
                    return lastChild.location.endTag != null ? lastChild.location.endTag.start : lastChild.location.startTag.end;
                }
                return node.location.endTag.start;
            })();
            return {
                autoCollapse: false,
                bannerText: node.tagName,
                kind: exports.LitOutliningSpanKind.Code,
                location: documentRangeToSFRange(document, { start: node.location.startTag.end, end: endIndex })
            };
        }));
    };
    LitHtmlDocumentAnalyzer.prototype.getFormatEdits = function (document, settings) {
        return this.vscodeHtmlService.format(document, settings);
    };
    return LitHtmlDocumentAnalyzer;
}());

var CssDocument = /** @class */ (function (_super) {
    __extends(CssDocument, _super);
    function CssDocument(virtualDocument) {
        return _super.call(this, virtualDocument) || this;
    }
    return CssDocument;
}(TextDocument));

var LitAnalyzer = /** @class */ (function () {
    function LitAnalyzer(context) {
        this.context = context;
        this.litHtmlDocumentAnalyzer = new LitHtmlDocumentAnalyzer();
        this.litCssDocumentAnalyzer = new LitCssDocumentAnalyzer();
        this.componentAnalyzer = new ComponentAnalyzer();
        // Set the Typescript module
        // I plan on removing this function, so only "context.ts" is used.
        setTypescriptModule(context.ts);
    }
    LitAnalyzer.prototype.getSupportedCodeFixes = function () {
        return Object.values(RULE_ID_CODE_MAP).map(String);
    };
    LitAnalyzer.prototype.getOutliningSpansInFile = function (file) {
        var _this = this;
        this.context.setContextBase({ file: file });
        var documents = this.getDocumentsInFile(file);
        this.context.updateComponents(file);
        return arrayFlat(documents.map(function (document) {
            if (document instanceof CssDocument) {
                return [];
            }
            else if (document instanceof HtmlDocument) {
                return _this.litHtmlDocumentAnalyzer.getOutliningSpans(document);
            }
            return [];
        }));
    };
    LitAnalyzer.prototype.getDefinitionAtPosition = function (file, position) {
        this.context.setContextBase({ file: file });
        var _a = this.getDocumentAndOffsetAtPosition(file, position), document = _a.document, offset = _a.offset;
        if (document == null)
            return undefined;
        this.context.updateComponents(file);
        if (document instanceof CssDocument) {
            return this.litCssDocumentAnalyzer.getDefinitionAtOffset(document, offset, this.context);
        }
        else if (document instanceof HtmlDocument) {
            return this.litHtmlDocumentAnalyzer.getDefinitionAtOffset(document, offset, this.context);
        }
        return;
    };
    LitAnalyzer.prototype.getQuickInfoAtPosition = function (file, position) {
        this.context.setContextBase({ file: file });
        var _a = this.getDocumentAndOffsetAtPosition(file, position), document = _a.document, offset = _a.offset;
        if (document == null)
            return undefined;
        this.context.updateComponents(file);
        if (document instanceof CssDocument) {
            return this.litCssDocumentAnalyzer.getQuickInfoAtOffset(document, offset, this.context);
        }
        else if (document instanceof HtmlDocument) {
            return this.litHtmlDocumentAnalyzer.getQuickInfoAtOffset(document, offset, this.context);
        }
        return;
    };
    LitAnalyzer.prototype.getRenameInfoAtPosition = function (file, position) {
        this.context.setContextBase({ file: file });
        var _a = this.getDocumentAndOffsetAtPosition(file, position), document = _a.document, offset = _a.offset;
        if (document != null) {
            if (document instanceof CssDocument) {
                return undefined;
            }
            else if (document instanceof HtmlDocument) {
                return this.litHtmlDocumentAnalyzer.getRenameInfoAtOffset(document, offset, this.context);
            }
        }
        else {
            var nodeUnderCursor = getNodeAtPosition(file, position);
            if (nodeUnderCursor == null)
                return undefined;
            if (this.context.ts.isStringLiteralLike(nodeUnderCursor)) {
                var tagName = nodeUnderCursor.text;
                var definition = this.context.definitionStore.getDefinitionForTagName(tagName);
                if (definition != null && nodeIntersects(nodeUnderCursor, iterableFirst(definition.tagNameNodes))) {
                    return {
                        fullDisplayName: tagName,
                        displayName: tagName,
                        range: makeSourceFileRange({ start: nodeUnderCursor.getStart() + 1, end: nodeUnderCursor.getEnd() - 1 }),
                        kind: "label",
                        target: definition
                    };
                }
            }
        }
        return;
    };
    LitAnalyzer.prototype.getRenameLocationsAtPosition = function (file, position) {
        this.context.setContextBase({ file: file });
        var renameInfo = this.getRenameInfoAtPosition(file, position);
        if (renameInfo == null)
            return [];
        if ("document" in renameInfo) {
            var document = renameInfo.document;
            var offset = document.virtualDocument.sfPositionToDocumentOffset(position);
            if (document instanceof CssDocument) {
                return [];
            }
            else {
                return this.litHtmlDocumentAnalyzer.getRenameLocationsAtOffset(document, offset, this.context);
            }
        }
        else {
            return renameLocationsForTagName(renameInfo.target.tagName, this.context);
        }
    };
    LitAnalyzer.prototype.getClosingTagAtPosition = function (file, position) {
        this.context.setContextBase({ file: file });
        var _a = this.getDocumentAndOffsetAtPosition(file, position), document = _a.document, offset = _a.offset;
        if (document == null)
            return undefined;
        this.context.updateComponents(file);
        if (document instanceof HtmlDocument) {
            return this.litHtmlDocumentAnalyzer.getClosingTagAtOffset(document, offset);
        }
        return;
    };
    LitAnalyzer.prototype.getCompletionDetailsAtPosition = function (file, position, name) {
        this.context.setContextBase({ file: file });
        var _a = this.getDocumentAndOffsetAtPosition(file, position), document = _a.document, offset = _a.offset;
        if (document == null)
            return undefined;
        if (document instanceof CssDocument) {
            return this.litCssDocumentAnalyzer.getCompletionDetailsAtOffset(document, offset, name, this.context);
        }
        else if (document instanceof HtmlDocument) {
            return this.litHtmlDocumentAnalyzer.getCompletionDetailsAtOffset(document, offset, name, this.context);
        }
        return;
    };
    LitAnalyzer.prototype.getCompletionsAtPosition = function (file, position) {
        this.context.setContextBase({ file: file });
        var _a = this.getDocumentAndOffsetAtPosition(file, position), document = _a.document, offset = _a.offset;
        if (document == null)
            return undefined;
        this.context.updateComponents(file);
        if (document instanceof CssDocument) {
            return this.litCssDocumentAnalyzer.getCompletionsAtOffset(document, offset, this.context);
        }
        else if (document instanceof HtmlDocument) {
            return this.litHtmlDocumentAnalyzer.getCompletionsAtOffset(document, offset, this.context);
        }
        return;
    };
    LitAnalyzer.prototype.getDiagnosticsInFile = function (file) {
        var e_1, _a, e_2, _b, e_3, _c;
        this.context.setContextBase({ file: file, timeout: 7000, throwOnCancellation: true });
        this.context.updateComponents(file);
        this.context.updateDependencies(file);
        var documents = this.getDocumentsInFile(file);
        var diagnostics = [];
        // Get diagnostics for components definitions in this file
        var definitions = this.context.definitionStore.getDefinitionsWithDeclarationInFile(file);
        try {
            for (var definitions_1 = __values(definitions), definitions_1_1 = definitions_1.next(); !definitions_1_1.done; definitions_1_1 = definitions_1.next()) {
                var definition = definitions_1_1.value;
                if (this.context.isCancellationRequested) {
                    break;
                }
                diagnostics.push.apply(diagnostics, __spread(this.componentAnalyzer.getDiagnostics(definition, this.context)));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (definitions_1_1 && !definitions_1_1.done && (_a = definitions_1.return)) _a.call(definitions_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        // Get diagnostics for components in this file
        var declarations = this.context.definitionStore.getComponentDeclarationsInFile(file);
        try {
            for (var declarations_1 = __values(declarations), declarations_1_1 = declarations_1.next(); !declarations_1_1.done; declarations_1_1 = declarations_1.next()) {
                var declaration = declarations_1_1.value;
                if (this.context.isCancellationRequested) {
                    break;
                }
                diagnostics.push.apply(diagnostics, __spread(this.componentAnalyzer.getDiagnostics(declaration, this.context)));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (declarations_1_1 && !declarations_1_1.done && (_b = declarations_1.return)) _b.call(declarations_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        try {
            // Get diagnostics for documents in this file
            for (var documents_1 = __values(documents), documents_1_1 = documents_1.next(); !documents_1_1.done; documents_1_1 = documents_1.next()) {
                var document = documents_1_1.value;
                if (this.context.isCancellationRequested) {
                    break;
                }
                if (document instanceof CssDocument) {
                    diagnostics.push.apply(diagnostics, __spread(this.litCssDocumentAnalyzer.getDiagnostics(document, this.context)));
                }
                else if (document instanceof HtmlDocument) {
                    diagnostics.push.apply(diagnostics, __spread(this.litHtmlDocumentAnalyzer.getDiagnostics(document, this.context)));
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (documents_1_1 && !documents_1_1.done && (_c = documents_1.return)) _c.call(documents_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return diagnostics;
    };
    LitAnalyzer.prototype.getCodeFixesAtPositionRange = function (file, sourceFileRange) {
        var e_4, _a, e_5, _b;
        this.context.setContextBase({ file: file });
        var document = this.getDocumentAndOffsetAtPosition(file, sourceFileRange.start).document;
        this.context.updateComponents(file);
        this.context.updateDependencies(file);
        // Return fixes for intersecting document
        if (document instanceof HtmlDocument) {
            return this.litHtmlDocumentAnalyzer.getCodeFixesAtOffsetRange(document, sfRangeToDocumentRange(document, sourceFileRange), this.context);
        }
        // Else, return fixes for components in this file
        else {
            var definitions = this.context.definitionStore.getDefinitionsWithDeclarationInFile(file);
            try {
                for (var definitions_2 = __values(definitions), definitions_2_1 = definitions_2.next(); !definitions_2_1.done; definitions_2_1 = definitions_2.next()) {
                    var definition = definitions_2_1.value;
                    var result = this.componentAnalyzer.getCodeFixesAtOffsetRange(definition, makeSourceFileRange(sourceFileRange), this.context);
                    if (result.length > 0) {
                        return result;
                    }
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (definitions_2_1 && !definitions_2_1.done && (_a = definitions_2.return)) _a.call(definitions_2);
                }
                finally { if (e_4) throw e_4.error; }
            }
            var components = this.context.definitionStore.getComponentDeclarationsInFile(file);
            try {
                for (var components_1 = __values(components), components_1_1 = components_1.next(); !components_1_1.done; components_1_1 = components_1.next()) {
                    var component = components_1_1.value;
                    var result = this.componentAnalyzer.getCodeFixesAtOffsetRange(component, makeSourceFileRange(sourceFileRange), this.context);
                    if (result.length > 0) {
                        return result;
                    }
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (components_1_1 && !components_1_1.done && (_b = components_1.return)) _b.call(components_1);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        return [];
    };
    LitAnalyzer.prototype.getFormatEditsInFile = function (file, settings) {
        var _this = this;
        this.context.setContextBase({ file: file });
        var documents = this.getDocumentsInFile(file);
        return arrayFlat(documents.map(function (document) {
            if (document instanceof CssDocument) {
                return [];
            }
            else if (document instanceof HtmlDocument) {
                return _this.litHtmlDocumentAnalyzer.getFormatEdits(document, settings);
            }
            return [];
        }));
    };
    LitAnalyzer.prototype.getDocumentAndOffsetAtPosition = function (sourceFile, position) {
        var document = this.context.documentStore.getDocumentAtPosition(sourceFile, position, this.context.config);
        return {
            document: document,
            offset: document != null ? document.virtualDocument.sfPositionToDocumentOffset(position) : -1
        };
    };
    LitAnalyzer.prototype.getDocumentsInFile = function (sourceFile) {
        return this.context.documentStore.getDocumentsInFile(sourceFile, this.context.config);
    };
    return LitAnalyzer;
}());

/* eslint-disable @typescript-eslint/no-explicit-any */
(function (LitAnalyzerLoggerLevel) {
    LitAnalyzerLoggerLevel[LitAnalyzerLoggerLevel["OFF"] = 0] = "OFF";
    LitAnalyzerLoggerLevel[LitAnalyzerLoggerLevel["ERROR"] = 1] = "ERROR";
    LitAnalyzerLoggerLevel[LitAnalyzerLoggerLevel["WARN"] = 2] = "WARN";
    LitAnalyzerLoggerLevel[LitAnalyzerLoggerLevel["DEBUG"] = 3] = "DEBUG";
    LitAnalyzerLoggerLevel[LitAnalyzerLoggerLevel["VERBOSE"] = 4] = "VERBOSE";
})(exports.LitAnalyzerLoggerLevel || (exports.LitAnalyzerLoggerLevel = {}));
var DefaultLitAnalyzerLogger = /** @class */ (function () {
    function DefaultLitAnalyzerLogger() {
        this.level = exports.LitAnalyzerLoggerLevel.OFF;
    }
    /**
     * Logs if this.level >= DEBUG
     * @param args
     */
    DefaultLitAnalyzerLogger.prototype.debug = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log.apply(this, __spread([exports.LitAnalyzerLoggerLevel.DEBUG], args));
    };
    /**
     * Logs if this.level >= ERROR
     * @param args
     */
    DefaultLitAnalyzerLogger.prototype.error = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log.apply(this, __spread([exports.LitAnalyzerLoggerLevel.ERROR], args));
    };
    /**
     * Logs if level >= WARN
     * @param args
     */
    DefaultLitAnalyzerLogger.prototype.warn = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log.apply(this, __spread([exports.LitAnalyzerLoggerLevel.WARN], args));
    };
    /**
     * Logs if level >= VERBOSE
     * @param args
     */
    DefaultLitAnalyzerLogger.prototype.verbose = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.log.apply(this, __spread([exports.LitAnalyzerLoggerLevel.VERBOSE], args));
    };
    DefaultLitAnalyzerLogger.prototype.log = function (level) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        // Only log for the set level
        if (level > this.level) {
            return;
        }
        var prefix = "[" + this.severityPrefix(level) + "]";
        switch (level) {
            case exports.LitAnalyzerLoggerLevel.VERBOSE:
                // eslint-disable-next-line no-console
                console.log.apply(console, __spread([prefix], args));
                return;
            case exports.LitAnalyzerLoggerLevel.DEBUG:
                // eslint-disable-next-line no-console
                console.debug.apply(console, __spread([prefix], args));
                return;
            case exports.LitAnalyzerLoggerLevel.WARN:
                // eslint-disable-next-line no-console
                console.warn.apply(console, __spread([prefix], args));
                return;
            case exports.LitAnalyzerLoggerLevel.ERROR:
                // eslint-disable-next-line no-console
                console.error.apply(console, __spread([prefix], args));
                return;
            case exports.LitAnalyzerLoggerLevel.OFF:
                return;
        }
    };
    DefaultLitAnalyzerLogger.prototype.severityPrefix = function (level) {
        switch (level) {
            case exports.LitAnalyzerLoggerLevel.VERBOSE:
                return "\x1b[36mVERBOSE\x1b[0m"; // CYAN
            case exports.LitAnalyzerLoggerLevel.DEBUG:
                return "\x1b[33mDEBUG\x1b[0m"; // YELLOW
            case exports.LitAnalyzerLoggerLevel.WARN:
                return "\x1b[35mWARN\x1b[0m"; // PURPLE
            case exports.LitAnalyzerLoggerLevel.ERROR:
                return "\x1b[31mERROR\x1b[0m"; // RED
            case exports.LitAnalyzerLoggerLevel.OFF:
                return "";
        }
    };
    return DefaultLitAnalyzerLogger;
}());

function removeUndefinedFromType(type) {
    switch (type.kind) {
        case "ALIAS":
            return __assign(__assign({}, type), { target: removeUndefinedFromType(type.target) });
        case "UNION":
            return __assign(__assign({}, type), { types: type.types.filter(function (t) { return !tsSimpleType.isAssignableToSimpleTypeKind(t, "UNDEFINED"); }) });
    }
    return type;
}

var partTypeNames = new Set([
    "Part",
    "NodePart",
    "AttributePart",
    "BooleanAttributePart",
    "PropertyPart",
    "EventPart"
]);
/**
 * Checks whether a type is a lit directive.
 * It will return true if the type is a function that takes a Part type and returns a void.
 * @param type
 */
function isLitDirective(type) {
    switch (type.kind) {
        case "ALIAS":
            return type.name === "DirectiveFn" || isLitDirective(type.target);
        case "OBJECT":
            return type.call != null && isLitDirective(type.call);
        case "FUNCTION": {
            // We expect a directive to be a function with at least one argument that
            // returns void.
            if (type.kind !== "FUNCTION" ||
                type.parameters == null ||
                type.parameters.length === 0 ||
                type.returnType == null ||
                type.returnType.kind !== "VOID") {
                return false;
            }
            // And that one argument must all be lit Part types.
            var firstArg = type.parameters[0].type;
            if (firstArg.kind === "UNION") {
                return firstArg.types.every(function (t) { return partTypeNames.has(t.name); });
            }
            return partTypeNames.has(firstArg.name);
        }
        case "GENERIC_ARGUMENTS":
            // Test for the built in type from lit-html: Directive<NodePart>
            return (type.target.kind === "FUNCTION" && type.target.name === "Directive") || isLitDirective(type.target);
        default:
            return false;
    }
}

function getDirective(assignment, context) {
    var ts = context.ts, program = context.program;
    var checker = program.getTypeChecker();
    if (assignment.kind !== HtmlNodeAttrAssignmentKind.EXPRESSION)
        return;
    // Type check lit-html directives
    if (ts.isCallExpression(assignment.expression)) {
        var functionName = assignment.expression.expression.getText();
        var args_1 = Array.from(assignment.expression.arguments);
        switch (functionName) {
            case "ifDefined": {
                // Example: html`<img src="${ifDefined(imageUrl)}">`;
                // Take the argument to ifDefined and remove undefined from the type union (if possible).
                // This new type becomes the actual type of the expression
                var actualType = lazy(function () {
                    if (args_1.length >= 1) {
                        var returnType = tsSimpleType.toSimpleType(checker.getTypeAtLocation(args_1[0]), checker);
                        return removeUndefinedFromType(returnType);
                    }
                    return undefined;
                });
                return {
                    kind: "ifDefined",
                    actualType: actualType,
                    args: args_1
                };
            }
            case "live": {
                // Example: html`<input .value=${live(x)}>`
                // The actual type will be the type of the first argument to live
                var actualType = lazy(function () {
                    if (args_1.length >= 1) {
                        return tsSimpleType.toSimpleType(checker.getTypeAtLocation(args_1[0]), checker);
                    }
                    return undefined;
                });
                return {
                    kind: "live",
                    actualType: actualType,
                    args: args_1
                };
            }
            case "guard": {
                // Example: html`<img src="${guard([imageUrl], () => Math.random() > 0.5 ? imageUrl : "nothing.png")}>`;
                // The return type of the function becomes the actual type of the expression
                var actualType = lazy(function () {
                    if (args_1.length >= 2) {
                        var returnFunctionType = tsSimpleType.toSimpleType(checker.getTypeAtLocation(args_1[1]), checker);
                        if ("call" in returnFunctionType && returnFunctionType.call != null) {
                            returnFunctionType = returnFunctionType.call;
                        }
                        if (returnFunctionType.kind === "FUNCTION") {
                            return returnFunctionType.returnType;
                        }
                    }
                    return undefined;
                });
                return {
                    kind: "guard",
                    actualType: actualType,
                    args: args_1
                };
            }
            case "classMap":
            case "styleMap":
                return {
                    kind: functionName,
                    actualType: function () { return ({ kind: "STRING" }); },
                    args: args_1
                };
            case "unsafeHTML":
            case "unsafeSVG":
            case "cache":
            case "repeat":
            case "templateContent":
            case "asyncReplace":
            case "asyncAppend":
                return {
                    kind: functionName,
                    args: args_1
                };
            default:
                // Grab the type of the expression and get a SimpleType
                if (assignment.kind === HtmlNodeAttrAssignmentKind.EXPRESSION) {
                    var typeB_1 = tsSimpleType.toSimpleType(checker.getTypeAtLocation(assignment.expression), checker);
                    if (isLitDirective(typeB_1)) {
                        // Factories can mark which parameters might be assigned to the property with the generic type in DirectiveFn<T>
                        // Here we get the actual type of the directive if the it is a generic directive with type. Example: DirectiveFn<string>
                        // Read more: https://github.com/Polymer/lit-html/pull/1151
                        var actualType = typeB_1.kind === "GENERIC_ARGUMENTS" && typeB_1.target.name === "DirectiveFn" && typeB_1.typeArguments.length > 0 // && typeB.typeArguments[0].kind !== "UNKNOWN"
                            ? function () { return typeB_1.typeArguments[0]; }
                            : undefined;
                        // Now we have an unknown (user defined) directive.
                        return {
                            kind: {
                                name: functionName
                            },
                            args: args_1,
                            actualType: actualType
                        };
                    }
                }
        }
    }
    return;
}

var cache = new WeakMap();
function extractBindingTypes(assignment, context) {
    var _a;
    if (cache.has(assignment)) {
        return cache.get(assignment);
    }
    var checker = context.program.getTypeChecker();
    // Infer the type of the RHS
    //const typeBInferred = shouldRelaxTypeB ? ({ kind: "ANY" } as SimpleType) : inferTypeFromAssignment(assignment, checker);
    var typeBInferred = inferTypeFromAssignment(assignment, checker);
    // Convert typeB to SimpleType
    var typeB = (function () {
        var type = tsSimpleType.isSimpleType(typeBInferred) ? typeBInferred : tsSimpleType.toSimpleType(typeBInferred, checker);
        return  type;
    })();
    // Find a corresponding target for this attribute
    var htmlAttrTarget = context.htmlStore.getHtmlAttrTarget(assignment.htmlAttr);
    //if (htmlAttrTarget == null) return [];
    var typeA = htmlAttrTarget == null ? { kind: "ANY" } : htmlAttrTarget.getType();
    // Handle directives
    var directive = getDirective(assignment, context);
    var directiveType = (_a = directive === null || directive === void 0 ? void 0 : directive.actualType) === null || _a === void 0 ? void 0 : _a.call(directive);
    if (directiveType != null) {
        typeB = directiveType;
    }
    // Cache the result
    var result = { typeA: typeA, typeB: typeB };
    cache.set(assignment, result);
    return result;
}
function inferTypeFromAssignment(assignment, checker) {
    switch (assignment.kind) {
        case HtmlNodeAttrAssignmentKind.STRING:
            return { kind: "STRING_LITERAL", value: assignment.value };
        case HtmlNodeAttrAssignmentKind.BOOLEAN:
            return { kind: "BOOLEAN_LITERAL", value: true };
        case HtmlNodeAttrAssignmentKind.EXPRESSION:
            return checker.getTypeAtLocation(assignment.expression);
        case HtmlNodeAttrAssignmentKind.MIXED:
            // Event bindings always looks at the first expression
            // Therefore, return the type of the first expression
            if (assignment.htmlAttr.kind === HtmlNodeAttrKind.EVENT_LISTENER) {
                var expression = assignment.values.find(function (val) { return typeof val !== "string"; });
                if (expression != null) {
                    return checker.getTypeAtLocation(expression);
                }
            }
            return { kind: "STRING" };
    }
}

var PRIMITIVE_STRING_ARRAY_TYPE_BRAND = Symbol("PRIMITIVE_STRING_ARRAY_TYPE");
/**
 * Brands a union as a primitive array type
 * This type is used for the "role" attribute that is a whitespace separated list
 * @param union
 */
function makePrimitiveArrayType(union) {
    var extendedUnion = __assign({}, union);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    extendedUnion[PRIMITIVE_STRING_ARRAY_TYPE_BRAND] = true;
    return extendedUnion;
}
/**
 * Returns if a simple type is branded as a primitive array type
 * @param simpleType
 */
function isPrimitiveArrayType(simpleType) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return simpleType.kind === "UNION" && simpleType[PRIMITIVE_STRING_ARRAY_TYPE_BRAND] === true;
}

/**
 * If the user's security policy overrides normal type checking for this
 * attribute binding, returns a (possibly empty) array of diagnostics.
 *
 * If the security policy does not apply to this binding, then
 */
function isAssignableBindingUnderSecuritySystem(htmlAttr, _a, context) {
    var typeA = _a.typeA, typeB = _a.typeB;
    var securityPolicy = context.config.securitySystem;
    switch (securityPolicy) {
        case "off":
            return undefined; // No security checks apply.
        case "ClosureSafeTypes":
            return checkClosureSecurityAssignability(typeB, htmlAttr, context);
        default: {
            var never = securityPolicy;
            context.logger.error("Unexpected security policy: " + never);
            return undefined;
        }
    }
}
var closureScopedOverrides = {
    iframe: {
        src: ["TrustedResourceUrl"]
    },
    a: {
        href: ["TrustedResourceUrl", "SafeUrl", "string"]
    },
    img: {
        src: ["TrustedResourceUrl", "SafeUrl", "string"]
    },
    script: {
        src: ["TrustedResourceUrl"]
    },
    source: {
        src: ["TrustedResourceUrl", "SafeUrl"]
    }
};
var closureGlobalOverrides = {
    style: ["SafeStyle", "string"]
};
function checkClosureSecurityAssignability(typeB, htmlAttr, context) {
    var scopedOverride = closureScopedOverrides[htmlAttr.htmlNode.tagName];
    var overriddenTypes = (scopedOverride && scopedOverride[htmlAttr.name]) || closureGlobalOverrides[htmlAttr.name];
    if (overriddenTypes === undefined) {
        return undefined;
    }
    // Directives are responsible for their own security.
    if (isLitDirective(typeB)) {
        return undefined;
    }
    var typeMatch = matchesAtLeastOneNominalType(overriddenTypes, typeB);
    if (typeMatch === false) {
        /*const nominalType: SimpleType = {
            kind: SimpleTypeKind.INTERFACE,
            members: [],
            name: "A security type"
        };*/
        context.report({
            location: rangeFromHtmlNodeAttr(htmlAttr),
            message: "Type '" + tsSimpleType.typeToString(typeB) + "' is not assignable to '" + overriddenTypes.join(" | ") + "'. This is due to Closure Safe Type enforcement."
        });
        return false;
    }
    return true;
}
function matchesAtLeastOneNominalType(typeNames, typeB) {
    if (typeB.name !== undefined && typeNames.includes(typeB.name)) {
        return true;
    }
    switch (typeB.kind) {
        case "UNION":
            return typeB.types.every(function (t) { return matchesAtLeastOneNominalType(typeNames, t); });
        case "STRING_LITERAL":
        case "STRING":
            return typeNames.includes("string");
        case "GENERIC_ARGUMENTS":
            return matchesAtLeastOneNominalType(typeNames, typeB.target);
        default:
            return false;
    }
}

function isAssignableToType(_a, context, options) {
    var typeA = _a.typeA, typeB = _a.typeB;
    var inJsFile = context.file.fileName.endsWith(".js");
    var expandedOptions = __assign(__assign(__assign({}, (inJsFile ? { strict: false } : {})), { options: context.ts }), (options || {}));
    return tsSimpleType.isAssignableToType(typeA, typeB, context.program, expandedOptions);
}

function isAssignableInAttributeBinding(htmlAttr, _a, context) {
    var typeA = _a.typeA, typeB = _a.typeB;
    var assignment = htmlAttr.assignment;
    if (assignment == null)
        return undefined;
    if (assignment.kind === HtmlNodeAttrAssignmentKind.BOOLEAN) {
        if (!isAssignableToType({ typeA: typeA, typeB: typeB }, context)) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Type '" + tsSimpleType.typeToString(typeB) + "' is not assignable to '" + tsSimpleType.typeToString(typeA) + "'"
            });
            return false;
        }
    }
    else {
        if (assignment.kind !== HtmlNodeAttrAssignmentKind.STRING) {
            // Purely static attributes are never security checked, they're handled
            // in the lit-html internals as trusted by default, because they can
            // not contain untrusted data, they were written by the developer.
            //
            // For everything else, we may need to apply a different type comparison
            // for some security-sensitive built in attributes and properties (like
            // <script src>).
            var securitySystemResult = isAssignableBindingUnderSecuritySystem(htmlAttr, { typeA: typeA, typeB: typeB }, context);
            if (securitySystemResult !== undefined) {
                // The security diagnostics take precedence here,
                // and we should not do any more checking.
                return securitySystemResult;
            }
        }
        var primitiveArrayTypeResult = isAssignableInPrimitiveArray(assignment, { typeA: typeA, typeB: typeB }, context);
        if (primitiveArrayTypeResult !== undefined) {
            return primitiveArrayTypeResult;
        }
        if (!isAssignableToType({ typeA: typeA, typeB: typeB }, context, { isAssignable: isAssignableToTypeWithStringCoercion })) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Type '" + tsSimpleType.typeToString(typeB) + "' is not assignable to '" + tsSimpleType.typeToString(typeA) + "'"
            });
            return false;
        }
    }
    return true;
}
/**
 * Assignability check that simulates string coercion
 * This is used to type check attribute bindings
 * @param typeA
 * @param typeB
 * @param options
 */
function isAssignableToTypeWithStringCoercion(typeA, typeB, options) {
    var safeOptions = __assign(__assign({}, options), { isAssignable: undefined });
    switch (typeB.kind) {
        /*case "NULL":
         return _isAssignableToType(typeA, { kind: "STRING_LITERAL", value: "null" }, safeOptions);

         case "UNDEFINED":
         return _isAssignableToType(typeA, { kind: "STRING_LITERAL", value: "undefined" }, safeOptions);
         */
        case "ALIAS":
        case "FUNCTION":
        case "GENERIC_ARGUMENTS":
            // Always return true if this is a lit directive
            if (isLitDirective(typeB)) {
                return true;
            }
            break;
        case "OBJECT":
        case "CLASS":
        case "INTERFACE":
            // This allows for types like: string | (part: Part) => void
            return tsSimpleType.isAssignableToType(typeA, {
                kind: "STRING_LITERAL",
                value: "[object Object]"
            }, safeOptions);
        case "STRING_LITERAL":
            /*if (typeA.kind === "ARRAY" && typeA.type.kind === "STRING_LITERAL") {
            }*/
            // Take into account that the empty string is is equal to true
            if (typeB.value.length === 0) {
                if (tsSimpleType.isAssignableToType(typeA, { kind: "BOOLEAN_LITERAL", value: true }, safeOptions)) {
                    return true;
                }
            }
            // Test if a potential string literal is a assignable to a number
            // Example: max="123"
            if (!isNaN(typeB.value)) {
                if (tsSimpleType.isAssignableToType(typeA, {
                    kind: "NUMBER_LITERAL",
                    value: Number(typeB.value)
                }, safeOptions)) {
                    return true;
                }
            }
            break;
        case "BOOLEAN":
            // Test if a boolean coerced string is possible.
            // Example: aria-expanded="${this.open}"
            return tsSimpleType.isAssignableToType(typeA, {
                kind: "UNION",
                types: [
                    {
                        kind: "STRING_LITERAL",
                        value: "true"
                    },
                    { kind: "STRING_LITERAL", value: "false" }
                ]
            }, safeOptions);
        case "BOOLEAN_LITERAL":
            /**
             * Test if a boolean literal coerced to string is possible
             * Example: aria-expanded="${this.open}"
             */
            return tsSimpleType.isAssignableToType(typeA, {
                kind: "STRING_LITERAL",
                value: String(typeB.value)
            }, safeOptions);
        case "NUMBER":
            // Test if a number coerced to string is possible
            // Example: value="${this.max}"
            if (tsSimpleType.isAssignableToType(typeA, { kind: "STRING" }, safeOptions)) {
                return true;
            }
            break;
        case "NUMBER_LITERAL":
            // Test if a number literal coerced to string is possible
            // Example: value="${this.max}"
            if (tsSimpleType.isAssignableToType(typeA, {
                kind: "STRING_LITERAL",
                value: String(typeB.value)
            }, safeOptions)) {
                return true;
            }
            break;
    }
    return undefined;
}
/**
 * Certain attributes like "role" are string literals, but should be type checked
 *   by comparing each item in the white-space-separated array against typeA
 * @param assignment
 * @param typeA
 * @param typeB
 * @param context
 */
function isAssignableInPrimitiveArray(assignment, _a, context) {
    var e_1, _b;
    var typeA = _a.typeA, typeB = _a.typeB;
    // Only check "STRING" and "EXPRESSION" for now
    if (assignment.kind !== HtmlNodeAttrAssignmentKind.STRING && assignment.kind !== HtmlNodeAttrAssignmentKind.EXPRESSION) {
        return undefined;
    }
    // Check if typeA is marked as a "primitive array type"
    if (isPrimitiveArrayType(typeA) && typeB.kind === "STRING_LITERAL") {
        // Split a value like: "button listitem" into ["button", " ", "listitem"]
        var valuesAndWhitespace = typeB.value.split(/(\s+)/g);
        var valuesNotAssignable = [];
        var startOffset = assignment.location.start;
        var offset = 0;
        try {
            for (var valuesAndWhitespace_1 = __values(valuesAndWhitespace), valuesAndWhitespace_1_1 = valuesAndWhitespace_1.next(); !valuesAndWhitespace_1_1.done; valuesAndWhitespace_1_1 = valuesAndWhitespace_1.next()) {
                var value = valuesAndWhitespace_1_1.value;
                // Check all non-whitespace values
                if (value.match(/\s+/) == null && value !== "") {
                    // Make sure that the the value is assignable to the union
                    if (!isAssignableToType({ typeA: typeA, typeB: { kind: "STRING_LITERAL", value: value } }, context, { isAssignable: isAssignableToTypeWithStringCoercion })) {
                        valuesNotAssignable.push(value);
                        // If the assignment kind is "STRING" we can report diagnostics directly on the value in the HTML
                        if (assignment.kind === "STRING") {
                            context.report({
                                location: documentRangeToSFRange(assignment.htmlAttr.document, {
                                    start: startOffset + offset,
                                    end: startOffset + offset + value.length
                                }),
                                message: "The value '" + value + "' is not assignable to '" + tsSimpleType.typeToString(typeA) + "'"
                            });
                        }
                    }
                }
                offset += value.length;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (valuesAndWhitespace_1_1 && !valuesAndWhitespace_1_1.done && (_b = valuesAndWhitespace_1.return)) _b.call(valuesAndWhitespace_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        // If the assignment kind as "EXPRESSION" report a single diagnostic on the attribute name
        if (assignment.kind === "EXPRESSION" && valuesNotAssignable.length > 0) {
            var multiple = valuesNotAssignable.length > 1;
            context.report({
                location: rangeFromHtmlNodeAttr(assignment.htmlAttr),
                message: "The value" + (multiple ? "s" : "") + " " + valuesNotAssignable.map(function (v) { return "'" + v + "'"; }).join(", ") + " " + (multiple ? "are" : "is") + " not assignable to '" + tsSimpleType.typeToString(typeA) + "'"
            });
        }
        return valuesNotAssignable.length === 0;
    }
    return undefined;
}

/**
 * This rule validates that you are not binding a boolean type in an attribute binding
 * This would result in binding the string 'true' or 'false' and a '?' binding should be used instead.
 */
var rule = {
    id: "no-boolean-in-attribute-binding",
    meta: {
        priority: "medium"
    },
    visitHtmlAssignment: function (assignment, context) {
        // Don't validate boolean attribute bindings.
        if (assignment.kind === HtmlNodeAttrAssignmentKind.BOOLEAN)
            return;
        // Only validate attribute bindings.
        var htmlAttr = assignment.htmlAttr;
        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE)
            return;
        var _a = extractBindingTypes(assignment, context), typeA = _a.typeA, typeB = _a.typeB;
        // Return early if the attribute is like 'required=""' because this is assignable to boolean.
        if (typeB.kind === "STRING_LITERAL" && typeB.value.length === 0)
            return;
        // Check that typeB is not of any|unknown type and typeB is assignable to boolean.
        // Report a diagnostic if typeB is assignable to boolean type because this would result in binding the boolean coerced to string.
        if (!tsSimpleType.isAssignableToSimpleTypeKind(typeB, ["ANY", "UNKNOWN"]) && isAssignableToType({ typeA: { kind: "BOOLEAN" }, typeB: typeB }, context)) {
            // Don't emit error if typeB is assignable to typeA with string coercion.
            if (isAssignableToType({ typeA: typeA, typeB: typeB }, context, { isAssignable: isAssignableToTypeWithStringCoercion })) {
                return;
            }
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "The value being assigned is a boolean type, but you are not using a boolean binding.",
                fixMessage: "Change to boolean binding?",
                fix: function () {
                    var newName = "" + LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER + htmlAttr.name;
                    return {
                        message: "Change to '" + newName + "'",
                        actions: [
                            {
                                kind: "changeAttributeName",
                                htmlAttr: htmlAttr,
                                newName: newName
                            }
                        ]
                    };
                }
            });
        }
        // Check that typeA is not of any|unknown type and typeA is assignable to boolean.
        // Report a diagnostic if typeA is assignable to boolean type because then
        //   we should probably be using a boolean binding instead of an attribute binding.
        else if (!tsSimpleType.isAssignableToSimpleTypeKind(typeA, ["ANY", "UNKNOWN"]) &&
            isAssignableToType({
                typeA: { kind: "BOOLEAN" },
                typeB: typeA
            }, context)) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "The '" + htmlAttr.name + "' attribute is of boolean type but you are not using a boolean binding.",
                fixMessage: "Change to boolean binding?",
                fix: function () {
                    var newName = "" + LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER + htmlAttr.name;
                    return {
                        message: "Change to '" + newName + "'",
                        actions: [
                            {
                                kind: "changeAttributeName",
                                htmlAttr: htmlAttr,
                                newName: newName
                            }
                        ]
                    };
                }
            });
        }
    }
};

/**
 * This rule validates that complex types are not used within an expression in an attribute binding.
 */
var rule$1 = {
    id: "no-complex-attribute-binding",
    meta: {
        priority: "medium"
    },
    visitHtmlAssignment: function (assignment, context) {
        // Only validate attribute bindings, because you are able to assign complex types in property bindings.
        var htmlAttr = assignment.htmlAttr;
        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE)
            return;
        var _a = extractBindingTypes(assignment, context), typeA = _a.typeA, typeB = _a.typeB;
        // Don't validate directives in this rule, because they are assignable even though they are complex types (functions).
        if (isLitDirective(typeB))
            return;
        // Only primitive types should be allowed as "typeB"
        if (!tsSimpleType.isAssignableToPrimitiveType(typeB)) {
            if (isAssignableBindingUnderSecuritySystem(htmlAttr, { typeA: typeA, typeB: typeB }, context) !== undefined) {
                // This is binding via a security sanitization system, let it do
                // this check. Apparently complex values are OK to assign here.
                return;
            }
            var message = "You are binding a non-primitive type '" + tsSimpleType.typeToString(typeB) + "'. This could result in binding the string \"[object Object]\".";
            var newModifier_1 = ".";
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: message,
                fixMessage: "Use '" + newModifier_1 + "' binding instead?",
                fix: function () { return ({
                    message: "Use '" + newModifier_1 + "' modifier instead",
                    actions: [
                        {
                            kind: "changeAttributeModifier",
                            htmlAttr: htmlAttr,
                            newModifier: newModifier_1
                        }
                    ]
                }); }
            });
        }
        // Only primitive types should be allowed as "typeA"
        else if (!tsSimpleType.isAssignableToPrimitiveType(typeA)) {
            var message = "You are assigning the primitive '" + tsSimpleType.typeToString(typeB) + "' to a non-primitive type '" + tsSimpleType.typeToString(typeA) + "'.";
            var newModifier_2 = ".";
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: message,
                fixMessage: "Use '" + newModifier_2 + "' binding instead?",
                fix: function () { return ({
                    message: "Use '" + newModifier_2 + "' modifier instead",
                    actions: [
                        {
                            kind: "changeAttributeModifier",
                            htmlAttr: htmlAttr,
                            newModifier: newModifier_2
                        }
                    ]
                }); }
            });
        }
    }
};

/**
 * This rule validates that non-attribute bindings are always used with an expression.
 */
var rule$2 = {
    id: "no-expressionless-property-binding",
    meta: {
        priority: "high"
    },
    visitHtmlAssignment: function (assignment, context) {
        var htmlAttr = assignment.htmlAttr;
        // Only make this check non-expression type assignments.
        switch (assignment.kind) {
            case HtmlNodeAttrAssignmentKind.STRING:
            case HtmlNodeAttrAssignmentKind.BOOLEAN:
                switch (htmlAttr.kind) {
                    case HtmlNodeAttrKind.EVENT_LISTENER:
                        context.report({
                            location: rangeFromHtmlNodeAttr(htmlAttr),
                            message: "You are using an event listener binding without an expression"
                        });
                        break;
                    case HtmlNodeAttrKind.BOOLEAN_ATTRIBUTE:
                        context.report({
                            location: rangeFromHtmlNodeAttr(htmlAttr),
                            message: "You are using a boolean attribute binding without an expression"
                        });
                        break;
                    case HtmlNodeAttrKind.PROPERTY:
                        context.report({
                            location: rangeFromHtmlNodeAttr(htmlAttr),
                            message: "You are using a property binding without an expression"
                        });
                        break;
                }
        }
    }
};

var rule$3 = {
    id: "no-incompatible-property-type",
    meta: {
        priority: "low"
    },
    visitComponentMember: function (member, context) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        if (member.kind !== "property" || ((_a = member.modifiers) === null || _a === void 0 ? void 0 : _a.has("static")) || member.meta == null)
            return;
        if (((_d = ((_c = (_b = member.meta.node) === null || _b === void 0 ? void 0 : _b.type) !== null && _c !== void 0 ? _c : member.node)) === null || _d === void 0 ? void 0 : _d.getSourceFile()) !== context.file)
            return;
        // Grab the type and fallback to "any"
        var type = ((_e = member.type) === null || _e === void 0 ? void 0 : _e.call(member)) || { kind: "ANY" };
        return validateLitPropertyConfig(((_f = member.meta.node) === null || _f === void 0 ? void 0 : _f.type) || ((_h = (_g = member.meta.node) === null || _g === void 0 ? void 0 : _g.decorator) === null || _h === void 0 ? void 0 : _h.expression) || member.node, member.meta, {
            propName: member.propName,
            simplePropType: tsSimpleType.isSimpleType(type) ? type : tsSimpleType.toSimpleType(type, context.program.getTypeChecker())
        }, context);
    }
};
/**
 * Returns a string, that can be used in a lit @property decorator for the type key, representing the simple type kind.
 * @param simpleTypeKind
 */
function toLitPropertyTypeString(simpleTypeKind) {
    switch (simpleTypeKind) {
        case "STRING":
            return "String";
        case "NUMBER":
            return "Number";
        case "BOOLEAN":
            return "Boolean";
        case "ARRAY":
            return "Array";
        case "OBJECT":
            return "Object";
        default:
            return "";
    }
}
/**
 * Prepares functions that can lazily test assignability against simple type kinds.
 * This tester function uses a cache for performance.
 * @param simpleType
 */
function prepareSimpleAssignabilityTester(simpleType) {
    // Test assignments to all possible type kinds
    var _isAssignableToCache = new Map();
    function isAssignableTo(simpleTypeKind) {
        if (_isAssignableToCache.has(simpleTypeKind)) {
            return _isAssignableToCache.get(simpleTypeKind);
        }
        var result = (function () {
            switch (simpleTypeKind) {
                case "STRING":
                    return tsSimpleType.isAssignableToSimpleTypeKind(simpleType, ["STRING", "STRING_LITERAL"]);
                case "NUMBER":
                    return tsSimpleType.isAssignableToSimpleTypeKind(simpleType, ["NUMBER", "NUMBER_LITERAL"]);
                case "BOOLEAN":
                    return tsSimpleType.isAssignableToSimpleTypeKind(simpleType, ["BOOLEAN", "BOOLEAN_LITERAL"]);
                case "ARRAY":
                    return tsSimpleType.isAssignableToSimpleTypeKind(simpleType, ["ARRAY", "TUPLE"]);
                case "OBJECT":
                    return tsSimpleType.isAssignableToSimpleTypeKind(simpleType, ["OBJECT", "INTERFACE"]);
                case "ANY":
                    return tsSimpleType.isAssignableToSimpleTypeKind(simpleType, "ANY");
                default:
                    return false;
            }
        })();
        _isAssignableToCache.set(simpleTypeKind, result);
        return result;
    }
    // Collect type kinds that can be used in as "type" in the @property decorator
    var acceptedTypeKinds = lazy(function () {
        return ["STRING", "NUMBER", "BOOLEAN", "ARRAY", "OBJECT", "ANY"]
            .filter(function (kind) { return kind !== "ANY"; })
            .filter(function (kind) { return isAssignableTo(kind); });
    });
    return { acceptedTypeKinds: acceptedTypeKinds, isAssignableTo: isAssignableTo };
}
/**
 * Runs through a lit configuration and validates against the "simplePropType".
 * Emits diagnostics through the context.
 * @param node
 * @param litConfig
 * @param propName
 * @param simplePropType
 * @param context
 */
function validateLitPropertyConfig(node, litConfig, _a, context) {
    var propName = _a.propName, simplePropType = _a.simplePropType;
    // Check if "type" is one of the built in default type converter hint
    if (typeof litConfig.type === "string" && !litConfig.hasConverter) {
        context.report({
            location: rangeFromNode(node),
            message: "'" + litConfig.type + "' is not a valid type for the default converter.",
            fixMessage: litConfig.attribute !== false ? "Have you considered '{attribute: false}' instead?" : "Have you considered removing 'type'?"
        });
    }
    // Don't continue if we don't know the property type (eg if we are in a js file)
    // Don't continue if this property has a custom converter (because then we don't know how the value will be converted)
    if (simplePropType == null || litConfig.hasConverter || typeof litConfig.type === "string") {
        return;
    }
    var _b = prepareSimpleAssignabilityTester(simplePropType), acceptedTypeKinds = _b.acceptedTypeKinds, isAssignableTo = _b.isAssignableTo;
    // Test the @property type against the actual type if a type has been provided
    if (litConfig.type != null) {
        // Report error if the @property type is not assignable to the actual type
        if (!isAssignableTo(litConfig.type.kind) && !isAssignableTo("ANY")) {
            // Suggest what to use instead
            if (acceptedTypeKinds().length >= 1) {
                var potentialKindText = joinArray(acceptedTypeKinds().map(function (kind) { return "'" + toLitPropertyTypeString(kind) + "'"; }), ", ", "or");
                context.report({
                    location: rangeFromNode(node),
                    message: "@property type should be " + potentialKindText + " instead of '" + toLitPropertyTypeString(litConfig.type.kind) + "'"
                });
            }
            // If no suggesting can be provided, report that they are not assignable
            // The OBJECT @property type is an escape from this error
            else if (litConfig.type.kind !== "OBJECT") {
                context.report({
                    location: rangeFromNode(node),
                    message: "@property type '" + tsSimpleType.typeToString(litConfig.type) + "' is not assignable to the actual type '" + tsSimpleType.typeToString(simplePropType) + "'"
                });
            }
        }
    }
    // If no type has been specified, suggest what to use as the @property type
    else if (litConfig.attribute !== false) {
        // Don't do anything if there are multiple possibilities for a type.
        if (isAssignableTo("ANY")) {
            return;
        }
        // Don't report errors because String conversion is default
        else if (isAssignableTo("STRING")) {
            return;
        }
        // Suggest what to use instead if there are multiple accepted @property types for this property
        else if (acceptedTypeKinds().length > 0) {
            // Suggest types to use and include "{attribute: false}" if the @property type is ARRAY or OBJECT
            var acceptedTypeText = joinArray(__spread(acceptedTypeKinds().map(function (kind) { return "'{type: " + toLitPropertyTypeString(kind) + "}'"; }), (isAssignableTo("ARRAY") || isAssignableTo("OBJECT") ? ["'{attribute: false}'"] : [])), ", ", "or");
            context.report({
                location: rangeFromNode(node),
                message: "Missing " + acceptedTypeText + " on @property decorator for '" + propName + "'"
            });
        }
        else {
            context.report({
                location: rangeFromNode(node),
                message: "The built in converter doesn't handle the property type '" + tsSimpleType.typeToString(simplePropType) + "'.",
                fixMessage: "Please add '{attribute: false}' on @property decorator for '" + propName + "'"
            });
        }
    }
    // message: `You need to add '{attribute: false}' to @property decorator for '${propName}' because '${toTypeString(simplePropType)}' type is not a primitive`
}

function isAssignableInBooleanBinding(htmlAttr, _a, context) {
    var typeA = _a.typeA, typeB = _a.typeB;
    // Test if the user is trying to use ? modifier on a non-boolean type.
    if (!isAssignableToType({ typeA: { kind: "UNION", types: [{ kind: "BOOLEAN" }, { kind: "UNDEFINED" }, { kind: "NULL" }] }, typeB: typeB }, context)) {
        context.report({
            location: rangeFromHtmlNodeAttr(htmlAttr),
            message: "Type '" + tsSimpleType.typeToString(typeB) + "' is not assignable to 'boolean'"
        });
        return false;
    }
    // Test if the user is trying to use the ? modifier on a non-boolean type.
    if (!isAssignableToType({ typeA: typeA, typeB: { kind: "BOOLEAN" } }, context)) {
        context.report({
            location: rangeFromHtmlNodeAttr(htmlAttr),
            message: "You are using a boolean binding on a non boolean type '" + tsSimpleType.typeToString(typeA) + "'",
            fix: function () {
                var htmlAttrTarget = context.htmlStore.getHtmlAttrTarget(htmlAttr);
                var newModifier = htmlAttrTarget == null ? "." : "";
                return {
                    message: newModifier.length === 0 ? "Remove '" + (htmlAttr.modifier || "") + "' modifier" : "Use '" + newModifier + "' modifier instead",
                    actions: [
                        {
                            kind: "changeAttributeModifier",
                            htmlAttr: htmlAttr,
                            newModifier: newModifier
                        }
                    ]
                };
            }
        });
        return false;
    }
    return true;
}

function isAssignableInPropertyBinding(htmlAttr, _a, context) {
    var typeA = _a.typeA, typeB = _a.typeB;
    var securitySystemResult = isAssignableBindingUnderSecuritySystem(htmlAttr, { typeA: typeA, typeB: typeB }, context);
    if (securitySystemResult !== undefined) {
        // The security diagnostics take precedence here,
        //   and we should not do any more checking.
        return securitySystemResult;
    }
    if (!isAssignableToType({ typeA: typeA, typeB: typeB }, context)) {
        context.report({
            location: rangeFromHtmlNodeAttr(htmlAttr),
            message: "Type '" + tsSimpleType.typeToString(typeB) + "' is not assignable to '" + tsSimpleType.typeToString(typeA) + "'"
        });
        return false;
    }
    return true;
}

/**
 * This rule validate if the types of a binding are assignable.
 */
var rule$4 = {
    id: "no-incompatible-type-binding",
    meta: {
        priority: "low"
    },
    visitHtmlAssignment: function (assignment, context) {
        var htmlAttr = assignment.htmlAttr;
        if (context.htmlStore.getHtmlAttrTarget(assignment.htmlAttr) == null) {
            return;
        }
        var _a = extractBindingTypes(assignment, context), typeA = _a.typeA, typeB = _a.typeB;
        // Validate types based on the binding in which they appear
        switch (htmlAttr.modifier) {
            case LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER:
                isAssignableInBooleanBinding(htmlAttr, { typeA: typeA, typeB: typeB }, context);
                break;
            case LIT_HTML_PROP_ATTRIBUTE_MODIFIER:
                isAssignableInPropertyBinding(htmlAttr, { typeA: typeA, typeB: typeB }, context);
                break;
            case LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER:
                break;
            default: {
                isAssignableInAttributeBinding(htmlAttr, { typeA: typeA, typeB: typeB }, context);
                break;
            }
        }
    }
};

var rule$5 = {
    id: "no-invalid-attribute-name",
    meta: {
        priority: "low"
    },
    visitComponentMember: function (member, context) {
        var _a, _b;
        // Check if the tag name is invalid
        var attrName;
        var attrNameNode;
        if (member.kind === "attribute") {
            attrName = member.attrName;
            attrNameNode = member.node;
        }
        else if (typeof ((_a = member.meta) === null || _a === void 0 ? void 0 : _a.attribute) === "string") {
            attrName = member.meta.attribute;
            attrNameNode = ((_b = member.meta.node) === null || _b === void 0 ? void 0 : _b.attribute) || member.node;
        }
        if (attrName != null && attrNameNode != null && attrNameNode.getSourceFile() === context.file && !isValidAttributeName(attrName)) {
            context.report({
                location: rangeFromNode(attrNameNode),
                message: "'" + attrName + "' is not a valid attribute name."
            });
        }
    }
};

/**
 * This rule validates that directives are used properly.
 */
var rule$6 = {
    id: "no-invalid-directive-binding",
    meta: {
        priority: "high"
    },
    visitHtmlAssignment: function (assignment, context) {
        var _a;
        var htmlAttr = assignment.htmlAttr;
        // Only validate expression because this is where directives can be used.
        if (assignment.kind !== HtmlNodeAttrAssignmentKind.EXPRESSION)
            return;
        // Check if the expression is a directive
        var directive = getDirective(assignment, context);
        if (directive == null)
            return;
        // Validate built-in directive kind
        if (typeof directive.kind === "string") {
            switch (directive.kind) {
                case "ifDefined":
                    // Example: html`<img src="${ifDefined(imageUrl)}">`;
                    // Take the argument to ifDefined and remove undefined from the type union (if possible).
                    // Then test if this result is now assignable to the attribute type.
                    if (directive.args.length === 1) {
                        // "ifDefined" only has an effect on "attribute" bindings
                        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE) {
                            context.report({
                                location: rangeFromHtmlNodeAttr(htmlAttr),
                                message: "The 'ifDefined' directive has no effect here."
                            });
                        }
                    }
                    break;
                case "live":
                    switch (htmlAttr.kind) {
                        case HtmlNodeAttrKind.ATTRIBUTE: {
                            // Make sure that only strings are passed in when using the live directive in attribute bindings
                            var typeB = (_a = directive.actualType) === null || _a === void 0 ? void 0 : _a.call(directive);
                            if (typeB != null && !tsSimpleType.isAssignableToType({ kind: "STRING" }, typeB)) {
                                context.report({
                                    location: rangeFromHtmlNodeAttr(htmlAttr),
                                    message: "If you use the 'live' directive in an attribute binding, make sure that only strings are passed in, or the binding will update every render"
                                });
                            }
                            break;
                        }
                        case HtmlNodeAttrKind.EVENT_LISTENER:
                            context.report({
                                location: rangeFromHtmlNodeAttr(htmlAttr),
                                message: "The 'live' directive can only be used in attribute and property bindings"
                            });
                    }
                    break;
                case "classMap":
                    // Report error if "classMap" is not being used on the "class" attribute.
                    if (htmlAttr.name !== "class" || htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE) {
                        context.report({
                            location: rangeFromHtmlNodeAttr(htmlAttr),
                            message: "The 'classMap' directive can only be used in an attribute binding for the 'class' attribute"
                        });
                    }
                    break;
                case "styleMap":
                    // Report error if "styleMap" is not being used on the "style" attribute.
                    if (htmlAttr.name !== "style" || htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE) {
                        context.report({
                            location: rangeFromHtmlNodeAttr(htmlAttr),
                            message: "The 'styleMap' directive can only be used in an attribute binding for the 'style' attribute"
                        });
                    }
                    break;
                case "unsafeHTML":
                case "unsafeSVG":
                case "cache":
                case "repeat":
                case "templateContent":
                case "asyncReplace":
                case "asyncAppend":
                    // These directives can only be used within a text binding.
                    // This function validating assignments is per definition used NOT in a text binding
                    context.report({
                        location: rangeFromHtmlNodeAttr(htmlAttr),
                        message: "The '" + directive.kind + "' directive can only be used within a text binding."
                    });
            }
        }
        else {
            // Now we have an unknown (user defined) directive.
            // This needs no further type checking, so break the chain
            // Don't break if the "actualType" was found. Then we can do further type checking.
            if (directive.actualType == null) {
                context.break();
            }
        }
    }
};

var rule$7 = {
    id: "no-invalid-tag-name",
    meta: {
        priority: "low"
    },
    visitComponentDefinition: function (definition, context) {
        // Check if the tag name is invalid
        if (!isValidCustomElementName(definition.tagName) && definition.tagName !== "") {
            var node = iterableFirst(definition.tagNameNodes) || iterableFirst(definition.identifierNodes);
            // Only report diagnostic if the tag is not built in,
            //  because this function among other things tests for missing "-" in custom element names
            var tag = context.htmlStore.getHtmlTag(definition.tagName);
            if (node != null && tag != null && !tag.builtIn) {
                context.report({
                    location: rangeFromNode(node),
                    message: "The tag name '" + definition.tagName + "' is not a valid custom element name. Remember that a hyphen (-) is required."
                });
            }
        }
    }
};

var LEGACY_ASSIGNMENT = /^(\[\[[^\]]+\]\]|{{[^}]+}})/;
/**
 * This rule validates that legacy Polymer attribute bindings are not used.
 */
var rule$8 = {
    id: "no-legacy-attribute",
    meta: {
        priority: "medium"
    },
    visitHtmlAttribute: function (htmlAttr, context) {
        if (htmlAttr.htmlNode.kind !== HtmlNodeKind.NODE) {
            return;
        }
        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE && htmlAttr.kind !== HtmlNodeAttrKind.BOOLEAN_ATTRIBUTE) {
            return;
        }
        //const suggestedTarget = suggestTargetForHtmlAttr(htmlAttr, htmlStore);
        var suggestedName = getSuggestedName(htmlAttr.name);
        if (suggestedName !== htmlAttr.name) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Legacy Polymer binding syntax in attribute '" + htmlAttr.name + "'.",
                fixMessage: "Did you mean '" + suggestedName + "'?",
                suggestion: "Legacy Polymer binding syntax is not supported in Lit."
                /*fix: () => ({
                    message: `Change to '${suggestedName}'`,
                    actions: [{ kind: "changeAttributeName", htmlAttr, newName: suggestedName }]
                })*/
            });
        }
    },
    visitHtmlAssignment: function (assignment, context) {
        if (assignment.kind !== HtmlNodeAttrAssignmentKind.STRING) {
            return;
        }
        var htmlAttr = assignment.htmlAttr;
        if (LEGACY_ASSIGNMENT.test(assignment.value)) {
            //const suggestedTarget = suggestTargetForHtmlAttr(htmlAttr, htmlStore);
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Legacy Polymer binding syntax in attribute '" + htmlAttr.name + "'.",
                suggestion: "Legacy Polymer binding syntax is not supported in Lit." + ' Instead you should use JavaScript interpolation, e.g. "attr=${foo}".'
                //suggestedTarget
            });
        }
    }
};
/**
 * Determines the non-legacy attribute name equivalent of the given name
 * @param name legacy name
 */
function getSuggestedName(name) {
    if (name.endsWith("?")) {
        return "?" + name.slice(0, -1);
    }
    if (name.endsWith("$")) {
        return "" + name.slice(0, -1);
    }
    return name;
}

/**
 * This rule validates that legacy Polymer attribute bindings are not used.
 */
var rule$9 = {
    id: "no-missing-element-type-definition",
    meta: {
        priority: "low"
    },
    visitComponentDefinition: function (definition, context) {
        // Don't run this rule on non-typescript files and declaration files
        if (context.file.isDeclarationFile || !context.file.fileName.endsWith(".ts")) {
            return;
        }
        // Try to find the tag name node on "interface HTMLElementTagNameMap"
        var htmlElementTagNameMapTagNameNode = iterableFind(definition.tagNameNodes, function (node) {
            return findParent(node, function (node) { return context.ts.isInterfaceDeclaration(node) && context.ts.isModuleBlock(node.parent) && node.name.getText() === "HTMLElementTagNameMap"; }) != null;
        });
        // Don't continue if the node was found
        if (htmlElementTagNameMapTagNameNode != null) {
            return;
        }
        // Find the identifier node
        var declarationIdentifier = definition.declaration != null ? getNodeIdentifier(definition.declaration.node, context.ts) : undefined;
        if (declarationIdentifier == null) {
            return;
        }
        // Only report diagnostic if the tag is not built in,
        var tag = context.htmlStore.getHtmlTag(definition.tagName);
        if (!(tag === null || tag === void 0 ? void 0 : tag.builtIn)) {
            context.report({
                location: rangeFromNode(declarationIdentifier),
                message: "'" + definition.tagName + "' has not been registered on HTMLElementTagNameMap",
                fix: function () {
                    return {
                        message: "Register '" + definition.tagName + "' on HTMLElementTagNameMap",
                        actions: [
                            {
                                kind: "extendGlobalDeclaration",
                                file: context.file,
                                name: "HTMLElementTagNameMap",
                                newMembers: ["\"" + definition.tagName + "\": " + declarationIdentifier.text]
                            }
                        ]
                    };
                }
            });
        }
    }
};

/**
 * This rule makes sure that all custom elements used are imported in a given file.
 */
var rule$a = {
    id: "no-missing-import",
    meta: {
        priority: "low"
    },
    visitHtmlNode: function (htmlNode, context) {
        var htmlStore = context.htmlStore, config = context.config, definitionStore = context.definitionStore, dependencyStore = context.dependencyStore, file = context.file;
        // Return if the html tag doesn't exists or if the html tag doesn't have a declaration
        var htmlTag = htmlStore.getHtmlTag(htmlNode);
        if (htmlTag == null)
            return;
        // Only check if custom elements have been imported.
        var isCustomElement = isCustomElementTagName(htmlNode.tagName);
        if (!isCustomElement)
            return;
        // Don't continue if this tag name doesn't have a definition.
        // If the html tag doesn't have a definition we won't know how to import it.
        var definition = definitionStore.getDefinitionForTagName(htmlNode.tagName);
        if (definition == null)
            return;
        // Check if the tag name has been imported in the file of the template.
        var isDefinitionImported = dependencyStore.hasTagNameBeenImported(file.fileName, htmlNode.tagName);
        // Report diagnostic if the html tag hasn't been imported.
        if (!isDefinitionImported) {
            context.report({
                location: rangeFromHtmlNode(htmlNode),
                message: "Missing import for <" + htmlNode.tagName + ">",
                suggestion: config.dontSuggestConfigChanges ? undefined : "You can disable this check by disabling the 'no-missing-import' rule.",
                fix: function () {
                    var importPath = getRelativePathForImport(file.fileName, definition.sourceFile.fileName);
                    return {
                        message: "Import <" + definition.tagName + "> from module \"" + importPath + "\"",
                        actions: [
                            {
                                kind: "import",
                                path: importPath,
                                file: context.file
                            }
                        ]
                    };
                }
            });
        }
    }
};
/**
 * Returns a relative path from a file path to another file path.
 * This path can be used in an import statement.
 * @param fromFileName
 * @param toFileName
 */
function getRelativePathForImport(fromFileName, toFileName) {
    var path$1 = path.posix.relative(path.dirname(fromFileName), path.dirname(toFileName));
    var filenameWithoutExt = path.basename(toFileName).replace(/\.[^/.]+$/, "");
    var prefix = path$1.startsWith("../") ? "" : "./";
    var importPath = "" + prefix + (path$1 ? path$1 + "/" : "") + filenameWithoutExt;
    return importPath
        .replace(/^.*node_modules\//, "")
        .replace(/\.d$/, "")
        .replace(/\/index$/, "");
}

/**
 * This rule validates that only callable types are used within event binding expressions.
 * This rule catches typos like: @click="onClick()"
 */
var rule$b = {
    id: "no-noncallable-event-binding",
    meta: {
        priority: "high"
    },
    visitHtmlAssignment: function (assignment, context) {
        // Only validate event listener bindings.
        var htmlAttr = assignment.htmlAttr;
        if (htmlAttr.kind !== HtmlNodeAttrKind.EVENT_LISTENER)
            return;
        var typeB = extractBindingTypes(assignment, context).typeB;
        // Make sure that the expression given to the event listener binding a function or an object with "handleEvent" property.
        if (!isTypeBindableToEventListener(typeB)) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "You are setting up an event listener with a non-callable type '" + tsSimpleType.typeToString(typeB) + "'"
            });
        }
    }
};
/**
 * Returns if this type can be used in a event listener binding
 * @param type
 */
function isTypeBindableToEventListener(type) {
    // Return "true" if the type has a call signature
    if ("call" in type && type.call != null) {
        return true;
    }
    // Callable types can be used in the binding
    if (tsSimpleType.isAssignableToSimpleTypeKind(type, ["FUNCTION", "METHOD", "UNKNOWN"], { matchAny: true })) {
        return true;
    }
    return tsSimpleType.validateType(type, function (simpleType) {
        switch (simpleType.kind) {
            // Object types with attributes for the setup function of the event listener can be used
            case "OBJECT":
            case "INTERFACE": {
                // The "handleEvent" property must be present
                var handleEventFunction = simpleType.members != null ? simpleType.members.find(function (m) { return m.name === "handleEvent"; }) : undefined;
                // The "handleEvent" property must be callable
                if (handleEventFunction != null) {
                    return isTypeBindableToEventListener(handleEventFunction.type);
                }
            }
        }
        return undefined;
    });
}

/**
 * This rule validates that "null" and "undefined" types are not bound in an attribute binding.
 */
var rule$c = {
    id: "no-nullable-attribute-binding",
    meta: {
        priority: "high"
    },
    visitHtmlAssignment: function (assignment, context) {
        // Only validate "expression" kind bindings.
        if (assignment.kind !== HtmlNodeAttrAssignmentKind.EXPRESSION)
            return;
        // Only validate "attribute" bindings because these will coerce null|undefined to a string.
        var htmlAttr = assignment.htmlAttr;
        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE)
            return;
        var typeB = extractBindingTypes(assignment, context).typeB;
        // Test if removing "null" from typeB would work and suggest using "ifDefined(exp === null ? undefined : exp)".
        if (tsSimpleType.isAssignableToSimpleTypeKind(typeB, "NULL")) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "This attribute binds the type '" + tsSimpleType.typeToString(typeB) + "' which can end up binding the string 'null'.",
                fixMessage: "Use the 'ifDefined' directive and strict null check?",
                fix: function () {
                    var newValue = "ifDefined(" + assignment.expression.getText() + " === null ? undefined : " + assignment.expression.getText() + ")";
                    return {
                        message: "Use '" + newValue + "'",
                        actions: [{ kind: "changeAssignment", assignment: assignment, newValue: newValue }]
                    };
                }
            });
        }
        // Test if removing "undefined" from typeB would work and suggest using "ifDefined".
        else if (tsSimpleType.isAssignableToSimpleTypeKind(typeB, "UNDEFINED")) {
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "This attribute binds the type '" + tsSimpleType.typeToString(typeB) + "' which can end up binding the string 'undefined'.",
                fixMessage: "Use the 'ifDefined' directive?",
                fix: function () { return ({
                    message: "Use the 'ifDefined' directive.",
                    actions: [{ kind: "changeAssignment", assignment: assignment, newValue: "ifDefined(" + assignment.expression.getText() + ")" }]
                }); }
            });
        }
    }
};

/**
 * Returns the identifier of the decorator used on the member if any
 * @param member
 * @param context
 */
var getDecoratorIdentifier = function (member, context) {
    var _a, _b;
    var decorator = (_b = (_a = member.meta) === null || _a === void 0 ? void 0 : _a.node) === null || _b === void 0 ? void 0 : _b.decorator;
    if (decorator == null) {
        return undefined;
    }
    return getNodeIdentifier(decorator, context.ts);
};
/**
 * This rule detects mismatches with property visibilities and the decorators
 * they were defined with.
 */
var rule$d = {
    id: "no-property-visibility-mismatch",
    meta: {
        priority: "medium"
    },
    visitComponentMember: function (member, context) {
        // Only run this rule on members of "property" kind
        if (member.kind !== "property") {
            return;
        }
        // Get the decorator of the property if any
        var decoratorIdentifier = getDecoratorIdentifier(member, context);
        if (decoratorIdentifier == null || decoratorIdentifier.getSourceFile() !== context.file) {
            return;
        }
        // Get the decorator of interest
        var decoratorName = decoratorIdentifier.text;
        var hasInternalDecorator = decoratorName === "internalProperty";
        var hasPropertyDecorator = decoratorName === "property";
        // Handle cases where @internalProperty decorator is used, but the property is public
        if (hasInternalDecorator && (member.visibility === "public" || member.visibility == null)) {
            var inJsFile = context.file.fileName.endsWith(".js");
            context.report(__assign({ location: rangeFromNode(decoratorIdentifier), message: "'" + member.propName + "' is marked as an internal property (@internalProperty) but is publicly accessible." }, (inJsFile
                ? {
                // We are in Javascript context. Add "@properted" or "@private" JSDoc
                }
                : {
                    // We are in Typescript context. Add "protected" or "private" keyword
                    fixMessage: "Change the property access to 'private' or 'protected'?",
                    fix: function () {
                        var _a;
                        // Make sure we operate on a property declaration
                        var propertyDeclaration = member.node;
                        if (!context.ts.isPropertyDeclaration(propertyDeclaration)) {
                            return [];
                        }
                        // The modifiers the user can choose to add to fix this warning/error
                        var modifiers = ["protected", "private"];
                        // Get the public modifier if any. If one exists, we want to change that one.
                        var publicModifier = (_a = propertyDeclaration.modifiers) === null || _a === void 0 ? void 0 : _a.find(function (modifier) { return modifier.kind === context.ts.SyntaxKind.PublicKeyword; });
                        if (publicModifier != null) {
                            // Return actions that can replace the modifier
                            return modifiers.map(function (keyword) { return ({
                                message: "Change to '" + keyword + "'",
                                actions: [
                                    {
                                        kind: "changeRange",
                                        range: rangeFromNode(publicModifier),
                                        newText: keyword
                                    }
                                ]
                            }); });
                        }
                        // If there is no existing visibility modifier, add a new modifier right in front of the property name (identifier)
                        var propertyIdentifier = propertyDeclaration.name;
                        if (propertyIdentifier != null) {
                            // Return actions that can add a modifier in front of the identifier
                            return modifiers.map(function (keyword) { return ({
                                message: "Add '" + keyword + "' modifier",
                                actions: [
                                    {
                                        kind: "changeRange",
                                        range: makeSourceFileRange({
                                            start: propertyIdentifier.getStart(),
                                            end: propertyIdentifier.getStart()
                                        }),
                                        newText: keyword + " "
                                    }
                                ]
                            }); });
                        }
                        return [];
                    }
                })));
        }
        // Handle cases where @property decorator is used, but the property is not public
        else if (hasPropertyDecorator && member.visibility !== "public") {
            context.report({
                location: rangeFromNode(decoratorIdentifier),
                message: "'" + member.propName + "' is not publicly accessible but is marked as a public property (@property).",
                fixMessage: "Use the '@internalProperty' decorator instead?",
                fix: function () {
                    var _a;
                    // Return a code action that can replace the identifier of the decorator
                    var newText = "internalProperty";
                    // Change identifier to "internal property"
                    var actions = [
                        {
                            kind: "changeIdentifier",
                            identifier: decoratorIdentifier,
                            newText: newText
                        }
                    ];
                    // Find the object literal node (the config of the "@property" decorator)
                    var objectLiteralNode = findChild(decoratorIdentifier.parent, function (node) {
                        return context.ts.isObjectLiteralExpression(node);
                    });
                    if (objectLiteralNode != null) {
                        // Remove the configuration if the config doesn't have any shared properties with the "internalProperty" config
                        var internalPropertyConfigProperties_1 = ["hasChanged"];
                        if (!((_a = objectLiteralNode.properties) === null || _a === void 0 ? void 0 : _a.some(function (propertyNode) { var _a; return internalPropertyConfigProperties_1.includes(((_a = propertyNode.name) === null || _a === void 0 ? void 0 : _a.getText()) || ""); }))) {
                            actions.push({
                                kind: "changeRange",
                                range: rangeFromNode(objectLiteralNode),
                                newText: ""
                            });
                        }
                    }
                    return {
                        message: "Change to '" + newText + "'",
                        actions: actions
                    };
                }
            });
        }
    }
};

/**
 * This rule validates that all tags are closed properly.
 */
var rule$e = {
    id: "no-unclosed-tag",
    meta: {
        priority: "low"
    },
    visitHtmlNode: function (htmlNode, context) {
        if (!htmlNode.selfClosed && htmlNode.location.endTag == null) {
            // Report specifically that a custom element cannot be self closing
            //   if the user is trying to close a custom element.
            var isCustomElement = isCustomElementTagName(htmlNode.tagName);
            context.report({
                location: rangeFromHtmlNode(htmlNode),
                message: "This tag isn't closed." + (isCustomElement ? " Custom elements cannot be self closing." : "")
            });
        }
        return;
    }
};

var CONTROL_CHARACTERS = ["'", '"', "}", "/"];
/**
 * This rule validates that bindings are not followed by certain characters that indicate typos.
 *
 * Examples:
 *   <input value=${val}' />
 *   <input value='${val}'' />
 *   <input value=${val}} />
 */
var rule$f = {
    id: "no-unintended-mixed-binding",
    meta: {
        priority: "high"
    },
    visitHtmlAssignment: function (assignment, context) {
        // Check only mixed bindings
        if (assignment.kind !== HtmlNodeAttrAssignmentKind.MIXED) {
            return;
        }
        // Only check mixed bindings with 2 values
        if (assignment.values.length !== 2) {
            return;
        }
        // Event listener binding ignores mixed bindings.
        // This kind of binding only uses the first expression present in the mixed binding.
        if (assignment.htmlAttr.kind === HtmlNodeAttrKind.EVENT_LISTENER) {
            return;
        }
        // Ensure the last value is a string literal
        var secondAssignment = assignment.values[1];
        if (typeof secondAssignment !== "string") {
            return;
        }
        // Report error if the string literal is one of the control characters
        if (CONTROL_CHARACTERS.includes(secondAssignment)) {
            var quoteChar_1 = secondAssignment === "'" ? '"' : "'";
            var message = (function () {
                switch (secondAssignment) {
                    case "/":
                        return "This binding is directly followed by a '/' which is probably unintended.";
                    default:
                        return "This binding is directly followed by an unmatched " + quoteChar_1 + secondAssignment + quoteChar_1 + " which is probably unintended.";
                }
            })();
            context.report({
                location: rangeFromHtmlNodeAttr(assignment.htmlAttr),
                message: message
            });
        }
        return;
    }
};

/**
 * Finds the best match between a string and elements in a list.
 * @param find
 * @param elements
 * @param options
 */
function findBestMatch(find, elements, options) {
    options.caseSensitive = "caseSensitive" in options ? options.caseSensitive : false;
    options.threshold = "threshold" in options ? options.threshold : 0.5;
    return (didYouMean__default(find, elements, {
        caseSensitive: options.caseSensitive,
        threshold: options.threshold,
        matchPath: [options.matchKey],
        returnType: didYouMean.ReturnTypeEnums.FIRST_CLOSEST_MATCH,
        trimSpaces: false
    }) || undefined);
}
function findBestStringMatch(find, elements, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.caseSensitive, caseSensitive = _c === void 0 ? true : _c, _d = _b.threshold, threshold = _d === void 0 ? 0.5 : _d;
    var matches = didYouMean__default(find, elements, { caseSensitive: caseSensitive, threshold: threshold });
    return typeof matches === "string" ? matches : Array.isArray(matches) ? matches[0] : undefined;
}

function suggestTargetForHtmlAttr(htmlNodeAttr, htmlStore) {
    var properties = htmlStore.getAllPropertiesForTag(htmlNodeAttr.htmlNode);
    var attributes = htmlStore.getAllAttributesForTag(htmlNodeAttr.htmlNode);
    var events = htmlStore.getAllEventsForTag(htmlNodeAttr.htmlNode);
    switch (htmlNodeAttr.kind) {
        case HtmlNodeAttrKind.EVENT_LISTENER:
            return findSuggestedTarget(htmlNodeAttr.name, [events]);
        case HtmlNodeAttrKind.PROPERTY:
            return findSuggestedTarget(htmlNodeAttr.name, [properties, attributes]);
        case HtmlNodeAttrKind.ATTRIBUTE:
        case HtmlNodeAttrKind.BOOLEAN_ATTRIBUTE:
            return findSuggestedTarget(htmlNodeAttr.name, [attributes, properties]);
    }
}
function findSuggestedTarget(name, tests) {
    var e_1, _a;
    try {
        for (var tests_1 = __values(tests), tests_1_1 = tests_1.next(); !tests_1_1.done; tests_1_1 = tests_1.next()) {
            var test = tests_1_1.value;
            var items = __spread(test);
            // If the search string starts with "on"/"aria", only check members starting with "on"/"aria"
            // If not, remove members starting with "on"/"aria" from the list of items
            if (name.startsWith("on")) {
                items = items.filter(function (item) { return item.name.startsWith("on"); });
            }
            else if (name.startsWith("aria")) {
                items = items.filter(function (item) { return item.name.startsWith("aria"); });
            }
            else {
                items = items.filter(function (item) { return !item.name.startsWith("on") && !item.name.startsWith("aria"); });
            }
            var match = findBestMatch(name, items, { matchKey: "name", caseSensitive: false });
            if (match != null) {
                return match;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (tests_1_1 && !tests_1_1.done && (_a = tests_1.return)) _a.call(tests_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return;
}

/**
 * This rule validates that only known attributes are used in attribute bindings.
 */
var rule$g = {
    id: "no-unknown-attribute",
    meta: {
        priority: "low"
    },
    visitHtmlAttribute: function (htmlAttr, context) {
        var htmlStore = context.htmlStore, config = context.config, definitionStore = context.definitionStore;
        // Ignore "style" and "svg" attrs because I don't yet have all data for them.
        if (htmlAttr.htmlNode.kind !== HtmlNodeKind.NODE)
            return;
        // Only validate attribute bindings.
        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE && htmlAttr.kind !== HtmlNodeAttrKind.BOOLEAN_ATTRIBUTE)
            return;
        // Report a diagnostic if the target is unknown
        var htmlAttrTarget = htmlStore.getHtmlAttrTarget(htmlAttr);
        if (htmlAttrTarget == null) {
            // Don't report unknown attributes on unknown tag names
            var htmlTag = htmlStore.getHtmlTag(htmlAttr.htmlNode);
            if (htmlTag == null)
                return;
            // Ignore unknown "data-" attributes
            if (htmlAttr.name.startsWith("data-"))
                return;
            // Get suggested target
            var suggestedTarget = suggestTargetForHtmlAttr(htmlAttr, htmlStore);
            var suggestedModifier_1 = suggestedTarget == null ? undefined : litAttributeModifierForTarget(suggestedTarget);
            var suggestedMemberName_1 = suggestedTarget == null ? undefined : suggestedTarget.name;
            var suggestion = getSuggestionText({ config: config, htmlTag: htmlTag, definitionStore: definitionStore });
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Unknown attribute '" + htmlAttr.name + "'.",
                fixMessage: suggestedMemberName_1 == null ? undefined : "Did you mean '" + suggestedModifier_1 + suggestedMemberName_1 + "'?",
                suggestion: suggestion,
                fix: function () {
                    return __spread([
                        {
                            message: "Change attribute to 'data-" + htmlAttr.name + "'",
                            actions: [
                                {
                                    kind: "changeAttributeName",
                                    newName: "data-" + htmlAttr.name,
                                    htmlAttr: htmlAttr
                                }
                            ]
                        }
                    ], (suggestedMemberName_1 == null
                        ? []
                        : [
                            {
                                message: "Change attribute to '" + suggestedModifier_1 + suggestedMemberName_1 + "'",
                                actions: [
                                    {
                                        kind: "changeAttributeName",
                                        newName: suggestedMemberName_1,
                                        htmlAttr: htmlAttr
                                    },
                                    {
                                        kind: "changeAttributeModifier",
                                        newModifier: suggestedModifier_1,
                                        htmlAttr: htmlAttr
                                    }
                                ]
                            }
                        ]));
                }
            });
        }
        return;
    }
};
/**
 * Returns are suggestion for the unknown attribute rule.
 * @param config
 * @param definitionStore
 * @param htmlTag
 */
function getSuggestionText(_a) {
    var _b, _c;
    var config = _a.config, definitionStore = _a.definitionStore, htmlTag = _a.htmlTag;
    if (config.dontSuggestConfigChanges) {
        return "Please consider using a data-* attribute.";
    }
    var tagHasDeclaration = htmlTag.declaration != null;
    var tagIsBuiltIn = htmlTag.builtIn || false;
    var tagIsFromLibrary = ((_c = (_b = definitionStore.getDefinitionForTagName(htmlTag.tagName)) === null || _b === void 0 ? void 0 : _b.sourceFile) === null || _c === void 0 ? void 0 : _c.isDeclarationFile) || false;
    return tagIsBuiltIn
        ? "This is a built in tag. Please consider using a 'data-*' attribute, adding the attribute to 'globalAttributes' or disabling the 'no-unknown-attribute' rule."
        : tagIsFromLibrary
            ? "If you are not the author of this component please consider using a 'data-*' attribute, adding the attribute to 'globalAttributes' or disabling the 'no-unknown-attribute' rule."
            : tagHasDeclaration
                ? "Please consider adding it as an attribute on the component, adding '@attr' tag to jsdoc on the component class or using a 'data-*' attribute instead."
                : "Please consider using a 'data-*' attribute.";
}

/**
 * This rule validates that only known events are used in event listener bindings.
 */
var rule$h = {
    id: "no-unknown-event",
    meta: {
        priority: "low"
    },
    visitHtmlAttribute: function (htmlAttr, context) {
        var htmlStore = context.htmlStore, config = context.config, definitionStore = context.definitionStore;
        // Ignore "style" and "svg" attrs because I don't yet have all data for them.
        if (htmlAttr.htmlNode.kind !== HtmlNodeKind.NODE)
            return;
        // Only validate event listener bindings.
        if (htmlAttr.kind !== HtmlNodeAttrKind.EVENT_LISTENER)
            return;
        // Report a diagnostic if the target is unknown
        var htmlAttrTarget = htmlStore.getHtmlAttrTarget(htmlAttr);
        if (htmlAttrTarget == null) {
            // Don't report unknown properties on unknown tags
            var htmlTag = htmlStore.getHtmlTag(htmlAttr.htmlNode);
            if (htmlTag == null)
                return;
            // Get suggested target
            var suggestedTarget = suggestTargetForHtmlAttr(htmlAttr, htmlStore);
            var suggestedMemberName_1 = (suggestedTarget && "" + litAttributeModifierForTarget(suggestedTarget) + suggestedTarget.name) || undefined;
            var suggestion = getSuggestionText$1({ config: config, definitionStore: definitionStore, htmlTag: htmlTag });
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Unknown event '" + htmlAttr.name + "'.",
                fixMessage: suggestedMemberName_1 == null ? undefined : "Did you mean '" + suggestedMemberName_1 + "'?",
                suggestion: suggestion,
                fix: suggestedMemberName_1 == null
                    ? undefined
                    : function () { return ({
                        message: "Change event to '" + suggestedMemberName_1 + "'",
                        actions: [
                            {
                                kind: "changeAttributeName",
                                newName: suggestedMemberName_1,
                                htmlAttr: htmlAttr
                            }
                        ]
                    }); }
            });
        }
    }
};
/**
 * Returns a suggestion text for the unknown event rule.
 * @param config
 * @param definitionStore
 * @param htmlTag
 */
function getSuggestionText$1(_a) {
    var config = _a.config, definitionStore = _a.definitionStore, htmlTag = _a.htmlTag;
    if (config.dontSuggestConfigChanges) {
        return "Please consider adding '@fires " + htmlTag.tagName + "' to the jsdoc on a component class";
    }
    return "Please consider adding '@fires " + htmlTag.tagName + "' to the jsdoc on a component class, adding it to 'globalEvents' or disabling the 'no-unknown-event' rule.";
}

/**
 * This rule validates that only known properties are used in bindings.
 */
var rule$i = {
    id: "no-unknown-property",
    meta: {
        priority: "low"
    },
    visitHtmlAttribute: function (htmlAttr, context) {
        var htmlStore = context.htmlStore, config = context.config, definitionStore = context.definitionStore;
        // Ignore "style" and "svg" attrs because I don't yet have all data for them.
        if (htmlAttr.htmlNode.kind !== HtmlNodeKind.NODE)
            return;
        // Only validate property bindings.
        if (htmlAttr.kind !== HtmlNodeAttrKind.PROPERTY)
            return;
        // Report a diagnostic if the target is unknown.
        var htmlAttrTarget = htmlStore.getHtmlAttrTarget(htmlAttr);
        if (htmlAttrTarget == null) {
            // Don't report unknown properties on unknown tags
            var htmlTag = htmlStore.getHtmlTag(htmlAttr.htmlNode);
            if (htmlTag == null)
                return;
            // Get suggested target because the name could be a typo.
            var suggestedTarget = suggestTargetForHtmlAttr(htmlAttr, htmlStore);
            var suggestedModifier_1 = suggestedTarget == null ? undefined : litAttributeModifierForTarget(suggestedTarget);
            var suggestedMemberName_1 = suggestedTarget == null ? undefined : suggestedTarget.name;
            var suggestion = getSuggestionText$2({ config: config, definitionStore: definitionStore, htmlTag: htmlTag });
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: "Unknown property '" + htmlAttr.name + "'.",
                fixMessage: suggestedMemberName_1 == null ? undefined : "Did you mean '" + suggestedModifier_1 + suggestedMemberName_1 + "'?",
                suggestion: suggestion,
                fix: suggestedMemberName_1 == null
                    ? undefined
                    : function () {
                        return ({
                            message: "Change property to '" + suggestedModifier_1 + suggestedMemberName_1 + "'",
                            actions: [
                                {
                                    kind: "changeAttributeModifier",
                                    newModifier: suggestedModifier_1,
                                    htmlAttr: htmlAttr
                                },
                                {
                                    kind: "changeAttributeName",
                                    newName: suggestedMemberName_1,
                                    htmlAttr: htmlAttr
                                }
                            ]
                        });
                    }
            });
        }
        return;
    }
};
/**
 * Generates a suggestion for the unknown property rule.
 * @param config
 * @param definitionStore
 * @param htmlTag
 */
function getSuggestionText$2(_a) {
    var _b, _c;
    var config = _a.config, definitionStore = _a.definitionStore, htmlTag = _a.htmlTag;
    // Don't generate suggestion if config changes has been disabled.
    if (config.dontSuggestConfigChanges) {
        return undefined;
    }
    var tagHasDeclaration = htmlTag.declaration != null;
    var tagIsBuiltIn = htmlTag.builtIn || false;
    var tagIsFromLibrary = ((_c = iterableFirst((_b = definitionStore.getDefinitionForTagName(htmlTag.tagName)) === null || _b === void 0 ? void 0 : _b.identifierNodes)) === null || _c === void 0 ? void 0 : _c.getSourceFile().isDeclarationFile) || false;
    return tagIsBuiltIn
        ? "This is a built in tag. Please consider disabling the 'no-unknown-property' rule."
        : tagIsFromLibrary
            ? "If you are not the author of this component please consider disabling the 'no-unknown-property' rule."
            : tagHasDeclaration
                ? "Please consider adding a '@prop' tag to jsdoc on the component class or disabling the 'no-unknown-property' rule."
                : "Please consider disabling the 'no-unknown-property' rule.";
}

/**
 * This rule checks validates the slot attribute
 *   and makes sure that slot names used have been defined using jsdoc.
 */
var rule$j = {
    id: "no-unknown-slot",
    meta: {
        priority: "high"
    },
    visitHtmlNode: function (htmlNode, context) {
        var htmlStore = context.htmlStore;
        // This visitor function validates that a "slot" attribute is present on children elements if a slot name is required.
        // Get available slot names from the parent node of this node, because this node defined what slots are available.
        // Example: <my-element><input slot="footer" /></my-element>
        var slots = htmlNode.parent && Array.from(htmlStore.getAllSlotsForTag(htmlNode.parent.tagName));
        // Validate slots for this attribute if any slots have been defined on the parent element, else opt out.
        if (slots == null || slots.length === 0)
            return;
        // Find out if it's possible to use an unnamed slot.
        var unnamedSlot = slots.find(function (s) { return s.name === ""; });
        if (unnamedSlot == null) {
            // If it's not possible to use an unnamed slot, see if there is a "slot" attribute present.
            var slotAttr = htmlNode.attributes.find(function (a) { return a.name === "slot"; });
            if (slotAttr == null) {
                var parentTagName = (htmlNode.parent && htmlNode.parent.tagName) || "";
                // The slot attribute is missing, and it's not possible to use an unnamed slot.
                var validSlotNames_1 = slots.map(function (s) { return s.name; });
                context.report({
                    location: rangeFromHtmlNode(htmlNode),
                    message: "Missing slot attribute. Parent element <" + parentTagName + "> only allows named slots as children.",
                    fixMessage: "Add slot attribute with: " + validSlotNames_1.map(function (n) { return "'" + n + "'"; }).join(" | ") + "?",
                    fix: function () {
                        return validSlotNames_1.map(function (slotName) { return ({
                            message: "Add slot attribute for '" + slotName + "'.",
                            actions: [
                                {
                                    kind: "addAttribute",
                                    htmlNode: htmlNode,
                                    name: "slot",
                                    value: "\"" + slotName + "\""
                                }
                            ]
                        }); });
                    }
                });
            }
        }
    },
    visitHtmlAssignment: function (assignment, context) {
        // This visitor function validates that the value of a "slot" attribute is valid.
        var htmlAttr = assignment.htmlAttr;
        // Only validate attributes with the name "slot"
        if (htmlAttr.name !== "slot")
            return;
        // Only validate attributes that are bound to the attribute
        if (htmlAttr.kind !== HtmlNodeAttrKind.ATTRIBUTE)
            return;
        // Only validate assignments of kind "string"
        if (assignment.kind !== HtmlNodeAttrAssignmentKind.STRING)
            return;
        // Grab the parent node of this attribute. The parent node defines what slot names are valid.
        var parent = htmlAttr.htmlNode.parent;
        if (parent == null)
            return;
        // Validate slots for this attribute if any slots have been defined on the parent element, else opt out.
        var parentHtmlTag = context.htmlStore.getHtmlTag(parent.tagName);
        if (parentHtmlTag == null || parentHtmlTag.slots.length === 0)
            return;
        // Grab the slot name of the "slot" attribute.
        var slotName = assignment.value;
        // Find which slots names are valid, and find if the slot name matches any of these.
        var validSlots = Array.from(context.htmlStore.getAllSlotsForTag(parentHtmlTag.tagName));
        var matchingSlot = validSlots.find(function (slot) { return slot.name === slotName; });
        if (matchingSlot == null) {
            // The slot name doesn't mach any slots! Generate a diagnostic.
            var validSlotNames = validSlots.map(function (s) { return s.name; });
            var message = validSlotNames.length === 1 && validSlotNames[0].length === 0
                ? "Invalid slot name '" + slotName + "'. Only the unnamed slot is valid for <" + parentHtmlTag.tagName + ">"
                : "Invalid slot name '" + slotName + "'. Valid slot names for <" + parentHtmlTag.tagName + "> are: " + validSlotNames.map(function (n) { return "'" + n + "'"; }).join(" | ");
            context.report({
                location: rangeFromHtmlNodeAttr(htmlAttr),
                message: message
            });
        }
    }
};

/**
 * This rule checks that all tag names used in a template are defined.
 */
var rule$k = {
    id: "no-unknown-tag-name",
    meta: {
        priority: "low"
    },
    visitHtmlNode: function (htmlNode, context) {
        var htmlStore = context.htmlStore, config = context.config;
        // Don't validate style and svg yet
        if (htmlNode.kind !== HtmlNodeKind.NODE)
            return;
        // Get the html tag from the html store
        var htmlTag = htmlStore.getHtmlTag(htmlNode);
        // Add diagnostics if the tag couldn't be found (not defined anywhere)
        if (htmlTag == null) {
            // Find a suggested name in the set of defined tag names. Maybe this tag name is a typo?
            var suggestedName_1 = findBestStringMatch(htmlNode.tagName, Array.from(htmlStore.getGlobalTags()).map(function (tag) { return tag.tagName; }));
            // Build a suggestion text
            var suggestion = "Check that you've imported the element, and that it's declared on the HTMLElementTagNameMap.";
            if (!config.dontSuggestConfigChanges) {
                suggestion += " If it can't be imported, consider adding it to the 'globalTags' plugin configuration or disabling the 'no-unknown-tag' rule.";
            }
            context.report({
                location: rangeFromHtmlNode(htmlNode),
                message: "Unknown tag <" + htmlNode.tagName + ">.",
                fixMessage: suggestedName_1 == null ? undefined : "Did you mean <" + suggestedName_1 + ">?",
                suggestion: suggestion,
                fix: suggestedName_1 == null
                    ? undefined
                    : function () { return ({
                        message: "Change tag name to '" + suggestedName_1 + "'",
                        actions: [
                            {
                                kind: "changeTagName",
                                htmlNode: htmlNode,
                                newName: suggestedName_1
                            }
                        ]
                    }); }
            });
        }
        return;
    }
};

var ALL_RULES = [
    rule$2,
    rule$f,
    rule$j,
    rule$b,
    rule$c,
    rule$1,
    rule,
    rule$6,
    rule$4,
    rule$a,
    rule$e,
    rule$k,
    rule$g,
    rule$i,
    rule$h,
    rule$3,
    rule$7,
    rule$5,
    rule$d,
    rule$8,
    rule$9
];

var version=1.1;var tags=[{name:"html",description:{kind:"markdown",value:"The html element represents the root of an HTML document."},attributes:[{name:"manifest",description:{kind:"markdown",value:"Specifies the URI of a resource manifest indicating resources that should be cached locally. See [Using the application cache](https://developer.mozilla.org/en-US/docs/Web/HTML/Using_the_application_cache) for details."}},{name:"version",description:"Specifies the version of the HTML [Document Type Definition](https://developer.mozilla.org/en-US/docs/Glossary/DTD \"Document Type Definition: In HTML, the doctype is the required \"<!DOCTYPE html>\" preamble found at the top of all documents. Its sole purpose is to prevent a browser from switching into so-called “quirks mode” when rendering a document; that is, the \"<!DOCTYPE html>\" doctype ensures that the browser makes a best-effort attempt at following the relevant specifications, rather than using a different rendering mode that is incompatible with some specifications.\") that governs the current document. This attribute is not needed, because it is redundant with the version information in the document type declaration."},{name:"xmlns",description:"Specifies the XML Namespace of the document. Default value is `\"http://www.w3.org/1999/xhtml\"`. This is required in documents parsed with XML parsers, and optional in text/html documents."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/html"}]},{name:"head",description:{kind:"markdown",value:"The head element represents a collection of metadata for the Document."},attributes:[{name:"profile",description:"The URIs of one or more metadata profiles, separated by white space."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/head"}]},{name:"title",description:{kind:"markdown",value:"The title element represents the document's title or name. Authors should use titles that identify their documents even when they are used out of context, for example in a user's history or bookmarks, or in search results. The document's title is often different from its first heading, since the first heading does not have to stand alone when taken out of context."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/title"}]},{name:"base",description:{kind:"markdown",value:"The base element allows authors to specify the document base URL for the purposes of resolving relative URLs, and the name of the default browsing context for the purposes of following hyperlinks. The element does not represent any content beyond this information."},attributes:[{name:"href",description:{kind:"markdown",value:"The base URL to be used throughout the document for relative URL addresses. If this attribute is specified, this element must come before any other elements with attributes whose values are URLs. Absolute and relative URLs are allowed."}},{name:"target",description:{kind:"markdown",value:"A name or keyword indicating the default location to display the result when hyperlinks or forms cause navigation, for elements that do not have an explicit target reference. It is a name of, or keyword for, a _browsing context_ (for example: tab, window, or inline frame). The following keywords have special meanings:\n\n*   `_self`: Load the result into the same browsing context as the current one. This value is the default if the attribute is not specified.\n*   `_blank`: Load the result into a new unnamed browsing context.\n*   `_parent`: Load the result into the parent browsing context of the current one. If there is no parent, this option behaves the same way as `_self`.\n*   `_top`: Load the result into the top-level browsing context (that is, the browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this option behaves the same way as `_self`.\n\nIf this attribute is specified, this element must come before any other elements with attributes whose values are URLs."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/base"}]},{name:"link",description:{kind:"markdown",value:"The link element allows authors to link their document to other resources."},attributes:[{name:"href",description:{kind:"markdown",value:"This attribute specifies the [URL](https://developer.mozilla.org/en-US/docs/Glossary/URL \"URL: Uniform Resource Locator (URL) is a text string specifying where a resource can be found on the Internet.\") of the linked resource. A URL can be absolute or relative."}},{name:"crossorigin",valueSet:"xo",description:{kind:"markdown",value:"This enumerated attribute indicates whether [CORS](https://developer.mozilla.org/en-US/docs/Glossary/CORS \"CORS: CORS (Cross-Origin Resource Sharing) is a system, consisting of transmitting HTTP headers, that determines whether browsers block frontend JavaScript code from accessing responses for cross-origin requests.\") must be used when fetching the resource. [CORS-enabled images](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_Enabled_Image) can be reused in the [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas \"Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.\") element without being _tainted_. The allowed values are:\n\n`anonymous`\n\nA cross-origin request (i.e. with an [`Origin`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Origin \"The Origin request header indicates where a fetch originates from. It doesn't include any path information, but only the server name. It is sent with CORS requests, as well as with POST requests. It is similar to the Referer header, but, unlike this header, it doesn't disclose the whole path.\") HTTP header) is performed, but no credential is sent (i.e. no cookie, X.509 certificate, or HTTP Basic authentication). If the server does not give credentials to the origin site (by not setting the [`Access-Control-Allow-Origin`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Access-Control-Allow-Origin \"The Access-Control-Allow-Origin response header indicates whether the response can be shared with requesting code from the given origin.\") HTTP header) the image will be tainted and its usage restricted.\n\n`use-credentials`\n\nA cross-origin request (i.e. with an `Origin` HTTP header) is performed along with a credential sent (i.e. a cookie, certificate, and/or HTTP Basic authentication is performed). If the server does not give credentials to the origin site (through [`Access-Control-Allow-Credentials`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Access-Control-Allow-Credentials \"The Access-Control-Allow-Credentials response header tells browsers whether to expose the response to frontend JavaScript code when the request's credentials mode (Request.credentials) is \"include\".\") HTTP header), the resource will be _tainted_ and its usage restricted.\n\nIf the attribute is not present, the resource is fetched without a [CORS](https://developer.mozilla.org/en-US/docs/Glossary/CORS \"CORS: CORS (Cross-Origin Resource Sharing) is a system, consisting of transmitting HTTP headers, that determines whether browsers block frontend JavaScript code from accessing responses for cross-origin requests.\") request (i.e. without sending the `Origin` HTTP header), preventing its non-tainted usage. If invalid, it is handled as if the enumerated keyword **anonymous** was used. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes) for additional information."}},{name:"rel",description:{kind:"markdown",value:"This attribute names a relationship of the linked document to the current document. The attribute must be a space-separated list of the [link types values](https://developer.mozilla.org/en-US/docs/Web/HTML/Link_types)."}},{name:"media",description:{kind:"markdown",value:"This attribute specifies the media that the linked resource applies to. Its value must be a media type / [media query](https://developer.mozilla.org/en-US/docs/Web/CSS/Media_queries). This attribute is mainly useful when linking to external stylesheets — it allows the user agent to pick the best adapted one for the device it runs on.\n\n**Notes:**\n\n*   In HTML 4, this can only be a simple white-space-separated list of media description literals, i.e., [media types and groups](https://developer.mozilla.org/en-US/docs/Web/CSS/@media), where defined and allowed as values for this attribute, such as `print`, `screen`, `aural`, `braille`. HTML5 extended this to any kind of [media queries](https://developer.mozilla.org/en-US/docs/Web/CSS/Media_queries), which are a superset of the allowed values of HTML 4.\n*   Browsers not supporting [CSS3 Media Queries](https://developer.mozilla.org/en-US/docs/Web/CSS/Media_queries) won't necessarily recognize the adequate link; do not forget to set fallback links, the restricted set of media queries defined in HTML 4."}},{name:"hreflang",description:{kind:"markdown",value:"This attribute indicates the language of the linked resource. It is purely advisory. Allowed values are determined by [BCP47](https://www.ietf.org/rfc/bcp/bcp47.txt). Use this attribute only if the [`href`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#attr-href) attribute is present."}},{name:"type",description:{kind:"markdown",value:"This attribute is used to define the type of the content linked to. The value of the attribute should be a MIME type such as **text/html**, **text/css**, and so on. The common use of this attribute is to define the type of stylesheet being referenced (such as **text/css**), but given that CSS is the only stylesheet language used on the web, not only is it possible to omit the `type` attribute, but is actually now recommended practice. It is also used on `rel=\"preload\"` link types, to make sure the browser only downloads file types that it supports."}},{name:"sizes",description:{kind:"markdown",value:"This attribute defines the sizes of the icons for visual media contained in the resource. It must be present only if the [`rel`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/link#attr-rel) contains a value of `icon` or a non-standard type such as Apple's `apple-touch-icon`. It may have the following values:\n\n*   `any`, meaning that the icon can be scaled to any size as it is in a vector format, like `image/svg+xml`.\n*   a white-space separated list of sizes, each in the format `_<width in pixels>_x_<height in pixels>_` or `_<width in pixels>_X_<height in pixels>_`. Each of these sizes must be contained in the resource.\n\n**Note:** Most icon formats are only able to store one single icon; therefore most of the time the [`sizes`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-sizes) contains only one entry. MS's ICO format does, as well as Apple's ICNS. ICO is more ubiquitous; you should definitely use it."}},{name:"as",description:"This attribute is only used when `rel=\"preload\"` or `rel=\"prefetch\"` has been set on the `<link>` element. It specifies the type of content being loaded by the `<link>`, which is necessary for content prioritization, request matching, application of correct [content security policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP), and setting of correct [`Accept`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Accept \"The Accept request HTTP header advertises which content types, expressed as MIME types, the client is able to understand. Using content negotiation, the server then selects one of the proposals, uses it and informs the client of its choice with the Content-Type response header. Browsers set adequate values for this header depending on the context where the request is done: when fetching a CSS stylesheet a different value is set for the request than when fetching an image, video or a script.\") request header."},{name:"importance",description:"Indicates the relative importance of the resource. Priority hints are delegated using the values:"},{name:"importance",description:"**`auto`**: Indicates **no preference**. The browser may use its own heuristics to decide the priority of the resource.\n\n**`high`**: Indicates to the browser that the resource is of **high** priority.\n\n**`low`**: Indicates to the browser that the resource is of **low** priority.\n\n**Note:** The `importance` attribute may only be used for the `<link>` element if `rel=\"preload\"` or `rel=\"prefetch\"` is present."},{name:"integrity",description:"Contains inline metadata — a base64-encoded cryptographic hash of the resource (file) you’re telling the browser to fetch. The browser can use this to verify that the fetched resource has been delivered free of unexpected manipulation. See [Subresource Integrity](https://developer.mozilla.org/en-US/docs/Web/Security/Subresource_Integrity)."},{name:"referrerpolicy",description:"A string indicating which referrer to use when fetching the resource:\n\n*   `no-referrer` means that the [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent.\n*   `no-referrer-when-downgrade` means that no [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will be sent when navigating to an origin without TLS (HTTPS). This is a user agent’s default behavior, if no policy is otherwise specified.\n*   `origin` means that the referrer will be the origin of the page, which is roughly the scheme, the host, and the port.\n*   `origin-when-cross-origin` means that navigating to other origins will be limited to the scheme, the host, and the port, while navigating on the same origin will include the referrer's path.\n*   `unsafe-url` means that the referrer will include the origin and the path (but not the fragment, password, or username). This case is unsafe because it can leak origins and paths from TLS-protected resources to insecure origins."},{name:"title",description:"The `title` attribute has special semantics on the `<link>` element. When used on a `<link rel=\"stylesheet\">` it defines a [preferred or an alternate stylesheet](https://developer.mozilla.org/en-US/docs/Web/CSS/Alternative_style_sheets). Incorrectly using it may [cause the stylesheet to be ignored](https://developer.mozilla.org/en-US/docs/Correctly_Using_Titles_With_External_Stylesheets)."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/link"}]},{name:"meta",description:{kind:"markdown",value:"The meta element represents various kinds of metadata that cannot be expressed using the title, base, link, style, and script elements."},attributes:[{name:"name",description:{kind:"markdown",value:"This attribute defines the name of a piece of document-level metadata. It should not be set if one of the attributes [`itemprop`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-itemprop), [`http-equiv`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-http-equiv) or [`charset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-charset) is also set.\n\nThis metadata name is associated with the value contained by the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) attribute. The possible values for the name attribute are:\n\n*   `application-name` which defines the name of the application running in the web page.\n    \n    **Note:**\n    \n    *   Browsers may use this to identify the application. It is different from the [`<title>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/title \"The HTML Title element (<title>) defines the document's title that is shown in a browser's title bar or a page's tab.\") element, which usually contain the application name, but may also contain information like the document name or a status.\n    *   Simple web pages shouldn't define an application-name.\n    \n*   `author` which defines the name of the document's author.\n*   `description` which contains a short and accurate summary of the content of the page. Several browsers, like Firefox and Opera, use this as the default description of bookmarked pages.\n*   `generator` which contains the identifier of the software that generated the page.\n*   `keywords` which contains words relevant to the page's content separated by commas.\n*   `referrer` which controls the [`Referer` HTTP header](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer) attached to requests sent from the document:\n    \n    Values for the `content` attribute of `<meta name=\"referrer\">`\n    \n    `no-referrer`\n    \n    Do not send a HTTP `Referrer` header.\n    \n    `origin`\n    \n    Send the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) of the document.\n    \n    `no-referrer-when-downgrade`\n    \n    Send the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) as a referrer to URLs as secure as the current page, (https→https), but does not send a referrer to less secure URLs (https→http). This is the default behaviour.\n    \n    `origin-when-cross-origin`\n    \n    Send the full URL (stripped of parameters) for same-origin requests, but only send the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) for other cases.\n    \n    `same-origin`\n    \n    A referrer will be sent for [same-site origins](https://developer.mozilla.org/en-US/docs/Web/Security/Same-origin_policy), but cross-origin requests will contain no referrer information.\n    \n    `strict-origin`\n    \n    Only send the origin of the document as the referrer to a-priori as-much-secure destination (HTTPS->HTTPS), but don't send it to a less secure destination (HTTPS->HTTP).\n    \n    `strict-origin-when-cross-origin`\n    \n    Send a full URL when performing a same-origin request, only send the origin of the document to a-priori as-much-secure destination (HTTPS->HTTPS), and send no header to a less secure destination (HTTPS->HTTP).\n    \n    `unsafe-URL`\n    \n    Send the full URL (stripped of parameters) for same-origin or cross-origin requests.\n    \n    **Notes:**\n    \n    *   Some browsers support the deprecated values of `always`, `default`, and `never` for referrer.\n    *   Dynamically inserting `<meta name=\"referrer\">` (with [`document.write`](https://developer.mozilla.org/en-US/docs/Web/API/Document/write) or [`appendChild`](https://developer.mozilla.org/en-US/docs/Web/API/Node/appendChild)) makes the referrer behaviour unpredictable.\n    *   When several conflicting policies are defined, the no-referrer policy is applied.\n    \n\nThis attribute may also have a value taken from the extended list defined on [WHATWG Wiki MetaExtensions page](https://wiki.whatwg.org/wiki/MetaExtensions). Although none have been formally accepted yet, a few commonly used names are:\n\n*   `creator` which defines the name of the creator of the document, such as an organization or institution. If there are more than one, several [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta \"The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.\") elements should be used.\n*   `googlebot`, a synonym of `robots`, is only followed by Googlebot (the indexing crawler for Google).\n*   `publisher` which defines the name of the document's publisher.\n*   `robots` which defines the behaviour that cooperative crawlers, or \"robots\", should use with the page. It is a comma-separated list of the values below:\n    \n    Values for the content of `<meta name=\"robots\">`\n    \n    Value\n    \n    Description\n    \n    Used by\n    \n    `index`\n    \n    Allows the robot to index the page (default).\n    \n    All\n    \n    `noindex`\n    \n    Requests the robot to not index the page.\n    \n    All\n    \n    `follow`\n    \n    Allows the robot to follow the links on the page (default).\n    \n    All\n    \n    `nofollow`\n    \n    Requests the robot to not follow the links on the page.\n    \n    All\n    \n    `none`\n    \n    Equivalent to `noindex, nofollow`\n    \n    [Google](https://support.google.com/webmasters/answer/79812)\n    \n    `noodp`\n    \n    Prevents using the [Open Directory Project](https://www.dmoz.org/) description, if any, as the page description in search engine results.\n    \n    [Google](https://support.google.com/webmasters/answer/35624#nodmoz), [Yahoo](https://help.yahoo.com/kb/search-for-desktop/meta-tags-robotstxt-yahoo-search-sln2213.html#cont5), [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)\n    \n    `noarchive`\n    \n    Requests the search engine not to cache the page content.\n    \n    [Google](https://developers.google.com/webmasters/control-crawl-index/docs/robots_meta_tag#valid-indexing--serving-directives), [Yahoo](https://help.yahoo.com/kb/search-for-desktop/SLN2213.html), [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)\n    \n    `nosnippet`\n    \n    Prevents displaying any description of the page in search engine results.\n    \n    [Google](https://developers.google.com/webmasters/control-crawl-index/docs/robots_meta_tag#valid-indexing--serving-directives), [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)\n    \n    `noimageindex`\n    \n    Requests this page not to appear as the referring page of an indexed image.\n    \n    [Google](https://developers.google.com/webmasters/control-crawl-index/docs/robots_meta_tag#valid-indexing--serving-directives)\n    \n    `nocache`\n    \n    Synonym of `noarchive`.\n    \n    [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)\n    \n    **Notes:**\n    \n    *   Only cooperative robots follow these rules. Do not expect to prevent e-mail harvesters with them.\n    *   The robot still needs to access the page in order to read these rules. To prevent bandwidth consumption, use a _[robots.txt](https://developer.mozilla.org/en-US/docs/Glossary/robots.txt \"robots.txt: Robots.txt is a file which is usually placed in the root of any website. It decides whether crawlers are permitted or forbidden access to the web site.\")_ file.\n    *   If you want to remove a page, `noindex` will work, but only after the robot visits the page again. Ensure that the `robots.txt` file is not preventing revisits.\n    *   Some values are mutually exclusive, like `index` and `noindex`, or `follow` and `nofollow`. In these cases the robot's behaviour is undefined and may vary between them.\n    *   Some crawler robots, like Google, Yahoo and Bing, support the same values for the HTTP header `X-Robots-Tag`; this allows non-HTML documents like images to use these rules.\n    \n*   `slurp`, is a synonym of `robots`, but only for Slurp - the crawler for Yahoo Search.\n*   `viewport`, which gives hints about the size of the initial size of the [viewport](https://developer.mozilla.org/en-US/docs/Glossary/viewport \"viewport: A viewport represents a polygonal (normally rectangular) area in computer graphics that is currently being viewed. In web browser terms, it refers to the part of the document you're viewing which is currently visible in its window (or the screen, if the document is being viewed in full screen mode). Content outside the viewport is not visible onscreen until scrolled into view.\"). Used by mobile devices only.\n    \n    Values for the content of `<meta name=\"viewport\">`\n    \n    Value\n    \n    Possible subvalues\n    \n    Description\n    \n    `width`\n    \n    A positive integer number, or the text `device-width`\n    \n    Defines the pixel width of the viewport that you want the web site to be rendered at.\n    \n    `height`\n    \n    A positive integer, or the text `device-height`\n    \n    Defines the height of the viewport. Not used by any browser.\n    \n    `initial-scale`\n    \n    A positive number between `0.0` and `10.0`\n    \n    Defines the ratio between the device width (`device-width` in portrait mode or `device-height` in landscape mode) and the viewport size.\n    \n    `maximum-scale`\n    \n    A positive number between `0.0` and `10.0`\n    \n    Defines the maximum amount to zoom in. It must be greater or equal to the `minimum-scale` or the behaviour is undefined. Browser settings can ignore this rule and iOS10+ ignores it by default.\n    \n    `minimum-scale`\n    \n    A positive number between `0.0` and `10.0`\n    \n    Defines the minimum zoom level. It must be smaller or equal to the `maximum-scale` or the behaviour is undefined. Browser settings can ignore this rule and iOS10+ ignores it by default.\n    \n    `user-scalable`\n    \n    `yes` or `no`\n    \n    If set to `no`, the user is not able to zoom in the webpage. The default is `yes`. Browser settings can ignore this rule, and iOS10+ ignores it by default.\n    \n    Specification\n    \n    Status\n    \n    Comment\n    \n    [CSS Device Adaptation  \n    The definition of '<meta name=\"viewport\">' in that specification.](https://drafts.csswg.org/css-device-adapt/#viewport-meta)\n    \n    Working Draft\n    \n    Non-normatively describes the Viewport META element\n    \n    See also: [`@viewport`](https://developer.mozilla.org/en-US/docs/Web/CSS/@viewport \"The @viewport CSS at-rule lets you configure the viewport through which the document is viewed. It's primarily used for mobile devices, but is also used by desktop browsers that support features like \"snap to edge\" (such as Microsoft Edge).\")\n    \n    **Notes:**\n    \n    *   Though unstandardized, this declaration is respected by most mobile browsers due to de-facto dominance.\n    *   The default values may vary between devices and browsers.\n    *   To learn about this declaration in Firefox for Mobile, see [this article](https://developer.mozilla.org/en-US/docs/Mobile/Viewport_meta_tag \"Mobile/Viewport meta tag\")."}},{name:"http-equiv",description:{kind:"markdown",value:"Defines a pragma directive. The attribute is named `**http-equiv**(alent)` because all the allowed values are names of particular HTTP headers:\n\n*   `\"content-language\"`  \n    Defines the default language of the page. It can be overridden by the [lang](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/lang) attribute on any element.\n    \n    **Warning:** Do not use this value, as it is obsolete. Prefer the `lang` attribute on the [`<html>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/html \"The HTML <html> element represents the root (top-level element) of an HTML document, so it is also referred to as the root element. All other elements must be descendants of this element.\") element.\n    \n*   `\"content-security-policy\"`  \n    Allows page authors to define a [content policy](https://developer.mozilla.org/en-US/docs/Web/Security/CSP/CSP_policy_directives) for the current page. Content policies mostly specify allowed server origins and script endpoints which help guard against cross-site scripting attacks.\n*   `\"content-type\"`  \n    Defines the [MIME type](https://developer.mozilla.org/en-US/docs/Glossary/MIME_type) of the document, followed by its character encoding. It follows the same syntax as the HTTP `content-type` entity-header field, but as it is inside a HTML page, most values other than `text/html` are impossible. Therefore the valid syntax for its `content` is the string '`text/html`' followed by a character set with the following syntax: '`; charset=_IANAcharset_`', where `IANAcharset` is the _preferred MIME name_ for a character set as [defined by the IANA.](https://www.iana.org/assignments/character-sets)\n    \n    **Warning:** Do not use this value, as it is obsolete. Use the [`charset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-charset) attribute on the [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta \"The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.\") element.\n    \n    **Note:** As [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta \"The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.\") can't change documents' types in XHTML or HTML5's XHTML serialization, never set the MIME type to an XHTML MIME type with `<meta>`.\n    \n*   `\"refresh\"`  \n    This instruction specifies:\n    *   The number of seconds until the page should be reloaded - only if the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) attribute contains a positive integer.\n    *   The number of seconds until the page should redirect to another - only if the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) attribute contains a positive integer followed by the string '`;url=`', and a valid URL.\n*   `\"set-cookie\"`  \n    Defines a [cookie](https://developer.mozilla.org/en-US/docs/cookie) for the page. Its content must follow the syntax defined in the [IETF HTTP Cookie Specification](https://tools.ietf.org/html/draft-ietf-httpstate-cookie-14).\n    \n    **Warning:** Do not use this instruction, as it is obsolete. Use the HTTP header [`Set-Cookie`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Set-Cookie) instead."}},{name:"content",description:{kind:"markdown",value:"This attribute contains the value for the [`http-equiv`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-http-equiv) or [`name`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-name) attribute, depending on which is used."}},{name:"charset",description:{kind:"markdown",value:"This attribute declares the page's character encoding. It must contain a [standard IANA MIME name for character encodings](https://www.iana.org/assignments/character-sets). Although the standard doesn't request a specific encoding, it suggests:\n\n*   Authors are encouraged to use [`UTF-8`](https://developer.mozilla.org/en-US/docs/Glossary/UTF-8).\n*   Authors should not use ASCII-incompatible encodings to avoid security risk: browsers not supporting them may interpret harmful content as HTML. This happens with the `JIS_C6226-1983`, `JIS_X0212-1990`, `HZ-GB-2312`, `JOHAB`, the ISO-2022 family and the EBCDIC family.\n\n**Note:** ASCII-incompatible encodings are those that don't map the 8-bit code points `0x20` to `0x7E` to the `0x0020` to `0x007E` Unicode code points)\n\n*   Authors **must not** use `CESU-8`, `UTF-7`, `BOCU-1` and/or `SCSU` as [cross-site scripting](https://developer.mozilla.org/en-US/docs/Glossary/Cross-site_scripting) attacks with these encodings have been demonstrated.\n*   Authors should not use `UTF-32` because not all HTML5 encoding algorithms can distinguish it from `UTF-16`.\n\n**Notes:**\n\n*   The declared character encoding must match the one the page was saved with to avoid garbled characters and security holes.\n*   The [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta \"The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.\") element declaring the encoding must be inside the [`<head>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/head \"The HTML <head> element provides general information (metadata) about the document, including its title and links to its scripts and style sheets.\") element and **within the first 1024 bytes** of the HTML as some browsers only look at those bytes before choosing an encoding.\n*   This [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta \"The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.\") element is only one part of the [algorithm to determine a page's character set](https://www.whatwg.org/specs/web-apps/current-work/multipage/parsing.html#encoding-sniffing-algorithm \"Algorithm charset page\"). The [`Content-Type` header](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Type) and any [Byte-Order Marks](https://developer.mozilla.org/en-US/docs/Glossary/Byte-Order_Mark \"The definition of that term (Byte-Order Marks) has not been written yet; please consider contributing it!\") override this element.\n*   It is strongly recommended to define the character encoding. If a page's encoding is undefined, cross-scripting techniques are possible, such as the [`UTF-7` fallback cross-scripting technique](https://code.google.com/p/doctype-mirror/wiki/ArticleUtf7).\n*   The [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta \"The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.\") element with a `charset` attribute is a synonym for the pre-HTML5 `<meta http-equiv=\"Content-Type\" content=\"text/html; charset=_IANAcharset_\">`, where _`IANAcharset`_ contains the value of the equivalent [`charset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-charset) attribute. This syntax is still allowed, although no longer recommended."}},{name:"scheme",description:"This attribute defines the scheme in which metadata is described. A scheme is a context leading to the correct interpretations of the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) value, like a format.\n\n**Warning:** Do not use this value, as it is obsolete. There is no replacement as there was no real usage for it."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/meta"}]},{name:"style",description:{kind:"markdown",value:"The style element allows authors to embed style information in their documents. The style element is one of several inputs to the styling processing model. The element does not represent content for the user."},attributes:[{name:"media",description:{kind:"markdown",value:"This attribute defines which media the style should be applied to. Its value is a [media query](https://developer.mozilla.org/en-US/docs/Web/Guide/CSS/Media_queries), which defaults to `all` if the attribute is missing."}},{name:"nonce",description:{kind:"markdown",value:"A cryptographic nonce (number used once) used to whitelist inline styles in a [style-src Content-Security-Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/style-src). The server must generate a unique nonce value each time it transmits a policy. It is critical to provide a nonce that cannot be guessed as bypassing a resource’s policy is otherwise trivial."}},{name:"type",description:{kind:"markdown",value:"This attribute defines the styling language as a MIME type (charset should not be specified). This attribute is optional and defaults to `text/css` if it is not specified — there is very little reason to include this in modern web documents."}},{name:"scoped",valueSet:"v"},{name:"title",description:"This attribute specifies [alternative style sheet](https://developer.mozilla.org/en-US/docs/Web/CSS/Alternative_style_sheets) sets."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/style"}]},{name:"body",description:{kind:"markdown",value:"The body element represents the content of the document."},attributes:[{name:"onafterprint",description:{kind:"markdown",value:"Function to call after the user has printed the document."}},{name:"onbeforeprint",description:{kind:"markdown",value:"Function to call when the user requests printing of the document."}},{name:"onbeforeunload",description:{kind:"markdown",value:"Function to call when the document is about to be unloaded."}},{name:"onhashchange",description:{kind:"markdown",value:"Function to call when the fragment identifier part (starting with the hash (`'#'`) character) of the document's current address has changed."}},{name:"onlanguagechange",description:{kind:"markdown",value:"Function to call when the preferred languages changed."}},{name:"onmessage",description:{kind:"markdown",value:"Function to call when the document has received a message."}},{name:"onoffline",description:{kind:"markdown",value:"Function to call when network communication has failed."}},{name:"ononline",description:{kind:"markdown",value:"Function to call when network communication has been restored."}},{name:"onpagehide"},{name:"onpageshow"},{name:"onpopstate",description:{kind:"markdown",value:"Function to call when the user has navigated session history."}},{name:"onstorage",description:{kind:"markdown",value:"Function to call when the storage area has changed."}},{name:"onunload",description:{kind:"markdown",value:"Function to call when the document is going away."}},{name:"alink",description:"Color of text for hyperlinks when selected. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color \"The color CSS property sets the foreground color value of an element's text and text decorations, and sets the currentcolor value.\") property in conjunction with the [`:active`](https://developer.mozilla.org/en-US/docs/Web/CSS/:active \"The :active CSS pseudo-class represents an element (such as a button) that is being activated by the user.\") pseudo-class instead._"},{name:"background",description:"URI of a image to use as a background. _This method is non-conforming, use CSS [`background`](https://developer.mozilla.org/en-US/docs/Web/CSS/background \"The background shorthand CSS property sets all background style properties at once, such as color, image, origin and size, or repeat method.\") property on the element instead._"},{name:"bgcolor",description:"Background color for the document. _This method is non-conforming, use CSS [`background-color`](https://developer.mozilla.org/en-US/docs/Web/CSS/background-color \"The background-color CSS property sets the background color of an element.\") property on the element instead._"},{name:"bottommargin",description:"The margin of the bottom of the body. _This method is non-conforming, use CSS [`margin-bottom`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-bottom \"The margin-bottom CSS property sets the margin area on the bottom of an element. A positive value places it farther from its neighbors, while a negative value places it closer.\") property on the element instead._"},{name:"leftmargin",description:"The margin of the left of the body. _This method is non-conforming, use CSS [`margin-left`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-left \"The margin-left CSS property sets the margin area on the left side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.\") property on the element instead._"},{name:"link",description:"Color of text for unvisited hypertext links. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color \"The color CSS property sets the foreground color value of an element's text and text decorations, and sets the currentcolor value.\") property in conjunction with the [`:link`](https://developer.mozilla.org/en-US/docs/Web/CSS/:link \"The :link CSS pseudo-class represents an element that has not yet been visited. It matches every unvisited <a>, <area>, or <link> element that has an href attribute.\") pseudo-class instead._"},{name:"onblur",description:"Function to call when the document loses focus."},{name:"onerror",description:"Function to call when the document fails to load properly."},{name:"onfocus",description:"Function to call when the document receives focus."},{name:"onload",description:"Function to call when the document has finished loading."},{name:"onredo",description:"Function to call when the user has moved forward in undo transaction history."},{name:"onresize",description:"Function to call when the document has been resized."},{name:"onundo",description:"Function to call when the user has moved backward in undo transaction history."},{name:"rightmargin",description:"The margin of the right of the body. _This method is non-conforming, use CSS [`margin-right`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-right \"The margin-right CSS property sets the margin area on the right side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.\") property on the element instead._"},{name:"text",description:"Foreground color of text. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color \"The color CSS property sets the foreground color value of an element's text and text decorations, and sets the currentcolor value.\") property on the element instead._"},{name:"topmargin",description:"The margin of the top of the body. _This method is non-conforming, use CSS [`margin-top`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-top \"The margin-top CSS property sets the margin area on the top of an element. A positive value places it farther from its neighbors, while a negative value places it closer.\") property on the element instead._"},{name:"vlink",description:"Color of text for visited hypertext links. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color \"The color CSS property sets the foreground color value of an element's text and text decorations, and sets the currentcolor value.\") property in conjunction with the [`:visited`](https://developer.mozilla.org/en-US/docs/Web/CSS/:visited \"The :visited CSS pseudo-class represents links that the user has already visited. For privacy reasons, the styles that can be modified using this selector are very limited.\") pseudo-class instead._"}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/body"}]},{name:"article",description:{kind:"markdown",value:"The article element represents a complete, or self-contained, composition in a document, page, application, or site and that is, in principle, independently distributable or reusable, e.g. in syndication. This could be a forum post, a magazine or newspaper article, a blog entry, a user-submitted comment, an interactive widget or gadget, or any other independent item of content. Each article should be identified, typically by including a heading (h1–h6 element) as a child of the article element."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/article"}]},{name:"section",description:{kind:"markdown",value:"The section element represents a generic section of a document or application. A section, in this context, is a thematic grouping of content. Each section should be identified, typically by including a heading ( h1- h6 element) as a child of the section element."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/section"}]},{name:"nav",description:{kind:"markdown",value:"The nav element represents a section of a page that links to other pages or to parts within the page: a section with navigation links."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/nav"}]},{name:"aside",description:{kind:"markdown",value:"The aside element represents a section of a page that consists of content that is tangentially related to the content around the aside element, and which could be considered separate from that content. Such sections are often represented as sidebars in printed typography."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/aside"}]},{name:"h1",description:{kind:"markdown",value:"The h1 element represents a section heading."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"}]},{name:"h2",description:{kind:"markdown",value:"The h2 element represents a section heading."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"}]},{name:"h3",description:{kind:"markdown",value:"The h3 element represents a section heading."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"}]},{name:"h4",description:{kind:"markdown",value:"The h4 element represents a section heading."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"}]},{name:"h5",description:{kind:"markdown",value:"The h5 element represents a section heading."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"}]},{name:"h6",description:{kind:"markdown",value:"The h6 element represents a section heading."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"}]},{name:"header",description:{kind:"markdown",value:"The header element represents introductory content for its nearest ancestor sectioning content or sectioning root element. A header typically contains a group of introductory or navigational aids. When the nearest ancestor sectioning content or sectioning root element is the body element, then it applies to the whole page."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/header"}]},{name:"footer",description:{kind:"markdown",value:"The footer element represents a footer for its nearest ancestor sectioning content or sectioning root element. A footer typically contains information about its section such as who wrote it, links to related documents, copyright data, and the like."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/footer"}]},{name:"address",description:{kind:"markdown",value:"The address element represents the contact information for its nearest article or body element ancestor. If that is the body element, then the contact information applies to the document as a whole."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/address"}]},{name:"p",description:{kind:"markdown",value:"The p element represents a paragraph."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/p"}]},{name:"hr",description:{kind:"markdown",value:"The hr element represents a paragraph-level thematic break, e.g. a scene change in a story, or a transition to another topic within a section of a reference book."},attributes:[{name:"align",description:"Sets the alignment of the rule on the page. If no value is specified, the default value is `left`."},{name:"color",description:"Sets the color of the rule through color name or hexadecimal value."},{name:"noshade",description:"Sets the rule to have no shading."},{name:"size",description:"Sets the height, in pixels, of the rule."},{name:"width",description:"Sets the length of the rule on the page through a pixel or percentage value."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/hr"}]},{name:"pre",description:{kind:"markdown",value:"The pre element represents a block of preformatted text, in which structure is represented by typographic conventions rather than by elements."},attributes:[{name:"cols",description:"Contains the _preferred_ count of characters that a line should have. It was a non-standard synonym of [`width`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/pre#attr-width). To achieve such an effect, use CSS [`width`](https://developer.mozilla.org/en-US/docs/Web/CSS/width \"The width CSS property sets an element's width. By default it sets the width of the content area, but if box-sizing is set to border-box, it sets the width of the border area.\") instead."},{name:"width",description:"Contains the _preferred_ count of characters that a line should have. Though technically still implemented, this attribute has no visual effect; to achieve such an effect, use CSS [`width`](https://developer.mozilla.org/en-US/docs/Web/CSS/width \"The width CSS property sets an element's width. By default it sets the width of the content area, but if box-sizing is set to border-box, it sets the width of the border area.\") instead."},{name:"wrap",description:"Is a _hint_ indicating how the overflow must happen. In modern browser this hint is ignored and no visual effect results in its present; to achieve such an effect, use CSS [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space \"The white-space CSS property sets how white space inside an element is handled.\") instead."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/pre"}]},{name:"blockquote",description:{kind:"markdown",value:"The blockquote element represents content that is quoted from another source, optionally with a citation which must be within a footer or cite element, and optionally with in-line changes such as annotations and abbreviations."},attributes:[{name:"cite",description:{kind:"markdown",value:"A URL that designates a source document or message for the information quoted. This attribute is intended to point to information explaining the context or the reference for the quote."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/blockquote"}]},{name:"ol",description:{kind:"markdown",value:"The ol element represents a list of items, where the items have been intentionally ordered, such that changing the order would change the meaning of the document."},attributes:[{name:"reversed",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute specifies that the items of the list are specified in reversed order."}},{name:"start",description:{kind:"markdown",value:"This integer attribute specifies the start value for numbering the individual list items. Although the ordering type of list elements might be Roman numerals, such as XXXI, or letters, the value of start is always represented as a number. To start numbering elements from the letter \"C\", use `<ol start=\"3\">`.\n\n**Note**: This attribute was deprecated in HTML4, but reintroduced in HTML5."}},{name:"type",valueSet:"lt",description:{kind:"markdown",value:"Indicates the numbering type:\n\n*   `'a'` indicates lowercase letters,\n*   `'A'` indicates uppercase letters,\n*   `'i'` indicates lowercase Roman numerals,\n*   `'I'` indicates uppercase Roman numerals,\n*   and `'1'` indicates numbers (default).\n\nThe type set is used for the entire list unless a different [`type`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/li#attr-type) attribute is used within an enclosed [`<li>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/li \"The HTML <li> element is used to represent an item in a list. It must be contained in a parent element: an ordered list (<ol>), an unordered list (<ul>), or a menu (<menu>). In menus and unordered lists, list items are usually displayed using bullet points. In ordered lists, they are usually displayed with an ascending counter on the left, such as a number or letter.\") element.\n\n**Note:** This attribute was deprecated in HTML4, but reintroduced in HTML5.\n\nUnless the value of the list number matters (e.g. in legal or technical documents where items are to be referenced by their number/letter), the CSS [`list-style-type`](https://developer.mozilla.org/en-US/docs/Web/CSS/list-style-type \"The list-style-type CSS property sets the marker (such as a disc, character, or custom counter style) of a list item element.\") property should be used instead."}},{name:"compact",description:"This Boolean attribute hints that the list should be rendered in a compact style. The interpretation of this attribute depends on the user agent and it doesn't work in all browsers.\n\n**Warning:** Do not use this attribute, as it has been deprecated: the [`<ol>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ol \"The HTML <ol> element represents an ordered list of items, typically rendered as a numbered list.\") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). To give an effect similar to the `compact` attribute, the [CSS](https://developer.mozilla.org/en-US/docs/CSS) property [`line-height`](https://developer.mozilla.org/en-US/docs/Web/CSS/line-height \"The line-height CSS property sets the amount of space used for lines, such as in text. On block-level elements, it specifies the minimum height of line boxes within the element. On non-replaced inline elements, it specifies the height that is used to calculate line box height.\") can be used with a value of `80%`."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/ol"}]},{name:"ul",description:{kind:"markdown",value:"The ul element represents a list of items, where the order of the items is not important — that is, where changing the order would not materially change the meaning of the document."},attributes:[{name:"compact",description:"This Boolean attribute hints that the list should be rendered in a compact style. The interpretation of this attribute depends on the user agent and it doesn't work in all browsers.\n\n**Usage note: **Do not use this attribute, as it has been deprecated: the [`<ul>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ul \"The HTML <ul> element represents an unordered list of items, typically rendered as a bulleted list.\") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). To give a similar effect as the `compact` attribute, the [CSS](https://developer.mozilla.org/en-US/docs/CSS) property [line-height](https://developer.mozilla.org/en-US/docs/CSS/line-height) can be used with a value of `80%`."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/ul"}]},{name:"li",description:{kind:"markdown",value:"The li element represents a list item. If its parent element is an ol, ul, or menu element, then the element is an item of the parent element's list, as defined for those elements. Otherwise, the list item has no defined list-related relationship to any other li element."},attributes:[{name:"value",description:{kind:"markdown",value:"This integer attribute indicates the current ordinal value of the list item as defined by the [`<ol>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ol \"The HTML <ol> element represents an ordered list of items, typically rendered as a numbered list.\") element. The only allowed value for this attribute is a number, even if the list is displayed with Roman numerals or letters. List items that follow this one continue numbering from the value set. The **value** attribute has no meaning for unordered lists ([`<ul>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ul \"The HTML <ul> element represents an unordered list of items, typically rendered as a bulleted list.\")) or for menus ([`<menu>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/menu \"The HTML <menu> element represents a group of commands that a user can perform or activate. This includes both list menus, which might appear across the top of a screen, as well as context menus, such as those that might appear underneath a button after it has been clicked.\")).\n\n**Note**: This attribute was deprecated in HTML4, but reintroduced in HTML5.\n\n**Note:** Prior to Gecko 9.0, negative values were incorrectly converted to 0. Starting in Gecko 9.0 all integer values are correctly parsed."}},{name:"type",description:"This character attribute indicates the numbering type:\n\n*   `a`: lowercase letters\n*   `A`: uppercase letters\n*   `i`: lowercase Roman numerals\n*   `I`: uppercase Roman numerals\n*   `1`: numbers\n\nThis type overrides the one used by its parent [`<ol>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ol \"The HTML <ol> element represents an ordered list of items, typically rendered as a numbered list.\") element, if any.\n\n**Usage note:** This attribute has been deprecated: use the CSS [`list-style-type`](https://developer.mozilla.org/en-US/docs/Web/CSS/list-style-type \"The list-style-type CSS property sets the marker (such as a disc, character, or custom counter style) of a list item element.\") property instead."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/li"}]},{name:"dl",description:{kind:"markdown",value:"The dl element represents an association list consisting of zero or more name-value groups (a description list). A name-value group consists of one or more names (dt elements) followed by one or more values (dd elements), ignoring any nodes other than dt and dd elements. Within a single dl element, there should not be more than one dt element for each name."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/dl"}]},{name:"dt",description:{kind:"markdown",value:"The dt element represents the term, or name, part of a term-description group in a description list (dl element)."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/dt"}]},{name:"dd",description:{kind:"markdown",value:"The dd element represents the description, definition, or value, part of a term-description group in a description list (dl element)."},attributes:[{name:"nowrap",description:"If the value of this attribute is set to `yes`, the definition text will not wrap. The default value is `no`."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/dd"}]},{name:"figure",description:{kind:"markdown",value:"The figure element represents some flow content, optionally with a caption, that is self-contained (like a complete sentence) and is typically referenced as a single unit from the main flow of the document."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/figure"}]},{name:"figcaption",description:{kind:"markdown",value:"The figcaption element represents a caption or legend for the rest of the contents of the figcaption element's parent figure element, if any."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/figcaption"}]},{name:"main",description:{kind:"markdown",value:"The main element represents the main content of the body of a document or application. The main content area consists of content that is directly related to or expands upon the central topic of a document or central functionality of an application."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/main"}]},{name:"div",description:{kind:"markdown",value:"The div element has no special meaning at all. It represents its children. It can be used with the class, lang, and title attributes to mark up semantics common to a group of consecutive elements."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/div"}]},{name:"a",description:{kind:"markdown",value:"If the a element has an href attribute, then it represents a hyperlink (a hypertext anchor) labeled by its contents."},attributes:[{name:"href",description:{kind:"markdown",value:"Contains a URL or a URL fragment that the hyperlink points to."}},{name:"target",description:{kind:"markdown",value:"Specifies where to display the linked URL. It is a name of, or keyword for, a _browsing context_: a tab, window, or `<iframe>`. The following keywords have special meanings:\n\n*   `_self`: Load the URL into the same browsing context as the current one. This is the default behavior.\n*   `_blank`: Load the URL into a new browsing context. This is usually a tab, but users can configure browsers to use new windows instead.\n*   `_parent`: Load the URL into the parent browsing context of the current one. If there is no parent, this behaves the same way as `_self`.\n*   `_top`: Load the URL into the top-level browsing context (that is, the \"highest\" browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this behaves the same way as `_self`.\n\n**Note:** When using `target`, consider adding `rel=\"noreferrer\"` to avoid exploitation of the `window.opener` API.\n\n**Note:** Linking to another page using `target=\"_blank\"` will run the new page on the same process as your page. If the new page is executing expensive JS, your page's performance may suffer. To avoid this use `rel=\"noopener\"`."}},{name:"download",description:{kind:"markdown",value:"This attribute instructs browsers to download a URL instead of navigating to it, so the user will be prompted to save it as a local file. If the attribute has a value, it is used as the pre-filled file name in the Save prompt (the user can still change the file name if they want). There are no restrictions on allowed values, though `/` and `\\` are converted to underscores. Most file systems limit some punctuation in file names, and browsers will adjust the suggested name accordingly.\n\n**Notes:**\n\n*   This attribute only works for [same-origin URLs](https://developer.mozilla.org/en-US/docs/Web/Security/Same-origin_policy).\n*   Although HTTP(s) URLs need to be in the same-origin, [`blob:` URLs](https://developer.mozilla.org/en-US/docs/Web/API/URL.createObjectURL) and [`data:` URLs](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs) are allowed so that content generated by JavaScript, such as pictures created in an image-editor Web app, can be downloaded.\n*   If the HTTP header [`Content-Disposition:`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Disposition) gives a different filename than this attribute, the HTTP header takes priority over this attribute.\n*   If `Content-Disposition:` is set to `inline`, Firefox prioritizes `Content-Disposition`, like the filename case, while Chrome prioritizes the `download` attribute."}},{name:"ping",description:{kind:"markdown",value:"Contains a space-separated list of URLs to which, when the hyperlink is followed, [`POST`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Methods/POST \"The HTTP POST method sends data to the server. The type of the body of the request is indicated by the Content-Type header.\") requests with the body `PING` will be sent by the browser (in the background). Typically used for tracking."}},{name:"rel",description:{kind:"markdown",value:"Specifies the relationship of the target object to the link object. The value is a space-separated list of [link types](https://developer.mozilla.org/en-US/docs/Web/HTML/Link_types)."}},{name:"hreflang",description:{kind:"markdown",value:"This attribute indicates the human language of the linked resource. It is purely advisory, with no built-in functionality. Allowed values are determined by [BCP47](https://www.ietf.org/rfc/bcp/bcp47.txt \"Tags for Identifying Languages\")."}},{name:"type",description:{kind:"markdown",value:"Specifies the media type in the form of a [MIME type](https://developer.mozilla.org/en-US/docs/Glossary/MIME_type \"MIME type: A MIME type (now properly called \"media type\", but also sometimes \"content type\") is a string sent along with a file indicating the type of the file (describing the content format, for example, a sound file might be labeled audio/ogg, or an image file image/png).\") for the linked URL. It is purely advisory, with no built-in functionality."}},{name:"referrerpolicy",description:"Indicates which [referrer](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer) to send when fetching the URL:\n\n*   `'no-referrer'` means the `Referer:` header will not be sent.\n*   `'no-referrer-when-downgrade'` means no `Referer:` header will be sent when navigating to an origin without HTTPS. This is the default behavior.\n*   `'origin'` means the referrer will be the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) of the page, not including information after the domain.\n*   `'origin-when-cross-origin'` meaning that navigations to other origins will be limited to the scheme, the host and the port, while navigations on the same origin will include the referrer's path.\n*   `'strict-origin-when-cross-origin'`\n*   `'unsafe-url'` means the referrer will include the origin and path, but not the fragment, password, or username. This is unsafe because it can leak data from secure URLs to insecure ones."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/a"}]},{name:"em",description:{kind:"markdown",value:"The em element represents stress emphasis of its contents."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/em"}]},{name:"strong",description:{kind:"markdown",value:"The strong element represents strong importance, seriousness, or urgency for its contents."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/strong"}]},{name:"small",description:{kind:"markdown",value:"The small element represents side comments such as small print."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/small"}]},{name:"s",description:{kind:"markdown",value:"The s element represents contents that are no longer accurate or no longer relevant."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/s"}]},{name:"cite",description:{kind:"markdown",value:"The cite element represents a reference to a creative work. It must include the title of the work or the name of the author(person, people or organization) or an URL reference, or a reference in abbreviated form as per the conventions used for the addition of citation metadata."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/cite"}]},{name:"q",description:{kind:"markdown",value:"The q element represents some phrasing content quoted from another source."},attributes:[{name:"cite",description:{kind:"markdown",value:"The value of this attribute is a URL that designates a source document or message for the information quoted. This attribute is intended to point to information explaining the context or the reference for the quote."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/q"}]},{name:"dfn",description:{kind:"markdown",value:"The dfn element represents the defining instance of a term. The paragraph, description list group, or section that is the nearest ancestor of the dfn element must also contain the definition(s) for the term given by the dfn element."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/dfn"}]},{name:"abbr",description:{kind:"markdown",value:"The abbr element represents an abbreviation or acronym, optionally with its expansion. The title attribute may be used to provide an expansion of the abbreviation. The attribute, if specified, must contain an expansion of the abbreviation, and nothing else."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/abbr"}]},{name:"ruby",description:{kind:"markdown",value:"The ruby element allows one or more spans of phrasing content to be marked with ruby annotations. Ruby annotations are short runs of text presented alongside base text, primarily used in East Asian typography as a guide for pronunciation or to include other annotations. In Japanese, this form of typography is also known as furigana. Ruby text can appear on either side, and sometimes both sides, of the base text, and it is possible to control its position using CSS. A more complete introduction to ruby can be found in the Use Cases & Exploratory Approaches for Ruby Markup document as well as in CSS Ruby Module Level 1. [RUBY-UC] [CSSRUBY]"},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/ruby"}]},{name:"rb",description:{kind:"markdown",value:"The rb element marks the base text component of a ruby annotation. When it is the child of a ruby element, it doesn't represent anything itself, but its parent ruby element uses it as part of determining what it represents."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/rb"}]},{name:"rt",description:{kind:"markdown",value:"The rt element marks the ruby text component of a ruby annotation. When it is the child of a ruby element or of an rtc element that is itself the child of a ruby element, it doesn't represent anything itself, but its ancestor ruby element uses it as part of determining what it represents."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/rt"}]},{name:"rp",description:{kind:"markdown",value:"The rp element is used to provide fallback text to be shown by user agents that don't support ruby annotations. One widespread convention is to provide parentheses around the ruby text component of a ruby annotation."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/rp"}]},{name:"time",description:{kind:"markdown",value:"The time element represents its contents, along with a machine-readable form of those contents in the datetime attribute. The kind of content is limited to various kinds of dates, times, time-zone offsets, and durations, as described below."},attributes:[{name:"datetime",description:{kind:"markdown",value:"This attribute indicates the time and/or date of the element and must be in one of the formats described below."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/time"}]},{name:"code",description:{kind:"markdown",value:"The code element represents a fragment of computer code. This could be an XML element name, a file name, a computer program, or any other string that a computer would recognize."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/code"}]},{name:"var",description:{kind:"markdown",value:"The var element represents a variable. This could be an actual variable in a mathematical expression or programming context, an identifier representing a constant, a symbol identifying a physical quantity, a function parameter, or just be a term used as a placeholder in prose."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/var"}]},{name:"samp",description:{kind:"markdown",value:"The samp element represents sample or quoted output from another program or computing system."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/samp"}]},{name:"kbd",description:{kind:"markdown",value:"The kbd element represents user input (typically keyboard input, although it may also be used to represent other input, such as voice commands)."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/kbd"}]},{name:"sub",description:{kind:"markdown",value:"The sub element represents a subscript."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/sub"}]},{name:"sup",description:{kind:"markdown",value:"The sup element represents a superscript."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/sup"}]},{name:"i",description:{kind:"markdown",value:"The i element represents a span of text in an alternate voice or mood, or otherwise offset from the normal prose in a manner indicating a different quality of text, such as a taxonomic designation, a technical term, an idiomatic phrase from another language, transliteration, a thought, or a ship name in Western texts."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/i"}]},{name:"b",description:{kind:"markdown",value:"The b element represents a span of text to which attention is being drawn for utilitarian purposes without conveying any extra importance and with no implication of an alternate voice or mood, such as key words in a document abstract, product names in a review, actionable words in interactive text-driven software, or an article lede."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/b"}]},{name:"u",description:{kind:"markdown",value:"The u element represents a span of text with an unarticulated, though explicitly rendered, non-textual annotation, such as labeling the text as being a proper name in Chinese text (a Chinese proper name mark), or labeling the text as being misspelt."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/u"}]},{name:"mark",description:{kind:"markdown",value:"The mark element represents a run of text in one document marked or highlighted for reference purposes, due to its relevance in another context. When used in a quotation or other block of text referred to from the prose, it indicates a highlight that was not originally present but which has been added to bring the reader's attention to a part of the text that might not have been considered important by the original author when the block was originally written, but which is now under previously unexpected scrutiny. When used in the main prose of a document, it indicates a part of the document that has been highlighted due to its likely relevance to the user's current activity."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/mark"}]},{name:"bdi",description:{kind:"markdown",value:"The bdi element represents a span of text that is to be isolated from its surroundings for the purposes of bidirectional text formatting. [BIDI]"},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/bdi"}]},{name:"bdo",description:{kind:"markdown",value:"The bdo element represents explicit text directionality formatting control for its children. It allows authors to override the Unicode bidirectional algorithm by explicitly specifying a direction override. [BIDI]"},attributes:[{name:"dir",description:"The direction in which text should be rendered in this element's contents. Possible values are:\n\n*   `ltr`: Indicates that the text should go in a left-to-right direction.\n*   `rtl`: Indicates that the text should go in a right-to-left direction."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/bdo"}]},{name:"span",description:{kind:"markdown",value:"The span element doesn't mean anything on its own, but can be useful when used together with the global attributes, e.g. class, lang, or dir. It represents its children."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/span"}]},{name:"br",description:{kind:"markdown",value:"The br element represents a line break."},attributes:[{name:"clear",description:"Indicates where to begin the next line after the break."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/br"}]},{name:"wbr",description:{kind:"markdown",value:"The wbr element represents a line break opportunity."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/wbr"}]},{name:"ins",description:{kind:"markdown",value:"The ins element represents an addition to the document."},attributes:[{name:"cite",description:"This attribute defines the URI of a resource that explains the change, such as a link to meeting minutes or a ticket in a troubleshooting system."},{name:"datetime",description:"This attribute indicates the time and date of the change and must be a valid date with an optional time string. If the value cannot be parsed as a date with an optional time string, the element does not have an associated time stamp. For the format of the string without a time, see [Format of a valid date string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_date_string \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\"). The format of the string if it includes both date and time is covered in [Format of a valid local date and time string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_local_date_and_time_string \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\")."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/ins"}]},{name:"del",description:{kind:"markdown",value:"The del element represents a removal from the document."},attributes:[{name:"cite",description:{kind:"markdown",value:"A URI for a resource that explains the change (for example, meeting minutes)."}},{name:"datetime",description:{kind:"markdown",value:"This attribute indicates the time and date of the change and must be a valid date string with an optional time. If the value cannot be parsed as a date with an optional time string, the element does not have an associated time stamp. For the format of the string without a time, see [Format of a valid date string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_date_string \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\"). The format of the string if it includes both date and time is covered in [Format of a valid local date and time string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_local_date_and_time_string \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats \"Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.\")."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/del"}]},{name:"picture",description:{kind:"markdown",value:"The picture element is a container which provides multiple sources to its contained img element to allow authors to declaratively control or give hints to the user agent about which image resource to use, based on the screen pixel density, viewport size, image format, and other factors. It represents its children."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/picture"}]},{name:"img",description:{kind:"markdown",value:"An img element represents an image."},attributes:[{name:"alt",description:{kind:"markdown",value:"This attribute defines an alternative text description of the image.\n\n**Note:** Browsers do not always display the image referenced by the element. This is the case for non-graphical browsers (including those used by people with visual impairments), if the user chooses not to display images, or if the browser cannot display the image because it is invalid or an [unsupported type](#Supported_image_formats). In these cases, the browser may replace the image with the text defined in this element's `alt` attribute. You should, for these reasons and others, provide a useful value for `alt` whenever possible.\n\n**Note:** Omitting this attribute altogether indicates that the image is a key part of the content, and no textual equivalent is available. Setting this attribute to an empty string (`alt=\"\"`) indicates that this image is _not_ a key part of the content (decorative), and that non-visual browsers may omit it from rendering."}},{name:"src",description:{kind:"markdown",value:"The image URL. This attribute is mandatory for the `<img>` element. On browsers supporting `srcset`, `src` is treated like a candidate image with a pixel density descriptor `1x` unless an image with this pixel density descriptor is already defined in `srcset,` or unless `srcset` contains '`w`' descriptors."}},{name:"srcset",description:{kind:"markdown",value:"A list of one or more strings separated by commas indicating a set of possible image sources for the user agent to use. Each string is composed of:\n\n1.  a URL to an image,\n2.  optionally, whitespace followed by one of:\n    *   A width descriptor, or a positive integer directly followed by '`w`'. The width descriptor is divided by the source size given in the `sizes` attribute to calculate the effective pixel density.\n    *   A pixel density descriptor, which is a positive floating point number directly followed by '`x`'.\n\nIf no descriptor is specified, the source is assigned the default descriptor: `1x`.\n\nIt is incorrect to mix width descriptors and pixel density descriptors in the same `srcset` attribute. Duplicate descriptors (for instance, two sources in the same `srcset` which are both described with '`2x`') are also invalid.\n\nThe user agent selects any one of the available sources at its discretion. This provides them with significant leeway to tailor their selection based on things like user preferences or bandwidth conditions. See our [Responsive images](https://developer.mozilla.org/en-US/docs/Learn/HTML/Multimedia_and_embedding/Responsive_images) tutorial for an example."}},{name:"crossorigin",valueSet:"xo",description:{kind:"markdown",value:"This enumerated attribute indicates if the fetching of the related image must be done using CORS or not. [CORS-enabled images](https://developer.mozilla.org/en-US/docs/CORS_Enabled_Image) can be reused in the [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas \"Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.\") element without being \"[tainted](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_enabled_image#What_is_a_tainted_canvas).\" The allowed values are:"}},{name:"usemap",description:{kind:"markdown",value:"The partial URL (starting with '#') of an [image map](https://developer.mozilla.org/en-US/docs/HTML/Element/map) associated with the element.\n\n**Note:** You cannot use this attribute if the `<img>` element is a descendant of an [`<a>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a \"The HTML <a> element (or anchor element) creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL.\") or [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") element."}},{name:"ismap",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that the image is part of a server-side map. If so, the precise coordinates of a click are sent to the server.\n\n**Note:** This attribute is allowed only if the `<img>` element is a descendant of an [`<a>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a \"The HTML <a> element (or anchor element) creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL.\") element with a valid [`href`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#attr-href) attribute."}},{name:"width",description:{kind:"markdown",value:"The intrinsic width of the image in pixels."}},{name:"height",description:{kind:"markdown",value:"The intrinsic height of the image in pixels."}},{name:"decoding",description:"Provides an image decoding hint to the browser. The allowed values are:"},{name:"decoding",description:"`sync`\n\nDecode the image synchronously for atomic presentation with other content.\n\n`async`\n\nDecode the image asynchronously to reduce delay in presenting other content.\n\n`auto`\n\nDefault mode, which indicates no preference for the decoding mode. The browser decides what is best for the user."},{name:"importance",description:"Indicates the relative importance of the resource. Priority hints are delegated using the values:"},{name:"importance",description:"`auto`: Indicates **no preference**. The browser may use its own heuristics to decide the priority of the image.\n\n`high`: Indicates to the browser that the image is of **high** priority.\n\n`low`: Indicates to the browser that the image is of **low** priority."},{name:"intrinsicsize",description:"This attribute tells the browser to ignore the actual intrinsic size of the image and pretend it’s the size specified in the attribute. Specifically, the image would raster at these dimensions and `naturalWidth`/`naturalHeight` on images would return the values specified in this attribute. [Explainer](https://github.com/ojanvafai/intrinsicsize-attribute), [examples](https://googlechrome.github.io/samples/intrinsic-size/index.html)"},{name:"referrerpolicy",description:"A string indicating which referrer to use when fetching the resource:\n\n*   `no-referrer:` The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent.\n*   `no-referrer-when-downgrade:` No `Referer` header will be sent when navigating to an origin without TLS (HTTPS). This is a user agent’s default behavior if no policy is otherwise specified.\n*   `origin:` The `Referer` header will include the page of origin's scheme, the host, and the port.\n*   `origin-when-cross-origin:` Navigating to other origins will limit the included referral data to the scheme, the host and the port, while navigating from the same origin will include the referrer's full path.\n*   `unsafe-url:` The `Referer` header will include the origin and the path, but not the fragment, password, or username. This case is unsafe because it can leak origins and paths from TLS-protected resources to insecure origins."},{name:"sizes",description:"A list of one or more strings separated by commas indicating a set of source sizes. Each source size consists of:\n\n1.  a media condition. This must be omitted for the last item.\n2.  a source size value.\n\nSource size values specify the intended display size of the image. User agents use the current source size to select one of the sources supplied by the `srcset` attribute, when those sources are described using width ('`w`') descriptors. The selected source size affects the intrinsic size of the image (the image’s display size if no CSS styling is applied). If the `srcset` attribute is absent, or contains no values with a width (`w`) descriptor, then the `sizes` attribute has no effect."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/img"}]},{name:"iframe",description:{kind:"markdown",value:"The iframe element represents a nested browsing context."},attributes:[{name:"src",description:{kind:"markdown",value:"The URL of the page to embed. Use a value of `about:blank` to embed an empty page that conforms to the [same-origin policy](https://developer.mozilla.org/en-US/docs/Web/Security/Same-origin_policy#Inherited_origins). Also note that programatically removing an `<iframe>`'s src attribute (e.g. via [`Element.removeAttribute()`](https://developer.mozilla.org/en-US/docs/Web/API/Element/removeAttribute \"The Element method removeAttribute() removes the attribute with the specified name from the element.\")) causes `about:blank` to be loaded in the frame in Firefox (from version 65), Chromium-based browsers, and Safari/iOS."}},{name:"srcdoc",description:{kind:"markdown",value:"Inline HTML to embed, overriding the `src` attribute. If a browser does not support the `srcdoc` attribute, it will fall back to the URL in the `src` attribute."}},{name:"name",description:{kind:"markdown",value:"A targetable name for the embedded browsing context. This can be used in the `target` attribute of the [`<a>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a \"The HTML <a> element (or anchor element) creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL.\"), [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\"), or [`<base>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/base \"The HTML <base> element specifies the base URL to use for all relative URLs contained within a document. There can be only one <base> element in a document.\") elements; the `formtarget` attribute of the [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") or [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") elements; or the `windowName` parameter in the [`window.open()`](https://developer.mozilla.org/en-US/docs/Web/API/Window/open \"The Window interface's open() method loads the specified resource into the browsing context (window, <iframe> or tab) with the specified name. If the name doesn't exist, then a new window is opened and the specified resource is loaded into its browsing context.\") method."}},{name:"sandbox",valueSet:"sb",description:{kind:"markdown",value:"Applies extra restrictions to the content in the frame. The value of the attribute can either be empty to apply all restrictions, or space-separated tokens to lift particular restrictions:\n\n*   `allow-forms`: Allows the resource to submit forms. If this keyword is not used, form submission is blocked.\n*   `allow-modals`: Lets the resource [open modal windows](https://html.spec.whatwg.org/multipage/origin.html#sandboxed-modals-flag).\n*   `allow-orientation-lock`: Lets the resource [lock the screen orientation](https://developer.mozilla.org/en-US/docs/Web/API/Screen/lockOrientation).\n*   `allow-pointer-lock`: Lets the resource use the [Pointer Lock API](https://developer.mozilla.org/en-US/docs/WebAPI/Pointer_Lock).\n*   `allow-popups`: Allows popups (such as `window.open()`, `target=\"_blank\"`, or `showModalDialog()`). If this keyword is not used, the popup will silently fail to open.\n*   `allow-popups-to-escape-sandbox`: Lets the sandboxed document open new windows without those windows inheriting the sandboxing. For example, this can safely sandbox an advertisement without forcing the same restrictions upon the page the ad links to.\n*   `allow-presentation`: Lets the resource start a [presentation session](https://developer.mozilla.org/en-US/docs/Web/API/PresentationRequest).\n*   `allow-same-origin`: If this token is not used, the resource is treated as being from a special origin that always fails the [same-origin policy](https://developer.mozilla.org/en-US/docs/Glossary/same-origin_policy \"same-origin policy: The same-origin policy is a critical security mechanism that restricts how a document or script loaded from one origin can interact with a resource from another origin.\").\n*   `allow-scripts`: Lets the resource run scripts (but not create popup windows).\n*   `allow-storage-access-by-user-activation` : Lets the resource request access to the parent's storage capabilities with the [Storage Access API](https://developer.mozilla.org/en-US/docs/Web/API/Storage_Access_API).\n*   `allow-top-navigation`: Lets the resource navigate the top-level browsing context (the one named `_top`).\n*   `allow-top-navigation-by-user-activation`: Lets the resource navigate the top-level browsing context, but only if initiated by a user gesture.\n\n**Notes about sandboxing:**\n\n*   When the embedded document has the same origin as the embedding page, it is **strongly discouraged** to use both `allow-scripts` and `allow-same-origin`, as that lets the embedded document remove the `sandbox` attribute — making it no more secure than not using the `sandbox` attribute at all.\n*   Sandboxing is useless if the attacker can display content outside a sandboxed `iframe` — such as if the viewer opens the frame in a new tab. Such content should be also served from a _separate origin_ to limit potential damage.\n*   The `sandbox` attribute is unsupported in Internet Explorer 9 and earlier."}},{name:"seamless",valueSet:"v"},{name:"allowfullscreen",valueSet:"v",description:{kind:"markdown",value:"Set to `true` if the `<iframe>` can activate fullscreen mode by calling the [`requestFullscreen()`](https://developer.mozilla.org/en-US/docs/Web/API/Element/requestFullscreen \"The Element.requestFullscreen() method issues an asynchronous request to make the element be displayed in full-screen mode.\") method."}},{name:"width",description:{kind:"markdown",value:"The width of the frame in CSS pixels. Default is `300`."}},{name:"height",description:{kind:"markdown",value:"The height of the frame in CSS pixels. Default is `150`."}},{name:"allow",description:"Specifies a [feature policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Feature_Policy) for the `<iframe>`."},{name:"allowpaymentrequest",description:"Set to `true` if a cross-origin `<iframe>` should be allowed to invoke the [Payment Request API](https://developer.mozilla.org/en-US/docs/Web/API/Payment_Request_API)."},{name:"allowpaymentrequest",description:"This attribute is considered a legacy attribute and redefined as `allow=\"payment\"`."},{name:"csp",description:"A [Content Security Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP) enforced for the embedded resource. See [`HTMLIFrameElement.csp`](https://developer.mozilla.org/en-US/docs/Web/API/HTMLIFrameElement/csp \"The csp property of the HTMLIFrameElement interface specifies the Content Security Policy that an embedded document must agree to enforce upon itself.\") for details."},{name:"importance",description:"The download priority of the resource in the `<iframe>`'s `src` attribute. Allowed values:\n\n`auto` (default)\n\nNo preference. The browser uses its own heuristics to decide the priority of the resource.\n\n`high`\n\nThe resource should be downloaded before other lower-priority page resources.\n\n`low`\n\nThe resource should be downloaded after other higher-priority page resources."},{name:"referrerpolicy",description:"Indicates which [referrer](https://developer.mozilla.org/en-US/docs/Web/API/Document/referrer) to send when fetching the frame's resource:\n\n*   `no-referrer`: The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent.\n*   `no-referrer-when-downgrade` (default): The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent to [origin](https://developer.mozilla.org/en-US/docs/Glossary/origin \"origin: Web content's origin is defined by the scheme (protocol), host (domain), and port of the URL used to access it. Two objects have the same origin only when the scheme, host, and port all match.\")s without [TLS](https://developer.mozilla.org/en-US/docs/Glossary/TLS \"TLS: Transport Layer Security (TLS), previously known as Secure Sockets Layer (SSL), is a protocol used by applications to communicate securely across a network, preventing tampering with and eavesdropping on email, web browsing, messaging, and other protocols.\") ([HTTPS](https://developer.mozilla.org/en-US/docs/Glossary/HTTPS \"HTTPS: HTTPS (HTTP Secure) is an encrypted version of the HTTP protocol. It usually uses SSL or TLS to encrypt all communication between a client and a server. This secure connection allows clients to safely exchange sensitive data with a server, for example for banking activities or online shopping.\")).\n*   `origin`: The sent referrer will be limited to the origin of the referring page: its [scheme](https://developer.mozilla.org/en-US/docs/Archive/Mozilla/URIScheme), [host](https://developer.mozilla.org/en-US/docs/Glossary/host \"host: A host is a device connected to the Internet (or a local network). Some hosts called servers offer additional services like serving webpages or storing files and emails.\"), and [port](https://developer.mozilla.org/en-US/docs/Glossary/port \"port: For a computer connected to a network with an IP address, a port is a communication endpoint. Ports are designated by numbers, and below 1024 each port is associated by default with a specific protocol.\").\n*   `origin-when-cross-origin`: The referrer sent to other origins will be limited to the scheme, the host, and the port. Navigations on the same origin will still include the path.\n*   `same-origin`: A referrer will be sent for [same origin](https://developer.mozilla.org/en-US/docs/Glossary/Same-origin_policy \"same origin: The same-origin policy is a critical security mechanism that restricts how a document or script loaded from one origin can interact with a resource from another origin.\"), but cross-origin requests will contain no referrer information.\n*   `strict-origin`: Only send the origin of the document as the referrer when the protocol security level stays the same (HTTPS→HTTPS), but don't send it to a less secure destination (HTTPS→HTTP).\n*   `strict-origin-when-cross-origin`: Send a full URL when performing a same-origin request, only send the origin when the protocol security level stays the same (HTTPS→HTTPS), and send no header to a less secure destination (HTTPS→HTTP).\n*   `unsafe-url`: The referrer will include the origin _and_ the path (but not the [fragment](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/hash), [password](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/password), or [username](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/username)). **This value is unsafe**, because it leaks origins and paths from TLS-protected resources to insecure origins."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/iframe"}]},{name:"embed",description:{kind:"markdown",value:"The embed element provides an integration point for an external (typically non-HTML) application or interactive content."},attributes:[{name:"src",description:{kind:"markdown",value:"The URL of the resource being embedded."}},{name:"type",description:{kind:"markdown",value:"The MIME type to use to select the plug-in to instantiate."}},{name:"width",description:{kind:"markdown",value:"The displayed width of the resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). This must be an absolute value; percentages are _not_ allowed."}},{name:"height",description:{kind:"markdown",value:"The displayed height of the resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). This must be an absolute value; percentages are _not_ allowed."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/embed"}]},{name:"object",description:{kind:"markdown",value:"The object element can represent an external resource, which, depending on the type of the resource, will either be treated as an image, as a nested browsing context, or as an external resource to be processed by a plugin."},attributes:[{name:"data",description:{kind:"markdown",value:"The address of the resource as a valid URL. At least one of **data** and **type** must be defined."}},{name:"type",description:{kind:"markdown",value:"The [content type](https://developer.mozilla.org/en-US/docs/Glossary/Content_type) of the resource specified by **data**. At least one of **data** and **type** must be defined."}},{name:"typemustmatch",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates if the **type** attribute and the actual [content type](https://developer.mozilla.org/en-US/docs/Glossary/Content_type) of the resource must match to be used."}},{name:"name",description:{kind:"markdown",value:"The name of valid browsing context (HTML5), or the name of the control (HTML 4)."}},{name:"usemap",description:{kind:"markdown",value:"A hash-name reference to a [`<map>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/map \"The HTML <map> element is used with <area> elements to define an image map (a clickable link area).\") element; that is a '#' followed by the value of a [`name`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/map#attr-name) of a map element."}},{name:"form",description:{kind:"markdown",value:"The form element, if any, that the object element is associated with (its _form owner_). The value of the attribute must be an ID of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element in the same document."}},{name:"width",description:{kind:"markdown",value:"The width of the display resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). -- (Absolute values only. [NO percentages](https://html.spec.whatwg.org/multipage/embedded-content.html#dimension-attributes))"}},{name:"height",description:{kind:"markdown",value:"The height of the displayed resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). -- (Absolute values only. [NO percentages](https://html.spec.whatwg.org/multipage/embedded-content.html#dimension-attributes))"}},{name:"archive",description:"A space-separated list of URIs for archives of resources for the object."},{name:"border",description:"The width of a border around the control, in pixels."},{name:"classid",description:"The URI of the object's implementation. It can be used together with, or in place of, the **data** attribute."},{name:"codebase",description:"The base path used to resolve relative URIs specified by **classid**, **data**, or **archive**. If not specified, the default is the base URI of the current document."},{name:"codetype",description:"The content type of the data specified by **classid**."},{name:"declare",description:"The presence of this Boolean attribute makes this element a declaration only. The object must be instantiated by a subsequent `<object>` element. In HTML5, repeat the <object> element completely each that that the resource is reused."},{name:"standby",description:"A message that the browser can show while loading the object's implementation and data."},{name:"tabindex",description:"The position of the element in the tabbing navigation order for the current document."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/object"}]},{name:"param",description:{kind:"markdown",value:"The param element defines parameters for plugins invoked by object elements. It does not represent anything on its own."},attributes:[{name:"name",description:{kind:"markdown",value:"Name of the parameter."}},{name:"value",description:{kind:"markdown",value:"Specifies the value of the parameter."}},{name:"type",description:"Only used if the `valuetype` is set to \"ref\". Specifies the MIME type of values found at the URI specified by value."},{name:"valuetype",description:"Specifies the type of the `value` attribute. Possible values are:\n\n*   data: Default value. The value is passed to the object's implementation as a string.\n*   ref: The value is a URI to a resource where run-time values are stored.\n*   object: An ID of another [`<object>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/object \"The HTML <object> element represents an external resource, which can be treated as an image, a nested browsing context, or a resource to be handled by a plugin.\") in the same document."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/param"}]},{name:"video",description:{kind:"markdown",value:"A video element is used for playing videos or movies, and audio files with captions."},attributes:[{name:"src"},{name:"crossorigin",valueSet:"xo"},{name:"poster"},{name:"preload",valueSet:"pl"},{name:"autoplay",valueSet:"v",description:{kind:"markdown",value:"A Boolean attribute; if specified, the video automatically begins to play back as soon as it can do so without stopping to finish loading the data."}},{name:"mediagroup"},{name:"loop",valueSet:"v"},{name:"muted",valueSet:"v"},{name:"controls",valueSet:"v"},{name:"width"},{name:"height"}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/video"}]},{name:"audio",description:{kind:"markdown",value:"An audio element represents a sound or audio stream."},attributes:[{name:"src",description:{kind:"markdown",value:"The URL of the audio to embed. This is subject to [HTTP access controls](https://developer.mozilla.org/en-US/docs/HTTP_access_control). This is optional; you may instead use the [`<source>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source \"The HTML <source> element specifies multiple media resources for the <picture>, the <audio> element, or the <video> element.\") element within the audio block to specify the audio to embed."}},{name:"crossorigin",valueSet:"xo",description:{kind:"markdown",value:"This enumerated attribute indicates whether to use CORS to fetch the related image. [CORS-enabled resources](https://developer.mozilla.org/en-US/docs/CORS_Enabled_Image) can be reused in the [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas \"Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.\") element without being _tainted_. The allowed values are:\n\nanonymous\n\nSends a cross-origin request without a credential. In other words, it sends the `Origin:` HTTP header without a cookie, X.509 certificate, or performing HTTP Basic authentication. If the server does not give credentials to the origin site (by not setting the `Access-Control-Allow-Origin:` HTTP header), the image will be _tainted_, and its usage restricted.\n\nuse-credentials\n\nSends a cross-origin request with a credential. In other words, it sends the `Origin:` HTTP header with a cookie, a certificate, or performing HTTP Basic authentication. If the server does not give credentials to the origin site (through `Access-Control-Allow-Credentials:` HTTP header), the image will be _tainted_ and its usage restricted.\n\nWhen not present, the resource is fetched without a CORS request (i.e. without sending the `Origin:` HTTP header), preventing its non-tainted used in [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas \"Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.\") elements. If invalid, it is handled as if the enumerated keyword **anonymous** was used. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/HTML/CORS_settings_attributes) for additional information."}},{name:"preload",valueSet:"pl",description:{kind:"markdown",value:"This enumerated attribute is intended to provide a hint to the browser about what the author thinks will lead to the best user experience. It may have one of the following values:\n\n*   `none`: Indicates that the audio should not be preloaded.\n*   `metadata`: Indicates that only audio metadata (e.g. length) is fetched.\n*   `auto`: Indicates that the whole audio file can be downloaded, even if the user is not expected to use it.\n*   _empty string_: A synonym of the `auto` value.\n\nIf not set, `preload`'s default value is browser-defined (i.e. each browser may have its own default value). The spec advises it to be set to `metadata`.\n\n**Usage notes:**\n\n*   The `autoplay` attribute has precedence over `preload`. If `autoplay` is specified, the browser would obviously need to start downloading the audio for playback.\n*   The browser is not forced by the specification to follow the value of this attribute; it is a mere hint."}},{name:"autoplay",valueSet:"v",description:{kind:"markdown",value:"A Boolean attribute: if specified, the audio will automatically begin playback as soon as it can do so, without waiting for the entire audio file to finish downloading.\n\n**Note**: Sites that automatically play audio (or videos with an audio track) can be an unpleasant experience for users, so should be avoided when possible. If you must offer autoplay functionality, you should make it opt-in (requiring a user to specifically enable it). However, this can be useful when creating media elements whose source will be set at a later time, under user control."}},{name:"mediagroup"},{name:"loop",valueSet:"v",description:{kind:"markdown",value:"A Boolean attribute: if specified, the audio player will automatically seek back to the start upon reaching the end of the audio."}},{name:"muted",valueSet:"v",description:{kind:"markdown",value:"A Boolean attribute that indicates whether the audio will be initially silenced. Its default value is `false`."}},{name:"controls",valueSet:"v",description:{kind:"markdown",value:"If this attribute is present, the browser will offer controls to allow the user to control audio playback, including volume, seeking, and pause/resume playback."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/audio"}]},{name:"source",description:{kind:"markdown",value:"The source element allows authors to specify multiple alternative media resources for media elements. It does not represent anything on its own."},attributes:[{name:"src",description:{kind:"markdown",value:"Required for [`<audio>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/audio \"The HTML <audio> element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the <source> element: the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream.\") and [`<video>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/video \"The HTML Video element (<video>) embeds a media player which supports video playback into the document.\"), address of the media resource. The value of this attribute is ignored when the `<source>` element is placed inside a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture \"The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.\") element."}},{name:"type",description:{kind:"markdown",value:"The MIME-type of the resource, optionally with a `codecs` parameter. See [RFC 4281](https://tools.ietf.org/html/rfc4281) for information about how to specify codecs."}},{name:"sizes",description:"Is a list of source sizes that describes the final rendered width of the image represented by the source. Each source size consists of a comma-separated list of media condition-length pairs. This information is used by the browser to determine, before laying the page out, which image defined in [`srcset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source#attr-srcset) to use.  \nThe `sizes` attribute has an effect only when the [`<source>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source \"The HTML <source> element specifies multiple media resources for the <picture>, the <audio> element, or the <video> element.\") element is the direct child of a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture \"The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.\") element."},{name:"srcset",description:"A list of one or more strings separated by commas indicating a set of possible images represented by the source for the browser to use. Each string is composed of:\n\n1.  one URL to an image,\n2.  a width descriptor, that is a positive integer directly followed by `'w'`. The default value, if missing, is the infinity.\n3.  a pixel density descriptor, that is a positive floating number directly followed by `'x'`. The default value, if missing, is `1x`.\n\nEach string in the list must have at least a width descriptor or a pixel density descriptor to be valid. Among the list, there must be only one string containing the same tuple of width descriptor and pixel density descriptor.  \nThe browser chooses the most adequate image to display at a given point of time.  \nThe `srcset` attribute has an effect only when the [`<source>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source \"The HTML <source> element specifies multiple media resources for the <picture>, the <audio> element, or the <video> element.\") element is the direct child of a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture \"The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.\") element."},{name:"media",description:"[Media query](https://developer.mozilla.org/en-US/docs/CSS/Media_queries) of the resource's intended media; this should be used only in a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture \"The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.\") element."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/source"}]},{name:"track",description:{kind:"markdown",value:"The track element allows authors to specify explicit external timed text tracks for media elements. It does not represent anything on its own."},attributes:[{name:"default",valueSet:"v",description:{kind:"markdown",value:"This attribute indicates that the track should be enabled unless the user's preferences indicate that another track is more appropriate. This may only be used on one `track` element per media element."}},{name:"kind",valueSet:"tk",description:{kind:"markdown",value:"How the text track is meant to be used. If omitted the default kind is `subtitles`. If the attribute is not present, it will use the `subtitles`. If the attribute contains an invalid value, it will use `metadata`. (Versions of Chrome earlier than 52 treated an invalid value as `subtitles`.) The following keywords are allowed:\n\n*   `subtitles`\n    *   Subtitles provide translation of content that cannot be understood by the viewer. For example dialogue or text that is not English in an English language film.\n    *   Subtitles may contain additional content, usually extra background information. For example the text at the beginning of the Star Wars films, or the date, time, and location of a scene.\n*   `captions`\n    *   Closed captions provide a transcription and possibly a translation of audio.\n    *   It may include important non-verbal information such as music cues or sound effects. It may indicate the cue's source (e.g. music, text, character).\n    *   Suitable for users who are deaf or when the sound is muted.\n*   `descriptions`\n    *   Textual description of the video content.\n    *   Suitable for users who are blind or where the video cannot be seen.\n*   `chapters`\n    *   Chapter titles are intended to be used when the user is navigating the media resource.\n*   `metadata`\n    *   Tracks used by scripts. Not visible to the user."}},{name:"label",description:{kind:"markdown",value:"A user-readable title of the text track which is used by the browser when listing available text tracks."}},{name:"src",description:{kind:"markdown",value:"Address of the track (`.vtt` file). Must be a valid URL. This attribute must be specified and its URL value must have the same origin as the document — unless the [`<audio>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/audio \"The HTML <audio> element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the <source> element: the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream.\") or [`<video>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/video \"The HTML Video element (<video>) embeds a media player which supports video playback into the document.\") parent element of the `track` element has a [`crossorigin`](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes) attribute."}},{name:"srclang",description:{kind:"markdown",value:"Language of the track text data. It must be a valid [BCP 47](https://r12a.github.io/app-subtags/) language tag. If the `kind` attribute is set to `subtitles,` then `srclang` must be defined."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/track"}]},{name:"map",description:{kind:"markdown",value:"The map element, in conjunction with an img element and any area element descendants, defines an image map. The element represents its children."},attributes:[{name:"name",description:{kind:"markdown",value:"The name attribute gives the map a name so that it can be referenced. The attribute must be present and must have a non-empty value with no space characters. The value of the name attribute must not be a compatibility-caseless match for the value of the name attribute of another map element in the same document. If the id attribute is also specified, both attributes must have the same value."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/map"}]},{name:"area",description:{kind:"markdown",value:"The area element represents either a hyperlink with some text and a corresponding area on an image map, or a dead area on an image map."},attributes:[{name:"alt"},{name:"coords"},{name:"shape",valueSet:"sh"},{name:"href"},{name:"target"},{name:"download"},{name:"ping"},{name:"rel"},{name:"hreflang"},{name:"type"},{name:"accesskey",description:"Specifies a keyboard navigation accelerator for the element. Pressing ALT or a similar key in association with the specified character selects the form control correlated with that key sequence. Page designers are forewarned to avoid key sequences already bound to browsers. This attribute is global since HTML5."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/area"}]},{name:"table",description:{kind:"markdown",value:"The table element represents data with more than one dimension, in the form of a table."},attributes:[{name:"border"},{name:"align",description:"This enumerated attribute indicates how the table must be aligned inside the containing document. It may have the following values:\n\n*   left: the table is displayed on the left side of the document;\n*   center: the table is displayed in the center of the document;\n*   right: the table is displayed on the right side of the document.\n\n**Usage Note**\n\n*   **Do not use this attribute**, as it has been deprecated. The [`<table>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/table \"The HTML <table> element represents tabular data — that is, information presented in a two-dimensional table comprised of rows and columns of cells containing data.\") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). Set [`margin-left`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-left \"The margin-left CSS property sets the margin area on the left side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.\") and [`margin-right`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-right \"The margin-right CSS property sets the margin area on the right side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.\") to `auto` or [`margin`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin \"The margin CSS property sets the margin area on all four sides of an element. It is a shorthand for margin-top, margin-right, margin-bottom, and margin-left.\") to `0 auto` to achieve an effect that is similar to the align attribute.\n*   Prior to Firefox 4, Firefox also supported the `middle`, `absmiddle`, and `abscenter` values as synonyms of `center`, in quirks mode only."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/table"}]},{name:"caption",description:{kind:"markdown",value:"The caption element represents the title of the table that is its parent, if it has a parent and that is a table element."},attributes:[{name:"align",description:"This enumerated attribute indicates how the caption must be aligned with respect to the table. It may have one of the following values:\n\n`left`\n\nThe caption is displayed to the left of the table.\n\n`top`\n\nThe caption is displayed above the table.\n\n`right`\n\nThe caption is displayed to the right of the table.\n\n`bottom`\n\nThe caption is displayed below the table.\n\n**Usage note:** Do not use this attribute, as it has been deprecated. The [`<caption>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/caption \"The HTML Table Caption element (<caption>) specifies the caption (or title) of a table, and if used is always the first child of a <table>.\") element should be styled using the [CSS](https://developer.mozilla.org/en-US/docs/CSS) properties [`caption-side`](https://developer.mozilla.org/en-US/docs/Web/CSS/caption-side \"The caption-side CSS property puts the content of a table's <caption> on the specified side. The values are relative to the writing-mode of the table.\") and [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\")."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/caption"}]},{name:"colgroup",description:{kind:"markdown",value:"The colgroup element represents a group of one or more columns in the table that is its parent, if it has a parent and that is a table element."},attributes:[{name:"span"},{name:"align",description:"This enumerated attribute specifies how horizontal alignment of each column cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-charoff) attributes Unimplemented (see [bug 2212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 \"character alignment not implemented (align=char, charoff=, text-align:<string>)\")).\n\nIf this attribute is not set, the `left` value is assumed. The descendant [`<col>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col \"The HTML <col> element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a <colgroup> element.\") elements may override this value using their own [`align`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-align) attribute.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values:\n    *   Do not try to set the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property on a selector giving a [`<colgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup \"The HTML <colgroup> element defines a group of columns within a table.\") element. Because [`<td>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td \"The HTML <td> element defines a cell of a table that contains data. It participates in the table model.\") elements are not descendant of the [`<colgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup \"The HTML <colgroup> element defines a group of columns within a table.\") element, they won't inherit it.\n    *   If the table doesn't use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, use one `td:nth-child(an+b)` CSS selector per column, where a is the total number of the columns in the table and b is the ordinal position of this column in the table. Only after this selector the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property can be used.\n    *   If the table does use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, the effect can be achieved by combining adequate CSS attribute selectors like `[colspan=n]`, though this is not trivial.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property Unimplemented."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/colgroup"}]},{name:"col",description:{kind:"markdown",value:"If a col element has a parent and that is a colgroup element that itself has a parent that is a table element, then the col element represents one or more columns in the column group represented by that colgroup."},attributes:[{name:"span"},{name:"align",description:"This enumerated attribute specifies how horizontal alignment of each column cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-charoff) attributes Unimplemented (see [bug 2212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 \"character alignment not implemented (align=char, charoff=, text-align:<string>)\")).\n\nIf this attribute is not set, its value is inherited from the [`align`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup#attr-align) of the [`<colgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup \"The HTML <colgroup> element defines a group of columns within a table.\") element this `<col>` element belongs too. If there are none, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values:\n    *   Do not try to set the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property on a selector giving a [`<col>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col \"The HTML <col> element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a <colgroup> element.\") element. Because [`<td>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td \"The HTML <td> element defines a cell of a table that contains data. It participates in the table model.\") elements are not descendant of the [`<col>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col \"The HTML <col> element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a <colgroup> element.\") element, they won't inherit it.\n    *   If the table doesn't use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, use the `td:nth-child(an+b)` CSS selector. Set `a` to zero and `b` to the position of the column in the table, e.g. `td:nth-child(2) { text-align: right; }` to right-align the second column.\n    *   If the table does use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, the effect can be achieved by combining adequate CSS attribute selectors like `[colspan=n]`, though this is not trivial.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property Unimplemented."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/col"}]},{name:"tbody",description:{kind:"markdown",value:"The tbody element represents a block of rows that consist of a body of data for the parent table element, if the tbody element has a parent and it is a table."},attributes:[{name:"align",description:"This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-charoff) attributes.\n\nIf this attribute is not set, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property on it.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property Unimplemented."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/tbody"}]},{name:"thead",description:{kind:"markdown",value:"The thead element represents the block of rows that consist of the column labels (headers) for the parent table element, if the thead element has a parent and it is a table."},attributes:[{name:"align",description:"This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/thead#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/thead#attr-charoff) attributes Unimplemented (see [bug 2212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 \"character alignment not implemented (align=char, charoff=, text-align:<string>)\")).\n\nIf this attribute is not set, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property on it.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/thead#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property Unimplemented."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/thead"}]},{name:"tfoot",description:{kind:"markdown",value:"The tfoot element represents the block of rows that consist of the column summaries (footers) for the parent table element, if the tfoot element has a parent and it is a table."},attributes:[{name:"align",description:"This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-charoff) attributes Unimplemented (see [bug 2212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 \"character alignment not implemented (align=char, charoff=, text-align:<string>)\")).\n\nIf this attribute is not set, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property on it.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tfoot#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property Unimplemented."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/tfoot"}]},{name:"tr",description:{kind:"markdown",value:"The tr element represents a row of cells in a table."},attributes:[{name:"align",description:"A [`DOMString`](https://developer.mozilla.org/en-US/docs/Web/API/DOMString \"DOMString is a UTF-16 String. As JavaScript already uses such strings, DOMString is mapped directly to a String.\") which specifies how the cell's context should be aligned horizontally within the cells in the row; this is shorthand for using `align` on every cell in the row individually. Possible values are:\n\n`left`\n\nAlign the content of each cell at its left edge.\n\n`center`\n\nCenter the contents of each cell between their left and right edges.\n\n`right`\n\nAlign the content of each cell at its right edge.\n\n`justify`\n\nWiden whitespaces within the text of each cell so that the text fills the full width of each cell (full justification).\n\n`char`\n\nAlign each cell in the row on a specific character (such that each row in the column that is configured this way will horizontally align its cells on that character). This uses the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tr#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tr#attr-charoff) to establish the alignment character (typically \".\" or \",\" when aligning numerical data) and the number of characters that should follow the alignment character. This alignment type was never widely supported.\n\nIf no value is expressly set for `align`, the parent node's value is inherited.\n\nInstead of using the obsolete `align` attribute, you should instead use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property to establish `left`, `center`, `right`, or `justify` alignment for the row's cells. To apply character-based alignment, set the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property to the alignment character (such as `\".\"` or `\",\"`)."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/tr"}]},{name:"td",description:{kind:"markdown",value:"The td element represents a data cell in a table."},attributes:[{name:"colspan"},{name:"rowspan"},{name:"headers"},{name:"abbr",description:"This attribute contains a short abbreviated description of the cell's content. Some user-agents, such as speech readers, may present this description before the content itself.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard. Alternatively, you can put the abbreviated description inside the cell and place the long content in the **title** attribute."},{name:"align",description:"This enumerated attribute specifies how the cell content's horizontal alignment will be handled. Possible values are:\n\n*   `left`: The content is aligned to the left of the cell.\n*   `center`: The content is centered in the cell.\n*   `right`: The content is aligned to the right of the cell.\n*   `justify` (with text only): The content is stretched out inside the cell so that it covers its entire width.\n*   `char` (with text only): The content is aligned to a character inside the `<th>` element with minimal offset. This character is defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-charoff) attributes Unimplemented (see [bug 2212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 \"character alignment not implemented (align=char, charoff=, text-align:<string>)\")).\n\nThe default value when this attribute is not specified is `left`.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, apply the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property to the element.\n*   To achieve the same effect as the `char` value, give the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property the same value you would use for the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-char). Unimplemented in CSS3."},{name:"axis",description:"This attribute contains a list of space-separated strings. Each string is the `id` of a group of cells that this header applies to.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard."},{name:"bgcolor",description:"This attribute defines the background color of each cell in a column. It consists of a 6-digit hexadecimal code as defined in [sRGB](https://www.w3.org/Graphics/Color/sRGB) and is prefixed by '#'. This attribute may be used with one of sixteen predefined color strings:\n\n \n\n`black` = \"#000000\"\n\n \n\n`green` = \"#008000\"\n\n \n\n`silver` = \"#C0C0C0\"\n\n \n\n`lime` = \"#00FF00\"\n\n \n\n`gray` = \"#808080\"\n\n \n\n`olive` = \"#808000\"\n\n \n\n`white` = \"#FFFFFF\"\n\n \n\n`yellow` = \"#FFFF00\"\n\n \n\n`maroon` = \"#800000\"\n\n \n\n`navy` = \"#000080\"\n\n \n\n`red` = \"#FF0000\"\n\n \n\n`blue` = \"#0000FF\"\n\n \n\n`purple` = \"#800080\"\n\n \n\n`teal` = \"#008080\"\n\n \n\n`fuchsia` = \"#FF00FF\"\n\n \n\n`aqua` = \"#00FFFF\"\n\n**Note:** Do not use this attribute, as it is non-standard and only implemented in some versions of Microsoft Internet Explorer: The [`<td>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td \"The HTML <td> element defines a cell of a table that contains data. It participates in the table model.\") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). To create a similar effect use the [`background-color`](https://developer.mozilla.org/en-US/docs/Web/CSS/background-color \"The background-color CSS property sets the background color of an element.\") property in [CSS](https://developer.mozilla.org/en-US/docs/CSS) instead."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/td"}]},{name:"th",description:{kind:"markdown",value:"The th element represents a header cell in a table."},attributes:[{name:"colspan"},{name:"rowspan"},{name:"headers"},{name:"scope",valueSet:"s"},{name:"sorted"},{name:"abbr",description:{kind:"markdown",value:"This attribute contains a short abbreviated description of the cell's content. Some user-agents, such as speech readers, may present this description before the content itself."}},{name:"align",description:"This enumerated attribute specifies how the cell content's horizontal alignment will be handled. Possible values are:\n\n*   `left`: The content is aligned to the left of the cell.\n*   `center`: The content is centered in the cell.\n*   `right`: The content is aligned to the right of the cell.\n*   `justify` (with text only): The content is stretched out inside the cell so that it covers its entire width.\n*   `char` (with text only): The content is aligned to a character inside the `<th>` element with minimal offset. This character is defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-charoff) attributes.\n\nThe default value when this attribute is not specified is `left`.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, apply the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property to the element.\n*   To achieve the same effect as the `char` value, give the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align \"The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.\") property the same value you would use for the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-char). Unimplemented in CSS3."},{name:"axis",description:"This attribute contains a list of space-separated strings. Each string is the `id` of a group of cells that this header applies to.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard: use the [`scope`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-scope) attribute instead."},{name:"bgcolor",description:"This attribute defines the background color of each cell in a column. It consists of a 6-digit hexadecimal code as defined in [sRGB](https://www.w3.org/Graphics/Color/sRGB) and is prefixed by '#'. This attribute may be used with one of sixteen predefined color strings:\n\n \n\n`black` = \"#000000\"\n\n \n\n`green` = \"#008000\"\n\n \n\n`silver` = \"#C0C0C0\"\n\n \n\n`lime` = \"#00FF00\"\n\n \n\n`gray` = \"#808080\"\n\n \n\n`olive` = \"#808000\"\n\n \n\n`white` = \"#FFFFFF\"\n\n \n\n`yellow` = \"#FFFF00\"\n\n \n\n`maroon` = \"#800000\"\n\n \n\n`navy` = \"#000080\"\n\n \n\n`red` = \"#FF0000\"\n\n \n\n`blue` = \"#0000FF\"\n\n \n\n`purple` = \"#800080\"\n\n \n\n`teal` = \"#008080\"\n\n \n\n`fuchsia` = \"#FF00FF\"\n\n \n\n`aqua` = \"#00FFFF\"\n\n**Note:** Do not use this attribute, as it is non-standard and only implemented in some versions of Microsoft Internet Explorer: The [`<th>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th \"The HTML <th> element defines a cell as header of a group of table cells. The exact nature of this group is defined by the scope and headers attributes.\") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/Web/CSS). To create a similar effect use the [`background-color`](https://developer.mozilla.org/en-US/docs/Web/CSS/background-color \"The background-color CSS property sets the background color of an element.\") property in [CSS](https://developer.mozilla.org/en-US/docs/Web/CSS) instead."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/th"}]},{name:"form",description:{kind:"markdown",value:"The form element represents a collection of form-associated elements, some of which can represent editable values that can be submitted to a server for processing."},attributes:[{name:"accept-charset",description:{kind:"markdown",value:"A space- or comma-delimited list of character encodings that the server accepts. The browser uses them in the order in which they are listed. The default value, the reserved string `\"UNKNOWN\"`, indicates the same encoding as that of the document containing the form element.  \nIn previous versions of HTML, the different character encodings could be delimited by spaces or commas. In HTML5, only spaces are allowed as delimiters."}},{name:"action",description:{kind:"markdown",value:"The URI of a program that processes the form information. This value can be overridden by a [`formaction`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formaction) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element."}},{name:"autocomplete",valueSet:"o",description:{kind:"markdown",value:"Indicates whether input elements can by default have their values automatically completed by the browser. This setting can be overridden by an `autocomplete` attribute on an element belonging to the form. Possible values are:\n\n*   `off`: The user must explicitly enter a value into each field for every use, or the document provides its own auto-completion method; the browser does not automatically complete entries.\n*   `on`: The browser can automatically complete values based on values that the user has previously entered in the form.\n\nFor most modern browsers (including Firefox 38+, Google Chrome 34+, IE 11+) setting the autocomplete attribute will not prevent a browser's password manager from asking the user if they want to store login fields (username and password), if the user permits the storage the browser will autofill the login the next time the user visits the page. See [The autocomplete attribute and login fields](https://developer.mozilla.org/en-US/docs/Web/Security/Securing_your_site/Turning_off_form_autocompletion#The_autocomplete_attribute_and_login_fields)."}},{name:"enctype",valueSet:"et",description:{kind:"markdown",value:"When the value of the `method` attribute is `post`, enctype is the [MIME type](https://en.wikipedia.org/wiki/Mime_type) of content that is used to submit the form to the server. Possible values are:\n\n*   `application/x-www-form-urlencoded`: The default value if the attribute is not specified.\n*   `multipart/form-data`: The value used for an [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element with the `type` attribute set to \"file\".\n*   `text/plain`: (HTML5)\n\nThis value can be overridden by a [`formenctype`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formenctype) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element."}},{name:"method",valueSet:"m",description:{kind:"markdown",value:"The [HTTP](https://developer.mozilla.org/en-US/docs/Web/HTTP) method that the browser uses to submit the form. Possible values are:\n\n*   `post`: Corresponds to the HTTP [POST method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.5) ; form data are included in the body of the form and sent to the server.\n*   `get`: Corresponds to the HTTP [GET method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.3); form data are appended to the `action` attribute URI with a '?' as separator, and the resulting URI is sent to the server. Use this method when the form has no side-effects and contains only ASCII characters.\n*   `dialog`: Use when the form is inside a [`<dialog>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/dialog \"The HTML <dialog> element represents a dialog box or other interactive component, such as an inspector or window.\") element to close the dialog when submitted.\n\nThis value can be overridden by a [`formmethod`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formmethod) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element."}},{name:"name",description:{kind:"markdown",value:"The name of the form. In HTML 4, its use is deprecated (`id` should be used instead). It must be unique among the forms in a document and not just an empty string in HTML 5."}},{name:"novalidate",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that the form is not to be validated when submitted. If this attribute is not specified (and therefore the form is validated), this default setting can be overridden by a [`formnovalidate`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formnovalidate) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element belonging to the form."}},{name:"target",description:{kind:"markdown",value:"A name or keyword indicating where to display the response that is received after submitting the form. In HTML 4, this is the name/keyword for a frame. In HTML5, it is a name/keyword for a _browsing context_ (for example, tab, window, or inline frame). The following keywords have special meanings:\n\n*   `_self`: Load the response into the same HTML 4 frame (or HTML5 browsing context) as the current one. This value is the default if the attribute is not specified.\n*   `_blank`: Load the response into a new unnamed HTML 4 window or HTML5 browsing context.\n*   `_parent`: Load the response into the HTML 4 frameset parent of the current frame, or HTML5 parent browsing context of the current one. If there is no parent, this option behaves the same way as `_self`.\n*   `_top`: HTML 4: Load the response into the full original window, and cancel all other frames. HTML5: Load the response into the top-level browsing context (i.e., the browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this option behaves the same way as `_self`.\n*   _iframename_: The response is displayed in a named [`<iframe>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/iframe \"The HTML Inline Frame element (<iframe>) represents a nested browsing context, embedding another HTML page into the current one.\").\n\nHTML5: This value can be overridden by a [`formtarget`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formtarget) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element."}},{name:"accept",description:"A comma-separated list of content types that the server accepts.\n\n**Usage note:** This attribute has been removed in HTML5 and should no longer be used. Instead, use the [`accept`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#attr-accept) attribute of the specific [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element."},{name:"autocapitalize",description:"This is a nonstandard attribute used by iOS Safari Mobile which controls whether and how the text value for textual form control descendants should be automatically capitalized as it is entered/edited by the user. If the `autocapitalize` attribute is specified on an individual form control descendant, it trumps the form-wide `autocapitalize` setting. The non-deprecated values are available in iOS 5 and later. The default value is `sentences`. Possible values are:\n\n*   `none`: Completely disables automatic capitalization\n*   `sentences`: Automatically capitalize the first letter of sentences.\n*   `words`: Automatically capitalize the first letter of words.\n*   `characters`: Automatically capitalize all characters.\n*   `on`: Deprecated since iOS 5.\n*   `off`: Deprecated since iOS 5."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/form"}]},{name:"label",description:{kind:"markdown",value:"The label element represents a caption in a user interface. The caption can be associated with a specific form control, known as the label element's labeled control, either using the for attribute, or by putting the form control inside the label element itself."},attributes:[{name:"form",description:{kind:"markdown",value:"The [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element with which the label is associated (its _form owner_). If specified, the value of the attribute is the `id` of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element in the same document. This lets you place label elements anywhere within a document, not just as descendants of their form elements."}},{name:"for",description:{kind:"markdown",value:"The [`id`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-id) of a [labelable](https://developer.mozilla.org/en-US/docs/Web/Guide/HTML/Content_categories#Form_labelable) form-related element in the same document as the `<label>` element. The first element in the document with an `id` matching the value of the `for` attribute is the _labeled control_ for this label element, if it is a labelable element. If it is not labelable then the `for` attribute has no effect. If there are other elements which also match the `id` value, later in the document, they are not considered.\n\n**Note**: A `<label>` element can have both a `for` attribute and a contained control element, as long as the `for` attribute points to the contained control element."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/label"}]},{name:"input",description:{kind:"markdown",value:"The input element represents a typed data field, usually with a form control to allow the user to edit the data."},attributes:[{name:"accept"},{name:"alt"},{name:"autocomplete",valueSet:"inputautocomplete"},{name:"autofocus",valueSet:"v"},{name:"checked",valueSet:"v"},{name:"dirname"},{name:"disabled",valueSet:"v"},{name:"form"},{name:"formaction"},{name:"formenctype",valueSet:"et"},{name:"formmethod",valueSet:"fm"},{name:"formnovalidate",valueSet:"v"},{name:"formtarget"},{name:"height"},{name:"inputmode",valueSet:"im"},{name:"list"},{name:"max"},{name:"maxlength"},{name:"min"},{name:"minlength"},{name:"multiple",valueSet:"v"},{name:"name"},{name:"pattern"},{name:"placeholder"},{name:"readonly",valueSet:"v"},{name:"required",valueSet:"v"},{name:"size"},{name:"src"},{name:"step"},{name:"type",valueSet:"t"},{name:"value"},{name:"width"}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/input"}]},{name:"button",description:{kind:"markdown",value:"The button element represents a button labeled by its contents."},attributes:[{name:"autofocus",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute lets you specify that the button should have input focus when the page loads, unless the user overrides it, for example by typing in a different control. Only one form-associated element in a document can have this attribute specified."}},{name:"disabled",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that the user cannot interact with the button. If this attribute is not specified, the button inherits its setting from the containing element, for example [`<fieldset>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/fieldset \"The HTML <fieldset> element is used to group several controls as well as labels (<label>) within a web form.\"); if there is no containing element with the **disabled** attribute set, then the button is enabled.\n\nFirefox will, unlike other browsers, by default, [persist the dynamic disabled state](https://stackoverflow.com/questions/5985839/bug-with-firefox-disabled-attribute-of-input-not-resetting-when-refreshing) of a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") across page loads. Use the [`autocomplete`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-autocomplete) attribute to control this feature."}},{name:"form",description:{kind:"markdown",value:"The form element that the button is associated with (its _form owner_). The value of the attribute must be the **id** attribute of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element in the same document. If this attribute is not specified, the `<button>` element will be associated to an ancestor [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element, if one exists. This attribute enables you to associate `<button>` elements to [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") elements anywhere within a document, not just as descendants of [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") elements."}},{name:"formaction",description:{kind:"markdown",value:"The URI of a program that processes the information submitted by the button. If specified, it overrides the [`action`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-action) attribute of the button's form owner."}},{name:"formenctype",valueSet:"et",description:{kind:"markdown",value:"If the button is a submit button, this attribute specifies the type of content that is used to submit the form to the server. Possible values are:\n\n*   `application/x-www-form-urlencoded`: The default value if the attribute is not specified.\n*   `multipart/form-data`: Use this value if you are using an [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") element with the [`type`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#attr-type) attribute set to `file`.\n*   `text/plain`\n\nIf this attribute is specified, it overrides the [`enctype`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-enctype) attribute of the button's form owner."}},{name:"formmethod",valueSet:"fm",description:{kind:"markdown",value:"If the button is a submit button, this attribute specifies the HTTP method that the browser uses to submit the form. Possible values are:\n\n*   `post`: The data from the form are included in the body of the form and sent to the server.\n*   `get`: The data from the form are appended to the **form** attribute URI, with a '?' as a separator, and the resulting URI is sent to the server. Use this method when the form has no side-effects and contains only ASCII characters.\n\nIf specified, this attribute overrides the [`method`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-method) attribute of the button's form owner."}},{name:"formnovalidate",valueSet:"v",description:{kind:"markdown",value:"If the button is a submit button, this Boolean attribute specifies that the form is not to be validated when it is submitted. If this attribute is specified, it overrides the [`novalidate`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-novalidate) attribute of the button's form owner."}},{name:"formtarget",description:{kind:"markdown",value:"If the button is a submit button, this attribute is a name or keyword indicating where to display the response that is received after submitting the form. This is a name of, or keyword for, a _browsing context_ (for example, tab, window, or inline frame). If this attribute is specified, it overrides the [`target`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-target) attribute of the button's form owner. The following keywords have special meanings:\n\n*   `_self`: Load the response into the same browsing context as the current one. This value is the default if the attribute is not specified.\n*   `_blank`: Load the response into a new unnamed browsing context.\n*   `_parent`: Load the response into the parent browsing context of the current one. If there is no parent, this option behaves the same way as `_self`.\n*   `_top`: Load the response into the top-level browsing context (that is, the browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this option behaves the same way as `_self`."}},{name:"name",description:{kind:"markdown",value:"The name of the button, which is submitted with the form data."}},{name:"type",valueSet:"bt",description:{kind:"markdown",value:"The type of the button. Possible values are:\n\n*   `submit`: The button submits the form data to the server. This is the default if the attribute is not specified, or if the attribute is dynamically changed to an empty or invalid value.\n*   `reset`: The button resets all the controls to their initial values.\n*   `button`: The button has no default behavior. It can have client-side scripts associated with the element's events, which are triggered when the events occur."}},{name:"value",description:{kind:"markdown",value:"The initial value of the button. It defines the value associated with the button which is submitted with the form data. This value is passed to the server in params when the form is submitted."}},{name:"autocomplete",description:"The use of this attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") is nonstandard and Firefox-specific. By default, unlike other browsers, [Firefox persists the dynamic disabled state](https://stackoverflow.com/questions/5985839/bug-with-firefox-disabled-attribute-of-input-not-resetting-when-refreshing) of a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button \"The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.\") across page loads. Setting the value of this attribute to `off` (i.e. `autocomplete=\"off\"`) disables this feature. See [bug 654072](https://bugzilla.mozilla.org/show_bug.cgi?id=654072 \"if disabled state is changed with javascript, the normal state doesn't return after refreshing the page\")."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/button"}]},{name:"select",description:{kind:"markdown",value:"The select element represents a control for selecting amongst a set of options."},attributes:[{name:"autocomplete",valueSet:"inputautocomplete",description:{kind:"markdown",value:"A [`DOMString`](https://developer.mozilla.org/en-US/docs/Web/API/DOMString \"DOMString is a UTF-16 String. As JavaScript already uses such strings, DOMString is mapped directly to a String.\") providing a hint for a [user agent's](https://developer.mozilla.org/en-US/docs/Glossary/user_agent \"user agent's: A user agent is a computer program representing a person, for example, a browser in a Web context.\") autocomplete feature. See [The HTML autocomplete attribute](https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete) for a complete list of values and details on how to use autocomplete."}},{name:"autofocus",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute lets you specify that a form control should have input focus when the page loads. Only one form element in a document can have the `autofocus` attribute."}},{name:"disabled",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that the user cannot interact with the control. If this attribute is not specified, the control inherits its setting from the containing element, for example `fieldset`; if there is no containing element with the `disabled` attribute set, then the control is enabled."}},{name:"form",description:{kind:"markdown",value:"This attribute lets you specify the form element to which the select element is associated (that is, its \"form owner\"). If this attribute is specified, its value must be the same as the `id` of a form element in the same document. This enables you to place select elements anywhere within a document, not just as descendants of their form elements."}},{name:"multiple",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that multiple options can be selected in the list. If it is not specified, then only one option can be selected at a time. When `multiple` is specified, most browsers will show a scrolling list box instead of a single line dropdown."}},{name:"name",description:{kind:"markdown",value:"This attribute is used to specify the name of the control."}},{name:"required",valueSet:"v",description:{kind:"markdown",value:"A Boolean attribute indicating that an option with a non-empty string value must be selected."}},{name:"size",description:{kind:"markdown",value:"If the control is presented as a scrolling list box (e.g. when `multiple` is specified), this attribute represents the number of rows in the list that should be visible at one time. Browsers are not required to present a select element as a scrolled list box. The default value is 0.\n\n**Note:** According to the HTML5 specification, the default value for size should be 1; however, in practice, this has been found to break some web sites, and no other browser currently does that, so Mozilla has opted to continue to return 0 for the time being with Firefox."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/select"}]},{name:"datalist",description:{kind:"markdown",value:"The datalist element represents a set of option elements that represent predefined options for other controls. In the rendering, the datalist element represents nothing and it, along with its children, should be hidden."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/datalist"}]},{name:"optgroup",description:{kind:"markdown",value:"The optgroup element represents a group of option elements with a common label."},attributes:[{name:"disabled",valueSet:"v",description:{kind:"markdown",value:"If this Boolean attribute is set, none of the items in this option group is selectable. Often browsers grey out such control and it won't receive any browsing events, like mouse clicks or focus-related ones."}},{name:"label",description:{kind:"markdown",value:"The name of the group of options, which the browser can use when labeling the options in the user interface. This attribute is mandatory if this element is used."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/optgroup"}]},{name:"option",description:{kind:"markdown",value:"The option element represents an option in a select element or as part of a list of suggestions in a datalist element."},attributes:[{name:"disabled",valueSet:"v",description:{kind:"markdown",value:"If this Boolean attribute is set, this option is not checkable. Often browsers grey out such control and it won't receive any browsing event, like mouse clicks or focus-related ones. If this attribute is not set, the element can still be disabled if one of its ancestors is a disabled [`<optgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/optgroup \"The HTML <optgroup> element creates a grouping of options within a <select> element.\") element."}},{name:"label",description:{kind:"markdown",value:"This attribute is text for the label indicating the meaning of the option. If the `label` attribute isn't defined, its value is that of the element text content."}},{name:"selected",valueSet:"v",description:{kind:"markdown",value:"If present, this Boolean attribute indicates that the option is initially selected. If the `<option>` element is the descendant of a [`<select>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/select \"The HTML <select> element represents a control that provides a menu of options\") element whose [`multiple`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/select#attr-multiple) attribute is not set, only one single `<option>` of this [`<select>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/select \"The HTML <select> element represents a control that provides a menu of options\") element may have the `selected` attribute."}},{name:"value",description:{kind:"markdown",value:"The content of this attribute represents the value to be submitted with the form, should this option be selected. If this attribute is omitted, the value is taken from the text content of the option element."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/option"}]},{name:"textarea",description:{kind:"markdown",value:"The textarea element represents a multiline plain text edit control for the element's raw value. The contents of the control represent the control's default value."},attributes:[{name:"autocomplete",valueSet:"inputautocomplete",description:{kind:"markdown",value:"This attribute indicates whether the value of the control can be automatically completed by the browser. Possible values are:\n\n*   `off`: The user must explicitly enter a value into this field for every use, or the document provides its own auto-completion method; the browser does not automatically complete the entry.\n*   `on`: The browser can automatically complete the value based on values that the user has entered during previous uses.\n\nIf the `autocomplete` attribute is not specified on a `<textarea>` element, then the browser uses the `autocomplete` attribute value of the `<textarea>` element's form owner. The form owner is either the [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element that this `<textarea>` element is a descendant of or the form element whose `id` is specified by the `form` attribute of the input element. For more information, see the [`autocomplete`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-autocomplete) attribute in [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\")."}},{name:"autofocus",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute lets you specify that a form control should have input focus when the page loads. Only one form-associated element in a document can have this attribute specified."}},{name:"cols",description:{kind:"markdown",value:"The visible width of the text control, in average character widths. If it is specified, it must be a positive integer. If it is not specified, the default value is `20`."}},{name:"dirname"},{name:"disabled",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that the user cannot interact with the control. If this attribute is not specified, the control inherits its setting from the containing element, for example [`<fieldset>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/fieldset \"The HTML <fieldset> element is used to group several controls as well as labels (<label>) within a web form.\"); if there is no containing element when the `disabled` attribute is set, the control is enabled."}},{name:"form",description:{kind:"markdown",value:"The form element that the `<textarea>` element is associated with (its \"form owner\"). The value of the attribute must be the `id` of a form element in the same document. If this attribute is not specified, the `<textarea>` element must be a descendant of a form element. This attribute enables you to place `<textarea>` elements anywhere within a document, not just as descendants of form elements."}},{name:"inputmode",valueSet:"im"},{name:"maxlength",description:{kind:"markdown",value:"The maximum number of characters (unicode code points) that the user can enter. If this value isn't specified, the user can enter an unlimited number of characters."}},{name:"minlength",description:{kind:"markdown",value:"The minimum number of characters (unicode code points) required that the user should enter."}},{name:"name",description:{kind:"markdown",value:"The name of the control."}},{name:"placeholder",description:{kind:"markdown",value:"A hint to the user of what can be entered in the control. Carriage returns or line-feeds within the placeholder text must be treated as line breaks when rendering the hint.\n\n**Note:** Placeholders should only be used to show an example of the type of data that should be entered into a form; they are _not_ a substitute for a proper [`<label>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label \"The HTML <label> element represents a caption for an item in a user interface.\") element tied to the input. See [Labels and placeholders](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Labels_and_placeholders \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") in [<input>: The Input (Form Input) element](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") for a full explanation."}},{name:"readonly",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates that the user cannot modify the value of the control. Unlike the `disabled` attribute, the `readonly` attribute does not prevent the user from clicking or selecting in the control. The value of a read-only control is still submitted with the form."}},{name:"required",valueSet:"v",description:{kind:"markdown",value:"This attribute specifies that the user must fill in a value before submitting a form."}},{name:"rows",description:{kind:"markdown",value:"The number of visible text lines for the control."}},{name:"wrap",valueSet:"w",description:{kind:"markdown",value:"Indicates how the control wraps text. Possible values are:\n\n*   `hard`: The browser automatically inserts line breaks (CR+LF) so that each line has no more than the width of the control; the `cols` attribute must also be specified for this to take effect.\n*   `soft`: The browser ensures that all line breaks in the value consist of a CR+LF pair, but does not insert any additional line breaks.\n*   `off` : Like `soft` but changes appearance to `white-space: pre` so line segments exceeding `cols` are not wrapped and the `<textarea>` becomes horizontally scrollable.\n\nIf this attribute is not specified, `soft` is its default value."}},{name:"autocapitalize",description:"This is a non-standard attribute supported by WebKit on iOS (therefore nearly all browsers running on iOS, including Safari, Firefox, and Chrome), which controls whether and how the text value should be automatically capitalized as it is entered/edited by the user. The non-deprecated values are available in iOS 5 and later. Possible values are:\n\n*   `none`: Completely disables automatic capitalization.\n*   `sentences`: Automatically capitalize the first letter of sentences.\n*   `words`: Automatically capitalize the first letter of words.\n*   `characters`: Automatically capitalize all characters.\n*   `on`: Deprecated since iOS 5.\n*   `off`: Deprecated since iOS 5."},{name:"spellcheck",description:"Specifies whether the `<textarea>` is subject to spell checking by the underlying browser/OS. the value can be:\n\n*   `true`: Indicates that the element needs to have its spelling and grammar checked.\n*   `default` : Indicates that the element is to act according to a default behavior, possibly based on the parent element's own `spellcheck` value.\n*   `false` : Indicates that the element should not be spell checked."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/textarea"}]},{name:"output",description:{kind:"markdown",value:"The output element represents the result of a calculation performed by the application, or the result of a user action."},attributes:[{name:"for",description:{kind:"markdown",value:"A space-separated list of other elements’ [`id`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/id)s, indicating that those elements contributed input values to (or otherwise affected) the calculation."}},{name:"form",description:{kind:"markdown",value:"The [form element](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form) that this element is associated with (its \"form owner\"). The value of the attribute must be an `id` of a form element in the same document. If this attribute is not specified, the output element must be a descendant of a form element. This attribute enables you to place output elements anywhere within a document, not just as descendants of their form elements."}},{name:"name",description:{kind:"markdown",value:"The name of the element, exposed in the [`HTMLFormElement`](https://developer.mozilla.org/en-US/docs/Web/API/HTMLFormElement \"The HTMLFormElement interface represents a <form> element in the DOM; it allows access to and in some cases modification of aspects of the form, as well as access to its component elements.\") API."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/output"}]},{name:"progress",description:{kind:"markdown",value:"The progress element represents the completion progress of a task. The progress is either indeterminate, indicating that progress is being made but that it is not clear how much more work remains to be done before the task is complete (e.g. because the task is waiting for a remote host to respond), or the progress is a number in the range zero to a maximum, giving the fraction of work that has so far been completed."},attributes:[{name:"value",description:{kind:"markdown",value:"This attribute specifies how much of the task that has been completed. It must be a valid floating point number between 0 and `max`, or between 0 and 1 if `max` is omitted. If there is no `value` attribute, the progress bar is indeterminate; this indicates that an activity is ongoing with no indication of how long it is expected to take."}},{name:"max",description:{kind:"markdown",value:"This attribute describes how much work the task indicated by the `progress` element requires. The `max` attribute, if present, must have a value greater than zero and be a valid floating point number. The default value is 1."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/progress"}]},{name:"meter",description:{kind:"markdown",value:"The meter element represents a scalar measurement within a known range, or a fractional value; for example disk usage, the relevance of a query result, or the fraction of a voting population to have selected a particular candidate."},attributes:[{name:"value",description:{kind:"markdown",value:"The current numeric value. This must be between the minimum and maximum values (`min` attribute and `max` attribute) if they are specified. If unspecified or malformed, the value is 0. If specified, but not within the range given by the `min` attribute and `max` attribute, the value is equal to the nearest end of the range.\n\n**Usage note:** Unless the `value` attribute is between `0` and `1` (inclusive), the `min` and `max` attributes should define the range so that the `value` attribute's value is within it."}},{name:"min",description:{kind:"markdown",value:"The lower numeric bound of the measured range. This must be less than the maximum value (`max` attribute), if specified. If unspecified, the minimum value is 0."}},{name:"max",description:{kind:"markdown",value:"The upper numeric bound of the measured range. This must be greater than the minimum value (`min` attribute), if specified. If unspecified, the maximum value is 1."}},{name:"low",description:{kind:"markdown",value:"The upper numeric bound of the low end of the measured range. This must be greater than the minimum value (`min` attribute), and it also must be less than the high value and maximum value (`high` attribute and `max` attribute, respectively), if any are specified. If unspecified, or if less than the minimum value, the `low` value is equal to the minimum value."}},{name:"high",description:{kind:"markdown",value:"The lower numeric bound of the high end of the measured range. This must be less than the maximum value (`max` attribute), and it also must be greater than the low value and minimum value (`low` attribute and **min** attribute, respectively), if any are specified. If unspecified, or if greater than the maximum value, the `high` value is equal to the maximum value."}},{name:"optimum",description:{kind:"markdown",value:"This attribute indicates the optimal numeric value. It must be within the range (as defined by the `min` attribute and `max` attribute). When used with the `low` attribute and `high` attribute, it gives an indication where along the range is considered preferable. For example, if it is between the `min` attribute and the `low` attribute, then the lower range is considered preferred."}},{name:"form",description:"This attribute associates the element with a `form` element that has ownership of the `meter` element. For example, a `meter` might be displaying a range corresponding to an `input` element of `type` _number_. This attribute is only used if the `meter` element is being used as a form-associated element; even then, it may be omitted if the element appears as a descendant of a `form` element."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/meter"}]},{name:"fieldset",description:{kind:"markdown",value:"The fieldset element represents a set of form controls optionally grouped under a common name."},attributes:[{name:"disabled",valueSet:"v",description:{kind:"markdown",value:"If this Boolean attribute is set, all form controls that are descendants of the `<fieldset>`, are disabled, meaning they are not editable and won't be submitted along with the `<form>`. They won't receive any browsing events, like mouse clicks or focus-related events. By default browsers display such controls grayed out. Note that form elements inside the [`<legend>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/legend \"The HTML <legend> element represents a caption for the content of its parent <fieldset>.\") element won't be disabled."}},{name:"form",description:{kind:"markdown",value:"This attribute takes the value of the `id` attribute of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form \"The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.\") element you want the `<fieldset>` to be part of, even if it is not inside the form."}},{name:"name",description:{kind:"markdown",value:"The name associated with the group.\n\n**Note**: The caption for the fieldset is given by the first [`<legend>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/legend \"The HTML <legend> element represents a caption for the content of its parent <fieldset>.\") element nested inside it."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/fieldset"}]},{name:"legend",description:{kind:"markdown",value:"The legend element represents a caption for the rest of the contents of the legend element's parent fieldset element, if any."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/legend"}]},{name:"details",description:{kind:"markdown",value:"The details element represents a disclosure widget from which the user can obtain additional information or controls."},attributes:[{name:"open",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute indicates whether or not the details — that is, the contents of the `<details>` element — are currently visible. The default, `false`, means the details are not visible."}}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/details"}]},{name:"summary",description:{kind:"markdown",value:"The summary element represents a summary, caption, or legend for the rest of the contents of the summary element's parent details element, if any."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/summary"}]},{name:"dialog",description:{kind:"markdown",value:"The dialog element represents a part of an application that a user interacts with to perform a task, for example a dialog box, inspector, or window."},attributes:[{name:"open",description:"Indicates that the dialog is active and available for interaction. When the `open` attribute is not set, the dialog shouldn't be shown to the user."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/dialog"}]},{name:"script",description:{kind:"markdown",value:"The script element allows authors to include dynamic script and data blocks in their documents. The element does not represent content for the user."},attributes:[{name:"src",description:{kind:"markdown",value:"This attribute specifies the URI of an external script; this can be used as an alternative to embedding a script directly within a document.\n\nIf a `script` element has a `src` attribute specified, it should not have a script embedded inside its tags."}},{name:"type",description:{kind:"markdown",value:"This attribute indicates the type of script represented. The value of this attribute will be in one of the following categories:\n\n*   **Omitted or a JavaScript MIME type:** For HTML5-compliant browsers this indicates the script is JavaScript. HTML5 specification urges authors to omit the attribute rather than provide a redundant MIME type. In earlier browsers, this identified the scripting language of the embedded or imported (via the `src` attribute) code. JavaScript MIME types are [listed in the specification](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types#JavaScript_types).\n*   **`module`:** For HTML5-compliant browsers the code is treated as a JavaScript module. The processing of the script contents is not affected by the `charset` and `defer` attributes. For information on using `module`, see [ES6 in Depth: Modules](https://hacks.mozilla.org/2015/08/es6-in-depth-modules/). Code may behave differently when the `module` keyword is used.\n*   **Any other value:** The embedded content is treated as a data block which won't be processed by the browser. Developers must use a valid MIME type that is not a JavaScript MIME type to denote data blocks. The `src` attribute will be ignored.\n\n**Note:** in Firefox you could specify the version of JavaScript contained in a `<script>` element by including a non-standard `version` parameter inside the `type` attribute — for example `type=\"text/javascript;version=1.8\"`. This has been removed in Firefox 59 (see [bug 1428745](https://bugzilla.mozilla.org/show_bug.cgi?id=1428745 \"FIXED: Remove support for version parameter from script loader\"))."}},{name:"charset"},{name:"async",valueSet:"v",description:{kind:"markdown",value:"This is a Boolean attribute indicating that the browser should, if possible, load the script asynchronously.\n\nThis attribute must not be used if the `src` attribute is absent (i.e. for inline scripts). If it is included in this case it will have no effect.\n\nBrowsers usually assume the worst case scenario and load scripts synchronously, (i.e. `async=\"false\"`) during HTML parsing.\n\nDynamically inserted scripts (using [`document.createElement()`](https://developer.mozilla.org/en-US/docs/Web/API/Document/createElement \"In an HTML document, the document.createElement() method creates the HTML element specified by tagName, or an HTMLUnknownElement if tagName isn't recognized.\")) load asynchronously by default, so to turn on synchronous loading (i.e. scripts load in the order they were inserted) set `async=\"false\"`.\n\nSee [Browser compatibility](#Browser_compatibility) for notes on browser support. See also [Async scripts for asm.js](https://developer.mozilla.org/en-US/docs/Games/Techniques/Async_scripts)."}},{name:"defer",valueSet:"v",description:{kind:"markdown",value:"This Boolean attribute is set to indicate to a browser that the script is meant to be executed after the document has been parsed, but before firing [`DOMContentLoaded`](https://developer.mozilla.org/en-US/docs/Web/Events/DOMContentLoaded \"/en-US/docs/Web/Events/DOMContentLoaded\").\n\nScripts with the `defer` attribute will prevent the `DOMContentLoaded` event from firing until the script has loaded and finished evaluating.\n\nThis attribute must not be used if the `src` attribute is absent (i.e. for inline scripts), in this case it would have no effect.\n\nTo achieve a similar effect for dynamically inserted scripts use `async=\"false\"` instead. Scripts with the `defer` attribute will execute in the order in which they appear in the document."}},{name:"crossorigin",valueSet:"xo",description:{kind:"markdown",value:"Normal `script` elements pass minimal information to the [`window.onerror`](https://developer.mozilla.org/en-US/docs/Web/API/GlobalEventHandlers/onerror \"The onerror property of the GlobalEventHandlers mixin is an EventHandler that processes error events.\") for scripts which do not pass the standard [CORS](https://developer.mozilla.org/en-US/docs/Glossary/CORS \"CORS: CORS (Cross-Origin Resource Sharing) is a system, consisting of transmitting HTTP headers, that determines whether browsers block frontend JavaScript code from accessing responses for cross-origin requests.\") checks. To allow error logging for sites which use a separate domain for static media, use this attribute. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes) for a more descriptive explanation of its valid arguments."}},{name:"nonce",description:{kind:"markdown",value:"A cryptographic nonce (number used once) to whitelist inline scripts in a [script-src Content-Security-Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/script-src). The server must generate a unique nonce value each time it transmits a policy. It is critical to provide a nonce that cannot be guessed as bypassing a resource's policy is otherwise trivial."}},{name:"integrity",description:"This attribute contains inline metadata that a user agent can use to verify that a fetched resource has been delivered free of unexpected manipulation. See [Subresource Integrity](https://developer.mozilla.org/en-US/docs/Web/Security/Subresource_Integrity)."},{name:"nomodule",description:"This Boolean attribute is set to indicate that the script should not be executed in browsers that support [ES2015 modules](https://hacks.mozilla.org/2015/08/es6-in-depth-modules/) — in effect, this can be used to serve fallback scripts to older browsers that do not support modular JavaScript code."},{name:"referrerpolicy",description:"Indicates which [referrer](https://developer.mozilla.org/en-US/docs/Web/API/Document/referrer) to send when fetching the script, or resources fetched by the script:\n\n*   `no-referrer`: The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent.\n*   `no-referrer-when-downgrade` (default): The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent to [origin](https://developer.mozilla.org/en-US/docs/Glossary/origin \"origin: Web content's origin is defined by the scheme (protocol), host (domain), and port of the URL used to access it. Two objects have the same origin only when the scheme, host, and port all match.\")s without [TLS](https://developer.mozilla.org/en-US/docs/Glossary/TLS \"TLS: Transport Layer Security (TLS), previously known as Secure Sockets Layer (SSL), is a protocol used by applications to communicate securely across a network, preventing tampering with and eavesdropping on email, web browsing, messaging, and other protocols.\") ([HTTPS](https://developer.mozilla.org/en-US/docs/Glossary/HTTPS \"HTTPS: HTTPS (HTTP Secure) is an encrypted version of the HTTP protocol. It usually uses SSL or TLS to encrypt all communication between a client and a server. This secure connection allows clients to safely exchange sensitive data with a server, for example for banking activities or online shopping.\")).\n*   `origin`: The sent referrer will be limited to the origin of the referring page: its [scheme](https://developer.mozilla.org/en-US/docs/Archive/Mozilla/URIScheme), [host](https://developer.mozilla.org/en-US/docs/Glossary/host \"host: A host is a device connected to the Internet (or a local network). Some hosts called servers offer additional services like serving webpages or storing files and emails.\"), and [port](https://developer.mozilla.org/en-US/docs/Glossary/port \"port: For a computer connected to a network with an IP address, a port is a communication endpoint. Ports are designated by numbers, and below 1024 each port is associated by default with a specific protocol.\").\n*   `origin-when-cross-origin`: The referrer sent to other origins will be limited to the scheme, the host, and the port. Navigations on the same origin will still include the path.\n*   `same-origin`: A referrer will be sent for [same origin](https://developer.mozilla.org/en-US/docs/Glossary/Same-origin_policy \"same origin: The same-origin policy is a critical security mechanism that restricts how a document or script loaded from one origin can interact with a resource from another origin.\"), but cross-origin requests will contain no referrer information.\n*   `strict-origin`: Only send the origin of the document as the referrer when the protocol security level stays the same (e.g. HTTPS→HTTPS), but don't send it to a less secure destination (e.g. HTTPS→HTTP).\n*   `strict-origin-when-cross-origin`: Send a full URL when performing a same-origin request, but only send the origin when the protocol security level stays the same (e.g.HTTPS→HTTPS), and send no header to a less secure destination (e.g. HTTPS→HTTP).\n*   `unsafe-url`: The referrer will include the origin _and_ the path (but not the [fragment](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/hash), [password](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/password), or [username](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/username)). **This value is unsafe**, because it leaks origins and paths from TLS-protected resources to insecure origins.\n\n**Note**: An empty string value (`\"\"`) is both the default value, and a fallback value if `referrerpolicy` is not supported. If `referrerpolicy` is not explicitly specified on the `<script>` element, it will adopt a higher-level referrer policy, i.e. one set on the whole document or domain. If a higher-level policy is not available, the empty string is treated as being equivalent to `no-referrer-when-downgrade`."},{name:"text",description:"Like the `textContent` attribute, this attribute sets the text content of the element. Unlike the `textContent` attribute, however, this attribute is evaluated as executable code after the node is inserted into the DOM."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/script"}]},{name:"noscript",description:{kind:"markdown",value:"The noscript element represents nothing if scripting is enabled, and represents its children if scripting is disabled. It is used to present different markup to user agents that support scripting and those that don't support scripting, by affecting how the document is parsed."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/noscript"}]},{name:"template",description:{kind:"markdown",value:"The template element is used to declare fragments of HTML that can be cloned and inserted in the document by script."},attributes:[],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/template"}]},{name:"canvas",description:{kind:"markdown",value:"The canvas element provides scripts with a resolution-dependent bitmap canvas, which can be used for rendering graphs, game graphics, art, or other visual images on the fly."},attributes:[{name:"width",description:{kind:"markdown",value:"The width of the coordinate space in CSS pixels. Defaults to 300."}},{name:"height",description:{kind:"markdown",value:"The height of the coordinate space in CSS pixels. Defaults to 150."}},{name:"moz-opaque",description:"Lets the canvas know whether or not translucency will be a factor. If the canvas knows there's no translucency, painting performance can be optimized. This is only supported by Mozilla-based browsers; use the standardized [`canvas.getContext('2d', { alpha: false })`](https://developer.mozilla.org/en-US/docs/Web/API/HTMLCanvasElement/getContext \"The HTMLCanvasElement.getContext() method returns a drawing context on the canvas, or null if the context identifier is not supported.\") instead."}],references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Element/canvas"}]}];var globalAttributes=[{name:"accesskey",description:{kind:"markdown",value:"Provides a hint for generating a keyboard shortcut for the current element. This attribute consists of a space-separated list of characters. The browser should use the first one that exists on the computer keyboard layout."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/accesskey"}]},{name:"autocapitalize",description:{kind:"markdown",value:"Controls whether and how text input is automatically capitalized as it is entered/edited by the user. It can have the following values:\n\n*   `off` or `none`, no autocapitalization is applied (all letters default to lowercase)\n*   `on` or `sentences`, the first letter of each sentence defaults to a capital letter; all other letters default to lowercase\n*   `words`, the first letter of each word defaults to a capital letter; all other letters default to lowercase\n*   `characters`, all letters should default to uppercase"},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/autocapitalize"}]},{name:"class",description:{kind:"markdown",value:"A space-separated list of the classes of the element. Classes allows CSS and JavaScript to select and access specific elements via the [class selectors](/en-US/docs/Web/CSS/Class_selectors) or functions like the method [`Document.getElementsByClassName()`](/en-US/docs/Web/API/Document/getElementsByClassName \"returns an array-like object of all child elements which have all of the given class names.\")."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/class"}]},{name:"contenteditable",description:{kind:"markdown",value:"An enumerated attribute indicating if the element should be editable by the user. If so, the browser modifies its widget to allow editing. The attribute must take one of the following values:\n\n*   `true` or the _empty string_, which indicates that the element must be editable;\n*   `false`, which indicates that the element must not be editable."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/contenteditable"}]},{name:"contextmenu",description:{kind:"markdown",value:"The `[**id**](#attr-id)` of a [`<menu>`](/en-US/docs/Web/HTML/Element/menu \"The HTML <menu> element represents a group of commands that a user can perform or activate. This includes both list menus, which might appear across the top of a screen, as well as context menus, such as those that might appear underneath a button after it has been clicked.\") to use as the contextual menu for this element."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/contextmenu"}]},{name:"dir",description:{kind:"markdown",value:"An enumerated attribute indicating the directionality of the element's text. It can have the following values:\n\n*   `ltr`, which means _left to right_ and is to be used for languages that are written from the left to the right (like English);\n*   `rtl`, which means _right to left_ and is to be used for languages that are written from the right to the left (like Arabic);\n*   `auto`, which lets the user agent decide. It uses a basic algorithm as it parses the characters inside the element until it finds a character with a strong directionality, then it applies that directionality to the whole element."},valueSet:"d",references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/dir"}]},{name:"draggable",description:{kind:"markdown",value:"An enumerated attribute indicating whether the element can be dragged, using the [Drag and Drop API](/en-us/docs/DragDrop/Drag_and_Drop). It can have the following values:\n\n*   `true`, which indicates that the element may be dragged\n*   `false`, which indicates that the element may not be dragged."},valueSet:"b",references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/draggable"}]},{name:"dropzone",description:{kind:"markdown",value:"An enumerated attribute indicating what types of content can be dropped on an element, using the [Drag and Drop API](/en-US/docs/DragDrop/Drag_and_Drop). It can have the following values:\n\n*   `copy`, which indicates that dropping will create a copy of the element that was dragged\n*   `move`, which indicates that the element that was dragged will be moved to this new location.\n*   `link`, will create a link to the dragged data."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/dropzone"}]},{name:"exportparts",description:{kind:"markdown",value:"Used to transitively export shadow parts from a nested shadow tree into a containing light tree."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/exportparts"}]},{name:"hidden",description:{kind:"markdown",value:"A Boolean attribute indicates that the element is not yet, or is no longer, _relevant_. For example, it can be used to hide elements of the page that can't be used until the login process has been completed. The browser won't render such elements. This attribute must not be used to hide content that could legitimately be shown."},valueSet:"v",references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/hidden"}]},{name:"id",description:{kind:"markdown",value:"Defines a unique identifier (ID) which must be unique in the whole document. Its purpose is to identify the element when linking (using a fragment identifier), scripting, or styling (with CSS)."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/id"}]},{name:"inputmode",description:{kind:"markdown",value:"Provides a hint to browsers as to the type of virtual keyboard configuration to use when editing this element or its contents. Used primarily on [`<input>`](/en-US/docs/Web/HTML/Element/input \"The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.\") elements, but is usable on any element while in `[contenteditable](/en-US/docs/Web/HTML/Global_attributes#attr-contenteditable)` mode."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/inputmode"}]},{name:"is",description:{kind:"markdown",value:"Allows you to specify that a standard HTML element should behave like a registered custom built-in element (see [Using custom elements](/en-US/docs/Web/Web_Components/Using_custom_elements) for more details)."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/is"}]},{name:"itemid",description:{kind:"markdown",value:"The unique, global identifier of an item."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemid"}]},{name:"itemprop",description:{kind:"markdown",value:"Used to add properties to an item. Every HTML element may have an `itemprop` attribute specified, where an `itemprop` consists of a name and value pair."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemprop"}]},{name:"itemref",description:{kind:"markdown",value:"Properties that are not descendants of an element with the `itemscope` attribute can be associated with the item using an `itemref`. It provides a list of element ids (not `itemid`s) with additional properties elsewhere in the document."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemref"}]},{name:"itemscope",description:{kind:"markdown",value:"`itemscope` (usually) works along with `[itemtype](/en-US/docs/Web/HTML/Global_attributes#attr-itemtype)` to specify that the HTML contained in a block is about a particular item. `itemscope` creates the Item and defines the scope of the `itemtype` associated with it. `itemtype` is a valid URL of a vocabulary (such as [schema.org](https://schema.org/)) that describes the item and its properties context."},valueSet:"v",references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemscope"}]},{name:"itemtype",description:{kind:"markdown",value:"Specifies the URL of the vocabulary that will be used to define `itemprop`s (item properties) in the data structure. `[itemscope](/en-US/docs/Web/HTML/Global_attributes#attr-itemscope)` is used to set the scope of where in the data structure the vocabulary set by `itemtype` will be active."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemtype"}]},{name:"lang",description:{kind:"markdown",value:"Helps define the language of an element: the language that non-editable elements are in, or the language that editable elements should be written in by the user. The attribute contains one “language tag” (made of hyphen-separated “language subtags”) in the format defined in [_Tags for Identifying Languages (BCP47)_](https://www.ietf.org/rfc/bcp/bcp47.txt). [**xml:lang**](#attr-xml:lang) has priority over it."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/lang"}]},{name:"part",description:{kind:"markdown",value:"A space-separated list of the part names of the element. Part names allows CSS to select and style specific elements in a shadow tree via the [`::part`](/en-US/docs/Web/CSS/::part \"The ::part CSS pseudo-element represents any element within a shadow tree that has a matching part attribute.\") pseudo-element."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/part"}]},{name:"role",valueSet:"roles"},{name:"slot",description:{kind:"markdown",value:"Assigns a slot in a [shadow DOM](/en-US/docs/Web/Web_Components/Shadow_DOM) shadow tree to an element: An element with a `slot` attribute is assigned to the slot created by the [`<slot>`](/en-US/docs/Web/HTML/Element/slot \"The HTML <slot> element—part of the Web Components technology suite—is a placeholder inside a web component that you can fill with your own markup, which lets you create separate DOM trees and present them together.\") element whose `[name](/en-US/docs/Web/HTML/Element/slot#attr-name)` attribute's value matches that `slot` attribute's value."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/slot"}]},{name:"spellcheck",description:{kind:"markdown",value:"An enumerated attribute defines whether the element may be checked for spelling errors. It may have the following values:\n\n*   `true`, which indicates that the element should be, if possible, checked for spelling errors;\n*   `false`, which indicates that the element should not be checked for spelling errors."},valueSet:"b",references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/spellcheck"}]},{name:"style",description:{kind:"markdown",value:"Contains [CSS](/en-US/docs/Web/CSS) styling declarations to be applied to the element. Note that it is recommended for styles to be defined in a separate file or files. This attribute and the [`<style>`](/en-US/docs/Web/HTML/Element/style \"The HTML <style> element contains style information for a document, or part of a document.\") element have mainly the purpose of allowing for quick styling, for example for testing purposes."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/style"}]},{name:"tabindex",description:{kind:"markdown",value:"An integer attribute indicating if the element can take input focus (is _focusable_), if it should participate to sequential keyboard navigation, and if so, at what position. It can take several values:\n\n*   a _negative value_ means that the element should be focusable, but should not be reachable via sequential keyboard navigation;\n*   `0` means that the element should be focusable and reachable via sequential keyboard navigation, but its relative order is defined by the platform convention;\n*   a _positive value_ means that the element should be focusable and reachable via sequential keyboard navigation; the order in which the elements are focused is the increasing value of the [**tabindex**](#attr-tabindex). If several elements share the same tabindex, their relative order follows their relative positions in the document."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/tabindex"}]},{name:"title",description:{kind:"markdown",value:"Contains a text representing advisory information related to the element it belongs to. Such information can typically, but not necessarily, be presented to the user as a tooltip."},references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/title"}]},{name:"translate",description:{kind:"markdown",value:"An enumerated attribute that is used to specify whether an element's attribute values and the values of its [`Text`](/en-US/docs/Web/API/Text \"The Text interface represents the textual content of Element or Attr. If an element has no markup within its content, it has a single child implementing Text that contains the element's text. However, if the element contains markup, it is parsed into information items and Text nodes that form its children.\") node children are to be translated when the page is localized, or whether to leave them unchanged. It can have the following values:\n\n*   empty string and `yes`, which indicates that the element will be translated.\n*   `no`, which indicates that the element will not be translated."},valueSet:"y",references:[{name:"MDN Reference",url:"https://developer.mozilla.org/docs/Web/HTML/Global_attributes/translate"}]},{name:"onabort",description:{kind:"markdown",value:"The loading of a resource has been aborted."}},{name:"onblur",description:{kind:"markdown",value:"An element has lost focus (does not bubble)."}},{name:"oncanplay",description:{kind:"markdown",value:"The user agent can play the media, but estimates that not enough data has been loaded to play the media up to its end without having to stop for further buffering of content."}},{name:"oncanplaythrough",description:{kind:"markdown",value:"The user agent can play the media up to its end without having to stop for further buffering of content."}},{name:"onchange",description:{kind:"markdown",value:"The change event is fired for <input>, <select>, and <textarea> elements when a change to the element's value is committed by the user."}},{name:"onclick",description:{kind:"markdown",value:"A pointing device button has been pressed and released on an element."}},{name:"oncontextmenu",description:{kind:"markdown",value:"The right button of the mouse is clicked (before the context menu is displayed)."}},{name:"ondblclick",description:{kind:"markdown",value:"A pointing device button is clicked twice on an element."}},{name:"ondrag",description:{kind:"markdown",value:"An element or text selection is being dragged (every 350ms)."}},{name:"ondragend",description:{kind:"markdown",value:"A drag operation is being ended (by releasing a mouse button or hitting the escape key)."}},{name:"ondragenter",description:{kind:"markdown",value:"A dragged element or text selection enters a valid drop target."}},{name:"ondragleave",description:{kind:"markdown",value:"A dragged element or text selection leaves a valid drop target."}},{name:"ondragover",description:{kind:"markdown",value:"An element or text selection is being dragged over a valid drop target (every 350ms)."}},{name:"ondragstart",description:{kind:"markdown",value:"The user starts dragging an element or text selection."}},{name:"ondrop",description:{kind:"markdown",value:"An element is dropped on a valid drop target."}},{name:"ondurationchange",description:{kind:"markdown",value:"The duration attribute has been updated."}},{name:"onemptied",description:{kind:"markdown",value:"The media has become empty; for example, this event is sent if the media has already been loaded (or partially loaded), and the load() method is called to reload it."}},{name:"onended",description:{kind:"markdown",value:"Playback has stopped because the end of the media was reached."}},{name:"onerror",description:{kind:"markdown",value:"A resource failed to load."}},{name:"onfocus",description:{kind:"markdown",value:"An element has received focus (does not bubble)."}},{name:"onformchange"},{name:"onforminput"},{name:"oninput",description:{kind:"markdown",value:"The value of an element changes or the content of an element with the attribute contenteditable is modified."}},{name:"oninvalid",description:{kind:"markdown",value:"A submittable element has been checked and doesn't satisfy its constraints."}},{name:"onkeydown",description:{kind:"markdown",value:"A key is pressed down."}},{name:"onkeypress",description:{kind:"markdown",value:"A key is pressed down and that key normally produces a character value (use input instead)."}},{name:"onkeyup",description:{kind:"markdown",value:"A key is released."}},{name:"onload",description:{kind:"markdown",value:"A resource and its dependent resources have finished loading."}},{name:"onloadeddata",description:{kind:"markdown",value:"The first frame of the media has finished loading."}},{name:"onloadedmetadata",description:{kind:"markdown",value:"The metadata has been loaded."}},{name:"onloadstart",description:{kind:"markdown",value:"Progress has begun."}},{name:"onmousedown",description:{kind:"markdown",value:"A pointing device button (usually a mouse) is pressed on an element."}},{name:"onmousemove",description:{kind:"markdown",value:"A pointing device is moved over an element."}},{name:"onmouseout",description:{kind:"markdown",value:"A pointing device is moved off the element that has the listener attached or off one of its children."}},{name:"onmouseover",description:{kind:"markdown",value:"A pointing device is moved onto the element that has the listener attached or onto one of its children."}},{name:"onmouseup",description:{kind:"markdown",value:"A pointing device button is released over an element."}},{name:"onmousewheel"},{name:"onpause",description:{kind:"markdown",value:"Playback has been paused."}},{name:"onplay",description:{kind:"markdown",value:"Playback has begun."}},{name:"onplaying",description:{kind:"markdown",value:"Playback is ready to start after having been paused or delayed due to lack of data."}},{name:"onprogress",description:{kind:"markdown",value:"In progress."}},{name:"onratechange",description:{kind:"markdown",value:"The playback rate has changed."}},{name:"onreset",description:{kind:"markdown",value:"A form is reset."}},{name:"onresize",description:{kind:"markdown",value:"The document view has been resized."}},{name:"onreadystatechange",description:{kind:"markdown",value:"The readyState attribute of a document has changed."}},{name:"onscroll",description:{kind:"markdown",value:"The document view or an element has been scrolled."}},{name:"onseeked",description:{kind:"markdown",value:"A seek operation completed."}},{name:"onseeking",description:{kind:"markdown",value:"A seek operation began."}},{name:"onselect",description:{kind:"markdown",value:"Some text is being selected."}},{name:"onshow",description:{kind:"markdown",value:"A contextmenu event was fired on/bubbled to an element that has a contextmenu attribute"}},{name:"onstalled",description:{kind:"markdown",value:"The user agent is trying to fetch media data, but data is unexpectedly not forthcoming."}},{name:"onsubmit",description:{kind:"markdown",value:"A form is submitted."}},{name:"onsuspend",description:{kind:"markdown",value:"Media data loading has been suspended."}},{name:"ontimeupdate",description:{kind:"markdown",value:"The time indicated by the currentTime attribute has been updated."}},{name:"onvolumechange",description:{kind:"markdown",value:"The volume has changed."}},{name:"onwaiting",description:{kind:"markdown",value:"Playback has stopped because of a temporary lack of data."}},{name:"aria-activedescendant",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-activedescendant"}],description:{kind:"markdown",value:"Identifies the currently active element when DOM focus is on a [`composite`](https://www.w3.org/TR/wai-aria-1.1/#composite) widget, [`textbox`](https://www.w3.org/TR/wai-aria-1.1/#textbox), [`group`](https://www.w3.org/TR/wai-aria-1.1/#group), or [`application`](https://www.w3.org/TR/wai-aria-1.1/#application)."}},{name:"aria-atomic",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-atomic"}],description:{kind:"markdown",value:"Indicates whether [assistive technologies](https://www.w3.org/TR/wai-aria-1.1/#dfn-assistive-technology) will present all, or only parts of, the changed region based on the change notifications defined by the [`aria-relevant`](https://www.w3.org/TR/wai-aria-1.1/#aria-relevant) attribute."}},{name:"aria-autocomplete",valueSet:"autocomplete",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-autocomplete"}],description:{kind:"markdown",value:"Indicates whether inputting text could trigger display of one or more predictions of the user's intended value for an input and specifies how predictions would be presented if they are made."}},{name:"aria-busy",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-busy"}],description:{kind:"markdown",value:"Indicates an element is being modified and that assistive technologies _MAY_ want to wait until the modifications are complete before exposing them to the user."}},{name:"aria-checked",valueSet:"tristate",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-checked"}],description:{kind:"markdown",value:"Indicates the current \"checked\" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) of checkboxes, radio buttons, and other [widgets](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget). See related [`aria-pressed`](https://www.w3.org/TR/wai-aria-1.1/#aria-pressed) and [`aria-selected`](https://www.w3.org/TR/wai-aria-1.1/#aria-selected)."}},{name:"aria-colcount",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-colcount"}],description:{kind:"markdown",value:"Defines the total number of columns in a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-colindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-colindex)."}},{name:"aria-colindex",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-colindex"}],description:{kind:"markdown",value:"Defines an [element's](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) column index or position with respect to the total number of columns within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-colcount`](https://www.w3.org/TR/wai-aria-1.1/#aria-colcount) and [`aria-colspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-colspan)."}},{name:"aria-colspan",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-colspan"}],description:{kind:"markdown",value:"Defines the number of columns spanned by a cell or gridcell within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-colindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-colindex) and [`aria-rowspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowspan)."}},{name:"aria-controls",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-controls"}],description:{kind:"markdown",value:"Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) whose contents or presence are controlled by the current element. See related [`aria-owns`](https://www.w3.org/TR/wai-aria-1.1/#aria-owns)."}},{name:"aria-current",valueSet:"current",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-current"}],description:{kind:"markdown",value:"Indicates the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) that represents the current item within a container or set of related elements."}},{name:"aria-describedat",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-describedat"}]},{name:"aria-describedby",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-describedby"}],description:{kind:"markdown",value:"Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) that describes the [object](https://www.w3.org/TR/wai-aria-1.1/#dfn-object). See related [`aria-labelledby`](https://www.w3.org/TR/wai-aria-1.1/#aria-labelledby)."}},{name:"aria-disabled",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-disabled"}],description:{kind:"markdown",value:"Indicates that the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is [perceivable](https://www.w3.org/TR/wai-aria-1.1/#dfn-perceivable) but disabled, so it is not editable or otherwise [operable](https://www.w3.org/TR/wai-aria-1.1/#dfn-operable). See related [`aria-hidden`](https://www.w3.org/TR/wai-aria-1.1/#aria-hidden) and [`aria-readonly`](https://www.w3.org/TR/wai-aria-1.1/#aria-readonly)."}},{name:"aria-dropeffect",valueSet:"dropeffect",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-dropeffect"}],description:{kind:"markdown",value:"\\[Deprecated in ARIA 1.1\\] Indicates what functions can be performed when a dragged object is released on the drop target."}},{name:"aria-errormessage",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-errormessage"}],description:{kind:"markdown",value:"Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) that provides an error message for the [object](https://www.w3.org/TR/wai-aria-1.1/#dfn-object). See related [`aria-invalid`](https://www.w3.org/TR/wai-aria-1.1/#aria-invalid) and [`aria-describedby`](https://www.w3.org/TR/wai-aria-1.1/#aria-describedby)."}},{name:"aria-expanded",valueSet:"u",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-expanded"}],description:{kind:"markdown",value:"Indicates whether the element, or another grouping element it controls, is currently expanded or collapsed."}},{name:"aria-flowto",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-flowto"}],description:{kind:"markdown",value:"Identifies the next [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) in an alternate reading order of content which, at the user's discretion, allows assistive technology to override the general default of reading in document source order."}},{name:"aria-grabbed",valueSet:"u",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-grabbed"}],description:{kind:"markdown",value:"\\[Deprecated in ARIA 1.1\\] Indicates an element's \"grabbed\" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) in a drag-and-drop operation."}},{name:"aria-haspopup",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-haspopup"}],description:{kind:"markdown",value:"Indicates the availability and type of interactive popup element, such as menu or dialog, that can be triggered by an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element)."}},{name:"aria-hidden",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-hidden"}],description:{kind:"markdown",value:"Indicates whether the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is exposed to an accessibility API. See related [`aria-disabled`](https://www.w3.org/TR/wai-aria-1.1/#aria-disabled)."}},{name:"aria-invalid",valueSet:"invalid",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-invalid"}],description:{kind:"markdown",value:"Indicates the entered value does not conform to the format expected by the application. See related [`aria-errormessage`](https://www.w3.org/TR/wai-aria-1.1/#aria-errormessage)."}},{name:"aria-kbdshortcuts",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-kbdshortcuts"}]},{name:"aria-label",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-label"}],description:{kind:"markdown",value:"Defines a string value that labels the current element. See related [`aria-labelledby`](https://www.w3.org/TR/wai-aria-1.1/#aria-labelledby)."}},{name:"aria-labelledby",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-labelledby"}],description:{kind:"markdown",value:"Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) that labels the current element. See related [`aria-describedby`](https://www.w3.org/TR/wai-aria-1.1/#aria-describedby)."}},{name:"aria-level",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-level"}],description:{kind:"markdown",value:"Defines the hierarchical level of an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) within a structure."}},{name:"aria-live",valueSet:"live",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-live"}],description:{kind:"markdown",value:"Indicates that an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) will be updated, and describes the types of updates the [user agents](https://www.w3.org/TR/wai-aria-1.1/#dfn-user-agent), [assistive technologies](https://www.w3.org/TR/wai-aria-1.1/#dfn-assistive-technology), and user can expect from the [live region](https://www.w3.org/TR/wai-aria-1.1/#dfn-live-region)."}},{name:"aria-modal",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-modal"}],description:{kind:"markdown",value:"Indicates whether an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is modal when displayed."}},{name:"aria-multiline",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-multiline"}],description:{kind:"markdown",value:"Indicates whether a text box accepts multiple lines of input or only a single line."}},{name:"aria-multiselectable",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-multiselectable"}],description:{kind:"markdown",value:"Indicates that the user may select more than one item from the current selectable descendants."}},{name:"aria-orientation",valueSet:"orientation",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-orientation"}],description:{kind:"markdown",value:"Indicates whether the element's orientation is horizontal, vertical, or unknown/ambiguous."}},{name:"aria-owns",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-owns"}],description:{kind:"markdown",value:"Identifies an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) in order to define a visual, functional, or contextual parent/child [relationship](https://www.w3.org/TR/wai-aria-1.1/#dfn-relationship) between DOM elements where the DOM hierarchy cannot be used to represent the relationship. See related [`aria-controls`](https://www.w3.org/TR/wai-aria-1.1/#aria-controls)."}},{name:"aria-placeholder",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-placeholder"}],description:{kind:"markdown",value:"Defines a short hint (a word or short phrase) intended to aid the user with data entry when the control has no value. A hint could be a sample value or a brief description of the expected format."}},{name:"aria-posinset",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-posinset"}],description:{kind:"markdown",value:"Defines an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element)'s number or position in the current set of listitems or treeitems. Not required if all elements in the set are present in the DOM. See related [`aria-setsize`](https://www.w3.org/TR/wai-aria-1.1/#aria-setsize)."}},{name:"aria-pressed",valueSet:"tristate",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-pressed"}],description:{kind:"markdown",value:"Indicates the current \"pressed\" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) of toggle buttons. See related [`aria-checked`](https://www.w3.org/TR/wai-aria-1.1/#aria-checked) and [`aria-selected`](https://www.w3.org/TR/wai-aria-1.1/#aria-selected)."}},{name:"aria-readonly",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-readonly"}],description:{kind:"markdown",value:"Indicates that the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is not editable, but is otherwise [operable](https://www.w3.org/TR/wai-aria-1.1/#dfn-operable). See related [`aria-disabled`](https://www.w3.org/TR/wai-aria-1.1/#aria-disabled)."}},{name:"aria-relevant",valueSet:"relevant",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-relevant"}],description:{kind:"markdown",value:"Indicates what notifications the user agent will trigger when the accessibility tree within a live region is modified. See related [`aria-atomic`](https://www.w3.org/TR/wai-aria-1.1/#aria-atomic)."}},{name:"aria-required",valueSet:"b",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-required"}],description:{kind:"markdown",value:"Indicates that user input is required on the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) before a form may be submitted."}},{name:"aria-roledescription",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-roledescription"}],description:{kind:"markdown",value:"Defines a human-readable, author-localized description for the [role](https://www.w3.org/TR/wai-aria-1.1/#dfn-role) of an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element)."}},{name:"aria-rowcount",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-rowcount"}],description:{kind:"markdown",value:"Defines the total number of rows in a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-rowindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowindex)."}},{name:"aria-rowindex",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-rowindex"}],description:{kind:"markdown",value:"Defines an [element's](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) row index or position with respect to the total number of rows within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-rowcount`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowcount) and [`aria-rowspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowspan)."}},{name:"aria-rowspan",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-rowspan"}],description:{kind:"markdown",value:"Defines the number of rows spanned by a cell or gridcell within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-rowindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowindex) and [`aria-colspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-colspan)."}},{name:"aria-selected",valueSet:"u",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-selected"}],description:{kind:"markdown",value:"Indicates the current \"selected\" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) of various [widgets](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget). See related [`aria-checked`](https://www.w3.org/TR/wai-aria-1.1/#aria-checked) and [`aria-pressed`](https://www.w3.org/TR/wai-aria-1.1/#aria-pressed)."}},{name:"aria-setsize",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-setsize"}],description:{kind:"markdown",value:"Defines the number of items in the current set of listitems or treeitems. Not required if all elements in the set are present in the DOM. See related [`aria-posinset`](https://www.w3.org/TR/wai-aria-1.1/#aria-posinset)."}},{name:"aria-sort",valueSet:"sort",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-sort"}],description:{kind:"markdown",value:"Indicates if items in a table or grid are sorted in ascending or descending order."}},{name:"aria-valuemax",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-valuemax"}],description:{kind:"markdown",value:"Defines the maximum allowed value for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget)."}},{name:"aria-valuemin",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-valuemin"}],description:{kind:"markdown",value:"Defines the minimum allowed value for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget)."}},{name:"aria-valuenow",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-valuenow"}],description:{kind:"markdown",value:"Defines the current value for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget). See related [`aria-valuetext`](https://www.w3.org/TR/wai-aria-1.1/#aria-valuetext)."}},{name:"aria-valuetext",references:[{name:"WAI-ARIA Reference",url:"https://www.w3.org/TR/wai-aria-1.1/#aria-valuetext"}],description:{kind:"markdown",value:"Defines the human readable text alternative of [`aria-valuenow`](https://www.w3.org/TR/wai-aria-1.1/#aria-valuenow) for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget)."}},{name:"aria-details",description:{kind:"markdown",value:"Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) that provides a detailed, extended description for the [object](https://www.w3.org/TR/wai-aria-1.1/#dfn-object). See related [`aria-describedby`](https://www.w3.org/TR/wai-aria-1.1/#aria-describedby)."}},{name:"aria-keyshortcuts",description:{kind:"markdown",value:"Indicates keyboard shortcuts that an author has implemented to activate or give focus to an element."}}];var valueSets=[{name:"b",values:[{name:"true"},{name:"false"}]},{name:"u",values:[{name:"true"},{name:"false"},{name:"undefined"}]},{name:"o",values:[{name:"on"},{name:"off"}]},{name:"y",values:[{name:"yes"},{name:"no"}]},{name:"w",values:[{name:"soft"},{name:"hard"}]},{name:"d",values:[{name:"ltr"},{name:"rtl"},{name:"auto"}]},{name:"m",values:[{name:"GET",description:{kind:"markdown",value:"Corresponds to the HTTP [GET method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.3); form data are appended to the `action` attribute URI with a '?' as separator, and the resulting URI is sent to the server. Use this method when the form has no side-effects and contains only ASCII characters."}},{name:"POST",description:{kind:"markdown",value:"Corresponds to the HTTP [POST method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.5); form data are included in the body of the form and sent to the server."}},{name:"dialog",description:{kind:"markdown",value:"Use when the form is inside a [`<dialog>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/dialog) element to close the dialog when submitted."}}]},{name:"fm",values:[{name:"GET"},{name:"POST"}]},{name:"s",values:[{name:"row"},{name:"col"},{name:"rowgroup"},{name:"colgroup"}]},{name:"t",values:[{name:"hidden"},{name:"text"},{name:"search"},{name:"tel"},{name:"url"},{name:"email"},{name:"password"},{name:"datetime"},{name:"date"},{name:"month"},{name:"week"},{name:"time"},{name:"datetime-local"},{name:"number"},{name:"range"},{name:"color"},{name:"checkbox"},{name:"radio"},{name:"file"},{name:"submit"},{name:"image"},{name:"reset"},{name:"button"}]},{name:"im",values:[{name:"verbatim"},{name:"latin"},{name:"latin-name"},{name:"latin-prose"},{name:"full-width-latin"},{name:"kana"},{name:"kana-name"},{name:"katakana"},{name:"numeric"},{name:"tel"},{name:"email"},{name:"url"}]},{name:"bt",values:[{name:"button"},{name:"submit"},{name:"reset"},{name:"menu"}]},{name:"lt",values:[{name:"1"},{name:"a"},{name:"A"},{name:"i"},{name:"I"}]},{name:"mt",values:[{name:"context"},{name:"toolbar"}]},{name:"mit",values:[{name:"command"},{name:"checkbox"},{name:"radio"}]},{name:"et",values:[{name:"application/x-www-form-urlencoded"},{name:"multipart/form-data"},{name:"text/plain"}]},{name:"tk",values:[{name:"subtitles"},{name:"captions"},{name:"descriptions"},{name:"chapters"},{name:"metadata"}]},{name:"pl",values:[{name:"none"},{name:"metadata"},{name:"auto"}]},{name:"sh",values:[{name:"circle"},{name:"default"},{name:"poly"},{name:"rect"}]},{name:"xo",values:[{name:"anonymous"},{name:"use-credentials"}]},{name:"sb",values:[{name:"allow-forms"},{name:"allow-modals"},{name:"allow-pointer-lock"},{name:"allow-popups"},{name:"allow-popups-to-escape-sandbox"},{name:"allow-same-origin"},{name:"allow-scripts"},{name:"allow-top-navigation"}]},{name:"tristate",values:[{name:"true"},{name:"false"},{name:"mixed"},{name:"undefined"}]},{name:"inputautocomplete",values:[{name:"additional-name"},{name:"address-level1"},{name:"address-level2"},{name:"address-level3"},{name:"address-level4"},{name:"address-line1"},{name:"address-line2"},{name:"address-line3"},{name:"bday"},{name:"bday-year"},{name:"bday-day"},{name:"bday-month"},{name:"billing"},{name:"cc-additional-name"},{name:"cc-csc"},{name:"cc-exp"},{name:"cc-exp-month"},{name:"cc-exp-year"},{name:"cc-family-name"},{name:"cc-given-name"},{name:"cc-name"},{name:"cc-number"},{name:"cc-type"},{name:"country"},{name:"country-name"},{name:"current-password"},{name:"email"},{name:"family-name"},{name:"fax"},{name:"given-name"},{name:"home"},{name:"honorific-prefix"},{name:"honorific-suffix"},{name:"impp"},{name:"language"},{name:"mobile"},{name:"name"},{name:"new-password"},{name:"nickname"},{name:"organization"},{name:"organization-title"},{name:"pager"},{name:"photo"},{name:"postal-code"},{name:"sex"},{name:"shipping"},{name:"street-address"},{name:"tel-area-code"},{name:"tel"},{name:"tel-country-code"},{name:"tel-extension"},{name:"tel-local"},{name:"tel-local-prefix"},{name:"tel-local-suffix"},{name:"tel-national"},{name:"transaction-amount"},{name:"transaction-currency"},{name:"url"},{name:"username"},{name:"work"}]},{name:"autocomplete",values:[{name:"inline"},{name:"list"},{name:"both"},{name:"none"}]},{name:"current",values:[{name:"page"},{name:"step"},{name:"location"},{name:"date"},{name:"time"},{name:"true"},{name:"false"}]},{name:"dropeffect",values:[{name:"copy"},{name:"move"},{name:"link"},{name:"execute"},{name:"popup"},{name:"none"}]},{name:"invalid",values:[{name:"grammar"},{name:"false"},{name:"spelling"},{name:"true"}]},{name:"live",values:[{name:"off"},{name:"polite"},{name:"assertive"}]},{name:"orientation",values:[{name:"vertical"},{name:"horizontal"},{name:"undefined"}]},{name:"relevant",values:[{name:"additions"},{name:"removals"},{name:"text"},{name:"all"},{name:"additions text"}]},{name:"sort",values:[{name:"ascending"},{name:"descending"},{name:"none"},{name:"other"}]},{name:"roles",values:[{name:"alert"},{name:"alertdialog"},{name:"button"},{name:"checkbox"},{name:"dialog"},{name:"gridcell"},{name:"link"},{name:"log"},{name:"marquee"},{name:"menuitem"},{name:"menuitemcheckbox"},{name:"menuitemradio"},{name:"option"},{name:"progressbar"},{name:"radio"},{name:"scrollbar"},{name:"searchbox"},{name:"slider"},{name:"spinbutton"},{name:"status"},{name:"switch"},{name:"tab"},{name:"tabpanel"},{name:"textbox"},{name:"timer"},{name:"tooltip"},{name:"treeitem"},{name:"combobox"},{name:"grid"},{name:"listbox"},{name:"menu"},{name:"menubar"},{name:"radiogroup"},{name:"tablist"},{name:"tree"},{name:"treegrid"},{name:"application"},{name:"article"},{name:"cell"},{name:"columnheader"},{name:"definition"},{name:"directory"},{name:"document"},{name:"feed"},{name:"figure"},{name:"group"},{name:"heading"},{name:"img"},{name:"list"},{name:"listitem"},{name:"math"},{name:"none"},{name:"note"},{name:"presentation"},{name:"region"},{name:"row"},{name:"rowgroup"},{name:"rowheader"},{name:"separator"},{name:"table"},{name:"term"},{name:"text"},{name:"toolbar"},{name:"banner"},{name:"complementary"},{name:"contentinfo"},{name:"form"},{name:"main"},{name:"navigation"},{name:"region"},{name:"search"},{name:"doc-abstract"},{name:"doc-acknowledgments"},{name:"doc-afterword"},{name:"doc-appendix"},{name:"doc-backlink"},{name:"doc-biblioentry"},{name:"doc-bibliography"},{name:"doc-biblioref"},{name:"doc-chapter"},{name:"doc-colophon"},{name:"doc-conclusion"},{name:"doc-cover"},{name:"doc-credit"},{name:"doc-credits"},{name:"doc-dedication"},{name:"doc-endnote"},{name:"doc-endnotes"},{name:"doc-epigraph"},{name:"doc-epilogue"},{name:"doc-errata"},{name:"doc-example"},{name:"doc-footnote"},{name:"doc-foreword"},{name:"doc-glossary"},{name:"doc-glossref"},{name:"doc-index"},{name:"doc-introduction"},{name:"doc-noteref"},{name:"doc-notice"},{name:"doc-pagebreak"},{name:"doc-pagelist"},{name:"doc-part"},{name:"doc-preface"},{name:"doc-prologue"},{name:"doc-pullquote"},{name:"doc-qna"},{name:"doc-subtitle"},{name:"doc-tip"},{name:"doc-toc"}]},{name:"metanames",values:[{name:"application-name"},{name:"author"},{name:"description"},{name:"format-detection"},{name:"generator"},{name:"keywords"},{name:"publisher"},{name:"referrer"},{name:"robots"},{name:"theme-color"},{name:"viewport"}]}];var htmlDataJson = {version:version,tags:tags,globalAttributes:globalAttributes,valueSets:valueSets};

function parseVscodeHtmlData(data, config) {
    if (config === void 0) { config = {}; }
    switch (data.version) {
        case 1:
        case 1.1:
            return parseVscodeDataV1(data, config);
    }
}
function parseVscodeDataV1(data, config) {
    var e_1, _a;
    var valueSetTypeMap = valueSetsToTypeMap(data.valueSets || []);
    valueSetTypeMap.set("v", { kind: "BOOLEAN" });
    // Transfer existing typemap to new typemap
    if (config.typeMap != null) {
        try {
            for (var _b = __values(config.typeMap.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), k = _d[0], v = _d[1];
                valueSetTypeMap.set(k, v);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    var newConfig = __assign(__assign({}, config), { typeMap: valueSetTypeMap });
    var globalAttributes = (data.globalAttributes || []).map(function (tagDataAttr) { return tagDataToHtmlTagAttr(tagDataAttr, newConfig); });
    var globalEvents = attrsToEvents(globalAttributes).map(function (evt) { return (__assign(__assign({}, evt), { global: true })); });
    return {
        tags: (data.tags || []).map(function (tagData) { return tagDataToHtmlTag(tagData, newConfig); }),
        global: {
            attributes: globalAttributes,
            events: globalEvents
        }
    };
}
function tagDataToHtmlTag(tagData, config) {
    var name = tagData.name, description = tagData.description;
    var attributes = tagData.attributes.map(function (tagDataAttr) { return tagDataToHtmlTagAttr(tagDataAttr, config, name); });
    var events = attrsToEvents(attributes);
    return {
        tagName: name,
        description: stringOrMarkupContentToString(description),
        attributes: attributes,
        events: events,
        properties: [],
        slots: [],
        builtIn: config.builtIn,
        cssParts: [],
        cssProperties: []
    };
}
function tagDataToHtmlTagAttr(tagDataAttr, config, fromTagName) {
    var _a;
    var name = tagDataAttr.name, description = tagDataAttr.description, valueSet = tagDataAttr.valueSet, values = tagDataAttr.values;
    var type = valueSet != null ? (_a = config.typeMap) === null || _a === void 0 ? void 0 : _a.get(valueSet) : values != null ? attrValuesToUnion(values) : undefined;
    return {
        kind: "attribute",
        name: name,
        description: stringOrMarkupContentToString(description),
        fromTagName: fromTagName,
        getType: lazy(function () { return type || { kind: "ANY" }; }),
        builtIn: config.builtIn
    };
}
function valueSetsToTypeMap(valueSets) {
    var entries = valueSets.map(function (valueSet) { return [valueSet.name, attrValuesToUnion(valueSet.values)]; });
    return new Map(entries);
}
function attrValuesToUnion(attrValues) {
    return {
        kind: "UNION",
        types: attrValues.map(function (value) {
            return ({
                value: value.name,
                kind: "STRING_LITERAL"
            });
        })
    };
}
function stringOrMarkupContentToString(str) {
    if (str == null || typeof str === "string") {
        return str;
    }
    return str.value;
}
function attrsToEvents(htmlAttrs) {
    return htmlAttrs
        .filter(function (htmlAttr) { return htmlAttr.name.startsWith("on"); })
        .map(function (htmlAttr) { return ({
        name: htmlAttr.name.replace(/^on/, ""),
        description: htmlAttr.description,
        fromTagName: htmlAttr.fromTagName,
        getType: lazy(function () { return ({ kind: "ANY" }); }),
        builtIn: htmlAttr.builtIn
    }); });
}

var HTML_5_ATTR_TYPES = {
    onafterprint: "string",
    onbeforeprint: "string",
    onbeforeunload: "string",
    onhashchange: "string",
    onlanguagechange: "string",
    onmessage: "string",
    onoffline: "string",
    ononline: "string",
    onpagehide: "string",
    onpageshow: "string",
    onpopstate: "string",
    onstorage: "string",
    onunload: "string",
    onslotchange: "string",
    "aria-activedescendant": "",
    "aria-colcount": "",
    "aria-colindex": "",
    "aria-colspan": "",
    "aria-controls": "",
    "aria-describedat": "",
    "aria-describedby": "",
    "aria-errormessage": "",
    "aria-flowto": "",
    "aria-kbdshortcuts": "",
    "aria-label": "",
    "aria-labelledby": "",
    "aria-level": "",
    "aria-owns": "",
    "aria-placeholder": "",
    "aria-posinset": "",
    "aria-roledescription": "",
    "aria-rowcount": "",
    "aria-rowindex": "",
    "aria-rowspan": "",
    "aria-setsize": "",
    "aria-valuemax": "",
    "aria-valuemin": "",
    "aria-valuenow": "",
    "aria-valuetext": "",
    accesskey: "string",
    translate: ["yes", "no", ""],
    autocapitalize: ["off", "none", "on", "sentences", "words", "characters"],
    class: "string",
    contextmenu: "string",
    dropzone: ["copy", "move", "link"],
    id: "string",
    itemid: "",
    itemprop: "",
    itemref: "",
    itemtype: "",
    lang: "string",
    style: "string",
    tabindex: "number",
    title: "string",
    manifest: "",
    href: "string",
    target: ["_blank", "_parent", "_self", "_top"],
    rel: "",
    media: "",
    hreflang: "",
    type: "",
    sizes: "",
    name: "string",
    "http-equiv": "",
    content: "",
    charset: "",
    nonce: "",
    cite: "",
    start: "",
    value: "string",
    download: "boolean|string",
    ping: "",
    datetime: "",
    alt: "string",
    src: "string",
    srcset: "",
    usemap: "",
    width: "number|string",
    height: "number|string",
    srcdoc: "",
    data: "",
    form: "string",
    poster: "string",
    mediagroup: "",
    label: "string",
    srclang: "string",
    coords: "string",
    border: ["0", "1"],
    span: "number",
    colspan: "number",
    rowspan: "number",
    headers: "string",
    sorted: "",
    abbr: "string",
    "accept-charset": "string",
    action: "string",
    for: "string",
    accept: "string",
    dirname: "string",
    formaction: "string",
    formtarget: ["_self", "_blank", "_parent", "_top"],
    list: "string",
    max: "number|string",
    maxlength: "number",
    min: "number|string",
    minlength: "number",
    pattern: "string",
    placeholder: "string",
    size: "number",
    step: "number",
    cols: "number",
    rows: "number",
    low: "number",
    high: "number",
    optimum: "number",
    slot: "string",
    part: "string",
    exportparts: "string",
    theme: "string",
    controlslist: [["nodownload", "nofullscreen", "noremoteplayback"]],
    role: [
        [
            "alert",
            "alertdialog",
            "button",
            "checkbox",
            "dialog",
            "gridcell",
            "link",
            "log",
            "marquee",
            "menuitem",
            "menuitemcheckbox",
            "menuitemradio",
            "option",
            "progressbar",
            "radio",
            "scrollbar",
            "searchbox",
            "slider",
            "spinbutton",
            "status",
            "switch",
            "tab",
            "tabpanel",
            "textbox",
            "timer",
            "tooltip",
            "treeitem",
            "combobox",
            "grid",
            "listbox",
            "menu",
            "menubar",
            "radiogroup",
            "tablist",
            "tree",
            "treegrid",
            "application",
            "article",
            "cell",
            "columnheader",
            "definition",
            "directory",
            "document",
            "feed",
            "figure",
            "group",
            "heading",
            "img",
            "list",
            "listitem",
            "math",
            "none",
            "note",
            "presentation",
            "region",
            "row",
            "rowgroup",
            "rowheader",
            "separator",
            "table",
            "term",
            "text",
            "toolbar",
            "banner",
            "complementary",
            "contentinfo",
            "form",
            "main",
            "navigation",
            "region",
            "search",
            "doc-abstract",
            "doc-acknowledgments",
            "doc-afterword",
            "doc-appendix",
            "doc-backlink",
            "doc-biblioentry",
            "doc-bibliography",
            "doc-biblioref",
            "doc-chapter",
            "doc-colophon",
            "doc-conclusion",
            "doc-cover",
            "doc-credit",
            "doc-credits",
            "doc-dedication",
            "doc-endnote",
            "doc-endnotes",
            "doc-epigraph",
            "doc-epilogue",
            "doc-errata",
            "doc-example",
            "doc-footnote",
            "doc-foreword",
            "doc-glossary",
            "doc-glossref",
            "doc-index",
            "doc-introduction",
            "doc-noteref",
            "doc-notice",
            "doc-pagebreak",
            "doc-pagelist",
            "doc-part",
            "doc-preface",
            "doc-prologue",
            "doc-pullquote",
            "doc-qna",
            "doc-subtitle",
            "doc-tip",
            "doc-toc"
        ]
    ]
};
function hasTypeForAttrName(attrName) {
    return HTML_5_ATTR_TYPES[attrName] != null && HTML_5_ATTR_TYPES[attrName].length > 0;
}
function html5TagAttrType(attrName) {
    return stringToSimpleType(HTML_5_ATTR_TYPES[attrName] || "", attrName);
}
function stringToSimpleType(typeString, name) {
    if (Array.isArray(typeString)) {
        if (Array.isArray(typeString[0])) {
            return makePrimitiveArrayType(stringToSimpleType(typeString[0]));
        }
        return {
            kind: "UNION",
            types: typeString.map(function (value) { return ({ kind: "STRING_LITERAL", value: value }); })
        };
    }
    if (typeString.includes("|")) {
        return {
            kind: "UNION",
            types: typeString.split("|").map(function (typeStr) { return stringToSimpleType(typeStr); })
        };
    }
    switch (typeString) {
        case "number":
            return { kind: "NUMBER", name: name };
        case "boolean":
            return { kind: "BOOLEAN", name: name };
        case "string":
            return { kind: "STRING", name: name };
        default:
            return { kind: "ANY", name: name };
    }
}
/**
 * Data from vscode-html-languageservice
 */
var EXTRA_HTML5_EVENTS = [
    {
        name: "onanimationend",
        description: "A CSS animation has completed."
    },
    {
        name: "onanimationiteration",
        description: "A CSS animation is repeated."
    },
    {
        name: "onanimationstart",
        description: "A CSS animation has started."
    },
    {
        name: "oncopy",
        description: "The text selection has been added to the clipboard."
    },
    {
        name: "oncut",
        description: "The text selection has been removed from the document and added to the clipboard."
    },
    {
        name: "ondragstart",
        description: "The user starts dragging an element or text selection."
    },
    {
        name: "onfocusin",
        description: "An element is about to receive focus (bubbles)."
    },
    {
        name: "onfocusout",
        description: "An element is about to lose focus (bubbles)."
    },
    {
        name: "onfullscreenchange",
        description: "An element was turned to fullscreen mode or back to normal mode."
    },
    {
        name: "onfullscreenerror",
        description: "It was impossible to switch to fullscreen mode for technical reasons or because the permission was denied."
    },
    {
        name: "ongotpointercapture",
        description: "Element receives pointer capture."
    },
    {
        name: "onlostpointercapture",
        description: "Element lost pointer capture."
    },
    {
        name: "onoffline",
        description: "The browser has lost access to the network."
    },
    {
        name: "ononline",
        description: "The browser has gained access to the network (but particular websites might be unreachable)."
    },
    {
        name: "onpaste",
        description: "Data has been transferred from the system clipboard to the document."
    },
    {
        name: "onpointercancel",
        description: "The pointer is unlikely to produce any more events."
    },
    {
        name: "onpointerdown",
        description: "The pointer enters the active buttons state."
    },
    {
        name: "onpointerenter",
        description: "Pointing device is moved inside the hit-testing boundary."
    },
    {
        name: "onpointerleave",
        description: "Pointing device is moved out of the hit-testing boundary."
    },
    {
        name: "onpointerlockchange",
        description: "The pointer was locked or released."
    },
    {
        name: "onpointerlockerror",
        description: "It was impossible to lock the pointer for technical reasons or because the permission was denied."
    },
    {
        name: "onpointermove",
        description: "The pointer changed coordinates."
    },
    {
        name: "onpointerout",
        description: "The pointing device moved out of hit-testing boundary or leaves detectable hover range."
    },
    {
        name: "onpointerover",
        description: "The pointing device is moved into the hit-testing boundary."
    },
    {
        name: "onpointerup",
        description: "The pointer leaves the active buttons state."
    },
    {
        name: "onratechange",
        description: "The playback rate has changed."
    },
    {
        name: "onselectstart",
        description: "A selection just started."
    },
    {
        name: "onselectionchange",
        description: "The selection in the document has been changed."
    },
    {
        name: "ontouchcancel",
        description: "A touch point has been disrupted in an implementation-specific manners (too many touch points for example)."
    },
    {
        name: "ontouchend",
        description: "A touch point is removed from the touch surface."
    },
    {
        name: "ontouchmove",
        description: "A touch point is moved along the touch surface."
    },
    {
        name: "ontouchstart",
        description: "A touch point is placed on the touch surface."
    },
    {
        name: "ontransitionend",
        description: "A CSS transition has completed."
    },
    {
        name: "onwheel",
        description: "A wheel button of a pointing device is rotated in any direction."
    }
];

function getBuiltInHtmlCollection() {
    var e_1, _a;
    var _b, _c;
    var vscodeHtmlData = htmlDataJson;
    var version = vscodeHtmlData.version;
    var globalAttributes = __spread(vscodeHtmlData.globalAttributes);
    // Modify valueSets
    var valueSets = (vscodeHtmlData.valueSets || []).map(function (valueSet) {
        // It seems like the autocompletion value map for <select>, <textarea> and <input> needs "on" and "off" values
        if (valueSet.name === "inputautocomplete") {
            return __assign(__assign({}, valueSet), { values: __spread([{ name: "on" }, { name: "off" }], valueSet.values) });
        }
        return valueSet;
    });
    // Modify tags
    var tags = (vscodeHtmlData.tags || []).map(function (tag) {
        switch (tag.name) {
            case "audio":
                return __assign(__assign({}, tag), { attributes: __spread(tag.attributes, [
                        {
                            name: "controlslist",
                            description: ""
                        }
                    ]) });
            case "video":
                return __assign(__assign({}, tag), { attributes: __spread(tag.attributes, [
                        {
                            name: "controlslist",
                            description: ""
                        },
                        {
                            name: "disablepictureinpicture",
                            valueSet: "v" // "v" is the undocumented boolean type
                        },
                        {
                            name: "playsinline",
                            description: 'The playsinline attribute is a boolean attribute. If present, it serves as a hint to the user agent that the video ought to be displayed "inline" in the document by default, constrained to the element\'s playback area, instead of being displayed fullscreen or in an independent resizable window.',
                            valueSet: "v" // "v" is the undocumented boolean type
                        }
                    ]) });
        }
        return tag;
    });
    // Add missing html tags
    tags.push({
        name: "svg",
        attributes: []
    }, {
        name: "slot",
        description: "",
        attributes: [
            {
                name: "name",
                description: ""
            },
            {
                name: "onslotchange",
                description: "The slotchange event is fired on an HTMLSlotElement instance (<slot> element) when the node(s) contained in that slot change.\n\nNote: the slotchange event doesn't fire if the children of a slotted node change — only if you change (e.g. add or delete) the actual nodes themselves."
            }
        ]
    });
    // Add missing global attributes
    globalAttributes.push.apply(globalAttributes, __spread(EXTRA_HTML5_EVENTS.filter(function (evt) { return globalAttributes.some(function (existingEvt) { return existingEvt.name === evt.name; }); }), [{
            name: "tabindex",
            description: ""
        },
        {
            name: "slot",
            description: ""
        }, {
            name: "part",
            description: "This attribute specifies a \"styleable\" part on the element in your shadow tree."
        },
        {
            name: "theme",
            description: "This attribute specifies a global \"styleable\" part on the element."
        },
        {
            name: "exportparts",
            description: "This attribute is used to explicitly forward a child\u2019s part to be styleable outside of the parent\u2019s shadow tree.\n\nThe value must be a comma-separated list of part mappings:\n  - \"some-box, some-input\"\n  - \"some-input: foo-input\"\n"
        }]));
    // Parse vscode html data
    var result = parseVscodeHtmlData({
        version: version,
        globalAttributes: globalAttributes,
        tags: tags,
        valueSets: valueSets
    }, {
        builtIn: true
    });
    try {
        // Add missing properties to the result, because they are not included in vscode html data
        for (var _d = __values(result.tags), _e = _d.next(); !_e.done; _e = _d.next()) {
            var tag = _e.value;
            switch (tag.tagName) {
                case "textarea":
                    tag.properties.push({
                        kind: "property",
                        name: "value",
                        builtIn: true,
                        fromTagName: "textarea",
                        getType: lazy(function () {
                            return ({
                                kind: "UNION",
                                types: [{ kind: "STRING" }, { kind: "NULL" }]
                            });
                        })
                    });
                    break;
                case "img":
                    tag.attributes.push({
                        kind: "attribute",
                        name: "loading",
                        builtIn: true,
                        fromTagName: "img",
                        getType: lazy(function () {
                            return ({
                                kind: "UNION",
                                types: [
                                    {
                                        kind: "STRING_LITERAL",
                                        value: "lazy"
                                    },
                                    {
                                        kind: "STRING_LITERAL",
                                        value: "auto"
                                    },
                                    { kind: "STRING_LITERAL", value: "eager" }
                                ]
                            });
                        })
                    });
                    break;
                case "input":
                    tag.properties.push({
                        kind: "property",
                        name: "value",
                        builtIn: true,
                        fromTagName: "input",
                        getType: lazy(function () {
                            return ({
                                kind: "UNION",
                                types: [{ kind: "STRING" }, { kind: "NULL" }]
                            });
                        })
                    });
                    break;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        }
        finally { if (e_1) throw e_1.error; }
    }
    // Add missing global properties to the result
    result.global.properties = __spread((result.global.properties || []), [
        {
            builtIn: true,
            description: "This attribute specifies a \"styleable\" part on the element in your shadow tree.",
            getType: function () { return ({ kind: "STRING" }); },
            kind: "property",
            name: "part"
        }
    ]);
    return __assign(__assign({}, result), { tags: result.tags.map(function (tag) { return (__assign(__assign({}, tag), { builtIn: true, attributes: addMissingAttrTypes(tag.attributes.map(function (attr) { return (__assign(__assign({}, attr), { builtIn: true })); })) })); }), global: __assign(__assign({}, result.global), { attributes: addMissingAttrTypes(((_b = result.global.attributes) === null || _b === void 0 ? void 0 : _b.map(function (attr) { return (__assign(__assign({}, attr), { builtIn: true })); })) || []), events: (_c = result.global.events) === null || _c === void 0 ? void 0 : _c.map(function (event) { return (__assign(__assign({}, event), { builtIn: true })); }) }) });
}
function addMissingAttrTypes(attrs) {
    return attrs.map(function (attr) {
        if (hasTypeForAttrName(attr.name) || attr.getType().kind === "ANY") {
            var newType_1 = html5TagAttrType(attr.name);
            return __assign(__assign({}, attr), { getType: lazy(function () { return newType_1; }) });
        }
        return attr;
    });
}

function getUserConfigHtmlCollection(config) {
    var collection = (function () {
        var e_1, _a;
        var collection = { tags: [], global: {} };
        try {
            for (var _b = __values(Array.isArray(config.customHtmlData) ? config.customHtmlData : [config.customHtmlData]), _c = _b.next(); !_c.done; _c = _b.next()) {
                var customHtmlData = _c.value;
                try {
                    var data = typeof customHtmlData === "string" && fs.existsSync(customHtmlData)
                        ? JSON.parse(fs.readFileSync(customHtmlData, "utf8").toString())
                        : customHtmlData;
                    var parsedCollection = parseVscodeHtmlData(data);
                    collection = {
                        tags: mergeHtmlTags(__spread(collection.tags, parsedCollection.tags)),
                        global: {
                            attributes: mergeHtmlAttrs(__spread((collection.global.attributes || []), (parsedCollection.global.attributes || []))),
                            events: mergeHtmlEvents(__spread((collection.global.events || []), (parsedCollection.global.events || [])))
                        }
                    };
                }
                catch (e) {
                    //logger.error("Error parsing user configuration 'customHtmlData'", e, customHtmlData);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return collection;
    })();
    var tags = config.globalTags.map(function (tagName) {
        return ({
            tagName: tagName,
            properties: [],
            attributes: [],
            events: [],
            slots: [],
            cssParts: [],
            cssProperties: []
        });
    });
    var attrs = config.globalAttributes.map(function (attrName) {
        return ({
            name: attrName,
            kind: "attribute",
            getType: lazy(function () { return ({ kind: "ANY" }); })
        });
    });
    var events = config.globalEvents.map(function (eventName) {
        return ({
            name: eventName,
            kind: "event",
            getType: lazy(function () { return ({ kind: "ANY" }); })
        });
    });
    return {
        tags: __spread(tags, collection.tags),
        global: {
            attributes: __spread(attrs, (collection.global.attributes || [])),
            events: __spread(events, (collection.global.events || []))
        }
    };
}

function convertAnalyzeResultToHtmlCollection(result, options) {
    var tags = result.componentDefinitions.map(function (definition) { return convertComponentDeclarationToHtmlTag(definition.declaration, definition, options); });
    var global = result.globalFeatures == null ? {} : convertComponentFeaturesToHtml(result.globalFeatures, { checker: options.checker });
    return {
        tags: tags,
        global: global
    };
}
function convertComponentDeclarationToHtmlTag(declaration, definition, _a) {
    var e_1, _b;
    var _c, _d;
    var checker = _a.checker, addDeclarationPropertiesAsAttributes = _a.addDeclarationPropertiesAsAttributes;
    var tagName = (_c = definition === null || definition === void 0 ? void 0 : definition.tagName) !== null && _c !== void 0 ? _c : "";
    var builtIn = definition == null || ((declaration === null || declaration === void 0 ? void 0 : declaration.sourceFile) || definition.sourceFile).fileName.endsWith("lib.dom.d.ts");
    if (declaration == null) {
        return {
            tagName: tagName,
            builtIn: builtIn,
            attributes: [],
            events: [],
            properties: [],
            slots: [],
            cssParts: [],
            cssProperties: []
        };
    }
    var htmlTag = __assign({ declaration: declaration,
        tagName: tagName,
        builtIn: builtIn, description: (_d = declaration.jsDoc) === null || _d === void 0 ? void 0 : _d.description }, convertComponentFeaturesToHtml(declaration, { checker: checker, builtIn: builtIn, fromTagName: tagName }));
    if (addDeclarationPropertiesAsAttributes && !builtIn) {
        try {
            for (var _e = __values(htmlTag.properties), _f = _e.next(); !_f.done; _f = _e.next()) {
                var htmlProp = _f.value;
                if (htmlProp.declaration != null && htmlProp.declaration.attrName == null && htmlProp.declaration.node.getSourceFile().isDeclarationFile) {
                    htmlTag.attributes.push(__assign(__assign({}, htmlProp), { kind: "attribute" }));
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    return htmlTag;
}
function convertComponentFeaturesToHtml(features, _a) {
    var e_2, _b, e_3, _c, e_4, _d, e_5, _e, e_6, _f;
    var _g, _h, _j, _k, _l, _m, _o, _p;
    var checker = _a.checker, builtIn = _a.builtIn, fromTagName = _a.fromTagName;
    var result = {
        attributes: [],
        events: [],
        properties: [],
        slots: [],
        cssParts: [],
        cssProperties: []
    };
    var _loop_1 = function (event) {
        result.events.push({
            declaration: event,
            description: (_g = event.jsDoc) === null || _g === void 0 ? void 0 : _g.description,
            name: event.name,
            getType: lazy(function () {
                var _a;
                var type = (_a = event.type) === null || _a === void 0 ? void 0 : _a.call(event);
                if (type == null) {
                    return { kind: "ANY" };
                }
                return tsSimpleType.isSimpleType(type) ? type : tsSimpleType.toSimpleType(type, checker);
            }),
            fromTagName: fromTagName,
            builtIn: builtIn
        });
        result.attributes.push({
            kind: "attribute",
            name: "on" + event.name,
            description: (_h = event.jsDoc) === null || _h === void 0 ? void 0 : _h.description,
            getType: lazy(function () { return ({ kind: "STRING" }); }),
            declaration: {
                attrName: "on" + event.name,
                jsDoc: event.jsDoc,
                kind: "attribute",
                node: event.node,
                type: function () { return ({ kind: "ANY" }); }
            },
            builtIn: builtIn,
            fromTagName: fromTagName
        });
    };
    try {
        for (var _q = __values(features.events), _r = _q.next(); !_r.done; _r = _q.next()) {
            var event = _r.value;
            _loop_1(event);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_r && !_r.done && (_b = _q.return)) _b.call(_q);
        }
        finally { if (e_2) throw e_2.error; }
    }
    try {
        for (var _s = __values(features.cssParts), _t = _s.next(); !_t.done; _t = _s.next()) {
            var cssPart = _t.value;
            result.cssParts.push({
                declaration: cssPart,
                description: (_j = cssPart.jsDoc) === null || _j === void 0 ? void 0 : _j.description,
                name: cssPart.name || "",
                fromTagName: fromTagName
            });
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (_t && !_t.done && (_c = _s.return)) _c.call(_s);
        }
        finally { if (e_3) throw e_3.error; }
    }
    try {
        for (var _u = __values(features.cssProperties), _v = _u.next(); !_v.done; _v = _u.next()) {
            var cssProp = _v.value;
            result.cssProperties.push({
                declaration: cssProp,
                description: (_k = cssProp.jsDoc) === null || _k === void 0 ? void 0 : _k.description,
                name: cssProp.name || "",
                typeHint: cssProp.typeHint,
                fromTagName: fromTagName
            });
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (_v && !_v.done && (_d = _u.return)) _d.call(_u);
        }
        finally { if (e_4) throw e_4.error; }
    }
    try {
        for (var _w = __values(features.slots), _x = _w.next(); !_x.done; _x = _w.next()) {
            var slot = _x.value;
            result.slots.push({
                declaration: slot,
                description: (_l = slot.jsDoc) === null || _l === void 0 ? void 0 : _l.description,
                name: slot.name || "",
                fromTagName: fromTagName
            });
        }
    }
    catch (e_5_1) { e_5 = { error: e_5_1 }; }
    finally {
        try {
            if (_x && !_x.done && (_e = _w.return)) _e.call(_w);
        }
        finally { if (e_5) throw e_5.error; }
    }
    var _loop_2 = function (member) {
        // Only add public members
        if (member.visibility != null && member.visibility !== "public") {
            return "continue";
        }
        // Only add non-static members
        if ((_m = member.modifiers) === null || _m === void 0 ? void 0 : _m.has("static")) {
            return "continue";
        }
        // Only add writable members
        if ((_o = member.modifiers) === null || _o === void 0 ? void 0 : _o.has("readonly")) {
            return "continue";
        }
        var base = {
            declaration: member,
            description: (_p = member.jsDoc) === null || _p === void 0 ? void 0 : _p.description,
            getType: lazy(function () {
                var _a;
                var type = (_a = member.type) === null || _a === void 0 ? void 0 : _a.call(member);
                if (type == null) {
                    return { kind: "ANY" };
                }
                return tsSimpleType.isSimpleType(type) ? type : tsSimpleType.toSimpleType(type, checker);
            }),
            builtIn: builtIn,
            fromTagName: fromTagName
        };
        if (member.kind === "property") {
            result.properties.push(__assign(__assign({}, base), { kind: "property", name: member.propName, required: member.required }));
        }
        if ("attrName" in member && member.attrName != null) {
            result.attributes.push(__assign(__assign({}, base), { kind: "attribute", name: member.attrName, required: member.required }));
        }
    };
    try {
        for (var _y = __values(features.members), _z = _y.next(); !_z.done; _z = _y.next()) {
            var member = _z.value;
            _loop_2(member);
        }
    }
    catch (e_6_1) { e_6 = { error: e_6_1 }; }
    finally {
        try {
            if (_z && !_z.done && (_f = _y.return)) _f.call(_y);
        }
        finally { if (e_6) throw e_6.error; }
    }
    return result;
}

/**
 * Visits all indirect imports from a source file
 * Emits them using "emitIndirectImport" callback
 * @param sourceFile
 * @param context
 */
function visitIndirectImportsFromSourceFile(sourceFile, context) {
    var e_1, _a, e_2, _b;
    var _c, _d, _e;
    var currentDepth = (_c = context.depth) !== null && _c !== void 0 ? _c : 0;
    // Emit a visit. If this file has been seen already, the function will return false, and traversal will stop
    if (!context.emitIndirectImport(sourceFile)) {
        return;
    }
    var inExternal = context.program.isSourceFileFromExternalLibrary(sourceFile);
    // Check if we have traversed too deep
    if (inExternal && currentDepth >= ((_d = context.maxExternalDepth) !== null && _d !== void 0 ? _d : Infinity)) {
        return;
    }
    else if (!inExternal && currentDepth >= ((_e = context.maxInternalDepth) !== null && _e !== void 0 ? _e : Infinity)) {
        return;
    }
    // Get all direct imports from the cache
    var directImports = context.directImportCache.get(sourceFile);
    if (directImports == null) {
        // If the cache didn't have all direct imports, build up using the visitor function
        directImports = new Set();
        var newContext = __assign(__assign({}, context), { emitDirectImport: function (file) {
                directImports.add(file);
            } });
        // Emit all direct imports
        visitDirectImports(sourceFile, newContext);
        // Cache the result
        context.directImportCache.set(sourceFile, directImports);
    }
    else {
        // Updated references to newest source files
        var updatedImports = new Set();
        try {
            for (var directImports_1 = __values(directImports), directImports_1_1 = directImports_1.next(); !directImports_1_1.done; directImports_1_1 = directImports_1.next()) {
                var sf = directImports_1_1.value;
                var updatedSf = context.program.getSourceFile(sf.fileName);
                if (updatedSf != null) {
                    updatedImports.add(updatedSf);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (directImports_1_1 && !directImports_1_1.done && (_a = directImports_1.return)) _a.call(directImports_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        directImports = updatedImports;
    }
    try {
        // Call this function recursively on all direct imports from this source file
        for (var directImports_2 = __values(directImports), directImports_2_1 = directImports_2.next(); !directImports_2_1.done; directImports_2_1 = directImports_2.next()) {
            var file = directImports_2_1.value;
            var toExternal = context.program.isSourceFileFromExternalLibrary(file);
            var fromProjectToExternal = !inExternal && toExternal;
            // It's possible to only follow external dependencies from the source file of interest (depth 0)
            /*if (fromProjectToExternal && currentDepth !== 0) {
             continue;
             }*/
            // Calculate new depth. Reset depth to 1 if we go from a project module to an external module.
            // This will make sure that we always go X modules deep into external modules
            var newDepth = void 0;
            if (fromProjectToExternal) {
                newDepth = 1;
            }
            else {
                newDepth = currentDepth + 1;
            }
            if (isFacadeModule(file, context.ts)) {
                // Facade modules are ignored when calculating depth
                newDepth--;
            }
            // Visit direct imported source files recursively
            visitIndirectImportsFromSourceFile(file, __assign(__assign({}, context), { depth: newDepth }));
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (directImports_2_1 && !directImports_2_1.done && (_b = directImports_2.return)) _b.call(directImports_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
}
/**
 * Visits all direct imports in an AST.
 * Emits them using "emitDirectImport"
 * @param node
 * @param context
 */
function visitDirectImports(node, context) {
    if (node == null)
        return;
    // Handle top level imports/exports: (import "..."), (import { ... } from "..."), (export * from "...")
    if (context.ts.isImportDeclaration(node) || context.ts.isExportDeclaration(node)) {
        if (node.moduleSpecifier != null && context.ts.isStringLiteral(node.moduleSpecifier) && context.ts.isSourceFile(node.parent)) {
            // Potentially ignore all imports/exports with named imports/exports because importing an interface would not
            //    necessarily result in the custom element being defined. An even better solution would be to ignore all
            //    import declarations with only interface-like/type-alias imports.
            /*if (("importClause" in node && node.importClause != null) || ("exportClause" in node && node.exportClause != null)) {
             return;
             }*/
            emitDirectModuleImportWithName(node.moduleSpecifier.text, node, context);
        }
    }
    // Handle async imports (await import(...))
    else if (context.ts.isCallExpression(node) && node.expression.kind === context.ts.SyntaxKind.ImportKeyword) {
        var moduleSpecifier = node.arguments[0];
        if (moduleSpecifier != null && context.ts.isStringLiteralLike(moduleSpecifier)) {
            emitDirectModuleImportWithName(moduleSpecifier.text, node, context);
        }
    }
    node.forEachChild(function (child) { return visitDirectImports(child, context); });
}
/**
 * Resolves and emits a direct imported module
 * @param moduleSpecifier
 * @param node
 * @param context
 */
function emitDirectModuleImportWithName(moduleSpecifier, node, context) {
    var _a, _b;
    var fromSourceFile = node.getSourceFile();
    // Resolve the imported string
    var result = context.project
        ? context.project.getResolvedModuleWithFailedLookupLocationsFromCache(moduleSpecifier, fromSourceFile.fileName)
        : "getResolvedModuleWithFailedLookupLocationsFromCache" in context.program
            ? // eslint-disable-next-line @typescript-eslint/no-explicit-any
                context.program["getResolvedModuleWithFailedLookupLocationsFromCache"](moduleSpecifier, fromSourceFile.fileName)
            : undefined;
    if (((_a = result === null || result === void 0 ? void 0 : result.resolvedModule) === null || _a === void 0 ? void 0 : _a.resolvedFileName) != null) {
        var resolvedModule = result.resolvedModule;
        var sourceFile = context.program.getSourceFile(resolvedModule.resolvedFileName);
        if (sourceFile != null) {
            (_b = context.emitDirectImport) === null || _b === void 0 ? void 0 : _b.call(context, sourceFile);
        }
    }
}
/**
 * Returns whether a SourceFile is a Facade Module.
 * A Facade Module only consists of import and export declarations.
 * @param sourceFile
 * @param ts
 */
function isFacadeModule(sourceFile, ts) {
    var statements = sourceFile.statements;
    var isFacade = statements.every(function (statement) {
        return ts.isImportDeclaration(statement) || ts.isExportDeclaration(statement);
    });
    return isFacade;
}

// A cache used to prevent traversing through entire source files multiple times to find direct imports
var DIRECT_IMPORT_CACHE = new WeakMap();
// Two caches used to return the result of of a known source file right away
var RESULT_CACHE = new WeakMap();
var IMPORTED_SOURCE_FILES_CACHE = new WeakMap();
/**
 * Returns a map of imported component definitions in each file encountered from a source file recursively.
 * @param sourceFile
 * @param context
 */
function parseDependencies(sourceFile, context) {
    var e_1, _a, e_2, _b, e_3, _c;
    if (RESULT_CACHE.has(sourceFile)) {
        var invalidate = false;
        try {
            // Check if the cache has been invalidated
            for (var _d = __values(IMPORTED_SOURCE_FILES_CACHE.get(sourceFile) || []), _e = _d.next(); !_e.done; _e = _d.next()) {
                var file = _e.value;
                // If we get a SourceFile with a certain fileName but it's not the same reference, the file has been updated
                if (context.program.getSourceFile(file.fileName) !== file) {
                    invalidate = true;
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (invalidate) {
            RESULT_CACHE.delete(sourceFile);
            IMPORTED_SOURCE_FILES_CACHE.delete(sourceFile);
        }
        else {
            return RESULT_CACHE.get(sourceFile);
        }
    }
    // Get all indirectly imported source files from this the source file
    var importedSourceFiles = parseAllIndirectImports(sourceFile, context);
    IMPORTED_SOURCE_FILES_CACHE.set(sourceFile, importedSourceFiles);
    // Get component definitions from all these source files
    var definitions = new Set();
    try {
        for (var importedSourceFiles_1 = __values(importedSourceFiles), importedSourceFiles_1_1 = importedSourceFiles_1.next(); !importedSourceFiles_1_1.done; importedSourceFiles_1_1 = importedSourceFiles_1.next()) {
            var file = importedSourceFiles_1_1.value;
            try {
                for (var _f = (e_3 = void 0, __values(context.definitionStore.getDefinitionsInFile(file))), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var def = _g.value;
                    definitions.add(def);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (importedSourceFiles_1_1 && !importedSourceFiles_1_1.done && (_b = importedSourceFiles_1.return)) _b.call(importedSourceFiles_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    // Cache the result
    var result = Array.from(definitions);
    RESULT_CACHE.set(sourceFile, result);
    return result;
}
/**
 * Returns a map of component declarations in each file encountered from a source file recursively.
 * @param sourceFile
 * @param context
 * @param maxExternalDepth
 * @param minExternalDepth
 */
function parseAllIndirectImports(sourceFile, context, _a) {
    var _b = _a === void 0 ? {} : _a, maxExternalDepth = _b.maxExternalDepth, maxInternalDepth = _b.maxInternalDepth;
    var importedSourceFiles = new Set();
    visitIndirectImportsFromSourceFile(sourceFile, {
        project: context.project,
        program: context.program,
        ts: context.ts,
        directImportCache: DIRECT_IMPORT_CACHE,
        maxExternalDepth: maxExternalDepth !== null && maxExternalDepth !== void 0 ? maxExternalDepth : context.config.maxNodeModuleImportDepth,
        maxInternalDepth: maxInternalDepth !== null && maxInternalDepth !== void 0 ? maxInternalDepth : context.config.maxProjectImportDepth,
        emitIndirectImport: function (file) {
            if (importedSourceFiles.has(file)) {
                return false;
            }
            importedSourceFiles.add(file);
            return true;
        }
    });
    return importedSourceFiles;
}

var RuleCollection = /** @class */ (function () {
    function RuleCollection() {
        this.rules = [];
    }
    RuleCollection.prototype.push = function () {
        var _a;
        var rule = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            rule[_i] = arguments[_i];
        }
        (_a = this.rules).push.apply(_a, __spread(rule));
        // Sort rules by most important first
        this.rules.sort(function (ruleA, ruleB) { return (getPriorityValue(ruleA) > getPriorityValue(ruleB) ? -1 : 1); });
    };
    RuleCollection.prototype.invokeRules = function (functionName, parameter, report, baseContext) {
        var e_1, _a;
        var shouldBreak = false;
        var config = baseContext.config, htmlStore = baseContext.htmlStore, program = baseContext.program, definitionStore = baseContext.definitionStore, dependencyStore = baseContext.dependencyStore, documentStore = baseContext.documentStore, logger = baseContext.logger, ts = baseContext.ts;
        var currentRuleId = undefined;
        var context = {
            config: config,
            htmlStore: htmlStore,
            program: program,
            definitionStore: definitionStore,
            dependencyStore: dependencyStore,
            documentStore: documentStore,
            logger: logger,
            ts: ts,
            file: baseContext.currentFile,
            report: function (diagnostic) {
                if (currentRuleId != null) {
                    report({ diagnostic: diagnostic, source: currentRuleId });
                }
                shouldBreak = true;
            },
            break: function () {
                shouldBreak = true;
            }
        };
        try {
            for (var _b = __values(this.rules), _c = _b.next(); !_c.done; _c = _b.next()) {
                var rule = _c.value;
                if (isRuleEnabled(context.config, rule.id)) {
                    var func = rule[functionName];
                    if (func != null) {
                        currentRuleId = rule.id;
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        func(parameter, context);
                    }
                }
                if (shouldBreak) {
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    RuleCollection.prototype.getDiagnosticsFromDeclaration = function (declaration, baseContext) {
        var e_2, _a;
        var file = baseContext.currentFile;
        var diagnostics = [];
        this.invokeRules("visitComponentDeclaration", declaration, function (d) { return diagnostics.push(d); }, baseContext);
        try {
            for (var _b = __values(declaration.members), _c = _b.next(); !_c.done; _c = _b.next()) {
                var member = _c.value;
                if (member.node.getSourceFile() === file) {
                    this.invokeRules("visitComponentMember", member, function (d) { return diagnostics.push(d); }, baseContext);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return diagnostics;
    };
    RuleCollection.prototype.getDiagnosticsFromDefinition = function (definition, baseContext) {
        var file = baseContext.currentFile;
        var diagnostics = [];
        if (definition.sourceFile === file) {
            this.invokeRules("visitComponentDefinition", definition, function (d) { return diagnostics.push(d); }, baseContext);
        }
        return diagnostics;
    };
    RuleCollection.prototype.getDiagnosticsFromDocument = function (htmlDocument, baseContext) {
        var _this = this;
        var diagnostics = [];
        var iterateNodes = function (nodes) {
            var e_3, _a;
            try {
                for (var nodes_1 = __values(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
                    var childNode = nodes_1_1.value;
                    // Don't check SVG yet. We don't yet have all the data for it, and it hasn't been tested fully.
                    if (childNode.kind === HtmlNodeKind.SVG) {
                        continue;
                    }
                    _this.invokeRules("visitHtmlNode", childNode, function (d) { return diagnostics.push(d); }, baseContext);
                    var iterateAttrs = function (attrs) {
                        var e_4, _a;
                        try {
                            for (var attrs_1 = (e_4 = void 0, __values(attrs)), attrs_1_1 = attrs_1.next(); !attrs_1_1.done; attrs_1_1 = attrs_1.next()) {
                                var attr = attrs_1_1.value;
                                _this.invokeRules("visitHtmlAttribute", attr, function (d) { return diagnostics.push(d); }, baseContext);
                                if (attr.assignment != null) {
                                    _this.invokeRules("visitHtmlAssignment", attr.assignment, function (d) { return diagnostics.push(d); }, baseContext);
                                }
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (attrs_1_1 && !attrs_1_1.done && (_a = attrs_1.return)) _a.call(attrs_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                    };
                    iterateAttrs(childNode.attributes);
                    iterateNodes(childNode.children);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        };
        iterateNodes(htmlDocument.rootNodes);
        return diagnostics;
    };
    return RuleCollection;
}());
function getPriorityValue(rule) {
    var _a, _b;
    if (((_a = rule.meta) === null || _a === void 0 ? void 0 : _a.priority) != null) {
        switch ((_b = rule.meta) === null || _b === void 0 ? void 0 : _b.priority) {
            case "low":
                return 0;
            case "medium":
                return 1;
            case "high":
                return 2;
        }
    }
    return 0;
}

function getDeclarationsInFile(definition, sourceFile) {
    var declarations = new Set();
    emitDeclarationsInFile(definition, sourceFile, function (decl) { return declarations.add(decl); });
    return Array.from(declarations);
}
function emitDeclarationsInFile(definition, sourceFile, emit) {
    var declaration = definition.declaration;
    if (declaration == null) {
        return;
    }
    if (declaration.sourceFile.fileName === sourceFile.fileName) {
        if (emit(declaration) === false) {
            return;
        }
    }
    webComponentAnalyzer.visitAllHeritageClauses(declaration, function (clause) {
        if (clause.declaration && clause.declaration.sourceFile === sourceFile) {
            if (emit(clause.declaration) === false) {
                return;
            }
        }
    });
}

var DefaultAnalyzerDefinitionStore = /** @class */ (function () {
    function DefaultAnalyzerDefinitionStore() {
        this.analysisResultForFile = new Map();
        this.definitionForTagName = new Map();
        this.intersectingDefinitionsForFile = new Map();
    }
    DefaultAnalyzerDefinitionStore.prototype.absorbAnalysisResult = function (sourceFile, result) {
        var _this = this;
        this.analysisResultForFile.set(sourceFile.fileName, result);
        result.componentDefinitions.forEach(function (definition) {
            var _a;
            _this.definitionForTagName.set(definition.tagName, definition);
            addToSetInMap(_this.intersectingDefinitionsForFile, definition.sourceFile.fileName, definition);
            if (definition.declaration == null) {
                return;
            }
            addToSetInMap(_this.intersectingDefinitionsForFile, (_a = definition.declaration) === null || _a === void 0 ? void 0 : _a.sourceFile.fileName, definition);
            webComponentAnalyzer.visitAllHeritageClauses(definition.declaration, function (clause) {
                if (clause.declaration != null) {
                    addToSetInMap(_this.intersectingDefinitionsForFile, clause.declaration.sourceFile.fileName, definition);
                }
            });
        });
    };
    DefaultAnalyzerDefinitionStore.prototype.forgetAnalysisResultForFile = function (sourceFile) {
        var _this = this;
        var result = this.analysisResultForFile.get(sourceFile.fileName);
        if (result == null)
            return;
        result.componentDefinitions.forEach(function (definition) {
            var _a, _b, _c;
            _this.definitionForTagName.delete(definition.tagName);
            (_a = _this.intersectingDefinitionsForFile.get(definition.sourceFile.fileName)) === null || _a === void 0 ? void 0 : _a.delete(definition);
            if (definition.declaration == null) {
                return;
            }
            (_c = _this.intersectingDefinitionsForFile.get((_b = definition.declaration) === null || _b === void 0 ? void 0 : _b.sourceFile.fileName)) === null || _c === void 0 ? void 0 : _c.delete(definition);
            webComponentAnalyzer.visitAllHeritageClauses(definition.declaration, function (clause) {
                var _a;
                if (clause.declaration != null) {
                    (_a = _this.intersectingDefinitionsForFile.get(clause.declaration.sourceFile.fileName)) === null || _a === void 0 ? void 0 : _a.delete(definition);
                }
            });
        });
        this.analysisResultForFile.delete(sourceFile.fileName);
    };
    DefaultAnalyzerDefinitionStore.prototype.getAnalysisResultForFile = function (sourceFile) {
        return this.analysisResultForFile.get(sourceFile.fileName);
    };
    DefaultAnalyzerDefinitionStore.prototype.getDefinitionsWithDeclarationInFile = function (sourceFile) {
        return Array.from(this.intersectingDefinitionsForFile.get(sourceFile.fileName) || []);
    };
    DefaultAnalyzerDefinitionStore.prototype.getComponentDeclarationsInFile = function (sourceFile) {
        var e_1, _a, e_2, _b;
        var declarations = new Set();
        try {
            for (var _c = __values(this.intersectingDefinitionsForFile.get(sourceFile.fileName) || []), _d = _c.next(); !_d.done; _d = _c.next()) {
                var definition = _d.value;
                try {
                    for (var _e = (e_2 = void 0, __values(getDeclarationsInFile(definition, sourceFile))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var declaration = _f.value;
                        declarations.add(declaration);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return Array.from(declarations);
    };
    DefaultAnalyzerDefinitionStore.prototype.getDefinitionForTagName = function (tagName) {
        return this.definitionForTagName.get(tagName);
    };
    DefaultAnalyzerDefinitionStore.prototype.getDefinitionsInFile = function (sourceFile) {
        var result = this.analysisResultForFile.get(sourceFile.fileName);
        return (result != null && result.componentDefinitions) || [];
    };
    return DefaultAnalyzerDefinitionStore;
}());
function addToSetInMap(map, key, value) {
    var set = map.get(key) || new Set();
    set.add(value);
    map.set(key, set);
}

var DefaultAnalyzerDependencyStore = /** @class */ (function () {
    function DefaultAnalyzerDependencyStore() {
        this.importedComponentDefinitionsInFile = new Map();
    }
    DefaultAnalyzerDependencyStore.prototype.absorbComponentDefinitionsForFile = function (sourceFile, result) {
        this.importedComponentDefinitionsInFile.set(sourceFile.fileName, result);
    };
    /**
     * Returns if a component for a specific file has been imported.
     * @param fileName
     * @param tagName
     */
    DefaultAnalyzerDependencyStore.prototype.hasTagNameBeenImported = function (fileName, tagName) {
        var e_1, _a;
        try {
            for (var _b = __values(this.importedComponentDefinitionsInFile.get(fileName) || []), _c = _b.next(); !_c.done; _c = _b.next()) {
                var file = _c.value;
                if (file.tagName === tagName) {
                    return true;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return false;
    };
    return DefaultAnalyzerDependencyStore;
}());

function findTaggedTemplates(sourceFile, templateTags, position) {
    if (position != null) {
        var token = getNodeAtPosition(sourceFile, position);
        var node = findParent(token, tsModule$1.ts.isTaggedTemplateExpression);
        if (node != null && tsModule$1.ts.isTaggedTemplateExpression(node)) {
            if (templateTags.includes(node.tag.getText())) {
                return node;
            }
        }
        return undefined;
    }
    else {
        var taggedTemplates_1 = [];
        visitTaggedTemplateNodes(sourceFile, {
            shouldCheckTemplateTag: function (templateTag) {
                return templateTags.includes(templateTag);
            },
            emitTaggedTemplateNode: function (node) {
                taggedTemplates_1.push(node);
            }
        });
        return taggedTemplates_1;
    }
}
function visitTaggedTemplateNodes(astNode, context) {
    var newContext = __assign({}, context);
    if (tsModule$1.ts.isTaggedTemplateExpression(astNode) && context.shouldCheckTemplateTag(astNode.tag.getText())) {
        // Only visit the template expression if the leading comments does not include the ts-ignore flag.
        //if (!leadingCommentsIncludes(astNode.getSourceFile().getText(), astNode.getFullStart(), TS_IGNORE_FLAG)) {
        newContext.parent = astNode;
        context.emitTaggedTemplateNode(astNode);
    }
    astNode.forEachChild(function (child) { return visitTaggedTemplateNodes(child, context); });
}

function getPartLength(part) {
    var end = part.parent && tsModule$1.ts.isTemplateSpan(part.parent) ? part.parent.literal.getStart() : part.getEnd();
    return end - part.getFullStart();
}
var VirtualAstDocument = /** @class */ (function () {
    function VirtualAstDocument(astNodeOrParts, location, fileName) {
        var _this = this;
        if (Array.isArray(astNodeOrParts)) {
            this.parts = astNodeOrParts.map(function (p, i) {
                return typeof p === "string" ? "" + (i !== 0 ? "}" : "") + p + (i !== astNodeOrParts.length - 1 ? "${" : "") : p;
            });
            this.location = location;
            this.fileName = fileName;
        }
        else {
            var _a = getPartsFromTaggedTemplate(astNodeOrParts), expressionParts_1 = _a.expressionParts, literalParts = _a.literalParts;
            // Text contains both the ` of the template string and ${  +  }.
            // Strip these chars and make it possible to substitute even ${ and }!
            this.parts = [];
            literalParts.forEach(function (p, i) {
                var expressionPart = expressionParts_1[i];
                _this.parts.push(p.getText().slice(i === 0 ? 1 : 0, expressionPart == null ? -1 : undefined));
                if (expressionPart != null)
                    _this.parts.push(expressionPart);
            });
            this.location = makeSourceFileRange({
                start: astNodeOrParts.template.getStart() + 1,
                end: astNodeOrParts.template.getEnd() - 1
            });
            this.fileName = this.fileName = astNodeOrParts.getSourceFile().fileName;
        }
    }
    Object.defineProperty(VirtualAstDocument.prototype, "text", {
        get: function () {
            var _this = this;
            if (this._text == null) {
                var str_1 = "";
                var prevPart_1 = "";
                this.parts.forEach(function (part, i) {
                    var isLastPart = i >= _this.parts.length - 1;
                    if (typeof part === "string") {
                        str_1 += part.substring(i === 0 ? 0 : 1, part.length - (isLastPart ? 0 : 2));
                        prevPart_1 = part;
                    }
                    else {
                        var length = getPartLength(part) + 3;
                        var substitution = _this.substituteExpression(length, part, prevPart_1, _this.parts[i + 1]);
                        str_1 += substitution;
                    }
                });
                this._text = str_1;
            }
            return this._text;
        },
        enumerable: false,
        configurable: true
    });
    VirtualAstDocument.prototype.getPartsAtDocumentRange = function (range) {
        var _this = this;
        if (range == null) {
            return this.parts;
        }
        var resultParts = [];
        var offset = 0;
        this.parts.forEach(function (part, i) {
            var isLastPart = i >= _this.parts.length - 1;
            var startOffset = offset;
            if (typeof part === "string") {
                var startPadding = i === 0 ? 0 : 1;
                var endPadding = isLastPart ? 0 : 2;
                offset += part.length;
                var literalPartRange = {
                    start: startOffset + startPadding,
                    end: offset - endPadding
                };
                if ((range.start < literalPartRange.start && range.end > literalPartRange.end) ||
                    intersects(range.start + 1, literalPartRange) ||
                    intersects(range.end - 1, literalPartRange)) {
                    var strStart = Math.max(literalPartRange.start, range.start);
                    var strEnd = Math.min(literalPartRange.end, range.end);
                    var substr = _this.text.substring(strStart, strEnd);
                    resultParts.push(substr);
                }
            }
            else {
                offset += getPartLength(part);
                var expressionPartRange = {
                    start: startOffset,
                    end: offset
                };
                if (intersects(expressionPartRange, range)) {
                    resultParts.push(part);
                }
            }
        });
        return resultParts;
    };
    VirtualAstDocument.prototype.sfPositionToDocumentOffset = function (position) {
        return position - this.location.start;
    };
    VirtualAstDocument.prototype.documentOffsetToSFPosition = function (offset) {
        return this.location.start + offset;
    };
    VirtualAstDocument.prototype.substituteExpression = function (length, expression, prev, next) {
        return "_".repeat(length);
    };
    return VirtualAstDocument;
}());
function getPartsFromTaggedTemplate(astNode) {
    var e_1, _a;
    var expressionParts = [];
    var literalParts = [];
    var template = astNode.template;
    if (tsModule$1.ts.isTemplateExpression(template)) {
        literalParts.push(template.head);
        try {
            for (var _b = __values(template.templateSpans), _c = _b.next(); !_c.done; _c = _b.next()) {
                var templateSpan = _c.value;
                var expression = templateSpan.expression;
                expressionParts.push(expression);
                literalParts.push(templateSpan.literal);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    else if (tsModule$1.ts.isNoSubstitutionTemplateLiteral(template)) {
        literalParts.push(template);
    }
    return { expressionParts: expressionParts, literalParts: literalParts };
}

var VirtualAstHtmlDocument = /** @class */ (function (_super) {
    __extends(VirtualAstHtmlDocument, _super);
    function VirtualAstHtmlDocument() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VirtualAstHtmlDocument.prototype.substituteExpression = function (length, expression) {
        return "_".repeat(length);
    };
    return VirtualAstHtmlDocument;
}(VirtualAstDocument));

var parseFragment = require("parse5").parseFragment;
/**
 * Returns if a p5Node is a tag node.
 * @param node
 */
function isTagNode(node) {
    return !node.nodeName.includes("#");
}
/**
 * Returns if a p5Node is a comment node.
 * @param node
 */
function isCommentNode(node) {
    return node.nodeName === "#comment";
}
/**
 * Parse a html string into p5Nodes.
 * @param html
 */
function parseHtml(html) {
    return parseFragment(html, { sourceCodeLocationInfo: true, locationInfo: true });
}

function getSourceLocation(node) {
    var nodeWithLocation = node;
    return nodeWithLocation.sourceCodeLocation || nodeWithLocation.__location;
}

/**
 * Parses a html attribute assignment.
 * @param p5Node
 * @param p5Attr
 * @param htmlAttr
 * @param context
 */
function parseHtmlAttrAssignment(p5Node, p5Attr, htmlAttr, context) {
    var location = getAssignmentLocation(p5Node, p5Attr, htmlAttr, context);
    if (location == null) {
        return { kind: HtmlNodeAttrAssignmentKind.BOOLEAN, htmlAttr: htmlAttr };
    }
    var values = context.getPartsAtOffsetRange(location);
    if (values.length === 0) {
        return undefined;
    }
    else if (values.length === 1) {
        var value = values[0];
        if (typeof value === "string") {
            return {
                kind: HtmlNodeAttrAssignmentKind.STRING,
                location: location,
                value: value,
                htmlAttr: htmlAttr
            };
        }
        else {
            return {
                kind: HtmlNodeAttrAssignmentKind.EXPRESSION,
                location: location,
                expression: value,
                htmlAttr: htmlAttr
            };
        }
    }
    else {
        return {
            kind: HtmlNodeAttrAssignmentKind.MIXED,
            location: location,
            values: values,
            htmlAttr: htmlAttr
        };
    }
}
function getAssignmentLocation(p5Node, p5Attr, htmlAttr, context) {
    var sourceLocation = getSourceLocation(p5Node);
    if (sourceLocation == null) {
        return undefined;
    }
    var htmlAttrLocation = (sourceLocation.startTag.attrs || {})[p5Attr.name];
    if (htmlAttrLocation == null)
        return undefined;
    var nameEndOffset = htmlAttr.location.name.end;
    var htmlAfterName = context.html.substring(nameEndOffset, htmlAttrLocation.endOffset);
    var firstQuote = indexOfRegExp(htmlAfterName, /^([\s=]*)(['"])/);
    var lastQuote = indexOfRegExp(htmlAfterName, /['"]\s*$/);
    var firstEquals = indexOfRegExp(htmlAfterName, /=/);
    // Example: attr
    if (firstEquals == null)
        return undefined;
    // Example: attr=myvalue | attr=myvalue" | attr="myvalue
    if (firstQuote == null || lastQuote == null) {
        return {
            start: nameEndOffset + firstEquals + 1,
            end: htmlAttrLocation.endOffset
        };
    }
    // Example: attr="myvalue"
    return {
        start: nameEndOffset + firstQuote + 1,
        end: nameEndOffset + lastQuote
    };
}
/**
 * Returns the index of a regex match.
 * Returns -1 when no match is found.
 * @param text
 * @param reg
 */
function indexOfRegExp(text, reg) {
    var match = text.match(reg);
    if (match == null)
        return undefined;
    // Support matching with a prefix group that counts as padding
    if (match.length === 3) {
        return match[1].length;
    }
    return match.index;
}

/**
 * Creates multiple html attributes based on multiple p5Attributes.
 * @param p5Node
 * @param context
 */
function parseHtmlNodeAttrs(p5Node, context) {
    return p5Node.attrs
        .map(function (htmlAttr) {
        return parseHtmlNodeAttr(p5Node, htmlAttr, __assign(__assign({}, context), { htmlNode: context.htmlNode }));
    })
        .filter(function (attr) { return attr != null; });
}
/**
 * Creates a html attr based on a p5Attr.
 * @param p5Node
 * @param p5Attr
 * @param context
 */
function parseHtmlNodeAttr(p5Node, p5Attr, context) {
    var htmlNode = context.htmlNode;
    var _a = parseLitAttrName(p5Attr.name), name = _a.name, modifier = _a.modifier;
    var location = makeHtmlAttrLocation(p5Node, p5Attr);
    if (location == null) {
        return undefined;
    }
    var htmlAttrBase = {
        name: name.toLowerCase(),
        document: context.document,
        modifier: modifier,
        htmlNode: htmlNode,
        location: location
    };
    var htmlAttr = parseHtmlAttrBase(htmlAttrBase);
    htmlAttr.assignment = parseHtmlAttrAssignment(p5Node, p5Attr, htmlAttr, context);
    return htmlAttr;
}
/**
 * Returns source code location based on a p5Node.
 * @param p5Node
 * @param p5Attr
 * @param context
 */
function makeHtmlAttrLocation(p5Node, p5Attr, context) {
    var _a = parseLitAttrName(p5Attr.name), name = _a.name, modifier = _a.modifier;
    var sourceLocation = getSourceLocation(p5Node);
    if (sourceLocation == null) {
        return undefined;
    }
    // Explicitly call "toLowerCase()" because of inconsistencies in parse5.
    // Parse5 lowercases source code location attr keys but doesnt lowercase the attr name when it comes to svg.
    // It would be correct not to lowercase the attr names because svg is case sensitive
    var sourceCodeLocationName = ("" + (p5Attr.prefix || "") + ((p5Attr.prefix && ":") || "") + p5Attr.name).toLowerCase();
    var htmlAttrLocation = (sourceLocation.startTag.attrs || {})[sourceCodeLocationName];
    var start = htmlAttrLocation.startOffset;
    var end = htmlAttrLocation.endOffset;
    return {
        start: start,
        end: end,
        name: {
            start: start + (modifier ? modifier.length : 0),
            end: start + (modifier ? modifier.length : 0) + name.length
        }
    };
}
function parseHtmlAttrBase(htmlAttrBase) {
    var modifier = htmlAttrBase.modifier;
    switch (modifier) {
        case LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER:
            return __assign(__assign({ kind: HtmlNodeAttrKind.EVENT_LISTENER }, htmlAttrBase), { modifier: modifier });
        case LIT_HTML_PROP_ATTRIBUTE_MODIFIER:
            return __assign(__assign({ kind: HtmlNodeAttrKind.PROPERTY }, htmlAttrBase), { modifier: modifier });
        case LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER:
            return __assign(__assign({ kind: HtmlNodeAttrKind.BOOLEAN_ATTRIBUTE }, htmlAttrBase), { modifier: modifier });
        default:
            return __assign(__assign({ kind: HtmlNodeAttrKind.ATTRIBUTE }, htmlAttrBase), { modifier: undefined });
    }
}

/**
 * Parses multiple p5Nodes into multiple html nodes.
 * @param p5Nodes
 * @param parent
 * @param context
 */
function parseHtmlNodes(p5Nodes, parent, context) {
    var e_1, _a;
    var htmlNodes = [];
    var ignoreNextNode = false;
    try {
        for (var p5Nodes_1 = __values(p5Nodes), p5Nodes_1_1 = p5Nodes_1.next(); !p5Nodes_1_1.done; p5Nodes_1_1 = p5Nodes_1.next()) {
            var p5Node = p5Nodes_1_1.value;
            // Check ts-ignore comments and indicate that we wan't to ignore the next node
            if (isCommentNode(p5Node)) {
                if (p5Node.data != null && p5Node.data.includes(TS_IGNORE_FLAG)) {
                    ignoreNextNode = true;
                }
            }
            if (isTagNode(p5Node)) {
                if (!ignoreNextNode) {
                    var htmlNode = parseHtmlNode(p5Node, parent, context);
                    if (htmlNode != null) {
                        htmlNodes.push(htmlNode);
                    }
                }
                else {
                    ignoreNextNode = false;
                }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (p5Nodes_1_1 && !p5Nodes_1_1.done && (_a = p5Nodes_1.return)) _a.call(p5Nodes_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return htmlNodes;
}
/**
 * Parses a single p5Node into a html node.
 * @param p5Node
 * @param parent
 * @param context
 */
function parseHtmlNode(p5Node, parent, context) {
    // `sourceCodeLocation` will be undefined if the element was implicitly created by the parser.
    if (getSourceLocation(p5Node) == null)
        return undefined;
    var htmlNodeBase = {
        tagName: p5Node.tagName.toLowerCase(),
        selfClosed: isSelfClosed(p5Node),
        attributes: [],
        location: makeHtmlNodeLocation(p5Node),
        children: [],
        document: context.document,
        parent: parent
    };
    var htmlNode = parseHtmlNodeBase(htmlNodeBase);
    // Don't parse children of <style> and <svg> as of now
    if (htmlNode.kind === HtmlNodeKind.NODE) {
        htmlNode.children = parseHtmlNodes(p5Node.childNodes || [], htmlNode, context);
    }
    htmlNode.attributes = parseHtmlNodeAttrs(p5Node, __assign(__assign({}, context), { htmlNode: htmlNode }));
    return htmlNode;
}
/**
 * Returns if this node is self-closed.
 * @param p5Node
 * @param context
 */
function isSelfClosed(p5Node, context) {
    var isEmpty = p5Node.childNodes == null || p5Node.childNodes.length === 0;
    var isSelfClosed = getSourceLocation(p5Node).startTag.endOffset === getSourceLocation(p5Node).endOffset;
    return isEmpty && isSelfClosed;
}
/**
 * Creates source code location from a p5Node.
 * @param p5Node
 * @param context
 */
function makeHtmlNodeLocation(p5Node, context) {
    var loc = getSourceLocation(p5Node);
    return {
        start: loc.startOffset,
        end: loc.endOffset,
        name: {
            start: loc.startTag.startOffset + 1,
            end: loc.startTag.startOffset + 1 + p5Node.tagName.length
        },
        startTag: {
            start: loc.startTag.startOffset,
            end: loc.startTag.endOffset
        },
        endTag: loc.endTag == null
            ? undefined
            : {
                start: loc.endTag.startOffset,
                end: loc.endTag.endOffset
            }
    };
}
function parseHtmlNodeBase(htmlNodeBase) {
    if (htmlNodeBase.tagName === "style") {
        return __assign(__assign({ kind: HtmlNodeKind.STYLE }, htmlNodeBase), { children: [] });
    }
    else if (htmlNodeBase.tagName === "svg") {
        // Ignore children of "svg" for now
        return __assign(__assign({ kind: HtmlNodeKind.SVG }, htmlNodeBase), { children: [] });
    }
    return __assign({ kind: HtmlNodeKind.NODE }, htmlNodeBase);
    /*if (component != null) {
     return {
     ...htmlNodeBase,
     kind: HtmlNodeKind.COMPONENT,
     component
     };
     }

     if (isBuiltInTag(htmlNodeBase.tagName)) {
     // For now: opt out of svg and style children tags
     // TODO: Handle svg and style tags
     const isBlacklisted = ["svg", "style"].includes(htmlNodeBase.tagName);

     return {
     ...htmlNodeBase,
     kind: HtmlNodeKind.BUILT_IN,
     children: isBlacklisted ? [] : htmlNodeBase.children
     };
     }*/
    /*return {
     kind: HtmlNodeKind.UNKNOWN,
     ...htmlNodeBase
     };*/
}

function parseHtmlDocument(node) {
    var virtualDocument = new VirtualAstHtmlDocument(node);
    var html = virtualDocument.text;
    var htmlAst = parseHtml(html);
    var document = new HtmlDocument(virtualDocument, []);
    var context = {
        html: html,
        document: document,
        getPartsAtOffsetRange: function (range) {
            return virtualDocument.getPartsAtDocumentRange(range);
        }
    };
    document.rootNodes = parseHtmlNodes(htmlAst.childNodes, undefined, context);
    return document;
}

var VirtualAstCssDocument = /** @class */ (function (_super) {
    __extends(VirtualAstCssDocument, _super);
    function VirtualAstCssDocument() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VirtualAstCssDocument.prototype.substituteExpression = function (length, expression, prev, next) {
        var hasLeftColon = prev.match(/:[^;{]*\${$/) != null;
        var hasRightColon = next != null && next.match(/^}\s*:\s+/) != null;
        var hasRightSemicolon = next != null && next.match(/^}\s*;/) != null;
        var hasRightPercentage = next != null && next.match(/^}%/) != null;
        // Inspired by https://github.com/Microsoft/typescript-styled-plugin/blob/909d4f17d61562fe77f24587ea443713b8da851d/src/_substituter.ts#L62
        // If this substitution contains both a property and a key, replace it with "$_:_"
        //   Example:
        //     div {
        //       ${unsafeCSS("color: red)};
        //     }
        if (hasRightSemicolon && !hasLeftColon) {
            var prefix = "$_:_";
            return ("" + prefix + "_".repeat(Math.max(0, length - prefix.length))).slice(0, length);
        }
        // If there is "%" to the right of this substitution, replace with a number, because the parser expects a number unit
        //    Example:
        //	    div {
        //        transform-origin: ${x}% ${y}%;
        //      }
        else if (hasRightPercentage) {
            return "0".repeat(length);
        }
        // If there is a ": " to the right of this substitution, replace it with an identifier
        //     Example:
        //       div {
        //         ${unsafeCSS("color")}: red
        //       }
        else if (hasRightColon) {
            return "$" + "_".repeat(length - 1);
        }
        // Else replace with an identifier "_"
        return "_".repeat(length);
    };
    return VirtualAstCssDocument;
}(VirtualAstDocument));

function parseDocumentsInSourceFile(sourceFile, options, position) {
    // Parse html tags in the relevant source file
    var templateTags = __spread(options.cssTags, options.htmlTags);
    var taggedTemplates = findTaggedTemplates(sourceFile, templateTags, position);
    var result = undefined;
    if (taggedTemplates == null) {
        return undefined;
    }
    else if (Array.isArray(taggedTemplates)) {
        result = taggedTemplates.map(function (t) { return taggedTemplateToDocument(t, options); });
    }
    else {
        result = taggedTemplateToDocument(taggedTemplates, options);
    }
    if (result == null)
        return undefined;
    if (Array.isArray(result)) {
        return arrayFlat(result.map(function (document) {
            var res = unpackHtmlDocument(document, position);
            return __spread([document], (res == null ? [] : Array.isArray(res) ? res : [res]));
        }));
    }
    else {
        var nestedDocuments = unpackHtmlDocument(result, position);
        if (position != null && nestedDocuments != null) {
            return nestedDocuments;
        }
    }
    return result;
}
function taggedTemplateToDocument(taggedTemplate, _a) {
    var cssTags = _a.cssTags;
    var tag = taggedTemplate.tag.getText();
    if (cssTags.includes(tag)) {
        return new CssDocument(new VirtualAstCssDocument(taggedTemplate));
    }
    else {
        return parseHtmlDocument(taggedTemplate);
    }
}
function unpackHtmlDocument(textDocument, position) {
    var e_1, _a;
    var documents = [];
    if (textDocument instanceof HtmlDocument) {
        try {
            for (var _b = __values(textDocument.rootNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
                var rootNode = _c.value;
                if (rootNode.kind === HtmlNodeKind.STYLE && rootNode.location.endTag != null) {
                    if (position == null) {
                        var nestedDocument = styleHtmlNodeToCssDocument(textDocument, rootNode);
                        if (nestedDocument != null) {
                            documents.push(nestedDocument);
                        }
                    }
                    else if (intersects(textDocument.virtualDocument.sfPositionToDocumentOffset(position), {
                        start: rootNode.location.startTag.end,
                        end: rootNode.location.endTag.start
                    })) {
                        return styleHtmlNodeToCssDocument(textDocument, rootNode);
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    if (position != null)
        return undefined;
    return documents;
}
function styleHtmlNodeToCssDocument(htmlDocument, styleNode) {
    if (styleNode.location.endTag == null)
        return undefined;
    var cssDocumentParts = htmlDocument.virtualDocument.getPartsAtDocumentRange(makeDocumentRange({
        start: styleNode.location.startTag.start,
        end: styleNode.location.endTag.start
    }));
    var cssVirtualDocument = new VirtualAstCssDocument(cssDocumentParts, documentRangeToSFRange(htmlDocument, styleNode.location.startTag), htmlDocument.virtualDocument.fileName);
    return new CssDocument(cssVirtualDocument);
}

var DefaultAnalyzerDocumentStore = /** @class */ (function () {
    function DefaultAnalyzerDocumentStore() {
    }
    DefaultAnalyzerDocumentStore.prototype.getDocumentAtPosition = function (sourceFile, position, options) {
        return parseDocumentsInSourceFile(sourceFile, {
            htmlTags: options.htmlTemplateTags,
            cssTags: options.cssTemplateTags
        }, position);
    };
    DefaultAnalyzerDocumentStore.prototype.getDocumentsInFile = function (sourceFile, config) {
        return parseDocumentsInSourceFile(sourceFile, {
            htmlTags: config.htmlTemplateTags,
            cssTags: config.cssTemplateTags
        });
    };
    return DefaultAnalyzerDocumentStore;
}());

var HtmlDataSource = /** @class */ (function () {
    function HtmlDataSource() {
        this._globalTags = new Map();
        this._globalAttributes = new Map();
        this._globalEvents = new Map();
        this._globalProperties = new Map();
        this._globalSlots = new Map();
        this._globalCssParts = new Map();
        this._globalCssProperties = new Map();
    }
    Object.defineProperty(HtmlDataSource.prototype, "globalTags", {
        get: function () {
            return this._globalTags;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HtmlDataSource.prototype, "globalAttributes", {
        get: function () {
            return this._globalAttributes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HtmlDataSource.prototype, "globalEvents", {
        get: function () {
            return this._globalEvents;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HtmlDataSource.prototype, "globalProperties", {
        get: function () {
            return this._globalProperties;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HtmlDataSource.prototype, "globalSlots", {
        get: function () {
            return this._globalSlots;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HtmlDataSource.prototype, "globalCssParts", {
        get: function () {
            return this._globalCssParts;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HtmlDataSource.prototype, "globalCssProperties", {
        get: function () {
            return this._globalCssProperties;
        },
        enumerable: false,
        configurable: true
    });
    HtmlDataSource.prototype.absorbCollection = function (collection) {
        var _this = this;
        var _a, _b, _c, _d, _e, _f;
        if (collection.tags != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.tags.forEach(function (tag) { return _this._globalTags.set(tag.tagName.toLowerCase(), tag); });
        }
        if (((_a = collection.global) === null || _a === void 0 ? void 0 : _a.attributes) != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.global.attributes.forEach(function (attr) { return _this._globalAttributes.set(attr.name.toLowerCase(), attr); });
        }
        if (((_b = collection.global) === null || _b === void 0 ? void 0 : _b.events) != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.global.events.forEach(function (evt) { return _this._globalEvents.set(evt.name.toLowerCase(), evt); });
        }
        if (((_c = collection.global) === null || _c === void 0 ? void 0 : _c.properties) != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.global.properties.forEach(function (prop) { return _this._globalProperties.set(prop.name.toLowerCase(), prop); });
        }
        if (((_d = collection.global) === null || _d === void 0 ? void 0 : _d.slots) != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.global.slots.forEach(function (slot) { return _this._globalSlots.set(slot.name.toLowerCase(), slot); });
        }
        if (((_e = collection.global) === null || _e === void 0 ? void 0 : _e.cssParts) != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.global.cssParts.forEach(function (cssPart) { return _this._globalCssParts.set(cssPart.name.toLowerCase(), cssPart); });
        }
        if (((_f = collection.global) === null || _f === void 0 ? void 0 : _f.cssProperties) != null) {
            // For now, lowercase all names because "parse5" doesn't distinguish when parsing
            collection.global.cssProperties.forEach(function (cssProperty) { return _this._globalCssProperties.set(cssProperty.name.toLowerCase(), cssProperty); });
        }
    };
    HtmlDataSource.prototype.forgetCollection = function (_a) {
        var _this = this;
        var tags = _a.tags, _b = _a.global, events = _b.events, attributes = _b.attributes, slots = _b.slots, properties = _b.properties, cssParts = _b.cssParts, cssProperties = _b.cssProperties;
        if (tags != null)
            tags.forEach(function (tagName) { return _this._globalTags.delete(tagName.toLowerCase()); });
        if (events != null)
            events.forEach(function (eventName) { return _this._globalEvents.delete(eventName.toLowerCase()); });
        if (attributes != null)
            attributes.forEach(function (attrName) { return _this._globalAttributes.delete(attrName.toLowerCase()); });
        if (properties != null)
            properties.forEach(function (propName) { return _this._globalProperties.delete(propName.toLowerCase()); });
        if (slots != null)
            slots.forEach(function (slotName) { return _this._globalSlots.delete(slotName.toLowerCase()); });
        if (cssParts != null)
            cssParts.forEach(function (partName) { return _this._globalCssParts.delete(partName.toLowerCase()); });
        if (cssProperties != null)
            cssProperties.forEach(function (cssPropName) { return _this._globalCssProperties.delete(cssPropName.toLowerCase()); });
    };
    HtmlDataSource.prototype.getGlobalTag = function (tagName) {
        return this._globalTags.get(tagName.toLowerCase());
    };
    HtmlDataSource.prototype.getGlobalAttribute = function (attrName) {
        return this._globalAttributes.get(attrName.toLowerCase());
    };
    HtmlDataSource.prototype.getGlobalEvent = function (eventName) {
        return this._globalEvents.get(eventName.toLowerCase());
    };
    HtmlDataSource.prototype.getGlobalProperty = function (propName) {
        return this._globalProperties.get(propName.toLowerCase());
    };
    HtmlDataSource.prototype.getGlobalSlot = function (slotName) {
        return this._globalSlots.get(slotName.toLowerCase());
    };
    HtmlDataSource.prototype.getGlobalCssPart = function (partName) {
        return this._globalCssParts.get(partName.toLowerCase());
    };
    HtmlDataSource.prototype.getGlobalCssProperty = function (propName) {
        return this._globalCssProperties.get(propName.toLowerCase());
    };
    return HtmlDataSource;
}());

var HtmlDataSourceKind;
(function (HtmlDataSourceKind) {
    HtmlDataSourceKind[HtmlDataSourceKind["DECLARED"] = 0] = "DECLARED";
    HtmlDataSourceKind[HtmlDataSourceKind["USER"] = 1] = "USER";
    HtmlDataSourceKind[HtmlDataSourceKind["BUILT_IN"] = 2] = "BUILT_IN";
    HtmlDataSourceKind[HtmlDataSourceKind["BUILT_IN_DECLARED"] = 3] = "BUILT_IN_DECLARED";
})(HtmlDataSourceKind || (HtmlDataSourceKind = {}));
var HtmlDataSourceMerged = /** @class */ (function () {
    function HtmlDataSourceMerged() {
        this.subclassExtensions = new Map();
        this.htmlDataSources = (function () {
            var array = [];
            array[HtmlDataSourceKind.BUILT_IN] = new HtmlDataSource();
            array[HtmlDataSourceKind.BUILT_IN_DECLARED] = new HtmlDataSource();
            array[HtmlDataSourceKind.USER] = new HtmlDataSource();
            array[HtmlDataSourceKind.DECLARED] = new HtmlDataSource();
            return array;
        })();
        this.combinedHtmlDataSource = new HtmlDataSource();
        this.relatedForTagName = {
            attrs: new Map(),
            events: new Map(),
            slots: new Map(),
            props: new Map(),
            cssParts: new Map(),
            cssProperties: new Map()
        };
    }
    Object.defineProperty(HtmlDataSourceMerged.prototype, "globalTags", {
        get: function () {
            return this.combinedHtmlDataSource.globalTags;
        },
        enumerable: false,
        configurable: true
    });
    HtmlDataSourceMerged.prototype.invalidateCache = function (collection) {
        var e_1, _a, e_2, _b;
        var tags = collection.tags, _c = collection.global, attributes = _c.attributes, events = _c.events, cssParts = _c.cssParts;
        if (tags && tags.length > 0) {
            var allCaches = Object.values(this.relatedForTagName);
            try {
                for (var tags_1 = __values(tags), tags_1_1 = tags_1.next(); !tags_1_1.done; tags_1_1 = tags_1.next()) {
                    var tagName = tags_1_1.value;
                    try {
                        // Clear caches for the tag name
                        for (var allCaches_1 = (e_2 = void 0, __values(allCaches)), allCaches_1_1 = allCaches_1.next(); !allCaches_1_1.done; allCaches_1_1 = allCaches_1.next()) {
                            var map = allCaches_1_1.value;
                            map.delete(tagName);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (allCaches_1_1 && !allCaches_1_1.done && (_b = allCaches_1.return)) _b.call(allCaches_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    // "events", "css parts" and "css custom properties" are all considered "global" when returning matches
                    // Therefore we clear all caches if any invalidated tag included those
                    var tag = this.getHtmlTag(tagName);
                    if (tag != null) {
                        if ((tag.events.length || 0) > 0) {
                            this.relatedForTagName.events.clear();
                        }
                        if ((tag.cssParts.length || 0) > 0) {
                            this.relatedForTagName.cssParts.clear();
                        }
                        if ((tag.cssProperties.length || 0) > 0) {
                            this.relatedForTagName.cssProperties.clear();
                        }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (tags_1_1 && !tags_1_1.done && (_a = tags_1.return)) _a.call(tags_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        if (attributes && attributes.length > 0) {
            this.relatedForTagName.attrs.clear();
        }
        if (events && events.length > 0) {
            this.relatedForTagName.events.clear();
        }
        if (cssParts && cssParts.length > 0) {
            this.relatedForTagName.cssParts.clear();
        }
    };
    HtmlDataSourceMerged.prototype.mergeDataSourcesAndInvalidate = function (collection) {
        var e_3, _a, e_4, _b, e_5, _c, e_6, _d, e_7, _e, e_8, _f, e_9, _g;
        var tags = collection.tags, _h = collection.global, events = _h.events, attributes = _h.attributes, properties = _h.properties, slots = _h.slots, cssParts = _h.cssParts, cssProperties = _h.cssProperties;
        this.invalidateCache(collection);
        if (tags != null) {
            var _loop_1 = function (tagName) {
                var allTags = iterableDefined(this_1.htmlDataSources.map(function (r) { return r.getGlobalTag(tagName); }));
                if (allTags.length > 0) {
                    var mergedTags = allTags.length === 1 ? allTags : mergeHtmlTags(allTags);
                    this_1.combinedHtmlDataSource.absorbCollection({ tags: mergedTags });
                }
            };
            var this_1 = this;
            try {
                for (var tags_2 = __values(tags), tags_2_1 = tags_2.next(); !tags_2_1.done; tags_2_1 = tags_2.next()) {
                    var tagName = tags_2_1.value;
                    _loop_1(tagName);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (tags_2_1 && !tags_2_1.done && (_a = tags_2.return)) _a.call(tags_2);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        if (attributes != null) {
            var _loop_2 = function (attrName) {
                var allAttrs = iterableDefined(this_2.htmlDataSources.map(function (r) { return r.getGlobalAttribute(attrName); }));
                if (allAttrs.length > 0) {
                    var mergedAttrs = allAttrs.length === 1 ? allAttrs : mergeHtmlAttrs(allAttrs);
                    this_2.combinedHtmlDataSource.absorbCollection({ global: { attributes: mergedAttrs } });
                }
            };
            var this_2 = this;
            try {
                for (var attributes_1 = __values(attributes), attributes_1_1 = attributes_1.next(); !attributes_1_1.done; attributes_1_1 = attributes_1.next()) {
                    var attrName = attributes_1_1.value;
                    _loop_2(attrName);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (attributes_1_1 && !attributes_1_1.done && (_b = attributes_1.return)) _b.call(attributes_1);
                }
                finally { if (e_4) throw e_4.error; }
            }
        }
        if (events != null) {
            var _loop_3 = function (eventName) {
                var allEvents = iterableDefined(this_3.htmlDataSources.map(function (r) { return r.getGlobalEvent(eventName); }));
                if (allEvents.length > 0) {
                    var mergedEvents = allEvents.length === 1 ? allEvents : mergeHtmlEvents(allEvents);
                    this_3.combinedHtmlDataSource.absorbCollection({ global: { events: mergedEvents } });
                }
            };
            var this_3 = this;
            try {
                for (var events_1 = __values(events), events_1_1 = events_1.next(); !events_1_1.done; events_1_1 = events_1.next()) {
                    var eventName = events_1_1.value;
                    _loop_3(eventName);
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (events_1_1 && !events_1_1.done && (_c = events_1.return)) _c.call(events_1);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        if (properties != null) {
            var _loop_4 = function (propName) {
                var allProps = iterableDefined(this_4.htmlDataSources.map(function (r) { return r.getGlobalProperty(propName); }));
                if (allProps.length > 0) {
                    var mergedProps = allProps.length === 1 ? allProps : mergeHtmlProps(allProps);
                    this_4.combinedHtmlDataSource.absorbCollection({ global: { properties: mergedProps } });
                }
            };
            var this_4 = this;
            try {
                for (var properties_1 = __values(properties), properties_1_1 = properties_1.next(); !properties_1_1.done; properties_1_1 = properties_1.next()) {
                    var propName = properties_1_1.value;
                    _loop_4(propName);
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (properties_1_1 && !properties_1_1.done && (_d = properties_1.return)) _d.call(properties_1);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
        if (slots != null) {
            var _loop_5 = function (slotName) {
                var allSlots = iterableDefined(this_5.htmlDataSources.map(function (r) { return r.getGlobalSlot(slotName); }));
                if (allSlots.length > 0) {
                    var mergedSlots = allSlots.length === 1 ? allSlots : mergeHtmlSlots(allSlots);
                    this_5.combinedHtmlDataSource.absorbCollection({ global: { slots: mergedSlots } });
                }
            };
            var this_5 = this;
            try {
                for (var slots_1 = __values(slots), slots_1_1 = slots_1.next(); !slots_1_1.done; slots_1_1 = slots_1.next()) {
                    var slotName = slots_1_1.value;
                    _loop_5(slotName);
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (slots_1_1 && !slots_1_1.done && (_e = slots_1.return)) _e.call(slots_1);
                }
                finally { if (e_7) throw e_7.error; }
            }
        }
        if (cssProperties != null) {
            var _loop_6 = function (cssPartName) {
                var allCssProps = iterableDefined(this_6.htmlDataSources.map(function (r) { return r.getGlobalCssProperty(cssPartName); }));
                if (allCssProps.length > 0) {
                    var mergedCssProps = allCssProps.length === 1 ? allCssProps : mergeCssProperties(allCssProps);
                    this_6.combinedHtmlDataSource.absorbCollection({ global: { cssProperties: mergedCssProps } });
                }
            };
            var this_6 = this;
            try {
                for (var cssProperties_1 = __values(cssProperties), cssProperties_1_1 = cssProperties_1.next(); !cssProperties_1_1.done; cssProperties_1_1 = cssProperties_1.next()) {
                    var cssPartName = cssProperties_1_1.value;
                    _loop_6(cssPartName);
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (cssProperties_1_1 && !cssProperties_1_1.done && (_f = cssProperties_1.return)) _f.call(cssProperties_1);
                }
                finally { if (e_8) throw e_8.error; }
            }
        }
        if (cssParts != null) {
            var _loop_7 = function (cssPartName) {
                var allCssParts = iterableDefined(this_7.htmlDataSources.map(function (r) { return r.getGlobalCssPart(cssPartName); }));
                if (allCssParts.length > 0) {
                    var mergedCssParts = allCssParts.length === 1 ? allCssParts : mergeCssParts(allCssParts);
                    this_7.combinedHtmlDataSource.absorbCollection({ global: { cssParts: mergedCssParts } });
                }
            };
            var this_7 = this;
            try {
                for (var cssParts_1 = __values(cssParts), cssParts_1_1 = cssParts_1.next(); !cssParts_1_1.done; cssParts_1_1 = cssParts_1.next()) {
                    var cssPartName = cssParts_1_1.value;
                    _loop_7(cssPartName);
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (cssParts_1_1 && !cssParts_1_1.done && (_g = cssParts_1.return)) _g.call(cssParts_1);
                }
                finally { if (e_9) throw e_9.error; }
            }
        }
    };
    HtmlDataSourceMerged.prototype.forgetCollection = function (collection, dataSource) {
        if (dataSource == null) {
            this.htmlDataSources.forEach(function (ds) { return ds.forgetCollection(collection); });
        }
        else {
            this.htmlDataSources[dataSource].forgetCollection(collection);
        }
        this.mergeDataSourcesAndInvalidate(collection);
        this.combinedHtmlDataSource.forgetCollection(collection);
    };
    HtmlDataSourceMerged.prototype.absorbCollection = function (collection, register) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        this.htmlDataSources[register].absorbCollection(collection);
        this.mergeDataSourcesAndInvalidate({
            tags: collection.tags.map(function (t) { return t.tagName; }),
            global: {
                events: (_b = (_a = collection.global) === null || _a === void 0 ? void 0 : _a.events) === null || _b === void 0 ? void 0 : _b.map(function (t) { return t.name; }),
                attributes: (_d = (_c = collection.global) === null || _c === void 0 ? void 0 : _c.attributes) === null || _d === void 0 ? void 0 : _d.map(function (a) { return a.name; }),
                properties: (_f = (_e = collection.global) === null || _e === void 0 ? void 0 : _e.properties) === null || _f === void 0 ? void 0 : _f.map(function (p) { return p.name; }),
                slots: (_h = (_g = collection.global) === null || _g === void 0 ? void 0 : _g.slots) === null || _h === void 0 ? void 0 : _h.map(function (s) { return s.name; }),
                cssParts: (_k = (_j = collection.global) === null || _j === void 0 ? void 0 : _j.cssParts) === null || _k === void 0 ? void 0 : _k.map(function (s) { return s.name; }),
                cssProperties: (_m = (_l = collection.global) === null || _l === void 0 ? void 0 : _l.cssProperties) === null || _m === void 0 ? void 0 : _m.map(function (s) { return s.name; })
            }
        });
    };
    HtmlDataSourceMerged.prototype.getHtmlTag = function (tagName) {
        return this.combinedHtmlDataSource.getGlobalTag(tagName);
    };
    HtmlDataSourceMerged.prototype.absorbSubclassExtension = function (name, extension) {
        this.subclassExtensions.set(name, extension);
    };
    HtmlDataSourceMerged.prototype.getSubclassExtensions = function (tagName) {
        // Right now, always return "HTMLElement" subclass extension
        var extension = this.subclassExtensions.get("HTMLElement");
        return extension != null ? [extension] : [];
    };
    HtmlDataSourceMerged.prototype.getAllAttributesForTag = function (tagName) {
        if (!this.relatedForTagName.attrs.has(tagName)) {
            this.relatedForTagName.attrs.set(tagName, mergeRelatedMembers(this.iterateAllAttributesForNode(tagName)));
        }
        return this.relatedForTagName.attrs.get(tagName);
    };
    HtmlDataSourceMerged.prototype.getAllPropertiesForTag = function (tagName) {
        if (!this.relatedForTagName.props.has(tagName)) {
            this.relatedForTagName.props.set(tagName, mergeRelatedMembers(this.iterateAllPropertiesForNode(tagName)));
        }
        return this.relatedForTagName.props.get(tagName);
    };
    HtmlDataSourceMerged.prototype.getAllEventsForTag = function (tagName) {
        if (!this.relatedForTagName.events.has(tagName)) {
            this.relatedForTagName.events.set(tagName, mergeRelatedEvents(this.iterateAllEventsForNode(tagName)));
        }
        return this.relatedForTagName.events.get(tagName);
    };
    HtmlDataSourceMerged.prototype.getAllSlotForTag = function (tagName) {
        if (!this.relatedForTagName.slots.has(tagName)) {
            this.relatedForTagName.slots.set(tagName, mergeRelatedSlots(this.iterateAllSlotsForNode(tagName)));
        }
        return this.relatedForTagName.slots.get(tagName);
    };
    HtmlDataSourceMerged.prototype.getAllCssPartsForTag = function (tagName) {
        if (!this.relatedForTagName.cssParts.has(tagName)) {
            this.relatedForTagName.cssParts.set(tagName, mergeRelatedCssParts(this.iterateAllCssPartsForNode(tagName)));
        }
        return this.relatedForTagName.cssParts.get(tagName);
    };
    HtmlDataSourceMerged.prototype.getAllCssPropertiesForTag = function (tagName) {
        if (!this.relatedForTagName.cssProperties.has(tagName)) {
            this.relatedForTagName.cssProperties.set(tagName, mergeRelatedCssProperties(this.iterateAllCssPropertiesForNode(tagName)));
        }
        return this.relatedForTagName.cssProperties.get(tagName);
    };
    HtmlDataSourceMerged.prototype.iterateGlobalAttributes = function () {
        return this.combinedHtmlDataSource.globalAttributes.values();
    };
    HtmlDataSourceMerged.prototype.iterateGlobalEvents = function () {
        return this.combinedHtmlDataSource.globalEvents.values();
    };
    HtmlDataSourceMerged.prototype.iterateGlobalProperties = function () {
        return this.combinedHtmlDataSource.globalProperties.values();
    };
    HtmlDataSourceMerged.prototype.iterateGlobalSlots = function () {
        return this.combinedHtmlDataSource.globalSlots.values();
    };
    HtmlDataSourceMerged.prototype.iterateGlobalCssParts = function () {
        return this.combinedHtmlDataSource.globalCssParts.values();
    };
    HtmlDataSourceMerged.prototype.iterateGlobalCssProperties = function () {
        return this.combinedHtmlDataSource.globalCssProperties.values();
    };
    HtmlDataSourceMerged.prototype.iterateAllPropertiesForNode = function (tagName) {
        var htmlTag, extensions, extensions_1, extensions_1_1, extTag, e_10_1;
        var e_10, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    htmlTag = this.getHtmlTag(tagName);
                    if (!(htmlTag != null)) return [3 /*break*/, 2];
                    return [5 /*yield**/, __values(htmlTag.properties)];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    extensions = this.getSubclassExtensions(tagName);
                    _b.label = 3;
                case 3:
                    _b.trys.push([3, 8, 9, 10]);
                    extensions_1 = __values(extensions), extensions_1_1 = extensions_1.next();
                    _b.label = 4;
                case 4:
                    if (!!extensions_1_1.done) return [3 /*break*/, 7];
                    extTag = extensions_1_1.value;
                    return [5 /*yield**/, __values(extTag.properties)];
                case 5:
                    _b.sent();
                    _b.label = 6;
                case 6:
                    extensions_1_1 = extensions_1.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_10_1 = _b.sent();
                    e_10 = { error: e_10_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (extensions_1_1 && !extensions_1_1.done && (_a = extensions_1.return)) _a.call(extensions_1);
                    }
                    finally { if (e_10) throw e_10.error; }
                    return [7 /*endfinally*/];
                case 10: 
                // Global propertjes
                return [5 /*yield**/, __values(this.iterateGlobalProperties())];
                case 11:
                    // Global propertjes
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    };
    HtmlDataSourceMerged.prototype.iterateAllEventsForNode = function (tagName) {
        var htmlTag, extensions, extensions_2, extensions_2_1, extTag, e_11_1, _a, _b, tag, e_12_1, eventNameSet, _c, _d, tag, _e, _f, evt, e_13_1, e_14_1, _g, _h, evt, e_15_1;
        var e_11, _j, e_12, _k, e_14, _l, e_13, _m, e_15, _o;
        return __generator(this, function (_p) {
            switch (_p.label) {
                case 0:
                    htmlTag = this.getHtmlTag(tagName);
                    if (!(htmlTag != null)) return [3 /*break*/, 2];
                    return [5 /*yield**/, __values(htmlTag.events)];
                case 1:
                    _p.sent();
                    _p.label = 2;
                case 2:
                    extensions = this.getSubclassExtensions(tagName);
                    _p.label = 3;
                case 3:
                    _p.trys.push([3, 8, 9, 10]);
                    extensions_2 = __values(extensions), extensions_2_1 = extensions_2.next();
                    _p.label = 4;
                case 4:
                    if (!!extensions_2_1.done) return [3 /*break*/, 7];
                    extTag = extensions_2_1.value;
                    return [5 /*yield**/, __values(extTag.events)];
                case 5:
                    _p.sent();
                    _p.label = 6;
                case 6:
                    extensions_2_1 = extensions_2.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_11_1 = _p.sent();
                    e_11 = { error: e_11_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (extensions_2_1 && !extensions_2_1.done && (_j = extensions_2.return)) _j.call(extensions_2);
                    }
                    finally { if (e_11) throw e_11.error; }
                    return [7 /*endfinally*/];
                case 10:
                    if (!(htmlTag == null || htmlTag.events.length === 0)) return [3 /*break*/, 20];
                    _p.label = 11;
                case 11:
                    _p.trys.push([11, 16, 17, 18]);
                    _a = __values(this.globalTags.values()), _b = _a.next();
                    _p.label = 12;
                case 12:
                    if (!!_b.done) return [3 /*break*/, 15];
                    tag = _b.value;
                    if (!(tag.tagName !== tagName)) return [3 /*break*/, 14];
                    return [5 /*yield**/, __values(tag.events)];
                case 13:
                    _p.sent();
                    _p.label = 14;
                case 14:
                    _b = _a.next();
                    return [3 /*break*/, 12];
                case 15: return [3 /*break*/, 18];
                case 16:
                    e_12_1 = _p.sent();
                    e_12 = { error: e_12_1 };
                    return [3 /*break*/, 18];
                case 17:
                    try {
                        if (_b && !_b.done && (_k = _a.return)) _k.call(_a);
                    }
                    finally { if (e_12) throw e_12.error; }
                    return [7 /*endfinally*/];
                case 18: 
                // Global events
                return [5 /*yield**/, __values(this.iterateGlobalEvents())];
                case 19:
                    // Global events
                    _p.sent();
                    return [3 /*break*/, 41];
                case 20:
                    eventNameSet = new Set(htmlTag.events.map(function (e) { return e.name; }));
                    _p.label = 21;
                case 21:
                    _p.trys.push([21, 32, 33, 34]);
                    _c = __values(this.globalTags.values()), _d = _c.next();
                    _p.label = 22;
                case 22:
                    if (!!_d.done) return [3 /*break*/, 31];
                    tag = _d.value;
                    if (!(tag.tagName !== tagName)) return [3 /*break*/, 30];
                    _p.label = 23;
                case 23:
                    _p.trys.push([23, 28, 29, 30]);
                    _e = (e_13 = void 0, __values(tag.events)), _f = _e.next();
                    _p.label = 24;
                case 24:
                    if (!!_f.done) return [3 /*break*/, 27];
                    evt = _f.value;
                    if (!!eventNameSet.has(evt.name)) return [3 /*break*/, 26];
                    return [4 /*yield*/, evt];
                case 25:
                    _p.sent();
                    _p.label = 26;
                case 26:
                    _f = _e.next();
                    return [3 /*break*/, 24];
                case 27: return [3 /*break*/, 30];
                case 28:
                    e_13_1 = _p.sent();
                    e_13 = { error: e_13_1 };
                    return [3 /*break*/, 30];
                case 29:
                    try {
                        if (_f && !_f.done && (_m = _e.return)) _m.call(_e);
                    }
                    finally { if (e_13) throw e_13.error; }
                    return [7 /*endfinally*/];
                case 30:
                    _d = _c.next();
                    return [3 /*break*/, 22];
                case 31: return [3 /*break*/, 34];
                case 32:
                    e_14_1 = _p.sent();
                    e_14 = { error: e_14_1 };
                    return [3 /*break*/, 34];
                case 33:
                    try {
                        if (_d && !_d.done && (_l = _c.return)) _l.call(_c);
                    }
                    finally { if (e_14) throw e_14.error; }
                    return [7 /*endfinally*/];
                case 34:
                    _p.trys.push([34, 39, 40, 41]);
                    _g = __values(this.iterateGlobalEvents()), _h = _g.next();
                    _p.label = 35;
                case 35:
                    if (!!_h.done) return [3 /*break*/, 38];
                    evt = _h.value;
                    if (!!eventNameSet.has(evt.name)) return [3 /*break*/, 37];
                    return [4 /*yield*/, evt];
                case 36:
                    _p.sent();
                    _p.label = 37;
                case 37:
                    _h = _g.next();
                    return [3 /*break*/, 35];
                case 38: return [3 /*break*/, 41];
                case 39:
                    e_15_1 = _p.sent();
                    e_15 = { error: e_15_1 };
                    return [3 /*break*/, 41];
                case 40:
                    try {
                        if (_h && !_h.done && (_o = _g.return)) _o.call(_g);
                    }
                    finally { if (e_15) throw e_15.error; }
                    return [7 /*endfinally*/];
                case 41: return [2 /*return*/];
            }
        });
    };
    HtmlDataSourceMerged.prototype.iterateAllAttributesForNode = function (tagName) {
        var htmlTag, extensions, extensions_3, extensions_3_1, extTag, e_16_1;
        var e_16, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    htmlTag = this.getHtmlTag(tagName);
                    if (!(htmlTag != null)) return [3 /*break*/, 2];
                    return [5 /*yield**/, __values(htmlTag.attributes)];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    extensions = this.getSubclassExtensions(tagName);
                    _b.label = 3;
                case 3:
                    _b.trys.push([3, 8, 9, 10]);
                    extensions_3 = __values(extensions), extensions_3_1 = extensions_3.next();
                    _b.label = 4;
                case 4:
                    if (!!extensions_3_1.done) return [3 /*break*/, 7];
                    extTag = extensions_3_1.value;
                    return [5 /*yield**/, __values(extTag.attributes)];
                case 5:
                    _b.sent();
                    _b.label = 6;
                case 6:
                    extensions_3_1 = extensions_3.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_16_1 = _b.sent();
                    e_16 = { error: e_16_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (extensions_3_1 && !extensions_3_1.done && (_a = extensions_3.return)) _a.call(extensions_3);
                    }
                    finally { if (e_16) throw e_16.error; }
                    return [7 /*endfinally*/];
                case 10: 
                // Global attributes
                return [5 /*yield**/, __values(this.iterateGlobalAttributes())];
                case 11:
                    // Global attributes
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    };
    HtmlDataSourceMerged.prototype.iterateAllSlotsForNode = function (tagName) {
        var htmlTag, extensions, extensions_4, extensions_4_1, extTag, e_17_1;
        var e_17, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    htmlTag = this.getHtmlTag(tagName);
                    if (!(htmlTag != null)) return [3 /*break*/, 2];
                    return [5 /*yield**/, __values(htmlTag.slots)];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    extensions = this.getSubclassExtensions(tagName);
                    _b.label = 3;
                case 3:
                    _b.trys.push([3, 8, 9, 10]);
                    extensions_4 = __values(extensions), extensions_4_1 = extensions_4.next();
                    _b.label = 4;
                case 4:
                    if (!!extensions_4_1.done) return [3 /*break*/, 7];
                    extTag = extensions_4_1.value;
                    return [5 /*yield**/, __values(extTag.slots)];
                case 5:
                    _b.sent();
                    _b.label = 6;
                case 6:
                    extensions_4_1 = extensions_4.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_17_1 = _b.sent();
                    e_17 = { error: e_17_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (extensions_4_1 && !extensions_4_1.done && (_a = extensions_4.return)) _a.call(extensions_4);
                    }
                    finally { if (e_17) throw e_17.error; }
                    return [7 /*endfinally*/];
                case 10: 
                // Global slots
                return [5 /*yield**/, __values(this.iterateGlobalSlots())];
                case 11:
                    // Global slots
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    };
    HtmlDataSourceMerged.prototype.iterateAllCssPartsForNode = function (tagName) {
        var _a, _b, tag, e_18_1, htmlTag, extensions, extensions_5, extensions_5_1, extTag, e_19_1;
        var e_18, _c, e_19, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!(tagName === "")) return [3 /*break*/, 9];
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 6, 7, 8]);
                    _a = __values(this.combinedHtmlDataSource.globalTags.values()), _b = _a.next();
                    _e.label = 2;
                case 2:
                    if (!!_b.done) return [3 /*break*/, 5];
                    tag = _b.value;
                    return [5 /*yield**/, __values(tag.cssParts)];
                case 3:
                    _e.sent();
                    _e.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_18_1 = _e.sent();
                    e_18 = { error: e_18_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_18) throw e_18.error; }
                    return [7 /*endfinally*/];
                case 8: return [3 /*break*/, 11];
                case 9:
                    htmlTag = this.getHtmlTag(tagName);
                    if (!(htmlTag != null)) return [3 /*break*/, 11];
                    return [5 /*yield**/, __values(htmlTag.cssParts)];
                case 10:
                    _e.sent();
                    _e.label = 11;
                case 11:
                    extensions = this.getSubclassExtensions(tagName);
                    _e.label = 12;
                case 12:
                    _e.trys.push([12, 17, 18, 19]);
                    extensions_5 = __values(extensions), extensions_5_1 = extensions_5.next();
                    _e.label = 13;
                case 13:
                    if (!!extensions_5_1.done) return [3 /*break*/, 16];
                    extTag = extensions_5_1.value;
                    return [5 /*yield**/, __values(extTag.cssParts)];
                case 14:
                    _e.sent();
                    _e.label = 15;
                case 15:
                    extensions_5_1 = extensions_5.next();
                    return [3 /*break*/, 13];
                case 16: return [3 /*break*/, 19];
                case 17:
                    e_19_1 = _e.sent();
                    e_19 = { error: e_19_1 };
                    return [3 /*break*/, 19];
                case 18:
                    try {
                        if (extensions_5_1 && !extensions_5_1.done && (_d = extensions_5.return)) _d.call(extensions_5);
                    }
                    finally { if (e_19) throw e_19.error; }
                    return [7 /*endfinally*/];
                case 19: 
                // Global slots
                return [5 /*yield**/, __values(this.iterateGlobalCssParts())];
                case 20:
                    // Global slots
                    _e.sent();
                    return [2 /*return*/];
            }
        });
    };
    HtmlDataSourceMerged.prototype.iterateAllCssPropertiesForNode = function (tagName) {
        var _a, _b, tag, e_20_1, htmlTag, extensions, extensions_6, extensions_6_1, extTag, e_21_1;
        var e_20, _c, e_21, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!(tagName === "")) return [3 /*break*/, 9];
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 6, 7, 8]);
                    _a = __values(this.combinedHtmlDataSource.globalTags.values()), _b = _a.next();
                    _e.label = 2;
                case 2:
                    if (!!_b.done) return [3 /*break*/, 5];
                    tag = _b.value;
                    return [5 /*yield**/, __values(tag.cssProperties)];
                case 3:
                    _e.sent();
                    _e.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_20_1 = _e.sent();
                    e_20 = { error: e_20_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_20) throw e_20.error; }
                    return [7 /*endfinally*/];
                case 8: return [3 /*break*/, 11];
                case 9:
                    htmlTag = this.getHtmlTag(tagName);
                    if (!(htmlTag != null)) return [3 /*break*/, 11];
                    return [5 /*yield**/, __values(htmlTag.cssProperties)];
                case 10:
                    _e.sent();
                    _e.label = 11;
                case 11:
                    extensions = this.getSubclassExtensions(tagName);
                    _e.label = 12;
                case 12:
                    _e.trys.push([12, 17, 18, 19]);
                    extensions_6 = __values(extensions), extensions_6_1 = extensions_6.next();
                    _e.label = 13;
                case 13:
                    if (!!extensions_6_1.done) return [3 /*break*/, 16];
                    extTag = extensions_6_1.value;
                    return [5 /*yield**/, __values(extTag.cssProperties)];
                case 14:
                    _e.sent();
                    _e.label = 15;
                case 15:
                    extensions_6_1 = extensions_6.next();
                    return [3 /*break*/, 13];
                case 16: return [3 /*break*/, 19];
                case 17:
                    e_21_1 = _e.sent();
                    e_21 = { error: e_21_1 };
                    return [3 /*break*/, 19];
                case 18:
                    try {
                        if (extensions_6_1 && !extensions_6_1.done && (_d = extensions_6.return)) _d.call(extensions_6);
                    }
                    finally { if (e_21) throw e_21.error; }
                    return [7 /*endfinally*/];
                case 19: 
                // Global slots
                return [5 /*yield**/, __values(this.iterateGlobalCssProperties())];
                case 20:
                    // Global slots
                    _e.sent();
                    return [2 /*return*/];
            }
        });
    };
    return HtmlDataSourceMerged;
}());
function mergeRelatedMembers(members) {
    var e_22, _a;
    var mergedMembers = new Map();
    var _loop_8 = function (member) {
        // For now, lowercase all names because "parse5" doesn't distinguish between uppercase and lowercase
        var name = member.name.toLowerCase();
        var existingMember = mergedMembers.get(name);
        if (existingMember == null) {
            mergedMembers.set(name, member);
        }
        else {
            var prevType_1 = existingMember.getType;
            mergedMembers.set(name, __assign(__assign({}, existingMember), { description: undefined, required: existingMember.required && member.required, builtIn: existingMember.required && member.required, fromTagName: existingMember.fromTagName || member.fromTagName, getType: lazy(function () { return mergeRelatedTypeToUnion(prevType_1(), member.getType()); }), related: existingMember.related == null ? [existingMember, member] : __spread(existingMember.related, [member]) }));
        }
    };
    try {
        for (var members_1 = __values(members), members_1_1 = members_1.next(); !members_1_1.done; members_1_1 = members_1.next()) {
            var member = members_1_1.value;
            _loop_8(member);
        }
    }
    catch (e_22_1) { e_22 = { error: e_22_1 }; }
    finally {
        try {
            if (members_1_1 && !members_1_1.done && (_a = members_1.return)) _a.call(members_1);
        }
        finally { if (e_22) throw e_22.error; }
    }
    return mergedMembers;
}
function mergeRelatedTypeToUnion(typeA, typeB) {
    if (typeA.kind === typeB.kind) {
        switch (typeA.kind) {
            case "ANY":
                return typeA;
        }
    }
    switch (typeA.kind) {
        case "UNION":
            if (typeB.kind === "ANY" && typeA.types.find(function (t) { return t.kind === "ANY"; }) != null) {
                return typeA;
            }
            else {
                return __assign(__assign({}, typeA), { types: __spread(typeA.types, [typeB]) });
            }
    }
    return {
        kind: "UNION",
        types: [typeA, typeB]
    };
}
function mergeNamedRelated(items) {
    var e_23, _a;
    var merged = new Map();
    try {
        for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
            var item = items_1_1.value;
            // For now, lowercase all names because "parse5" doesn't distinguish between uppercase and lowercase
            var name = item.name.toLowerCase();
            var existingItem = merged.get(name);
            if (existingItem != null) {
                merged.set(name, __assign(__assign({}, item), { related: existingItem.related == null ? [existingItem, item] : [existingItem.related, item] }));
            }
            else {
                merged.set(name, item);
            }
        }
    }
    catch (e_23_1) { e_23 = { error: e_23_1 }; }
    finally {
        try {
            if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
        }
        finally { if (e_23) throw e_23.error; }
    }
    return merged;
}
function mergeRelatedSlots(slots) {
    return mergeNamedRelated(slots);
}
function mergeRelatedCssParts(cssParts) {
    return mergeNamedRelated(cssParts);
}
function mergeRelatedCssProperties(cssProperties) {
    return mergeNamedRelated(cssProperties);
}
function mergeRelatedEvents(events) {
    var e_24, _a;
    var mergedAttrs = new Map();
    var _loop_9 = function (event) {
        // For now, lowercase all names because "parse5" doesn't distinguish between uppercase and lowercase
        var name = event.name.toLowerCase();
        var existingEvent = mergedAttrs.get(name);
        if (existingEvent == null) {
            mergedAttrs.set(name, event);
        }
        else {
            var prevType_2 = existingEvent.getType;
            mergedAttrs.set(name, __assign(__assign({}, existingEvent), { global: existingEvent.global && event.global, description: undefined, getType: lazy(function () { return mergeRelatedTypeToUnion(prevType_2(), event.getType()); }), related: existingEvent.related == null ? [existingEvent, event] : __spread(existingEvent.related, [event]), fromTagName: existingEvent.fromTagName || event.fromTagName }));
        }
    };
    try {
        for (var events_2 = __values(events), events_2_1 = events_2.next(); !events_2_1.done; events_2_1 = events_2.next()) {
            var event = events_2_1.value;
            _loop_9(event);
        }
    }
    catch (e_24_1) { e_24 = { error: e_24_1 }; }
    finally {
        try {
            if (events_2_1 && !events_2_1.done && (_a = events_2.return)) _a.call(events_2);
        }
        finally { if (e_24) throw e_24.error; }
    }
    return mergedAttrs;
}

var DefaultAnalyzerHtmlStore = /** @class */ (function () {
    function DefaultAnalyzerHtmlStore() {
        this.dataSource = new HtmlDataSourceMerged();
    }
    DefaultAnalyzerHtmlStore.prototype.absorbSubclassExtension = function (name, extension) {
        this.dataSource.absorbSubclassExtension(name, extension);
    };
    DefaultAnalyzerHtmlStore.prototype.absorbCollection = function (collection, register) {
        this.dataSource.absorbCollection(collection, register);
    };
    DefaultAnalyzerHtmlStore.prototype.forgetCollection = function (collection, register) {
        this.dataSource.forgetCollection(collection, register);
    };
    DefaultAnalyzerHtmlStore.prototype.getHtmlTag = function (htmlNode) {
        return this.dataSource.getHtmlTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName);
    };
    DefaultAnalyzerHtmlStore.prototype.getGlobalTags = function () {
        return this.dataSource.globalTags.values();
    };
    DefaultAnalyzerHtmlStore.prototype.getAllAttributesForTag = function (htmlNode) {
        return this.dataSource.getAllAttributesForTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName).values();
    };
    DefaultAnalyzerHtmlStore.prototype.getAllPropertiesForTag = function (htmlNode) {
        return this.dataSource.getAllPropertiesForTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName).values();
    };
    DefaultAnalyzerHtmlStore.prototype.getAllEventsForTag = function (htmlNode) {
        return this.dataSource.getAllEventsForTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName).values();
    };
    DefaultAnalyzerHtmlStore.prototype.getAllSlotsForTag = function (htmlNode) {
        return this.dataSource.getAllSlotForTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName).values();
    };
    DefaultAnalyzerHtmlStore.prototype.getAllCssPartsForTag = function (htmlNode) {
        return this.dataSource.getAllCssPartsForTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName).values();
    };
    DefaultAnalyzerHtmlStore.prototype.getAllCssPropertiesForTag = function (htmlNode) {
        return this.dataSource.getAllCssPropertiesForTag(typeof htmlNode === "string" ? htmlNode : htmlNode.tagName).values();
    };
    DefaultAnalyzerHtmlStore.prototype.getHtmlAttrTarget = function (htmlNodeAttr) {
        var name = htmlNodeAttr.name.toLowerCase();
        switch (htmlNodeAttr.kind) {
            case HtmlNodeAttrKind.EVENT_LISTENER:
                return this.dataSource.getAllEventsForTag(htmlNodeAttr.htmlNode.tagName).get(name);
            case HtmlNodeAttrKind.BOOLEAN_ATTRIBUTE:
            case HtmlNodeAttrKind.ATTRIBUTE:
                return this.dataSource.getAllAttributesForTag(htmlNodeAttr.htmlNode.tagName).get(name);
            case HtmlNodeAttrKind.PROPERTY:
                return this.dataSource.getAllPropertiesForTag(htmlNodeAttr.htmlNode.tagName).get(name);
        }
    };
    return DefaultAnalyzerHtmlStore;
}());

/**
 * Yields source files that have changed since last time this function was called.
 */
function changedSourceFileIterator() {
    var sourceFileCache = new WeakSet();
    var iterator = function (sourceFiles) {
        var sourceFiles_1, sourceFiles_1_1, sourceFile, e_1_1;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 5, 6, 7]);
                    sourceFiles_1 = __values(sourceFiles), sourceFiles_1_1 = sourceFiles_1.next();
                    _b.label = 1;
                case 1:
                    if (!!sourceFiles_1_1.done) return [3 /*break*/, 4];
                    sourceFile = sourceFiles_1_1.value;
                    if (!!sourceFileCache.has(sourceFile)) return [3 /*break*/, 3];
                    return [4 /*yield*/, sourceFile];
                case 2:
                    _b.sent();
                    sourceFileCache.add(sourceFile);
                    _b.label = 3;
                case 3:
                    sourceFiles_1_1 = sourceFiles_1.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (sourceFiles_1_1 && !sourceFiles_1_1.done && (_a = sourceFiles_1.return)) _a.call(sourceFiles_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    return Object.assign(iterator, {
        invalidate: function (sourceFile) {
            sourceFileCache.delete(sourceFile);
        }
    });
}

var DefaultLitAnalyzerContext = /** @class */ (function () {
    function DefaultLitAnalyzerContext(handler) {
        this.handler = handler;
        this.componentSourceFileIterator = changedSourceFileIterator();
        this.hasAnalyzedSubclassExtensions = false;
        this._config = makeConfig({});
        this._currentStartTime = Date.now();
        this._currentTimeout = MAX_RUNNING_TIME_PER_OPERATION;
        this._currentCancellationToken = undefined;
        this._hasRequestedCancellation = false;
        this._throwOnRequestedCancellation = false;
        this.htmlStore = new DefaultAnalyzerHtmlStore();
        this.dependencyStore = new DefaultAnalyzerDependencyStore();
        this.documentStore = new DefaultAnalyzerDocumentStore();
        this.definitionStore = new DefaultAnalyzerDefinitionStore();
        this.logger = new DefaultLitAnalyzerLogger();
        // Add all HTML5 tags and attributes
        var builtInCollection = getBuiltInHtmlCollection();
        this.htmlStore.absorbCollection(builtInCollection, HtmlDataSourceKind.BUILT_IN);
    }
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "ts", {
        get: function () {
            return this.handler.ts || tsModuleType;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "program", {
        get: function () {
            return this.handler.getProgram();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "project", {
        get: function () {
            return this.handler.getProject != null ? this.handler.getProject() : undefined;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "config", {
        get: function () {
            return this._config;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "currentRunningTime", {
        get: function () {
            return Date.now() - this._currentStartTime;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "isCancellationRequested", {
        get: function () {
            var _a;
            if (this._hasRequestedCancellation) {
                return true;
            }
            if (this._currentCancellationToken == null) {
                // Never cancel if "cancellation token" is not present
                // This means that we are in a CLI context, and are willing to wait for the operation to finish for correctness reasons
                return false;
            }
            if ((_a = this._currentCancellationToken) === null || _a === void 0 ? void 0 : _a.isCancellationRequested()) {
                if (!this._hasRequestedCancellation) {
                    this.logger.error("Cancelling current operation because project host has requested cancellation");
                }
                this._hasRequestedCancellation = true;
            }
            if (this.currentRunningTime > this._currentTimeout) {
                if (!this._hasRequestedCancellation) {
                    this.logger.error("Cancelling current operation because it has been running for more than " + this._currentTimeout + "ms (" + this.currentRunningTime + "ms)");
                }
                this._hasRequestedCancellation = true;
            }
            // Throw if necessary
            if (this._hasRequestedCancellation && this._throwOnRequestedCancellation) {
                throw new this.ts.OperationCanceledException();
            }
            return this._hasRequestedCancellation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "currentFile", {
        get: function () {
            if (this._currentFile == null) {
                throw new Error("Current file is not set");
            }
            return this._currentFile;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "rules", {
        get: function () {
            var _a;
            if (this._rules == null) {
                this._rules = new RuleCollection();
                (_a = this._rules).push.apply(_a, __spread(ALL_RULES));
            }
            return this._rules;
        },
        enumerable: false,
        configurable: true
    });
    DefaultLitAnalyzerContext.prototype.setContextBase = function (_a) {
        var _b;
        var file = _a.file, timeout = _a.timeout, throwOnCancellation = _a.throwOnCancellation;
        this._currentFile = file;
        this._currentStartTime = Date.now();
        this._currentTimeout = timeout !== null && timeout !== void 0 ? timeout : MAX_RUNNING_TIME_PER_OPERATION;
        this._currentCancellationToken = (_b = this.project) === null || _b === void 0 ? void 0 : _b.getCancellationToken();
        this._throwOnRequestedCancellation = throwOnCancellation !== null && throwOnCancellation !== void 0 ? throwOnCancellation : false;
        this._hasRequestedCancellation = false;
    };
    DefaultLitAnalyzerContext.prototype.updateConfig = function (config) {
        this._config = config;
        this.logger.level = (function () {
            switch (config.logging) {
                case "off":
                    return exports.LitAnalyzerLoggerLevel.OFF;
                case "error":
                    return exports.LitAnalyzerLoggerLevel.ERROR;
                case "warn":
                    return exports.LitAnalyzerLoggerLevel.WARN;
                case "debug":
                    return exports.LitAnalyzerLoggerLevel.DEBUG;
                case "verbose":
                    return exports.LitAnalyzerLoggerLevel.VERBOSE;
                default:
                    return exports.LitAnalyzerLoggerLevel.OFF;
            }
        })();
        // Add user configured HTML5 collection
        var collection = getUserConfigHtmlCollection(config);
        this.htmlStore.absorbCollection(collection, HtmlDataSourceKind.USER);
    };
    DefaultLitAnalyzerContext.prototype.updateDependencies = function (file) {
        this.findDependenciesInFile(file);
    };
    DefaultLitAnalyzerContext.prototype.updateComponents = function (file) {
        this.findInvalidatedComponents();
        this.analyzeSubclassExtensions();
    };
    Object.defineProperty(DefaultLitAnalyzerContext.prototype, "checker", {
        get: function () {
            return this.program.getTypeChecker();
        },
        enumerable: false,
        configurable: true
    });
    DefaultLitAnalyzerContext.prototype.findInvalidatedComponents = function () {
        var e_1, _a, e_2, _b;
        var _this = this;
        var startTime = Date.now();
        var seenFiles = new Set();
        var invalidatedFiles = new Set();
        var getRunningTime = function () {
            return Date.now() - startTime;
        };
        try {
            // Find components in all changed files
            for (var _c = __values(this.componentSourceFileIterator(this.program.getSourceFiles())), _d = _c.next(); !_d.done; _d = _c.next()) {
                var sourceFile = _d.value;
                if (this.isCancellationRequested) {
                    break;
                }
                seenFiles.add(sourceFile);
                // All components definitions that use this file must be invidalited
                this.definitionStore.getDefinitionsWithDeclarationInFile(sourceFile).forEach(function (definition) {
                    var sf = _this.program.getSourceFile(definition.sourceFile.fileName);
                    if (sf != null) {
                        invalidatedFiles.add(sf);
                    }
                });
                this.logger.debug("Analyzing components in " + sourceFile.fileName + " (changed) (" + getRunningTime() + "ms total)");
                this.findComponentsInFile(sourceFile);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var invalidatedFiles_1 = __values(invalidatedFiles), invalidatedFiles_1_1 = invalidatedFiles_1.next(); !invalidatedFiles_1_1.done; invalidatedFiles_1_1 = invalidatedFiles_1.next()) {
                var sourceFile = invalidatedFiles_1_1.value;
                if (this.isCancellationRequested) {
                    break;
                }
                if (!seenFiles.has(sourceFile)) {
                    seenFiles.add(sourceFile);
                    this.logger.debug("Analyzing components in " + sourceFile.fileName + " (invalidated) (" + getRunningTime() + "ms total)");
                    this.findComponentsInFile(sourceFile);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (invalidatedFiles_1_1 && !invalidatedFiles_1_1.done && (_b = invalidatedFiles_1.return)) _b.call(invalidatedFiles_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.logger.verbose("Analyzed " + seenFiles.size + " files (" + invalidatedFiles.size + " invalidated) in " + getRunningTime() + "ms");
    };
    DefaultLitAnalyzerContext.prototype.findComponentsInFile = function (sourceFile) {
        var _a, _b, _c, _d, _e, _f;
        var isDefaultLibrary = this.program.isSourceFileDefaultLibrary(sourceFile);
        var isExternalLibrary = this.program.isSourceFileFromExternalLibrary(sourceFile);
        // Only analyzing specific default libs of interest can save us up to 500ms in startup time
        if ((isDefaultLibrary && sourceFile.fileName.match(/(lib\.dom\.d\.ts)/) == null) ||
            (isExternalLibrary && sourceFile.fileName.match(/(@types\/node)/) != null)) {
            return;
        }
        var analyzeResult = webComponentAnalyzer.analyzeSourceFile(sourceFile, {
            program: this.program,
            ts: this.ts,
            config: {
                features: ["event", "member", "slot", "csspart", "cssproperty"],
                analyzeGlobalFeatures: !isDefaultLibrary,
                analyzeDefaultLib: true,
                analyzeDependencies: true,
                analyzeAllDeclarations: false,
                excludedDeclarationNames: ["HTMLElement"]
            }
        });
        var reg = isDefaultLibrary ? HtmlDataSourceKind.BUILT_IN_DECLARED : HtmlDataSourceKind.DECLARED;
        // Forget
        var existingResult = this.definitionStore.getAnalysisResultForFile(sourceFile);
        if (existingResult != null) {
            this.htmlStore.forgetCollection({
                tags: existingResult.componentDefinitions.map(function (d) { return d.tagName; }),
                global: {
                    events: (_a = existingResult.globalFeatures) === null || _a === void 0 ? void 0 : _a.events.map(function (e) { return e.name; }),
                    slots: (_b = existingResult.globalFeatures) === null || _b === void 0 ? void 0 : _b.slots.map(function (s) { return s.name || ""; }),
                    cssParts: (_c = existingResult.globalFeatures) === null || _c === void 0 ? void 0 : _c.cssParts.map(function (s) { return s.name || ""; }),
                    cssProperties: (_d = existingResult.globalFeatures) === null || _d === void 0 ? void 0 : _d.cssProperties.map(function (s) { return s.name || ""; }),
                    attributes: (_e = existingResult.globalFeatures) === null || _e === void 0 ? void 0 : _e.members.filter(function (m) { return m.kind === "attribute"; }).map(function (m) { return m.attrName || ""; }),
                    properties: (_f = existingResult.globalFeatures) === null || _f === void 0 ? void 0 : _f.members.filter(function (m) { return m.kind === "property"; }).map(function (m) { return m.propName || ""; })
                }
            }, reg);
            this.definitionStore.forgetAnalysisResultForFile(sourceFile);
        }
        // Absorb
        this.definitionStore.absorbAnalysisResult(sourceFile, analyzeResult);
        var htmlCollection = convertAnalyzeResultToHtmlCollection(analyzeResult, {
            checker: this.checker,
            addDeclarationPropertiesAsAttributes: this.program.isSourceFileFromExternalLibrary(sourceFile)
        });
        this.htmlStore.absorbCollection(htmlCollection, reg);
    };
    DefaultLitAnalyzerContext.prototype.analyzeSubclassExtensions = function () {
        if (this.hasAnalyzedSubclassExtensions)
            return;
        var result = webComponentAnalyzer.analyzeHTMLElement(this.program, this.ts);
        if (result != null) {
            var extension = convertComponentDeclarationToHtmlTag(result, undefined, { checker: this.checker });
            this.htmlStore.absorbSubclassExtension("HTMLElement", extension);
            this.hasAnalyzedSubclassExtensions = true;
        }
    };
    DefaultLitAnalyzerContext.prototype.findDependenciesInFile = function (file) {
        if (isRuleDisabled(this.config, "no-missing-import"))
            return;
        // Build a graph of component dependencies
        var res = parseDependencies(file, this);
        this.dependencyStore.importedComponentDefinitionsInFile.set(file.fileName, res);
    };
    return DefaultLitAnalyzerContext;
}());

var requiredCompilerOptions = {
    noEmitOnError: false,
    noEmit: true,
    allowJs: true,
    //maxNodeModuleJsDepth: 3,
    strictNullChecks: true,
    moduleResolution: tsModuleType.ModuleResolutionKind.NodeJs,
    skipLibCheck: true,
    lib: ["lib.esnext.d.ts", "lib.dom.d.ts"]
};
/**
 * The most general version of compiler options.
 */
var defaultCompilerOptions = __assign(__assign({}, requiredCompilerOptions), { experimentalDecorators: true, target: tsModuleType.ScriptTarget.Latest, downlevelIteration: true, module: tsModuleType.ModuleKind.ESNext, 
    //module: ModuleKind.CommonJS,
    esModuleInterop: true, allowSyntheticDefaultImports: true, allowUnreachableCode: true, allowUnusedLabels: true });
/**
 * Compiles an array of file paths using typescript.
 * @param filePaths
 */
function compileTypescript(filePaths) {
    var options = getCompilerOptions();
    filePaths = Array.isArray(filePaths) ? filePaths : [filePaths];
    var program = tsModuleType.createProgram(filePaths, options);
    var files = program
        .getSourceFiles()
        .filter(function (sf) { return filePaths.includes(sf.fileName); })
        .sort(function (sfA, sfB) { return (sfA.fileName > sfB.fileName ? 1 : -1); });
    return { program: program, files: files };
}
/**
 * Returns compiler options to be used
 */
function getCompilerOptions() {
    // Get compiler options from files
    var compilerOptions = resolveTsConfigCompilerOptions();
    // If we found existing compiler options, merged "required compiler options" into it.
    if (compilerOptions != null) {
        return __assign(__assign({}, compilerOptions), requiredCompilerOptions);
    }
    // Return default compiler options if no compiler options were found
    return defaultCompilerOptions;
}
/**
 * Resolves "tsconfig.json" file and returns its CompilerOptions
 */
function resolveTsConfigCompilerOptions() {
    // Find the nearest tsconfig.json file if possible
    var tsConfigFilePath = tsModuleType.findConfigFile(process.cwd(), fs.existsSync, "tsconfig.json");
    if (tsConfigFilePath != null) {
        // Read the tsconfig.json file
        var parsedConfig = tsModuleType.readConfigFile(tsConfigFilePath, function (path) { return fs.readFileSync(path, "utf8"); });
        if (parsedConfig != null && parsedConfig.config != null) {
            // Parse the tsconfig.json file
            var parsedJson = tsModuleType.convertCompilerOptionsFromJson(parsedConfig.config.compilerOptions, path.basename(tsConfigFilePath), "tsconfig.json");
            return parsedJson === null || parsedJson === void 0 ? void 0 : parsedJson.options;
        }
    }
    return undefined;
}
/**
 * Resolves the nearest tsconfig.json and returns the configuration seed within the plugins section for "ts-lit-plugin"
 */
function readLitAnalyzerConfigFromTsConfig() {
    var compilerOptions = resolveTsConfigCompilerOptions();
    // Finds the plugin section
    if (compilerOptions != null && "plugins" in compilerOptions) {
        var plugins = compilerOptions.plugins;
        var tsLitPluginOptions = plugins.find(function (plugin) { return plugin.name === "ts-lit-plugin"; });
        if (tsLitPluginOptions != null) {
            return tsLitPluginOptions;
        }
    }
    return undefined;
}

//const IGNORE_GLOBS = ["!**/node_modules/**", "!**/web_modules/**"];
var IGNORE_GLOBS = [];
var DEFAULT_DIR_GLOB = "**/*.{js,jsx,ts,tsx}";
/**
 * Parses and analyses all globs and calls some callbacks while doing it.
 * @param globs
 * @param config
 * @param context
 */
function analyzeGlobs(globs, config, context) {
    if (context === void 0) { context = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var filePaths, _a, program, files, files_1, files_1_1, file, result;
        var e_1, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, expandGlobs(globs)];
                case 1:
                    filePaths = _c.sent();
                    if (config.debug) {
                        // eslint-disable-next-line no-console
                        console.log(filePaths);
                    }
                    // Callbacks
                    if (context.didExpandGlobs != null)
                        context.didExpandGlobs(filePaths);
                    if (context.willAnalyzeFiles != null)
                        context.willAnalyzeFiles(filePaths);
                    _a = compileTypescript(filePaths), program = _a.program, files = _a.files;
                    try {
                        // Analyze each file
                        for (files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                            file = files_1_1.value;
                            // Analyze
                            if (context.analyzeSourceFile != null) {
                                result = context.analyzeSourceFile(file, { program: program });
                                if (result === false)
                                    break;
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (files_1_1 && !files_1_1.done && (_b = files_1.return)) _b.call(files_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return [2 /*return*/, { program: program, files: files }];
            }
        });
    });
}
/**
 * Expands the globs.
 * @param globs
 */
function expandGlobs(globs) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    globs = Array.isArray(globs) ? globs : [globs];
                    _a = arrayFlat;
                    return [4 /*yield*/, Promise.all(globs.map(function (g) {
                            try {
                                // Test if the glob points to a directory.
                                // If so, return the result of a new glob that searches for files in the directory excluding node_modules..
                                var dirExists = fs.existsSync(g) && fs.lstatSync(g).isDirectory();
                                if (dirExists) {
                                    return fastGlob.async(__spread(IGNORE_GLOBS, [path.join(g, DEFAULT_DIR_GLOB)]), {
                                        absolute: true,
                                        followSymlinkedDirectories: false
                                    });
                                }
                            }
                            catch (_a) {
                                // Do nothing
                            }
                            // Return the result of globbing
                            return fastGlob.async(__spread(IGNORE_GLOBS, [g]), {
                                absolute: true,
                                followSymlinkedDirectories: false
                            });
                        }))];
                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
            }
        });
    });
}

function generalReport(stats) {
    function numberStatText(n, text) {
        return n + " " + text + (n === 1 ? "" : "s");
    }
    if (stats.diagnostics > 0) {
        var message = "  \u2716 " + numberStatText(stats.diagnostics, "problem") + " in " + numberStatText(stats.filesWithProblems, "file") + " (" + numberStatText(stats.errors, "error") + ", " + numberStatText(stats.warnings, "warning") + ")";
        if (stats.errors > 0) {
            return "\n" + chalk.red(message);
        }
        else {
            return "\n" + chalk.yellow(message);
        }
    }
    else {
        return "\n" + chalk.green("  \u2713 Found 0 problems in " + numberStatText(stats.totalFiles, "file"));
    }
}
function relativeFileName(fileName) {
    return fileName.replace(process.cwd(), ".");
}
function markText(text, range, colorFunction) {
    if (colorFunction === void 0) { colorFunction = chalk.bgRedBright; }
    return (text.substring(0, range.start) + chalk.bold(colorFunction(text.substr(range.start, range.length))) + text.substring(range.start + range.length));
}
function textPad(str, _a) {
    var width = _a.width, fill = _a.fill, dir = _a.dir;
    var padding = (fill || " ").repeat(Math.max(0, width - str.length));
    return "" + (dir !== "right" ? padding : "") + str + (dir === "right" ? padding : "");
}

var CodeDiagnosticFormatter = /** @class */ (function () {
    function CodeDiagnosticFormatter() {
    }
    CodeDiagnosticFormatter.prototype.report = function (stats) {
        return generalReport(stats);
    };
    CodeDiagnosticFormatter.prototype.diagnosticTextForFile = function (file, diagnostics) {
        if (diagnostics.length === 0)
            return undefined;
        var diagnosticText = diagnostics.map(function (diagnostic) { return diagnosticTextForFile(file, diagnostic); }).join("\n");
        return "\n" + chalk.underline("" + relativeFileName(file.fileName)) + "\n" + diagnosticText;
    };
    return CodeDiagnosticFormatter;
}());
function diagnosticTextForFile(file, diagnostic) {
    var MAX_LINE_WIDTH = 50;
    var MIN_MESSAGE_PADDING = 10;
    // Get line and character of start position
    var lineContext = file.getLineAndCharacterOfPosition(diagnostic.location.start);
    // Get start and end position of the line
    var linePositionRange = {
        start: file.getPositionOfLineAndCharacter(lineContext.line, 0),
        end: file.getLineEndOfPosition(diagnostic.location.start)
    };
    // Modify the line position range if the width of the line exceeds MAX_LINE_WIDTH
    if (linePositionRange.end - linePositionRange.start > MAX_LINE_WIDTH) {
        // Calculate even padding to both sides
        var padding = Math.max(MIN_MESSAGE_PADDING, Math.round((MAX_LINE_WIDTH - (diagnostic.location.end - diagnostic.location.start)) / 2));
        // Calculate new start and end position without exceeding the line position range
        var start = Math.max(linePositionRange.start, diagnostic.location.start - padding);
        var end = Math.min(linePositionRange.end, diagnostic.location.end + padding);
        linePositionRange = { start: start, end: end };
    }
    // Get the source file text on the position range
    var lineText = file.getFullText().substring(linePositionRange.start, linePositionRange.end);
    // Highlight the error in the text
    // The highlighting range is offsetted by subtracting the line start position
    var highlightingColorFunction = function (str) { return chalk.black(diagnostic.severity === "error" ? chalk.bgRedBright(str) : chalk.bgYellow(str)); };
    var markedLine = markText(lineText, {
        start: diagnostic.location.start - linePositionRange.start,
        length: diagnostic.location.end - diagnostic.location.start
    }, highlightingColorFunction).replace(/^\s*/, " ");
    var block = [
        chalk.bold("" + diagnostic.message + (diagnostic.fixMessage ? " " + diagnostic.fixMessage : "")),
        chalk.gray(lineContext.line + 1 + ":") + " " + markedLine,
        diagnostic.source == null ? undefined : chalk.gray("" + diagnostic.source)
    ]
        .filter(function (line) { return line != null; })
        .map(function (line) { return "    " + line; })
        .join("\n");
    return "\n" + block + "\n";
}

var ListDiagnosticFormatter = /** @class */ (function () {
    function ListDiagnosticFormatter() {
    }
    ListDiagnosticFormatter.prototype.report = function (stats) {
        return generalReport(stats);
    };
    ListDiagnosticFormatter.prototype.diagnosticTextForFile = function (file, diagnostics) {
        if (diagnostics.length === 0)
            return undefined;
        return diagnosticTextForFile$1(file, diagnostics);
    };
    return ListDiagnosticFormatter;
}());
function diagnosticTextForFile$1(file, diagnostics) {
    var diagnosticText = diagnostics.map(function (diagnostic) { return litDiagnosticToErrorText(file, diagnostic); }).join("\n");
    return "\n" + chalk.underline("" + relativeFileName(file.fileName)) + "\n" + diagnosticText;
}
function litDiagnosticToErrorText(file, diagnostic) {
    var lineContext = file.getLineAndCharacterOfPosition(diagnostic.location.start);
    var linePart = textPad("" + (lineContext.line + 1), { width: 5 }) + ":" + textPad("" + lineContext.character, {
        width: 4,
        dir: "right"
    });
    var severityPart = "" + textPad(diagnostic.severity === "warning" ? chalk.yellow("warning") : chalk.red("error"), {
        width: 18,
        dir: "right"
    });
    var messagePart = diagnostic.message;
    return linePart + " " + severityPart + " " + messagePart;
}

/**
 * Highlights some text
 * @param text
 */
function markdownHighlight(text) {
    return "`" + text + "`";
}
/**
 * Returns a markdown header with a specific level
 * @param level
 * @param title
 */
function markdownHeader(level, title) {
    return "#".repeat(level) + " " + title;
}
var DEFAULT_MARKDOWN_TABLE_OPTIONS = {
    removeEmptyColumns: true,
    minCellWidth: 3,
    maxCellWidth: 50,
    cellPadding: 1
};
/**
 * Returns a markdown table representation of the rows.
 * Strips unused columns.
 * @param rows
 * @param options
 */
function markdownTable(rows, options) {
    if (options === void 0) { options = {}; }
    // Constants for pretty printing the markdown tables
    var MIN_CELL_WIDTH = options.minCellWidth || DEFAULT_MARKDOWN_TABLE_OPTIONS.minCellWidth;
    var MAX_CELL_WIDTH = options.maxCellWidth || DEFAULT_MARKDOWN_TABLE_OPTIONS.maxCellWidth;
    var CELL_PADDING = options.cellPadding || DEFAULT_MARKDOWN_TABLE_OPTIONS.cellPadding;
    // Count the number of columns
    var columnCount = Math.max.apply(Math, __spread(rows.map(function (r) { return r.length; })));
    if (options.removeEmptyColumns) {
        // Create a boolean array where each entry tells if a column is used or not (excluding the header)
        var emptyColumns_1 = Array(columnCount)
            .fill(false)
            .map(function (b, i) { return i !== 0 && rows.slice(1).find(function (r) { return r[i] != null && r[i].length > 0; }) == null; });
        // Remove unused columns if necessary
        if (emptyColumns_1.includes(true)) {
            // Filter out the unused columns in each row
            rows = rows.map(function (row) { return row.filter(function (column, i) { return !emptyColumns_1[i]; }); });
            // Adjust the column count
            columnCount = Math.max.apply(Math, __spread(rows.map(function (r) { return r.length; })));
        }
    }
    // Escape all cells in the markdown output
    rows = rows.map(function (r) { return r.map(markdownEscapeTableCell); });
    // Create a boolean array where each entry corresponds to the preferred column width.
    // This is done by taking the largest width of all cells in each column.
    var columnWidths = Array(columnCount)
        .fill(0)
        .map(function (c, i) { return Math.min(MAX_CELL_WIDTH, Math.max.apply(Math, __spread([MIN_CELL_WIDTH], rows.map(function (r) { return (r[i] || "").length; }))) + CELL_PADDING * 2); });
    // Build up the table
    return "\n|" + rows[0].map(function (r, i) { return fillWidth(r, columnWidths[i], CELL_PADDING); }).join("|") + "|\n|" + columnWidths.map(function (c) { return "-".repeat(c); }).join("|") + "|\n" + rows
        .slice(1)
        .map(function (r) { return "|" + r.map(function (r, i) { return fillWidth(r, columnWidths[i], CELL_PADDING); }).join("|") + "|"; })
        .join("\n") + "\n";
}
/**
 * Escape a text so it can be used in a markdown table
 * @param text
 */
function markdownEscapeTableCell(text) {
    return text.replace(/\n/g, "<br />").replace(/\|/g, "\\|");
}
/**
 * Creates padding around some text with a target width.
 * @param text
 * @param width
 * @param paddingStart
 */
function fillWidth(text, width, paddingStart) {
    return " ".repeat(paddingStart) + text + " ".repeat(Math.max(1, width - text.length - paddingStart));
}

var MarkdownDiagnosticFormatter = /** @class */ (function () {
    function MarkdownDiagnosticFormatter() {
    }
    MarkdownDiagnosticFormatter.prototype.report = function (stats) {
        return "\n" + markdownHeader(2, "Summary") + "\n" + markdownTable([
            ["Files analyzed", "Files with problems", "Problems", "Errors", "Warnings"],
            [stats.totalFiles, stats.filesWithProblems, stats.diagnostics, stats.errors, stats.warnings].map(function (v) { return v.toString(); })
        ]);
    };
    MarkdownDiagnosticFormatter.prototype.diagnosticTextForFile = function (file, diagnostics) {
        if (diagnostics.length === 0)
            return undefined;
        return "\n" + markdownHeader(2, "" + relativeFileName(file.fileName)) + "\n" + markdownDiagnosticTable(file, diagnostics);
    };
    return MarkdownDiagnosticFormatter;
}());
function markdownDiagnosticTable(file, diagnostics) {
    var headerRow = ["Line", "Column", "Type", "Rule", "Message"];
    var rows = diagnostics.map(function (diagnostic) {
        var lineContext = file.getLineAndCharacterOfPosition(diagnostic.location.start);
        return [
            (lineContext.line + 1).toString(),
            (lineContext.character + 1).toString(),
            diagnostic.severity === "error" ? markdownHighlight("error") : "warning",
            diagnostic.source || "",
            diagnostic.message
        ];
    });
    return markdownTable(__spread([headerRow], rows), { removeEmptyColumns: true });
}

function printText(text, config) {
    if (config.outFile != null) {
        fs.appendFileSync(config.outFile, text);
    }
    else {
        // eslint-disable-next-line no-console
        console.log(text);
    }
}
/**
 * Executes the configuration and returns a boolean indicating if the command ran successfully.
 * @param globs
 * @param cliConfig
 */
function analyzeCommand(globs, cliConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var program, context, configFromTS, configFromCLI, configSeed, tsPluginConfig, analyzer, stats, formatter, timeMap, statsText, sortedTimeArray;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    program = undefined;
                    context = new DefaultLitAnalyzerContext({
                        getProgram: function () {
                            return program;
                        }
                    });
                    configFromTS = readLitAnalyzerConfigFromTsConfig() || {};
                    configFromCLI = readLitAnalyzerConfigFromCliConfig(cliConfig);
                    configSeed = __assign(__assign(__assign({}, configFromTS), configFromCLI), { 
                        // Also merge rules deep
                        rules: __assign(__assign({}, (configFromTS.rules || {})), (configFromCLI.rules || {})) });
                    tsPluginConfig = makeConfig(configSeed);
                    // Set the config on the context
                    context.updateConfig(tsPluginConfig);
                    // Debug config
                    context.logger.verbose("Lit Analyzer Configuration", tsPluginConfig);
                    analyzer = new LitAnalyzer(context);
                    stats = { errors: 0, warnings: 0, filesWithProblems: 0, totalFiles: 0, diagnostics: 0 };
                    formatter = getFormatter(cliConfig.format || "code");
                    timeMap = new Map();
                    return [4 /*yield*/, analyzeGlobs(globs, cliConfig, {
                            didExpandGlobs: function (filePaths) {
                                if (filePaths.length === 0) {
                                    // eslint-disable-next-line no-console
                                    console.log("\n" + chalk.red("  ✖ Couldn't find any files to analyze"));
                                }
                                else {
                                    // eslint-disable-next-line no-console
                                    console.log("Analyzing " + filePaths.length + " file" + (filePaths.length === 1 ? "" : "s") + "...");
                                }
                            },
                            willAnalyzeFiles: function (filePaths) {
                                // Prepare output file
                                if (cliConfig.outFile != null) {
                                    fs.writeFileSync(cliConfig.outFile, "");
                                }
                            },
                            analyzeSourceFile: function (file, options) {
                                program = options.program;
                                if (cliConfig.debug) {
                                    // eslint-disable-next-line no-console
                                    console.log("Analyzing " + file.fileName + "...");
                                }
                                var timeStart = Date.now();
                                // Get all diagnostics in the source file (errors and warnings)
                                var diagnostics = analyzer.getDiagnosticsInFile(file);
                                var time = Date.now() - timeStart;
                                timeMap.set(file.fileName, time);
                                // Filter all diagnostics by "error" if "quiet" option is active
                                diagnostics = cliConfig.quiet ? diagnostics.filter(function (d) { return d.severity === "error"; }) : diagnostics;
                                // Print the diagnostic text based on the formatter
                                var fileDiagnosticsText = formatter.diagnosticTextForFile(file, diagnostics, cliConfig);
                                if (fileDiagnosticsText != null) {
                                    printText(fileDiagnosticsText, cliConfig);
                                }
                                // Calculate stats
                                stats.diagnostics += diagnostics.length;
                                stats.totalFiles += 1;
                                // Add stats if there are more than 0 diagnostics
                                if (diagnostics.length > 0) {
                                    stats.errors += diagnostics.reduce(function (sum, d) { return (d.severity === "error" ? sum + 1 : sum); }, 0);
                                    stats.warnings += diagnostics.reduce(function (sum, d) { return (d.severity === "warning" ? sum + 1 : sum); }, 0);
                                    stats.filesWithProblems += 1;
                                    // Fail fast if "failFast" is true and the command is not successful
                                    if (cliConfig.failFast && !isSuccessful(stats, cliConfig)) {
                                        return false;
                                    }
                                }
                            }
                        })];
                case 1:
                    _a.sent();
                    statsText = formatter.report(stats, cliConfig);
                    if (statsText != null) {
                        printText(statsText, cliConfig);
                    }
                    // Print debugging
                    if (cliConfig.debug) {
                        sortedTimeArray = Array.from(timeMap.entries()).sort(function (_a, _b) {
                            var _c = __read(_a, 2), timeA = _c[1];
                            var _d = __read(_b, 2), timeB = _d[1];
                            return (timeA > timeB ? 1 : -1);
                        });
                        // eslint-disable-next-line no-console
                        console.log(sortedTimeArray.map(function (_a) {
                            var _b = __read(_a, 2), fileName = _b[0], time = _b[1];
                            return fileName + ": " + time + "ms";
                        }).join("\n"));
                    }
                    // Return if this command was successful or not
                    return [2 /*return*/, isSuccessful(stats, cliConfig)];
            }
        });
    });
}
function getFormatter(format) {
    switch (format) {
        case "list":
            return new ListDiagnosticFormatter();
        case "code":
            return new CodeDiagnosticFormatter();
        case "markdown":
            return new MarkdownDiagnosticFormatter();
        default:
            throw new Error("Unknown format: '" + format + "'");
    }
}
/**
 * Returns a boolean based on a "stats" object that indicates if the command is successful or not.
 * @param stats
 * @param config
 */
function isSuccessful(stats, config) {
    var maxErrorCount = 0;
    var maxWarningCount = config.maxWarnings != null ? config.maxWarnings : -1;
    if (stats.errors > maxErrorCount) {
        return false;
    }
    if (maxWarningCount !== -1 && stats.warnings > maxWarningCount) {
        return false;
    }
    return true;
}
function readLitAnalyzerConfigFromCliConfig(cliConfig) {
    var config = {};
    config.rules = cliConfig.rules;
    // Assign "strict" setting from the CLI command (which overwrites tsconfig rules)
    if (cliConfig.strict != null) {
        config.strict = cliConfig.strict;
    }
    // Assign "logging" based on "debug" option from the CLI command
    if (cliConfig.debug != null) {
        config.logging = cliConfig.debug ? "verbose" : "off";
    }
    // Assign "maxProjectImportDepth" setting from the CLI command (which overwrites tsconfig rules)
    if (cliConfig.maxProjectImportDepth != null) {
        config.maxProjectImportDepth = cliConfig.maxProjectImportDepth;
    }
    // Assign "maxNodeModuleImportDepth" setting from the CLI command (which overwrites tsconfig rules)
    if (cliConfig.maxNodeModuleImportDepth != null) {
        config.maxNodeModuleImportDepth = cliConfig.maxNodeModuleImportDepth;
    }
    return config;
}

/**
 * Converts from snake case to camel case
 * @param str
 */
function dashToCamelCase(str) {
    return str.replace(/(-\w)/g, function (m) { return m[1].toUpperCase(); });
}
/**
 * Converts from camel case to snake case
 * @param str
 */
function camelToDashCase(str) {
    return str.replace(/[A-Z]/g, function (m) { return "-" + m.toLowerCase(); });
}

/**
 * Parses CLI arguments.
 * @param args
 */
function parseCliArguments(args) {
    var result = { _: [] };
    for (var i = 0; i < args.length; i++) {
        var arg = args[i];
        // Parses: "--key", "-k", "--key=value", "--key value"
        if (arg.startsWith("-")) {
            // Parses: "--key=value"
            if (arg.includes("=")) {
                var _a = __read(arg.split("="), 2), key = _a[0], value = _a[1];
                assignValue(result, key, value);
            }
            // Parses: "--key value", "--key", "-k
            else {
                var key = transformKey(arg);
                // Parses: "--key value"
                if (i < args.length - 1) {
                    var value = args[i + 1];
                    if (!value.startsWith("-")) {
                        assignValue(result, key, value);
                        i++;
                        continue;
                    }
                }
                // Parses: "--key", "-k"
                assignValue(result, key, true);
            }
        }
        // Parses: "arg1", "arg2", ...
        else {
            result._.push(arg);
        }
    }
    return result;
}
/**
 * Transform a string to a primitive type.
 * @param value
 */
function transformValue(value) {
    if (typeof value === "boolean") {
        return value;
    }
    else if (!isNaN(Number(value))) {
        return Number(value);
    }
    else if (value === "true" || value === "false") {
        return value === "true";
    }
    return value;
}
/**
 * Transform a key by removing the first "-" characters.
 * @param key
 */
function transformKey(key) {
    return dashToCamelCase(key.replace(/^-*/g, ""));
}
/**
 * Assigns a value on a specific key and transforms the value at the same time.
 * @param obj
 * @param key
 * @param value
 */
function assignValue(obj, key, value) {
    // The key could be "nested.key"
    var keys = transformKey(key).split(".");
    keys.forEach(function (k, i) {
        // Assign the final value
        if (i >= keys.length - 1) {
            obj[k] = transformValue(value);
        }
        // Create nested objects
        else {
            if (!(k in obj)) {
                obj[k] = {};
            }
            obj = obj[k];
        }
    });
}

var DEFAULT_GLOB = "src/**/*.{js,jsx,ts,tsx}";
var DEFAULT_CONFIG = {
    noColor: false,
    quiet: false,
    maxWarnings: -1,
    //debug: false,
    help: false,
    failFast: false,
    format: "code",
    //strict: false,
    rules: {}
};
/**
 * The main function of the cli.
 */
function cli() {
    return __awaiter(this, void 0, void 0, function () {
        var _a, args, rest, globs, config, success;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = parseCliArguments(process.argv.slice(2)), args = _a._, rest = __rest(_a, ["_"]);
                    globs = args.length > 0 ? args : [DEFAULT_GLOB];
                    config = __assign(__assign({}, DEFAULT_CONFIG), rest);
                    if (config.debug) {
                        // eslint-disable-next-line no-console
                        console.log("CLI Config", config);
                    }
                    // Always convert "rules" to "dash case" because "rules" expects it.
                    config.rules = Object.entries(config.rules || {}).reduce(function (acc, _a) {
                        var _b = __read(_a, 2), k = _b[0], v = _b[1];
                        acc[camelToDashCase(k)] = v;
                        return acc;
                    }, {});
                    if (config.help) {
                        // eslint-disable-next-line no-console
                        console.log("\n\n  Usage\n    lit-analyzer [<file|directory|glob>]\n    \n  Options\n    --help                Print this message.\n    --format FORMAT       Specify output format. The possible options are:\n                            o code                Highlight problems in the code (default)\n                            o list                Short and precise list of problems\n                            o markdown            Markdown format\n    --noColor             Print results without color\n    --outFile FILE        Emit all output to a single file\n    --maxWarnings NUMBER  Fail only when the number of warnings is larger than this number\n    --quiet               Report only errors and not warnings\n    --failFast            Exit the process right after the first problem has been found\n    --strict              Enable strict mode. This change the default ruleset.\n    --rules.___ SEVERITY  Enable or disable a rule (example: --rules.no-unknown-tag-name off). \n                          Severity can be: \"off\" | \"warn\" | \"error\". The possible rules are:\n                          " + ALL_RULE_IDS.map(function (ruleName) { return "o  " + ruleName; }).join("\n                          ") + "\n    \n  Examples\n    lit-analyzer src\n    lit-analyzer \"src/**/*.{js,ts}\"\n    lit-analyzer my-element.js\n\t\t");
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, analyzeCommand(globs, config)];
                case 1:
                    success = _b.sent();
                    process.exit(success ? 0 : 1);
                    return [2 /*return*/];
            }
        });
    });
}

exports.ALL_RULE_IDS = ALL_RULE_IDS;
exports.DIAGNOSTIC_SOURCE = DIAGNOSTIC_SOURCE;
exports.DefaultLitAnalyzerContext = DefaultLitAnalyzerContext;
exports.DefaultLitAnalyzerLogger = DefaultLitAnalyzerLogger;
exports.LIT_HTML_ATTRIBUTE_MODIFIERS = LIT_HTML_ATTRIBUTE_MODIFIERS;
exports.LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER = LIT_HTML_BOOLEAN_ATTRIBUTE_MODIFIER;
exports.LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER = LIT_HTML_EVENT_LISTENER_ATTRIBUTE_MODIFIER;
exports.LIT_HTML_PROP_ATTRIBUTE_MODIFIER = LIT_HTML_PROP_ATTRIBUTE_MODIFIER;
exports.LitAnalyzer = LitAnalyzer;
exports.MAX_RUNNING_TIME_PER_OPERATION = MAX_RUNNING_TIME_PER_OPERATION;
exports.RULE_ID_CODE_MAP = RULE_ID_CODE_MAP;
exports.TS_IGNORE_FLAG = TS_IGNORE_FLAG;
exports.VERSION = VERSION;
exports.cli = cli;
exports.isRuleDisabled = isRuleDisabled;
exports.isRuleEnabled = isRuleEnabled;
exports.litDiagnosticRuleSeverity = litDiagnosticRuleSeverity;
exports.makeConfig = makeConfig;
exports.makeRules = makeRules;
exports.ruleIdCode = ruleIdCode;
exports.ruleSeverity = ruleSeverity;
